package provide FIQBOK 1.0
#FIQBOK.tcl
#BookMark Functions

#reads Bookmarks and create a View
proc readBookmarks {} {
	global normLight backColor listColor tagStyle bookName BookMarks homeDir anzBook msgText linktext
	set window .tile.top.html.tile.bookmark.dir
	set dir [string trimright $homeDir /]/bookmarks/
#	mkCacheDir
	set dummy [string trimright $dir /]
	set bookdir [lsort -dictionary [glob -nocomplain $dummy/*.FQB]]
	set anzBook [format "%02u" [llength $bookdir]]
	set bookmark ""
	foreach inhalt $bookdir {
		set dummy [lindex [split [lindex [split $inhalt /] end] .] 0]
		lappend bookmark $dummy
	}
	set BookMarks [list $msgText(bookmark) ""]
	$window configure -state normal
	$window delete 1.0 end
	$window image create 1.0 -image imWorld -padx 2 -pady 1
	$window insert 1.1 [lindex $BookMarks 0]\n 1
	#reset to unselectable State of TopTree (which may set by opened Bookmark)
	$window tag bind 1 <Any-Enter> {}
	$window tag bind 1 <Any-Leave> {}
	$window tag bind 1 <1> {}
	$window tag bind 1 <3> {}
	$window tag configure 1 -background {} -relief flat
	set i 2
	foreach inhalt $bookmark {
		#set inhalt [string trim $inhalt]
		regsub -nocase -all {#} $inhalt {.} inhalt
		$window image create $i.0 -image imBookClosed -padx 4 -pady 1
		$window insert $i.1 $inhalt\n $i
		$window tag bind $i <Any-Enter> "$window tag configure $i $tagStyle(bold); set linktext $inhalt"
		$window tag bind $i <Any-Leave> "$window tag configure $i $tagStyle(normal); set linktext {}"
		#ActionBindings on every TextTag (What should happen, if User Clicks on Tag)
		$window tag bind $i <1> [subst "openBook {$inhalt}"]
		$window tag bind $i <3> [subst "selectBook $i {$inhalt}"]
		lappend BookMarks {$inhalt ""}
		incr i
	}
	$window configure -state disabled
	unset i
}

#Select a Bookmark
proc selectBook {tag name} {
	global merkBook bookName etryBack fgColor sysFont
	set bookName $name
	set merkBook $name
	set window .tile.top.html.tile.bookmark.dir
	unmarkBook $tag
	if {[$window tag cget $tag -foreground]==$etryBack} {
		$window tag configure $tag -foreground $fgColor -font $sysFont(3)
		set bookName ""
	} else {
		$window tag configure $tag -foreground $etryBack -font "$sysFont(3) bold"
	}
}

#Unselect a Bookmark
proc unmarkBook {tag} {
        global sysFont fgColor bookName
	set window .tile.top.html.tile.bookmark.dir
	set such [$window tag names]
	foreach inhalt $such {
		if {$inhalt==$tag} continue
		$window tag configure $inhalt -foreground $fgColor -font $sysFont(3)
	}
}

#OpensBookmark for Display
proc openBook {mark} {
	global debug normLight backColor tagStyle urltext bookName BookMarks bookMerk homeDir anzBook renderUPD linktext remSTR cacheLocation normLight listColor
	set mark [string trim $mark /]
	set merkmark $mark
	regsub -nocase -all {\.} $mark {#} mark
	mkCacheDir
	set dir [string trimright $homeDir /]/bookmarks
	set datei $dir/[string trim $mark].FQB
	set bookMerk $datei
	if {![file exists $datei]} return
	ChangeMode 3
	set dummy [openFile $datei]
	set anzBook [format "%02u" [llength $dummy]]
	set window .tile.top.html.tile.bookmark.dir
	$window configure -state normal
	$window delete 1.0 end
	set BookMarks $merkmark
	#CreateNewTags IN Bookmark
	$window image create 1.0 -image imBookOpen -padx 2 -pady 1
	$window insert 1.1 "$merkmark\n" 1
	$window tag bind 1 <Any-Enter> "$window tag configure 1 $tagStyle(bold)"
	$window tag bind 1 <Any-Leave> "$window tag configure 1 $tagStyle(normal)"
	$window tag bind 1 <1> {unmarkBook -1; readBookmarks}
	#$window tag bind 1 <3> [subst "set bookName $merkmark"]
	set i 2
	set z 1
	foreach inhalt $dummy {
	        ProgressFile $z $anzBook
		set name [lindex $inhalt 0]
		set url [lindex $inhalt 1]
		#NEU120604: Wenn FavIcon zu URL gefunden, zeige FavIcon an
		set url [regSTR $remSTR $url 0]
		set fake [trimFile $url]
		set datei [string trimleft $url /]
                set dummy [lindex [split $datei ?] 0]
                set basedom [lindex [split $dummy /] 0]
                set fake [trimFile $basedom]
		set chart [getCachedir $fake]
                set icondir [string trimright $cacheLocation /]/cache/favicons/$chart
		set favicon [lindex [split $url /] 0]/favicon.ico
		set favicon [acode encode $favicon]
		if {$debug>4} {puts "openBook Icon: $icondir/$favicon"}
		if {[file exists $icondir/$favicon]} {
			if {[file size $icondir/$favicon]>0} {
				if {[catch {image create photo -file $icondir/$favicon} imDummy]==0} {
        				if {[info exists imDummy]} {
	        				if {[image width $imDummy]>16 || [image height $imDummy]>16} {
								  set imDummy [resizeIMG $imDummy 16 16]
							}
        					$window image create $i.0 -image $imDummy -padx 4 -pady 1
        					catch {unset imDummy}
        				} else {
        					$window image create $i.0 -image imBookmark -padx 4 -pady 1
        				}
                                } else {
        				$window image create $i.0 -image imBookmark -padx 4 -pady 1
				}
			} else {
				$window image create $i.0 -image imBookmark -padx 4 -pady 1
			}
		} else {
			#Ansonsten zeige Normales BookmarkIcon
			$window image create $i.0 -image imBookmark -padx 4 -pady 1
		}
		$window insert $i.1 $name\n $i
		$window tag bind $i <Any-Enter> "$window tag configure $i $tagStyle(bold); set linktext $url"
		$window tag bind $i <Any-Leave> "$window tag configure $i $tagStyle(normal); set linktext {}"
		#ActionBindings on every TextTag (What should happen, if User Clicks on Tag)
		$window tag bind $i <1> [subst "ChangeMode 3; set urltext [upperHTTP $url]; update; preSolve"]
		$window tag bind $i <3> [subst "selectBook $i {$name}; set urltext [upperHTTP $url]"]
		lappend BookMarks [list $name $url]
		incr i
		incr z
	}
	$window configure -state disabled
	if {[info exists imDummy]} {
		catch {image delete $imDummy}
	}
	ProgressFile 0 0
}

#copys complete History to a new BookmarkFolder
proc addFolder {} {
        global BookMarks histry idxHistry msgText remSTR
        set book [lindex $BookMarks 1]
	if {[string length $book]>0} {dispMSG $msgText(bookmark.open); setLED orange; return}
	set BookMarks $msgText(bookmark.new)
	foreach inhalt $histry {
                set domain [regSTR $remSTR $inhalt 0]
	        set name [lindex [split $domain /] 0]
                if {[regsub -nocase -all {www\.|www[0-9]\.} $name {} name]} {
                       regsub -nocase {^\.} $name {} name
                       set name [lindex [split $name .] 0]
                }
                lappend BookMarks [list $name $domain]
        }
        saveBook
        openBook [lindex $BookMarks 0]
}

#adds an Entry to a Bookmark
proc addBook {domain} {
	global BookMarks msgText remSTR
    set book [lindex $BookMarks 1]
	if {[string length $book]<=0} {dispMSG $msgText(bookmark.select.1); setLED orange; return}
	if {[string length $domain]<=0} {dispMSG $msgText(bookmark.addurl); setLED orange; return}
	set domain [regSTR $remSTR $domain 0]
	set name [lindex [split $domain /] 0]
        if {[regsub -nocase -all {www\.|www[0-9]\.} $name {} name]} {
                regsub -nocase {^\.} $name {} name
                set name [lindex [split $name .] 0]
        }
        lappend BookMarks [list $name $domain]
        saveBook
        openBook [lindex $BookMarks 0]
}

#Delete Bookmark
proc clearBook {} {
	global bookName BookMarks homeDir FTPask msgText
	if {[string length $bookName]<=0} {dispMSG $msgText(bookmark.select.4); setLED orange; return}
      	set book [lindex $BookMarks 1]
        set mark [string trim $bookName /]
	regsub -nocase -all {\.} $mark {#} mark
	set dir [string trimright $homeDir /]/bookmarks
	set datei $dir/[string trim $mark].FQB
        if {$FTPask==1} {
		set answer [optionBox -title $msgText(bookmark.delete.1) -icon warning -type yesno -message $msgText(bookmark.delete.2)]
	} else {
		set answer yes
	}
	switch $answer {
                yes {
                        if {[string length $book]<=0} {
                                file delete -force $datei
                                set bookName ""
                                readBookmarks
                                dispMSG "$msgText(bookmark.delete.3) $bookName"
				setLED blue
                        } else {
                                set idx [lsearch -regexp $BookMarks $bookName]
				set zlr 0
				set dummy ""
				foreach inhalt $BookMarks {
					if {$zlr != $idx} {
						lappend dummy $inhalt
					}
					incr zlr
				}
				set BookMarks $dummy
                                saveBook
                                openBook [lindex $BookMarks 0]
                                dispMSG "$msgText(bookmark.delete.4) $bookName"
				setLED blue
                        }
                }
                no return
        }
}

#saves a Bookmark
proc saveBook {} {
        global BookMarks homeDir msgText language
        set dummy [lindex $BookMarks 1]
	if {[string length $dummy]<=0} {dispMSG $msgText(bookmark.select.1); setLED orange; return}
	mkCacheDir
	set bookname [lindex $BookMarks 0]
        set mark [string trim $bookname /]
	regsub -nocase -all {\.} $mark {#} mark
	set dir [string trimright $homeDir /]/bookmarks
	set datei $dir/[string trim $mark].FQB
	set dummy [lrange $BookMarks 1 end]
     	if {![catch {open $datei "w"} fileid]} {
                foreach inhalt $dummy {
                        puts $fileid [list $inhalt]
                }
		close $fileid
	}
	dispMSG $msgText(bookmark.save)
	setLED blue
}

#renames a Bookmark
proc renBook {src dest} {
	global bookName BookMarks urltext homeDir msgText
	if {[string length $dest]<=0} {dispMSG $msgText(bookmark.name.1); setLED orange; return}
	if {[string toupper $src]==[string toupper $dest]} return
	mkCacheDir
	set dir [string trimright $homeDir /]/bookmarks
	set datei $dir/[string trim $src].FQB
	set book [lindex $BookMarks 1]
	if {[string length $book]<=0} {
		set target $dir/[string trim $dest].FQB
		if {![file exists $datei]} return
		catch {file rename -force $datei $target}
		readBookmarks
		unmarkBook $dest
		dispMSG $msgText(bookmark.name.2)
		setLED blue
	} else {
		#Bookmark IN BookmarkFile umbenennen
                set BookList [lrange $BookMarks 1 end]
                set BookMarks [lindex $BookMarks 0]
                set book $BookMarks
                foreach inhalt $BookList {
                        set back $inhalt
                        set name [lindex $inhalt 0]
                        if {[regexp -nocase $name $src]} {
                                set back [list $dest [lindex $inhalt 1]]
  	                }
  	                lappend BookMarks $back
  	        }
                saveBook
		openBook $book
                dispMSG $msgText(bookmark.name.3)
		setLED blue
	}
	set bookName ""
}

#Open/close BookmarkWindow
proc dispBook {} {
	global debug HTMLactive activeHTM bookWidth
	set window .tile.top.html.tile
	if {$debug>3} {puts "dispBook coords: [lindex [$window sash coord 0] 0]"}
	set win .tile.top.html.tile.html.pane
	set x [winfo width .]
	if {[lindex [$window sash coord 0] 0]<=3} {
		#norm (Windoof) = 146/144
		$window sash dragto 0 $bookWidth 1
		$window sash place 0 $bookWidth 1
#		set sashX [lindex [$win sash coord 0] 0]
#		set x [expr $sashX - [expr $bookWidth - 2]]
		#$win sash dragto 0 $x 1
		#$win sash place 0 $x 1
	} else {
		$window sash dragto 0 3 1
		$window sash place 0 3 1
	}
	if {$debug>3} {puts "dispBook HTMcoords: [lindex [$win sash coord 0] 0]"}
#	$win sash dragto 0 $x 1
#	$win sash place 0 $x 1
}

#Aktualisiert untere Select TextBox (No ListBox anymore !)
proc refreshSelected {args} {
	global debug selected etryBack normLight backColor listColor tagStyle linkmark showPHPlinks urltext tagIDX winSYS fTypes
	set window .tile.bottom.foot.box.selected
	$window configure -state normal
	#1st Step: delete all old Text
	$window delete 1.0 end
	if {[llength $selected]>0} {
		set i 1
		#2nd Step: create New Tags/Text
		foreach inhalt $selected {
			if {$debug>8} {puts $inhalt}
			if {$showPHPlinks == 0} {
				set inhalt [lindex [split $inhalt ] 0]
			}
			$window insert $i.0 "$inhalt\n" $i
			#NEU050604: linke Maus wirft ausgewhltes File in SelectBox wieder raus
			$window tag bind $i <1> [subst "set linkmark 1; AddSelected {$inhalt} 0; set urltext {$inhalt}; focus .head.dispUrl.url.e"]
			$window tag bind $i <3> [subst "set linkmark 1; AddSelected {$inhalt} 0; $window see $i.0"]
			#$window tag bind $i <3> [subst "preSelected $inhalt"]
			$window tag bind $i <Any-Enter> "$window tag configure $i $tagStyle(mark); set tagIDX $i"
			$window tag bind $i <Any-Leave> "$window tag configure $i $tagStyle(unmark); set tagIDX 0"
			incr i
		}
		unset inhalt i
	}
	#Don't write within Selection (WriteProtect)
	$window configure -state disabled
	unset window
}

#NEW021104: AddBookmarks2Selecton
proc book2select {} {
	global BookMarks linkmark msgText language
       	set dummy [lindex $BookMarks 1]
	if {[string length $dummy]<=0} {dispMSG $msgText(bookmark.select.1); setLED orange; return}
	set merk $linkmark
	set linkmark 1
	foreach inhalt [lrange $BookMarks 1 end] {
		AddSelected [lindex $inhalt 1] 0
	}
	set linkmark $merk
	unset merk dummy inhalt
	dispMSG $msgText(bookmark.select.2)
	setLED blue
}

#NEW041104: AddSelection2Bookmarks
proc select2book {} {
       	global anzBook BookMarks selected tagStyle msgText language normLight backColor listColor
       	set dummy [lindex $BookMarks 1]
	if {[string length $dummy]<=0} {dispMSG $msgText(bookmark.select.1); setLED orange; return}
	set window .tile.top.html.tile.bookmark.dir
        $window configure -state normal
	set i [expr $anzBook + 2]
        foreach inhalt $selected {
	        set inhalt [lindex [split $inhalt ] 0]
                set name [lindex [split $inhalt /] end]
                if {[regsub -nocase -all {www\.|www[0-9]\.} $name {} name]} {
                        regsub -nocase {^\.} $name {} name
                        set name [lindex [split $name .] 0]
                }
		lappend BookMarks [list $name $inhalt]
		$window image create $i.0 -image imBookmark -padx 4 -pady 1
		$window insert $i.1 $name\n $i
		$window tag bind $i <Any-Enter> "$window tag configure $i $tagStyle(bold)"
		$window tag bind $i <Any-Leave> "$window tag configure $i $tagStyle(normal)"
		#ActionBindings on every TextTag (What should happen, if User Clicks on Tag)
		$window tag bind $i <1> [subst "set urltext [upperHTTP $inhalt]; update; preSolve"]
		$window tag bind $i <3> [subst "selectBook $i {$name}; set urltext [upperHTTP $inhalt]"]
		incr anzBook
		incr i
	}
	$window configure -state disabled
	unset dummy inhalt name
        dispMSG $msgText(bookmark.select.3)
	setLED blue
}

#Experimental functions (currently unused ?):
# JavaScript Functions 4 testing
proc createJava {code} {
	set jcmd ""
	regsub -nocase -all {\n} [join $code] {} code
#puts "Code: $code"
	regsub -nocase -all {;} $code {\n} code
	regsub -nocase -all {\(} $code { \{} code
	regsub -nocase -all {\)} $code {\} } code
	regsub -nocase -all {\[} $code {\(} code
	regsub -nocase -all {\]} $code {\)} code
	regsub -nocase -all { +} $code { } code

	regsub -nocase -all {if } $code {\nif } code
	regsub -nocase -all {else } $code {\nelse } code
#puts "Code: $code"
	regsub -nocase -all {\}\{} $code {\}\n\{} code
	set code [split $code \n]
#puts "Code: $code"
	foreach inhalt $code {
		set inhalt [join $inhalt]
#puts "jInhalt: $inhalt"
		regsub -nocase -all {,} $code { } code
		#jFunction2TCLproc
		if {[regexp -nocase {^function} $code]} {
			regsub -nocase -all {^function} $code {proc} code
			append jcmd $code
		}
	}
	return [join $jcmd]
}

#<SCRIPT LANGUAGE="JavaScript1.2">
#function openpic(pic)
#{
#window.open("image/"+pic+"_big.jpg", "",
# "toolbar=0,location=0,directories=0,status=0,menubar=no,scrollbars=no,resizable=yes,width=470,height=625, left=0, top=0");
#}
#</script>
#<a href=javascript:openpic(3)><img src='thumbnail.jpg'></a>
#set zeile "script LANGUAGE='JavaScript1.2' function openpic(pic) {window.open('image/'+pic+'_big.jpg', '', 'toolbar=0,location=0,directories=0,status=0,menubar=no,scrollbars=no,resizable=yes,width=470,height=625, left=0, top=0');} {}"

#Function 4 parsing Java
#Fills JavaArrays (jFunction/jCommand) with JavaScript Variables/Command
proc parseJava {scr} {
#return
	global jFunction jCommand baseurl activeHTM
#puts "parseJava gets: $scr"
	foreach zeile $scr {
		if {[regexp -nocase {window.open|document.write} $zeile]} {
#puts "javaZeile: $zeile"
			set dummy [getValue function $zeile]
			regsub -nocase -all {\(|\)|,} $dummy "\n" dummy
			set dummy [split $dummy \n]
			set funcname [lindex $dummy 0]
			set args [lindex $dummy 1 end]
			#create JavaFunction Array with Variables used by Java
			set jFunction($funcname) $args
			set zeile [join $zeile]
			regsub -nocase {window.open|document.write} $zeile "window.open" zeile
			regsub -nocase ";" $zeile ";" zeile
			regsub -nocase {\{|\}} $zeile {} zeile
			set cmd [lindex [split $zeile ] 1]
			#create JavaCommand (contains whole JavaCommand incl Variables)
			set jCommand($funcname) $cmd
                } elseif {[regexp -nocase {document.cookie} $zeile]} {
                        set cookie [getValue document.cookie $zeile]
                        regsub -nocase -all { } $cookie {} cookie
                        getCookie $baseurl($activeHTM) $cookie
		} else {
			continue
		}
	}
}

#NEW130206: returns JavaCommand from JavaArrays (and replaces in result Variables with Values)
proc getJava {cmd} {
	global jFunction jCommand
	set back ""
	regsub -nocase -all {\(|\)|,} $cmd "\n" dummy
	set dummy [split $dummy \n]
	#Read FunctionName and Args from input
	set funcname [lindex $dummy 0]
	set args [lindex $dummy 1 end]
	#Read FunctionName and Args from previous stored JavaArrays
	set vars ""
	catch {set vars $jFunction($funcname)}
	catch {set back $jCommand($funcname)}
	if {[llength $vars]<=0 || [string length $back]<=0} {return $cmd}
	set z 0
	#Fill each JavaVariable with Values from input
	foreach inhalt $vars {
		regsub -nocase -all $inhalt $back [lindex $args $z] back
		regsub -nocase -all {\'\+|\+\'} $back {} back
		incr z
	}
	if {$back==""} {set back $cmd}
	return $back
}

#NEW080907: import/export Bookmarks
proc importBook {} {
 	global homeDir lastDir msgText language imFavIcon cacheLocation remSTR linktext cancel
	set filetypes {
		{{Bookmark Files} {.htm .html}}
		{{All Files} *}
	}
	catch {stop_anigif .mbar.lbAnim} err
	catch {show_anigif [list -data [getAnim floater22]] .mbar.lbAnim} err
	set f [tk_getOpenFile -title $msgText(bookmark.import) -initialdir $lastDir -filetypes $filetypes]
#	catch {stop_anigif .mbar.lbAnim} err
	if {[string length $f]<=1} {
	   	 catch {stop_anigif .mbar.lbAnim} err
	 	 return
	}
	set lastDir [string trimright [fileDIR $f] /]/
	set dir [string trimright $homeDir /]/bookmarks
	set dummy [openFile $f]
	if {![regexp -nocase {Bookmark-file} $dummy]} {
		 catch {stop_anigif .mbar.lbAnim} err
	 	 return
	}
	update
	regsub -nocase -all {\r+|\n+|\t+|\f+|\v+|\x0a+|\x0d+|\x09+|\x0b+|\xff+|\xfe+|\x00|\xc2} $dummy {} dummy
	set dummy [decode [encode $dummy]]
#	set dummy [decode $dummy]
	regsub -nocase -all {<a href} $dummy "\n<A HREF" dummy
	regsub -nocase -all {</a *>} $dummy "\n</A>" dummy
	regsub -nocase -all {<H3} $dummy "\n<H3" dummy
	set name ""
	set icon ""
	set entr ""
	set href ""
	set dref ""
	set img ""
	set fav ""
	set book ""
	set dummy [split $dummy "\n"]
	set max [llength $dummy]
#puts "$max: $dummy"
	set z 0
	MouseCurs 1
	foreach zeile $dummy {
				ProgressFile $z $max
				if {$cancel==1} break
#puts "Zeile: $zeile"
				#Directory found
				if {[regexp -nocase {</H3>|</DL>} $zeile]} {
				   if {[llength $book]>0} {
 	  			         if {[string length $name]<=0} {
							set name "Import"
							set datei $dir/[string trim $name].FQB
						 }
				   	     set linktext $name
						 writeFile $datei $book
			 	   }
 				   regsub -nocase -all {</H3>.*} $zeile {} zeile
#puts "NAME: $zeile"
 				   set name [string trim [lindex [split $zeile >] end]]
 				   regsub -nocase -all { } $name {_} name
 				   set datei $dir/[string trim $name].FQB
#puts "Datei: $datei"
#puts "BOOK: $book"
 				   set book ""
				}
				#Bookmark Entry
				if {[regexp -nocase {<A HREF} $zeile]} {
				   regsub -nocase -all {</A>.*} $zeile {} zeile
				   set href [getValue href $zeile]
				   set entr [lindex [split $zeile >] end]
				   if {[regexp -nocase { ICON=} $zeile]} {
				   	  #Bookmark contains FavIcon
				   	  regsub -nocase -all {,} $zeile ";" zeile
				   	  set icon [getValue ICON $zeile]
				   	  set icon [lindex [split $icon ";"] end]
				   	  if {[string length $icon]>1} {
				   	  	 if {[catch {image create photo -data $icon} img]==0} {
					   	  	 if {[image width $img]>16 || [image height $img]>16} {
								  set img [resizeIMG $img 16 16]
							 }
						 	 set imFavIcon $img
						 }
#	   	  	 	 		 set datei [regSTR $remSTR $favicon 0]
						 set chart [getCachedir $href]
						 set cachedir [string trimright $cacheLocation /]/cache/favicons/$chart
						 if {![file isdirectory $cachedir]} {file mkdir $cachedir}
						 set dref [string trimright [lindex [split [regSTR $remSTR $href] /] 0] /]
						 set fav "[string trim $cachedir]/[string trim [acode encode $dref]]%2Ffavicon.ico"
#puts "FAVdir: $fav"
	 		  	   		 if {[string length $img]>0 && ![file exists $fav]} {
						 	catch {$img write $fav -format ico}
						 }
				   	  }
#puts "ICON: $icon"
				   }
				   lappend book [list "$entr" $href]
				}
		incr z
	}
	set imFavIcon imClrURL
    set linktext ""
	update
	readBookmarks
	catch {unset fav zeile dref href name book dummy icon entr img}
	catch {stop_anigif .mbar.lbAnim} err
	ProgressFile 0 0
	MouseCurs 0
}

proc exportBook {} {
     global homeDir lastDir msgText language imFavIcon cacheLocation remSTR cancel
	 set filetypes {
		{{Bookmark Files} {.htm .html}}
		{{All Files} *}
	 }
	 catch {stop_anigif .mbar.lbAnim} err
	 catch {show_anigif [list -data [getAnim superTux22]] .mbar.lbAnim} err
	 set f [tk_getSaveFile -title $msgText(bookmark.export) -initialdir $lastDir -filetypes $filetypes -initialfile "Bookmarks.HTM"]
	 if {[string length $f]<=1} {
	 	catch {stop_anigif .mbar.lbAnim} err
	 	return
 	 }
	 MouseCurs 1
	 set icon ""
	 set img ""
	 set fav ""
	 set chart ""
	 set output ""
	 append output "<!DOCTYPE NETSCAPE-Bookmark-file-1>\n"
	 append output "<!-- This is an automatically generated file.\nIt will be read and overwritten.\nDo Not Edit! -->\n"
	 append output "<TITLE>Bookmarks</TITLE>\n"
	 append output "<H1>Bookmarks</H1>\n"
	 append output "<DL><p>\n"
	 set dirs [glob -nocomplain "[string trimright $homeDir /]/bookmarks/*"]
     set z 0
 	 set max [llength $dirs]
	 foreach folder $dirs {
         ProgressFile $z $max
    	 if {$cancel==1} break
         set inhalt [openFile $folder]
	 	 regsub -nocase -all {\-} [clock clicks] {} timestamp
         set foldname [lindex [split $folder /] end]
         regsub -nocase {.FQB$} $foldname {} foldname
         append output "\t<DT><H3 FOLDED ADD_DATE=\"$timestamp\">$foldname</H3>\n"
#append output "<DL><p>\n"
         foreach dummy $inhalt {
#puts "DUMMY: $dummy"
#         		 set dummy [split $dummy]
         		 set name [lindex $dummy 0]
          		 set href [lindex $dummy 1]
		 		 if {[string length $href]>1 && [string length $name]>1} {
   					 set chart [getCachedir $href]
					 set cachedir [string trimright $cacheLocation /]/cache/favicons/$chart
					 set dref [string trimright [lindex [split [regSTR $remSTR $href] /] 0] /]
					 set fav "[string trim $cachedir]/[string trim [acode encode $dref]]%2Ffavicon.ico"

					 if {[file exists $fav]} {
					 	  if {[catch {image create photo -file $fav} img]==0} {
							  regsub -nocase -all "\n" [$img data -format ico] {} icon
							  append output "\t<DT><A HREF=\"$href\" ADD_DATE=\"$timestamp\" LAST_VISIT=\"$timestamp\" LAST_MODIFIED=\"$timestamp\" ICON=\"data:image/x-icon;base64,$icon\">$name</A>\n"
				  		  } else {
					  	  	  append output "\t<DT><A HREF=\"$href\" ADD_DATE=\"$timestamp\" LAST_VISIT=\"$timestamp\" LAST_MODIFIED=\"$timestamp\" ICON=\"data:image/x-icon;base64,-\">$name</A>\n"
						  }
				  	 } else {
					  	  append output "\t<DT><A HREF=\"$href\" ADD_DATE=\"$timestamp\" LAST_VISIT=\"$timestamp\" LAST_MODIFIED=\"$timestamp\" ICON=\"data:image/x-icon;base64,-\">$name</A>\n"
				  	 }
				 }
  		 }
  		 append output "\t</DL><p>\n\t<DL><p>\n"
	     incr z
	 }
     append output "</DL><p>\n"
     writeFile $f $output
     catch {image delete $img}
     catch {unset dirs output f name href inhalt folder foldname icon img chart fav}
	 catch {stop_anigif .mbar.lbAnim} err
	 ProgressFile 0 0
	 MouseCurs 0
}

#Example (including FavIcon)
#[DEFAULT]
#BASEURL=http://wiki.tcl.tk/
#[InternetShortcut]
#URL=http://wiki.tcl.tk/
#Modified=E09C5F3D91F4C70165
#IconFile=http://wiki.tcl.tk/favicon.ico
#IconIndex=1

proc sendDesktop {url ziel} {
	 global userDir remSTR cacheLocation msgText appText lastDir
	 set url [string trim $url]
	 if {[string length $url]<=0} {
	 	dispMSG $msgText(url.empty)
	 	setLED orange
	 	return
 	 }
	 set dref [regSTR $remSTR $url]
 	 set datei [lindex [split $dref /] 0]
	 set href [reslvURL $datei 1]
 	 set dref [reslvURL $url 1]
	 set chart [getCachedir $href]
	 set cachedir [string trimright $cacheLocation /]/cache/favicons/$chart
	 set fav "[string trim $cachedir]/[string trim [acode encode $datei]]%2Ffavicon.ico"
	 regsub -nocase -all {^ww[w0-9]+\.} $datei {} datei
	 regsub -nocase {\.} $datei {_} datei
	 set datei "[string trim [lindex [split $datei .] 0]].url"
	 if {[string length $ziel]<=0} {
	 	 set ziel [tk_getSaveFile -title $appText(.mbar.file.2.1) -initialdir $lastDir -filetypes "{Links {.url .URL}}" -initialfile $datei]
	 } else {
		 set ziel "[string trimright $ziel /]/$datei"
	 }
	 if {[string length $ziel]<=0} {
	 	dispMSG $msgText(ftp.copy.2)
	 	setLED orange
	 	return
 	 }
	 regsub -nocase -all {\-} [clock clicks] {} timestamp
	 set output ""
	 append output "\[DEFAULT\]\n"
	 append output "BASEURL=$href\n"
	 append output "\[InternetShortcut\]\n"
	 append output "URL=$dref\n"
	 append output "Modified=$timestamp\n"
	 if {[file exists $fav]} {
		 append output "IconIndex=0\n"
 		 append output "IconFile=[regsub -nocase -all {/} $fav {\\}]\n"
#		 append output "IconFile=$fav\n"
	 } else {
	 	 append output "IconFile=[string trimright $href /]/favicon.ico\n"
		 append output "IconIndex=1\n"
	 }
	 writeFile $ziel $output
	 catch {unset output datei timestamp chart href dref datei fav cachedir}
}

#NEW090907: actualize FavIcons
proc loadFavIcons {} {
	 global homeDir remSTR cacheLocation backColor cancel active msgText otherWarn FTPask synCount HTMLtimeout infostatus linktext
 	 if {$otherWarn==1} {
		 set answer [optionBox -title $msgText(download.icons.1) -icon warning -type okcancel -message $msgText(download.icons.2)]
		 if {[string length $answer]<=0 || [regexp -nocase {no|0} $answer]} return
	 }
	 set dirs [glob -nocomplain "[string trimright $homeDir /]/bookmarks/*"]
     set z 1
 	 set max [llength $dirs]
 	 set active 1
 	 MouseCurs 1
	 catch {stop_anigif .mbar.lbAnim} err
	 catch {show_anigif [list -data [getAnim penguinL22]] .mbar.lbAnim} err
	 foreach folder $dirs {
         ProgressBar $z $max
		 set erg [expr $max - $z]
		 wm title . "FIQ: $z/$max ($erg)"
		 wm iconname . "FIQ: $z/$max ($erg)"
         if {$cancel==1} break
         set inhalt [openFile $folder]
         foreach dummy $inhalt {
#puts "DUMMY: $dummy"
          		 set href [lindex $dummy 1]
		 		 if {[string length $href]>1} {
   					 set chart [getCachedir $href]
					 set cachedir [string trimright $cacheLocation /]/cache/favicons/$chart
					 set dref [string trimright [lindex [split [regSTR $remSTR $href] /] 0] /]
					 set fav "[string trim $cachedir]/[string trim [acode encode $dref]]%2Ffavicon.ico"

					 if {[file exists $fav]} {
					 	continue
				  	 } else {
				  	    set href [reslvURL "[string trimright $dref /]/favicon.ico" 1]
#				  	    AddSelected $href 0
#puts "HREF: $href"
						set linktext "$msgText(request.send.6): $href"
					 	getSyncURL $href
					 	#getFileURL $href
				  	 }
				 }
  		 }
	     incr z
	 }
	 #wait for download complete
	 if {$synCount>0 && $cancel<=0} {
		set chk 0
		setLED cyan
		after [expr $HTMLtimeout] {set chk 1}
		while {$synCount>0 && $cancel<=0 && $chk<=0} {
			vwait synCount
		}
	 }
 	 .imHTTPS configure -image imUnLock -background $backColor
	 catch {stop_anigif .mbar.lbAnim} err
	 wm title . "Inquisitor"
	 wm iconname . "FIQ"
	 set linktext ""
	 set infostatus "System $msgText(fiq.ready)"
	 set active 0
     ProgressBar 0 0
     MouseCurs 0
     setLED blue
}
