package provide FIQFTP 1.0
#FIQFTP V260904
#FTP Functions 4 Frenzy's Inquisitor
#(C) 2004 by: Frenzy Softworks
#Written by: Jens Timmermann

#Button Direction in FTPpanel (1 sets PipeON = sunken)
proc chkClick {bin} {
	global normLight FTPmode backColor pipe msgText
	set win .tile.bottom.pane.f4.box.lbDirection
	if {$bin==1} {
		set dummy [.tile.bottom.pane.f4.box.lbDirection cget -text]
		#RightClick sets Pipe
		if {[$win cget -relief]=="groove"} {
			$win configure -relief sunken
			if {[regexp -nocase {<} $dummy]} {$win configure -text "<" -image imPipeLeft}
			if {[regexp -nocase {>} $dummy]} {$win configure -text ">" -image imPipeRight}
			set pipe 1
			dispMSG $msgText(ftp.pipe.1)
			setLED blue
		} else {
			$win configure -relief groove
			if {[regexp -nocase {<} $dummy]} {$win configure -text "<" -image imBack}
			if {[regexp -nocase {>} $dummy]} {$win configure -text ">" -image imForw}
			set pipe 0
			dispMSG $msgText(ftp.pipe.2)
			setLED blue
		}
	} else {
		#LeftClick sets ActivePassiveMode
		set dummy [$win cget -background]
		if {$dummy=="Green" || $dummy=="LightGreen"} {
			$win configure -background $backColor
			bind  .tile.bottom.pane.f4.box.lbDirection <Any-Enter> {.tile.bottom.pane.f4.box.lbDirection configure -background $normLight}
			bind  .tile.bottom.pane.f4.box.lbDirection <Any-Leave> {.tile.bottom.pane.f4.box.lbDirection configure -background $backColor}
			set FTPmode "passive"
			dispMSG $msgText(ftp.mode.1)
			setLED blue
		} else {
			$win configure -background Green
			bind  .tile.bottom.pane.f4.box.lbDirection <Any-Enter> {.tile.bottom.pane.f4.box.lbDirection configure -background LightGreen}
			bind  .tile.bottom.pane.f4.box.lbDirection <Any-Leave> {.tile.bottom.pane.f4.box.lbDirection configure -background Green}
			set FTPmode "active"
			dispMSG $msgText(ftp.mode.2)
			setLED blue
		}
	}
	catch {unset dummy win}
}

#NEU300404 FTPinput
#EingabeFeld fr FTPmkDir
proc inputMode {} {
	global iMode msgText
	switch $iMode {
		1 {
			dispMSG $msgText(ftp.name)
			pack forget .head.dispUrl
			pack .head.mkdirFTP -in .head -expand true -fill x
			focus .head.mkdirFTP.etInput
			set iMode 0
		}
		0 {
			pack forget .head.mkdirFTP
			pack .head.dispUrl -in .head -expand true -fill x
			focus .head.dispUrl.url.e
			set iMode 1
		}
	}
}

#NEU300404 FTPinput
#EingabeFeld fr reName
proc renameMode {} {
	global rMode selected msgText
	if {[llength $selected]<=0} {
		dispMSG $msgText(download.1)
		setLED orange
		return
	}
	switch $rMode {
		1 {
			dispMSG $msgText(ftp.name)
			pack forget .head.dispUrl
			pack .head.renameFTP -in .head -expand true -fill x
			focus .head.renameFTP.etInput
			set rMode 0
		}
		0 {
			pack forget .head.renameFTP
			pack .head.dispUrl -in .head -expand true -fill x
			focus .head.dispUrl.url.e
			set rMode 1
		}
	}
	#return $back
}

#MapMode=4; FTP-Mode
proc MapFTP {} {
	global FTPrender debug destDir selected FTPdir urltext backColor imgSize cancel
	set merk $selected
	set imgSize 2
	pack forget .tile.top.html
	pack .tile.top.ftp -fill both -expand true
	clearSelected
	set win local
	if {[llength $FTPdir($win)]<=0} {
		refreshFTP $win
		refreshFTP "remote"
        #NEW290105: disable remoteFTPwindows for TextWriting
        .tile.top.ftp.tile.remote.remote configure -state disabled
		readLocalDir $win $destDir
		displayTag $win
	}
	#ReadOnly ListBox
	.tile.bottom.foot.box.selected configure -state disabled
	if {[llength $merk]>0} {
		#Auf HTML selectierte Images auch in FTP selectieren (FileManagement)
		foreach inhalt $merk {
			if {$cancel==1} {break}
			set dummy [lindex [split $inhalt /] end]
			if {$debug>3} {puts "Inhalt: $inhalt"}
			set tag [lsearch -regexp $FTPdir($win) $dummy]
			if {$tag>0} {
				if {$debug>3} {puts "Found: $tag"}
				selectTag $win [expr $tag + 1]
			}
		}
	}
}

#Called when entered an URL
proc enterFTP {win} {
	global FTPdest FTPhome MapMode
	if {$MapMode!=4} return
	if {[string length $FTPdest($win)]<=0} {
		set url [fileDIR [reslvURL $FTPdest($win) 0]]
	} else {
		set url [string trimright $FTPdest($win) /]/
	}
	if {[regexp -nocase {^/|^/*[a-zA-Z]:} $FTPdest($win)]} {
		set mode local
	} else {
		set mode remote
	}
	if {![regexp -nocase {/} $url]} {
		set url [string trimright $url /]/
	} else {
		set such [lindex [split $url /] end]
		if {![regexp -nocase {\.} $url]} {
			set url [string trimright $url /]/
		}
	}
	setFTPmode $win $mode
	useFTP $win $url
}

#sets FTP-WindowMode (local/remote)
proc setFTPmode {win mode} {
	global FTPdest
	set dest "local"
	if {$win=="local"} {
		set dest "remote"
	}
	if {$mode=="remote"} {
		.tile.top.ftp.tile.$win.title.lbMode configure -text "Remote:" -image imRemote -compound left
	} else {
		.tile.top.ftp.tile.$win.title.lbMode configure -text "Local:" -image imLocal -compound left
		closeFTP
	}
}

#Change FTP-Mode
proc changeFTPmode {win} {
	global FTPdest active
	if {$active==1} return
	if {$win=="local"} {
		refreshFTP local
		set dummy [chkMode local]
		if {$dummy=="local"} {
			.tile.top.ftp.tile.local.title.lbMode configure -text "Remote:" -image imRemote -compound left
			.tile.top.ftp.tile.remote.title.lbMode configure -text "Remote:" -image imRemote -compound left
			setActive local
			readRemoteDir local $FTPdest(remote)
		} else {
			.tile.top.ftp.tile.local.title.lbMode configure -text "Local:" -image imLocal -compound left
			setActive local
			closeFTP
			readLocalDir local $FTPdest(remote)
		}
		displayTag local
	} else {
		refreshFTP remote
		set dummy [chkMode remote]
		if {$dummy=="remote"} {
			.tile.top.ftp.tile.remote.title.lbMode configure -text "Local:" -image imLocal -compound left
			.tile.top.ftp.tile.local.title.lbMode configure -text "Local:" -image imLocal -compound left
			setActive remote
			closeFTP
			readLocalDir remote $FTPdest(local)
		} else {
			.tile.top.ftp.tile.remote.title.lbMode configure -text "Remote:" -image imRemote -compound left
			setActive remote
			if {![regexp -nocase {^/} $FTPdest(remote)]} {
				readRemoteDir remote $FTPdest(remote)
			} else {
				set FTPdest(remote) ""
			}
		}
		displayTag remote
	}
	unset dummy
	setActive $win
}

#NEU150304: initialize FTP-Procedure
proc useFTP {win url} {
#Liefert FTP-Directory, und ggf. File zurck
	global debug FTPhome MapMode backColor remSTR urltext
	set url [acode recode $url]
	set urltext $url
	if {$debug>1} {puts "useFTP bekommt: $win $url"}
	if {$MapMode!=4} {
		set merkMode $MapMode
		ChangeMode 4
	}
	refreshFTP $win
	if {[regexp -nocase {file://} $url] || [regexp -nocase {^/} $url]} {
		regsub -nocase -all {file://} $url {} dummy
		.tile.top.ftp.tile.$win.title.lbMode configure -text "Local:" -foreground black -background $backColor -image imLocal -compound left
	}
	set url [regSTR $remSTR $url]
	set url [string trimright [fileDIR $url] /]/
	#Modus (local/FTP) des aktiven Windows auslesen
	if {[chkMode $win]=="local"} {
		readLocalDir $win $url
	} else {
		readRemoteDir $win $url
	}
	displayTag $win
	set FTPhome($win) $url
}

#Open FTPconnection
proc openFTP {win url} {
	global debug HTMLtimeout FTP FTPuser FTPpass FTPport FTPhost FTPstatus FTPdebug blocksize FTPmode msgText linktext remSTR
	if {$debug>1} {puts "openFTP get: $win $url"}
	if {[string length $FTP($win)]>0} return
	if {[regexp -nocase {^/} $url]} return
	set url [acode recode $url]
	set url [URLsplit $url]
	set FTPhost($win) [acode recode [lindex $url 1]]
	set dummy [acode recode [lindex $url 2]]
	set ftpFile [lindex [split $dummy /] end]
#	regsub -nocase -all {ftp://} $url {} dummy
        set dummy [regSTR $remSTR $url 0]
	set ftpDir [fileDIR $dummy]
	setLED green
    dispMSG "$msgText(ftp.connect.1) $FTPhost($win)"
	set linktext "$msgText(ftp.connect.1) $FTPhost($win)"
    catch {stop_anigif .mbar.lbAnim}
	catch {show_anigif [list -data [getAnim penguinR22]] .mbar.lbAnim} err
	update
	set ftp::DEBUG $FTPdebug
	set ftp::VERBOSE $FTPdebug
	if {[regexp -nocase {:} $ftpFile]} {
		set FTPport($win) [string trim [lindex [split $ftpFile :] end]]
	}
	catch {ftp::Open $FTPhost($win) $FTPuser($win) $FTPpass($win) -port $FTPport($win) -mode $FTPmode -blocksize $blocksize -progress FTPprogress -timeout $HTMLtimeout} FTP($win)
	if {$FTP($win)<0} {
		dispMSG $msgText(ftp.connect.2)
		closeFTP
		setLED red
		set linktext ""
		catch {stop_anigif .mbar.lbAnim} err
		return
	}
	catch {ftp::Type $FTP($win) "bin"} err
	if {[lsearch -regexp $FTPstatus($win) "^230"]} {
		#ConnectionOpened (Lock=Blue)
		if {[regexp -nocase {anonymous} $FTPuser($win)]} {
		   	.imHTTPS configure -image imUnLock -background LightGreen
		} else {
			.imHTTPS configure -image imLock -background LightGreen
		}
		dispMSG $msgText(ftp.connect.3)
		setLED blue
		set linktext $msgText(ftp.connect.1)
	} else {
		closeFTP
		set linktext ""
	}
    catch {stop_anigif .mbar.lbAnim}
}

#FTP progress
proc FTPprogress {arg} {
	#puts "FTPprogress: $arg"
	global FTPfilesize
	ProgressFile $arg $FTPfilesize([chkFTPactive])
}

#Close FTPconnection
proc closeFTP {} {
	global debug FTP FTPedit FTPdest destDir appText sysFont backColor linktext
	if {$debug>2} {puts "closeFTP"}
	if {$FTPedit==0} {
		if {[string length $FTP(local)]>0} {
			catch {ftp::Close $FTP(local)} err
			set FTP(local) ""
		}
		if {[string length $FTP(remote)]>0} {
			catch {ftp::Close $FTP(remote)} err
			set FTP(remote) ""
		}
		#ConnectionClosed (Lock=Green)
		.imHTTPS configure -image imUnLock -background $backColor
		. configure -cursor {}
		setLED blue
		set linktext ""
	} else {
		set FTPedit 0
		set window .tile.top.ftp.tile.remote.remote
		set win [chkFTPactive]
		if {$win=="remote"} {
			set window .tile.top.ftp.tile.local.local
			set win local
		} else {
			set win remote
		}
		.tile.bottom.pane.f4.box.btEdit configure -text $appText(.tile.bottom.pane.f4.box.btEdit)
		.tile.top.ftp.tile.${win}.title.lbMode configure -text "Remote:" -relief groove -cursor hand2 -image imRemote -compound left -font $sysFont(4) -background $backColor
		activateFTP $win
		catch {$window configure -state disabled -setgrid 0 -undo 0 -autosep 0}
		set FTPdest($win) ""
		set linktext ""
		refreshFTP $win
		#readLocalDir $win $destDir
		displayTag $win
	}
}

#Ausgewhlte Files in Liste: FTPselect (currently unused)
proc selectFTP {window inlist} {
	global cancel
	set tag 1
	set FTPselect ""
	foreach inhalt $inlist {
		#Aktiven Tag (also Selected File) auslesen
		if {$cancel==1} {break}
		set test [$window tag cget $tag -relief]
		if {$test=="raised"} {
			lappend FTPselect $inhalt
		}
		incr tag
	}
	return FTPselect
}

#deleteFile; deletes a File in local/remote-Window as localFile or FTP-File
#Args: win = local/remote-Window
proc deleteFTP {win} {
	global FTPask FTP FTPdir FTPdest selected cancel msgText cancel linktext
	set FTPselect ""
	set window .tile.top.ftp.tile.local.local
	if {$win=="remote"} {
		set window .tile.top.ftp.tile.remote.remote
	}
	if {[llength $FTPdir($win)]>0} {
		set FTPselect $selected
	} else {
		dispMSG $msgText(ftp.delete.1)
		setLED orange
		return
	}
	set anz [llength $FTPselect]
	if {$anz<=0} {
		dispMSG $msgText(ftp.delete.2)
		setLED orange
		return
	}
	set delete [chkFTPactive]
	if {$FTPask==1} {
		set answer [optionBox -title $msgText(ftp.delete.3) -icon warning -type yesno -message $msgText(ftp.delete.4)]
	} else {
		set answer yes
	}
	switch $answer {
		yes {
			set i 1
  			catch {stop_anigif .mbar.lbAnim}
			catch {show_anigif [list -data [getAnim wackel22]] .mbar.lbAnim}
			update
			foreach datei $FTPselect {
				ProgressBar $i $anz
				if {$cancel==1} {break}
				set datei [lindex $datei 0]
				set dummy [string trim [lindex [split $datei {/}] end]]
				set linktext "$msgText(ftp.delete.6) $dummy"
				if {[chkMode $win]=="remote"} {
					if {[regexp -nocase {^/} $dummy]} {
					#is $dummy ein Directory ?
						catch {ftp::RmDir $FTP($win) $dummy} err
					} else {
					#Nein, ein File
						catch {ftp::Delete $FTP($win) $dummy} err
					}
				} else {
					catch {file delete -force $datei}
				}
				AddSelected $datei 0
				if {$cancel==1} {
					set cancel 0
					break
				}
				incr i
			}
            catch {stop_anigif .mbar.lbAnim}
			refreshFTP $win
			if {[chkMode $win]=="remote"} {
				readRemoteDir $win $FTPdest($win)
			} else {
				readLocalDir $win $FTPdest($win)
			}
			displayTag $win
			ProgressBar 0 0
			set linktext ""
			dispMSG "$msgText(ftp.delete.5) $anz"
			setLED blue
		}
		no return
	}
}

#move File via FTP (copy and delete)
proc moveFTP {win} {
	global selected
	set merk $selected
	copyFTP $win
	set selected $merk
	deleteFTP $win
}

#copyFile from $win via FTP
proc copyFTP {win} {
	global convert debug FTPfilesize FTPask FTP FTPdir FTPdest selected cancel destDir createMirror linktext msgText cancel
	if {$debug>2} {puts "copyFTP: $win"}
	set FTPselect ""
	set window .tile.top.ftp.tile.local.local
	set target remote
	if {$win=="remote"} {
		set window .tile.top.ftp.tile.remote.remote
		set target local
	}
	if {[llength $FTPdir($win)]>0} {
		set FTPselect $selected
	} else {
		dispMSG $msgText(ftp.copy.1)
		setLED orange
		return
	}
	if {[string length $FTPdest($target)]<=0} {
		dispMSG $msgText(ftp.copy.2)
		setLED orange
		return
	}
	set anz [llength $FTPselect]
	if {$anz<=0} {
		dispMSG $msgText(ftp.delete.2)
		setLED orange
		return
	}
	set direction [.tile.bottom.pane.f4.box.lbDirection cget -text]
	if {$FTPask==1} {
		set answer [optionBox -title $msgText(ftp.copy.3) -icon warning -type yesno -message $msgText(ftp.copy.4)]
	} else {
		set answer yes
	}
	switch $answer {
		yes {
			#Set FTPmode binary
			#catch {ftp::Type $FTP($win) "bin"} err
			#catch {ftp::Type $FTP($target) "bin"} err
			set i 1
            catch {stop_anigif .mbar.lbAnim}
			catch {show_anigif [list -data [getAnim penguinL22]] .mbar.lbAnim} err
			update
			foreach datei $FTPselect {
				ProgressBar $i $anz
				if {$cancel==1} {break}
				set datei [lindex $datei 0]
				set merk $datei
				set datei [convertGFX $datei $convert]
				set filesize [lindex $datei 1]
				set linktext "$msgText(ftp.copy.5) $datei"
				set dummy [string trim [lindex [split $datei {/}] end] /]
				set ziel [string trimright $FTPdest($target) /]/[string trimleft $dummy /]
				if {$debug>3} {puts "FTPcopy $datei $dummy $ziel"}
				if {[chkMode $target]=="local" && [chkMode $win]=="local"} {
					catch {file copy -force $datei $ziel}
					if {[.tile.bottom.pane.f4.box.lbDirection cget -relief]=="sunken"} {
						if {![regexp -nocase $destDir $ziel]} {
						#Nur im PipeMode kopieren, wenn $ziel und $destDir nicht gleich
							catch {file copy -force $datei $destDir}
						}
					}
					if {$debug>3} {puts "FTP: fileCopy $datei $ziel"}
				} else {
					#Filesize 4 ProgressFile
					set searchIDX [lsearch -regexp $FTPdir($win) $dummy]
					set filesize [lindex $FTPdir($win) $searchIDX]
					regsub -nocase -all {\(} [lindex [split $filesize { }] 1] {} FTPfilesize($win)
					set searchIDX [lsearch -regexp $FTPdir($target) $dummy]
					set filesize [lindex $FTPdir($target) $searchIDX]
					regsub -nocase -all {\(} [lindex [split $filesize { }] 1] {} FTPfilesize($target)
					#catch {ftp::Type $FTP($win) "bin"} err
					#catch {ftp::Type $FTP($target) "bin"} err
					if {[chkMode $target]=="remote" && [chkMode $win]=="remote"} {
					#Beide Windows = remote (also erst GET, dann PUT)
						set ziel [string trimright $destDir /]/[string trimleft $dummy /]
						ProgressFile 0 $FTPfilesize($win)
						catch {ftp::Get $FTP($win) $dummy $ziel} err
						set ziel [convertGFX $ziel $convert]
						ProgressFile 0 $FTPfilesize($target)
						catch {ftp::Put $FTP($target) $ziel} err
						if {[.tile.bottom.pane.f4.box.lbDirection cget -relief]!="sunken"} {
							#Wenn NICHT PipeMode, lsche lokal DummyFile
							catch {file delete -force $ziel}
						}
					} else {
						#Local 2 Remote
						if {$direction==">>" || $direction==">"} {
							ProgressFile 0 $FTPfilesize($target)
							set ziel [convertGFX $datei $convert]
							catch {ftp::Put $FTP($target) $ziel} err
						} else {
							ProgressFile 0 $FTPfilesize($win)
							#catch {ftp::Cd $FTP($win) $FTPdest($win)} err
							catch {ftp::Get $FTP($win) $dummy $ziel} err
							set ziel [convertGFX $ziel $convert]
						}
					}
					#Pipe-Mode ?
					if {[.tile.bottom.pane.f4.box.lbDirection cget -relief]=="sunken"} {
					#Yes, PipeMode = ON (MirrorFTP)
						if {[regexp -nocase {^/} $datei]} {
							set direx [string trimright $destDir /]/[string trimleft $datei /]
							if {![file isdirectory $direx]} {
								file mkdir $direx
								set destDir $direx
							}
						} else {
						        set ziel [convertGFX $ziel $convert]
							catch {file copy -force $ziel $destDir}
						}
					}
				}
				AddSelected $merk 0
				if {$cancel==1} {
					set cancel 0
					break
				}
				incr i
				#update idletasks
				update
			}
			catch {stop_anigif .mbar.lbAnim}
			refreshFTP $target
			if {[chkMode $target]=="remote"} {
				readRemoteDir $target $FTPdest($target)
			} else {
				readLocalDir $target $FTPdest($target)
			}
			displayTag $target
			ProgressFile 0 0
			ProgressBar 0 0
			set linktext ""
			dispMSG "$msgText(ftp.copy.6) $anz"
			setLED blue
			unselectTags 0
		}
		no return
	}
}

#create Mirror via FTP
proc mirrorFTP {arg} {
	global createMirror selected msgText backColor
	set createMirror 1
	#PipeModeON
	set win .tile.bottom.pane.f4.box.lbDirection
	$win configure -relief sunken -background $backColor
	set dummy [.tile.bottom.pane.f4.box.lbDirection cget -text]
	if {[regexp -nocase {<} $dummy]} {$win configure -text "<" -image imPipeLeft}
	if {[regexp -nocase {>} $dummy]} {$win configure -text ">" -image imPipeRight}

	if {$arg==0} {
	#Whole FTPmirror
		selectALL 0
	} else {
	#selected FTPmirror
	}
	copyFTP [chkFTPactive]
	set createMirror 0
	dispMSG $msgText(ftp.mirror)
	setLED blue
}

#rename file from $win via FTP
proc renameFTP {win} {
	global FTPask FTP FTPdir FTPdest FTPinput selected cancel linktext homeDir msgText cacheLocation cancel
	set FTPselect ""
	set window .tile.top.ftp.tile.local.local
	if {$win=="remote"} {
		set window .tile.top.ftp.tile.remote.remote
	}
	if {[llength $FTPdir($win)]>0} {
		set FTPselect $selected
	} else {
		dispMSG $msgText(ftp.name.1)
		setLED orange
		return
	}
	set anz [llength $FTPselect]
	if {$anz<=0} {
		dispMSG $msgText(ftp.delete.2)
		setLED orange
		return
	}
	set delete [chkFTPactive]
	if {$FTPask==1} {
		set answer [optionBox -title $msgText(ftp.name.2) -icon warning -type yesno -message $msgText(ftp.name.3)]
	} else {
		set answer yes
	}
	switch $answer {
		yes {
			mkCacheDir
			if {$anz==1} {
			##nur 1 Datei manuell Renamen
		#Hier TargetFileName eingeben
				if {[string length $FTPinput]<=0} return
				set datei [lindex $selected 0]
				set dummy [string trim [lindex [split $datei /] 0]]
				set ziel [string trimright $FTPdest($win) /]/[string trimleft $FTPinput /]
				if {[chkMode $win]=="remote"} {
					catch {ftp::Rename $FTP($win) $dummy $FTPinput} err
				} else {
					catch {file rename -force $datei $ziel}
					set cdir [string trim $datei /]
					set cfile [acode encode $cdir]
					set cachedir [string trimright $cacheLocation /]/cache/preview/[getCachedir $cfile]
					#if {![file isdirectory $cachedir]} {file mkdir $cachedir}
					set filename ${cachedir}/${cfile}.FQV
#					set infoname ${cachedir}/${cfile}.FQI
					if {[file exists $filename]} {
					#Wenn DBfiles auch vorhanden, ebenfalls umbenennen
						set newdir [string trim $ziel /]
						set newfile [acode encode $newdir]
						set newcache [string trimright $cacheLocation /]/cache/preview/[getCachedir $newfile]
						set newfile [lindex [split $newfile .] 0]
						set newfilename ${newcache}/${newfile}.FQV
#						set newinfoname ${newcache}/${newfile}.FQI
						catch {file rename -force $filename $newfilename}
#						catch {file rename -force $infoname $newinfoname}
					}
				}
			} else {
			#Mehrere Files automatisch renamen
				set i 1
				foreach datei $FTPselect {
					ProgressBar $i $anz
					if {$cancel==1} {break}
					set linktext "$msgText(ftp.name.4) $datei"
					#set datei [lindex $datei 0]
					set dummy [string trim [lindex [split $datei {/}] end]]
					set dummy [string trim $dummy /]
					#File umbenennen
					if {[string length $FTPinput]<=0} {
						set zielname [lindex [split $dummy .] 0 ]_$i
						set extension [lindex [split $dummy .] end ]
					} else {
						set zielname [lindex [split $FTPinput .] 0 ]_$i
						if {[regexp -nocase {\.} $FTPinput]} {
							set extension [lindex [split $FTPinput .] end ]
						} else {
							set extension [lindex [split $dummy .] end ]
						}
					}
					set target $zielname.$extension
					set ziel [string trimright $FTPdest($win) /]/[string trimleft $target /]
					if {[chkMode $win]=="remote"} {
						catch {ftp::Rename $FTP($win) $dummy $target} err
					} else {
						catch {file rename -force $datei $ziel}
					}
					AddSelected $datei 0
					if {$cancel==1} {
						set cancel 0
						break
					}
					incr i
				}
			}
			refreshFTP $win
			if {[chkMode $win]=="remote"} {
				readRemoteDir $win $FTPdest($win)
			} else {
				readLocalDir $win $FTPdest($win)
			}
			displayTag $win
			set linktext ""
			ProgressBar 0 0
			setLED blue
			dispMSG "$msgText(ftp.name.5) $anz"
		}
		no return
	}
}

#mkdir $win FTP
proc mkdirFTP {win} {
	global FTP FTPdest FTPinput msgText
	if {[string length $FTPinput]<=0} return
	if {[chkMode $win]=="remote"} {
		catch {ftp::MkDir $FTP($win) $FTPinput} err
	} else {
		file mkdir [string trimright $FTPdest($win) /]/[string trimleft $FTPinput /]
	}
	refreshFTP $win
	if {[chkMode $win]=="remote"} {
		readRemoteDir $win $FTPdest($win)
	} else {
		readLocalDir $win $FTPdest($win)
	}
	displayTag $win
	dispMSG $msgText(ftpdir.create)
	setLED blue
}

#read Directory from local HD
proc readLocalDir {win dir} {
	global debug FTPidx FTPhistry FTPdir FTPdest FTPanz FTPsort volumes cancel msgText linktext remSTR
	if {[string length $dir]<=0} return
	update
	set dir [reslvDIR $dir]
#	regsub -nocase -all {ftp://} $dir {} dir
        set dir [regSTR $remSTR $dir 0]
if {[chkKidz $dir]==1} {setLED magenta; .mbar.lbAnim configure -image imStopTux; return}
	if {$debug>2} {puts "readLocalDir: $win $dir"}
	#readDir from Local
	set FTPdir($win) ""
	set FTPdest($win) $dir
	lappend FTPhistry($win) $dir
	#set FTPidx($win) [llength $FTPhistry($win)]
	set dummy [string trimright $dir /]
set localdir [concat $volumes [glob -nocomplain $dummy/* $dummy/.*]]
#puts "localDIR: $localdir"
	set max [llength $localdir]
	set z 0
    set linktext "$msgText(ftp.connect.5) $dir"
	foreach inhalt $localdir {
		ProgressFile $z $max
		if {$cancel==1} {break}
		set inhalt [string trim $inhalt]
                set dummy [lindex [split $inhalt /] end]
		#set perm [file attributes $inhalt -permissions]
		if {[file isdirectory $inhalt] && ![regexp -nocase {.exe} $inhalt]} {
		         if {[regexp -nocase -all {^[a-zA-Z]\:} $inhalt] && [string length $inhalt]==3} {
	                          lappend FTPdir($win) "/[string trim $inhalt /] (Volume)"
	                 } else {
                              lappend FTPdir($win) "/$dummy"
                         }
		} else {
			regsub -nocase {^\.} $dummy {~} dummy
			regsub -nocase -all { } $dummy {%20} dummy
		        if {[regexp -nocase -all {^[a-zA-Z]\:} $inhalt] && [string length $inhalt]==3} {
	                          #lappend FTPdir($win) "$inhalt (???)"
		        } else {
                              set size [file size $inhalt]
                              lappend FTPdir($win) "$dummy ($size bytes)"
	                }
		}
		incr z
	}
	set FTPdir($win) [lsort -dictionary $FTPdir($win)]
	if {$FTPsort==1} {
		set FTPdir($win) [lsort -command compare $FTPdir($win)]
	}
	set dummy [llength $FTPdir($win)]
	if {$dummy<1} {
		set dummy 00
	} else {
		set dummy [expr $dummy - 2]
	}
	set FTPanz($win) [format "%02u" $dummy]
	ProgressFile 0 0
	set linktext ""
	if {$cancel==1} {
		set cancel 0
	}
	setLED blue
}

#readDirectory from FTP
proc readRemoteDir {win dir} {
	global debug active FTPidx FTPhistry FTP FTPdir FTPdest FTPanz FTPsort msgText cancel linktext remSTR
	if {[string length $dir]<=0} return
	if {[regexp -nocase {^/} $dir]} return
	set dir [string trim [reslvDIR $dir]]
#	regsub -nocase -all {ftp://} $dir {} dir
        set dir [regSTR $remSTR $dir 0]
if {[chkKidz $dir]==1} {setLED magenta; .mbar.lbAnim configure -image imStopTux; return}
	if {$debug>2} {puts "readRemoteDir get: $win $dir"}
	set active 1
	#check FTPconnection
	if {[string length $FTP($win)]<=0} {
		openFTP $win $dir
	}
	if {[string length $FTP($win)]<=0} {
		set active 0
		return
	}
    catch {stop_anigif .mbar.lbAnim}
   	catch {show_anigif [list -data [getAnim penguinR22]] .mbar.lbAnim} err
   	update
	#readDir from FTP
	set FTPdir($win) ""
	set FTPdest($win) $dir
	set ftpDir [string trimright $dir /]
	lappend FTPhistry($win) $dir
	#set FTPidx($win) [llength $FTPhistry($win)]
	set dummy [string trim [lindex [split $ftpDir /] end]]
	if {[string length $dummy]<=0} {
		set ftpDir /
	} else {
		set url [string trim [URLsplit [string trimright $ftpDir /]/]]
		set ftpDir /[string trim [lindex $url 2] /]
		set ftpDir [acode recode $ftpDir]
	}
	set linktext "$msgText(ftp.connect.4) $ftpDir"
	update
	if {$debug>3} {puts "FTP: cd $ftpDir"}
	catch {ftp::Cd $FTP($win) $ftpDir} err
	if {$err==0} {
		dispMSG $msgText(ftp.error.1)
		setLED orange
		set linktext ""
		set active 0
		return
	}
	set ftpList [ftp::List $FTP($win) $ftpDir]
	catch {ftp::Type $FTP($win) "bin"} err
	if {$ftpList==""} {
		dispMSG $msgText(ftp.error.2)
		setLED orange
		set linktext ""
		set active 0
		return
	}
	set max [llength $ftpList]
	set z 0
	lappend FTPdir($win) "/."
	lappend FTPdir($win) "/.."
        foreach inhalt $ftpList {
		ProgressFile $z $max
		if {$cancel==1} {break}
		set rc [scan $inhalt "%s %s %s %s %s %s %s %s %s" perm l u g size d1 d2 d3 name]
		if {$rc=="9"} {
			set type [string range $perm 0 0]
	 	    if {$name=="\." || $name=="\.\."} continue
			#$type is (d)irectory, (l)ink, or any other is file
			switch "\\$type" {
					"\\d" {
					   	   lappend FTPdir($win) /$name
			  		}
					"\\-" {

						   lappend FTPdir($win) "$name ($size bytes)"
					}
					"\\l" {
						   lappend FTPdir($win) "~$name ($size bytes)"
					}
					default {
						   lappend FTPdir($win) "$name ($size bytes)"
					}
			}
		}
		incr z
	}
	set FTPdir($win) [lsort -dictionary $FTPdir($win)]
	if {$FTPsort==1} {
		set FTPdir($win) [lsort -command compare $FTPdir($win)]
	}
	set dummy [llength $FTPdir($win)]
	if {$dummy<1} {
		set dummy 00
	} else {
		set dummy [expr $dummy - 2]
	}
	set FTPanz($win) [format "%02u" $dummy]
	#setActive $win
	ProgressFile 0 0
	set linktext ""
	set active 0
	setLED blue
	if {$cancel==1} {
		set cancel 0
	}
	if {$debug>2} {puts "readFTP returns: $FTP($win) remoteDir"}
}

#FTP:displayTags within $win (Tags in Fenster anzeigen)
proc displayTag {win} {
	global homeDir backColor FTPrender debug tagStyle FTPimages imgPrev active anzSEL FTPpreview FTPdest FTPdir normLight mainHTML \
    listColor linktext cancel msgText cacheLocation
	if {$debug>2} {puts "displayTags: $win"}
	set active 1
	dispMSG $msgText(ftp.dir)
	catch {stop_anigif .mbar.lbAnim}
	catch {show_anigif [list -data [getAnim reader22]] .mbar.lbAnim}
	update
	set window .tile.top.ftp.tile.local.local
	if {$win=="remote"} {
		set window .tile.top.ftp.tile.remote.remote
	}
#puts "FTPdir: $FTPdir($win)"
	if {[llength $FTPdir($win)]<=0} {
		set active 0
		catch {stop_anigif .mbar.lbAnim}
		set linktext ""
		dispMSG $msgText(fiq.ready)
		return
	}
	#DisplayRemoteDirs
	set i 1
	set max [llength $FTPdir($win)]
	if {$max<10} {
		set anzSEL [format "%02u" $max]
	} else {
		set anzSEL $max
	}
	.lbAnzSelGfx configure -width [string length $anzSEL]
	set cfile [string trim $FTPdest($win) /]
	set cfile [lindex [split [acode encode $cfile] .] 0]
	mkCacheDir
	set prevdir [string trimright $cacheLocation /]/cache/preview
	set cachedir ${prevdir}/[getCachedir $cfile]
	set filename ${cachedir}/${cfile}.FQV
	#set infoname ${cachedir}/${cfile}.FQI
	if {$debug>3} {puts "file: $filename"}
	set check -1
	set cachelist ""
	if {[file exists $filename]} {
		#lade DirDB
		set imgPrev [openFile $filename]
		set cachelist ""
		foreach {inhalt dummy} $imgPrev {
			lappend cachelist $inhalt
		}
		#Check if CachedDIR == act. Dir
		if {[llength $cachelist] == [llength $FTPdir($win)]} {
		#Wenn DirDB = aktDir dann lade imgDB
		#	set imgPrev [openFile $filename]
			set check 0
		} else {
			#DB-File lschen, falls nicht mehr aktuellem Dir entspricht
			catch {file delete -force $filename}
			set imgPrev ""
		}
	}
	if {$debug>3} {puts "File: $filename"}
	set img 0
	set htmlsrc ""
	set tag ""
	foreach inhalt $FTPdir($win) {
		if {$cancel==1} {break}
		if {[string length $inhalt]<=0} continue
		ProgressBar $i $max
		setLED green
		#set anzSEL [format "%02u" [expr $max - $i]]
		set erg [expr $max - $i]
		wm title . "FIQ: $i/$max ($erg)"
		wm iconname . "FIQ: $i/$max ($erg)"
		if {$erg<10} {
			set anzSEL [format "%02u" $erg]
		} else {
			set anzSEL $erg
		}
		.lbAnzSelGfx configure -width [string length $anzSEL]
		regsub -nocase -all {\n} $inhalt {} datei
		set inhalt [string trim $inhalt]\n
		set dummy [lindex $inhalt 0]
		regsub -nocase -all {%20} $dummy { } dummy
		regsub -nocase -all {%20} $inhalt { } inhalt
		if {$FTPrender==0} {
			if {$check>=0} {
				set img [lsearch -exact $imgPrev $dummy]
				if {$img >= 0} {
					set imgDummy [getImage $FTPdest($win) $dummy $img]
				} else {
					set imgDummy [getImage $FTPdest($win) $dummy -1]
				}
			} else {
				set imgDummy [getImage $FTPdest($win) $dummy -1]
			}
			$window image create $i.0 -image $imgDummy -padx 2
			#ImageNames je FTP-Window merken, um spter lschen zu knnen
			if {[regexp -nocase {image} $imgDummy]} {
				lappend FTPimages($win) $imgDummy
			}
			$window insert $i.1 $inhalt $i
			#ActionBindings on every TextTag (What should happen, if User Clicks on Tag)
			$window tag bind $i <1> [subst "openTag $win $i"]
			$window tag bind $i <3> [subst "selectTag $win $i"]
			#NEU200504: activeSelection
			set link [string trimright $FTPdest($win) /]/[string trimleft [string trimleft $dummy ~] /]
			$window tag bind $i <Any-Enter> "$window tag configure $i $tagStyle(bold); set linktext \"$link\""
			$window tag bind $i <Any-Leave> "$window tag configure $i $tagStyle(normal); set linktext {}"
		} else {
			set link [string trimright $FTPdest($win) /]/[string trimleft [string trimleft $dummy ~] /]
			append htmlsrc "<a href=\"$link\"><img src=\"$link\"/> $inhalt</a><br>\n"
		}
		incr i
	}
	catch {unset imgDummy dummy}
	if {$FTPrender==0} {
		$window mark set insert 0.0
		catch {$window configure -state disabled}
	} else {
		setActive local
		if {[catch {$window parse $htmlsrc} err]} {
			onError $err "DisplayTag: GFX_Parse $inhalt Error: $err"
		}
		createImgLinks $htmlsrc
	}
	set active 0
	setActive $win
	catch {stop_anigif .mbar.lbAnim} err
	ProgressBar 0 0
	setLED blue
	set anzSEL 00
	wm title . "Inquisitor"
	wm iconname . "FIQ"
	.lbAnzSelGfx configure -width [string length $anzSEL]
	set linktext ""
	if {$cancel==1} {
		set cancel 0
	}
	dispMSG $msgText(fiq.ready)
}

#Setzt aktives (zuletzt auferufenes/geklicktes) Fenster (local/remote) auf active
#Wird von "displayTag" (zuletzt geladenes), und "selectTag" (zuletzt geklicktes) Fenster, aufgreufen
proc setActive {win} {
	global activeHTM FTPrender HTMLactive active listColor etryBack normLight fgColor backColor FTPuser FTPpass htmlFG htmlBG
	if {$active==1} return
	set window .tile.top.ftp.tile.local.local
	set input .tile.top.ftp.tile.local.title.etInput
	set wmodel .tile.top.ftp.tile.local.title.lbMode
	set buttonl .tile.top.ftp.tile.local.title.btClrLocal
	set anzFileL .tile.top.ftp.tile.local.title.lbAnzFiles
	set otherw .tile.top.ftp.tile.remote.remote
	set otheri .tile.top.ftp.tile.remote.title.etInput
	set wmoder .tile.top.ftp.tile.remote.title.lbMode
	set buttonr .tile.top.ftp.tile.remote.title.btClrRemote
	set anzFileR .tile.top.ftp.tile.remote.title.lbAnzFiles
	set arw2 .tile.top.ftp.tile.local.frm.rbButton
	set arw .tile.top.ftp.tile.remote.frm.rbButton
	if {$win=="remote"} {
		set window .tile.top.ftp.tile.remote.remote
		set input .tile.top.ftp.tile.remote.title.etInput
		set wmodel .tile.top.ftp.tile.remote.title.lbMode
		set buttonl .tile.top.ftp.tile.remote.title.btClrRemote
		set anzFileL .tile.top.ftp.tile.remote.title.lbAnzFiles
		set otherw .tile.top.ftp.tile.local.local
		set otheri .tile.top.ftp.tile.local.title.etInput
		set wmoder .tile.top.ftp.tile.local.title.lbMode
		set buttonr .tile.top.ftp.tile.local.title.btClrLocal
		set anzFileR .tile.top.ftp.tile.local.title.lbAnzFiles
		set arw .tile.top.ftp.tile.local.frm.rbButton
		set arw2 .tile.top.ftp.tile.remote.frm.rbButton

	}
	.tile.bottom.pane.f4.box.etUser configure -textvariable FTPuser($win)
	.tile.bottom.pane.f4.box.etPass configure -textvariable FTPpass($win)
	#Set ActiveWindow
	if {[$window cget -relief]=="sunken"} {
		$window configure -relief raised
		$input configure -background $normLight -foreground $fgColor -relief ridge
		$otherw configure -relief sunken
		$otheri configure -background $backColor -foreground $htmlFG -relief groove
		$wmodel configure -foreground $fgColor -background $backColor -relief ridge
		$wmoder configure -foreground $htmlFG -background $backColor -relief groove
		$buttonl configure -relief raised -background $backColor
		$buttonr configure -relief groove -background $backColor
		$anzFileL configure -foreground $fgColor -background $backColor
		$anzFileR configure -foreground $etryBack -background $backColor
		if {$FTPrender==0} {
			$arw2 configure -background green -relief sunken
			$arw configure -background $backColor -relief ridge
		}
		set arrow .tile.bottom.pane.f4.box.lbDirection
		if {$win=="local"} {
			unselectTags 2
			if {[$arrow cget -relief]=="sunken"} {
				$arrow configure -text ">>" -image imPipeRight
			} else {
				$arrow configure -text ">>" -image imForw
			}
		} else {
			unselectTags 1
			if {[$arrow cget -relief]=="sunken"} {
				$arrow configure -text "<<" -image imPipeLeft
			} else {
				$arrow configure -text "<<" -image imBack
			}
		}
		focus $input
	}
	#update idletasks
	update
}

#Opens one FTP-Window (left/right) to full Screen
proc wideFTP {wert} {
	global FTPrender
	if {[string length $wert]<=0 || $FTPrender>0} return
	set win .tile.top.ftp.tile
	set x [winfo width .]
	if {$wert==1} {
		if {[lindex [$win sash coord 0] 0]==1} {
			$win sash dragto 0 $x 1
			$win sash place 0 $x 1
		} else {
			$win sash dragto 0 1 1
			$win sash place 0 1 1
		}
	} else {
		if {[lindex [$win sash coord 0] 0]==1} {
			$win sash dragto 0 1 1
			$win sash place 0 1 1
		} else {
			$win sash dragto 0 $x 1
			$win sash place 0 $x 1
		}
	}
}

#prft welches (links/rechts) das aktive Fenster ist, Rckgabe = local/remote
proc chkFTPactive {} {
	if {![winfo exists .tile.top.ftp.tile.local.local]} return
	set back remote
	set test [.tile.top.ftp.tile.local.local cget -relief]
	if {$test=="raised"} {
		set back local
	}
	return $back
}

#prft Modus (local/FTP) des Fensters $win (links/rechts)
proc chkMode {win} {
	if {![winfo exists .tile.top.ftp.tile.local.title.lbMode]} return
	set mode [.tile.top.ftp.tile.local.title.lbMode cget -text]
	if {$win=="remote"} {
		set mode [.tile.top.ftp.tile.remote.title.lbMode cget -text]
	}
	set back local
	if {$mode=="Remote:"} {
		set back remote
	}
	return $back
}

#Lscht ausgewhlte Tags in beiden FTP-Fenstern, wenn CLRselected geklickt wird
#wird von "clearSelected" aufgerufen
proc unselectTags {win} {
	global FTPrender FTPdir FTPfont fontsize listColor anzSEL selected cancel
	if {[string length $win]<=0} {set win 0}
	if {$FTPrender==0} {
		if {$win==0 || $win==1} {
			set tag 0
			foreach dummy $FTPdir(local) {
				if {$cancel==1} {break}
				.tile.top.ftp.tile.local.local tag configure $tag -foreground white -background $listColor -relief flat -font "\"gothic i\" $FTPfont($fontsize)"
				incr tag
			}
		}
		if {$win==0 || $win==2} {
			set tag 0
			foreach dummy $FTPdir(remote) {
				if {$cancel==1} {break}
				.tile.top.ftp.tile.remote.remote tag configure $tag -foreground white -background $listColor -relief flat -font "\"gothic i\" $FTPfont($fontsize)"
				incr tag
			}
		}
	}
	set selected ""
	set anzSEL 00
	.lbAnzSelGfx configure -width [string length $anzSEL]
}

#Markiert ausgewhlten (geklickten) Tag (Zeile) in $win (local/remote) im FTPmode
proc selectTag {win tag} {
	global debug FTPfont fontsize FTPdest FTPdir etryBack listColor normLight fgColor backColor linkmark
	setActive $win
	set dtag [expr $tag - 1]
	set dummy [lindex $FTPdir($win) $dtag]
	set inhalt [lindex [split $dummy { }] 0]
	set inhalt [string trimright $FTPdest($win) /]/[string trimleft $inhalt /]
	if {$debug>4} {puts "$win $inhalt $tag"}
# Warum muss linkmark hier gesetzt werden ???????????????
	set linkmark 1
	AddSelected $inhalt 0
	set window .tile.top.ftp.tile.local.local
	if {$win=="remote"} {
		set window .tile.top.ftp.tile.remote.remote
	}
	#preSelected $inhalt
	if {[$window tag cget $tag -foreground]==$etryBack} {
		$window tag configure $tag -foreground white -font "\"gothic i\" $FTPfont($fontsize)"
	} else {
		$window tag configure $tag -foreground $etryBack -font "\"gothic i\" $FTPfont($fontsize) bold"
	}
}

#ffnet ein durch LinksKlick geffnetes Verzeichis (bzw. zeigt dies an)
proc openTag {win tag} {
	global pipe debug active FTP FTPfilesize FTPidx FTPhistry FTPdir FTPdest FTPanz FTPhome urltext mainHTML MapMode \
	       playAnim playSounds onceSounds activeHTM homeDir snd msgText cacheLocation GIFdelay winSYS
	if {$debug>2} {puts "openTag: $win $tag"}
	if {$active==1} return
	setActive $win
	clearSelected
	#Liste zhlt von 0; TextWidget von 1 (also ausgleichen)
	set dummy [expr $tag - 1]
	set datei [string trim [lindex [split [lindex $FTPdir($win) $dummy] (] 0]]
	regsub -nocase -all {\n} $datei {} datei
	if {$FTPdest($win)==$datei} return
	MouseCurs 1
	if {[regexp -nocase {^/} $datei]} {
	#Directory geklickt
                dispMSG $msgText(ftp.dir)
		switch -regexp $datei {
			{^/\.\.} {
				set dummy [string trimright $FTPdest($win) /]/[string trim $datei /]/
			}
			{^/\.} {
				set dummy $FTPhome($win)
			}
			{^/[a-zA-Z]:} {
                                set dummy [string trim $datei /]/
			}
                        default {
				set dummy [string trimright $FTPdest($win) /]/[string trim $datei /]/
			}
		}
		set FTPdest($win) $dummy
		refreshFTP $win
		#Modus (local/FTP) des aktiven Windows auslesen
		if {[chkMode $win]=="local"} {
			readLocalDir $win $FTPdest($win)
		} else {
			readRemoteDir $win $FTPdest($win)
		}
		displayTag $win
		set FTPidx($win) [expr [llength $FTPhistry($win)] - 1]
	} else {
	#File geklickt
                #NEU250704: nonLocalFile
                set window .tile.top.ftp.tile.local.title.lbMode
	        if {$win=="remote"} {
		        set window .tile.top.ftp.tile.remote.title.lbMode
          	}
          	set dummy [$window cget -text]
                if {[regexp -nocase -all "remote" $dummy]} {
                #NEU250704: if FTPfile doesn't exists local get it into cache (like getFileURL)
                        mkCacheDir
                        set dummy [string trim $FTPdest($win) /]/[string trim $datei /]
			set chart [getCachedir $dummy]
                        set fakedest [lindex [split $dummy /] end]
                        #regsub -nocase -all {/} $dummy {#} fake
			set fake [acode encode $dummy]
                        set dest [string trim [string trimright $cacheLocation /]/cache/html/$chart /]
                        set ziel [string trim $dest/$fake]
                        if {[file exists $ziel]} {
                                  set datei $fakedest
                        } else {
                                  #File doesn't exists in local Cache
                                  ProgressFile 0 $FTPfilesize($win)
                                  if {![file isdirectory $dest]} {
                                          file mkdir $dest
                                  }
                                  catch {ftp::Get $FTP($win) $datei $ziel} err
                                  set datei $fakedest
                        }
                }
	        #NEU250704end
        	set ext [transType .[string trim [getEXT $datei] .]]
		if {[chkIMG $ext] || [chkEXT $ext] || ([chkTXT $ext] && ![regexp -nocase {pdf|ps} $ext])} {
		#Wenn geklickte Datei Image is
			if {$pipe==1} {
				#Display Image within 2nd FTPwin
				if {[chkIMG $ext]} {
					#Ggf. FTPwin durch HTMLwin ersetzen (wegen Zoom + Scroll) !!!!!!!!!
					set title .tile.top.ftp.tile.local.title.lbMode
					set window .tile.top.ftp.tile.local.local
					set dest local
					if {$win=="local"} {
						set title .tile.top.ftp.tile.remote.title.lbMode
						set window .tile.top.ftp.tile.remote.remote
						set dest remote
					}
					set dummy /[string trim $FTPdest($win) /]/[string trim $datei /]
					#set imgDummy [getImage $FTPdest($win) $dummy 3]
					refreshFTP $dest
					$title configure -text $msgText(ftp.preview) -relief sunken -image imFTbackground -compound left
					catch {image create photo -file $dummy} dummyIMG
					#$window insert 1.0 "Preview\n" 1
					$window image create 0.0 -image $dummyIMG -padx 1 -pady 1
					MouseCurs 0
					dispMSG $msgText(fiq.ready)
					#image delete $FTPimages($dest)
					unset dummyIMG
				} else {
				    MouseCurs 0
					ChangeMode 3
					setHTMLactive $activeHTM 0
					set urltext /[string trim $FTPdest($win) /]/[string trim $datei /]
#					LoadFile $urltext
					preSolve
				}
			} else {
				MouseCurs 0
				ChangeMode 3
				setHTMLactive $activeHTM 0
				set urltext /[string trim $FTPdest($win) /]/[string trim $datei /]
#				LoadFile $urltext
				preSolve
			}
		} elseif {[chkSND $ext] && $playSounds==1} {
                catch {stop_anigif .mbar.lbAnim}
                .mbar.lbAnim configure -image imTuxmeter
           		catch {snd stop; s stop}
           		s record
           		after $GIFdelay tuxOmeter
				snd config -file /[string trim $FTPdest($win) /]/[string trim $datei /] -skip 0
# 		        catch {show_anigif [list -data [getAnim faller22]] .mbar.lbAnim} err
			if {$onceSounds==1} {
				snd play -start 0 -block 1 -command {catch {snd stop; s stop; .mbar.lbAnim configure -image imAnim}} -blocking false
				# -command {after 1000 exit}
			} else {
				snd play -start 0 -block 0 -command {catch {snd stop; s stop; .mbar.lbAnim configure -image imAnim}} -blocking false
				#s play -block 0 -command {after 1000 exit}
			}
        } elseif {[chkARC $ext]} {
		#elseif ZIPfiles
				set help 0
				if {[regexp -nocase {ZIP} $ext]} {
                    if {$winSYS==1} {
						set datei "[string trim $FTPdest($win) /]/[string trim $datei /]"
						if {[file exists $datei]} {
							set dir [string trimright [cutEXT $datei] /]
							if {![file isdirectory $dir]} {file mkdir $dir}
							catch "zip open $datei" zHandle
							catch "zip files $zHandle" files
							set max [llength $files]
							if {$max<=0 || $zHandle==""} {
	   						   dispMSG $msgText(ftp.unzip.error)
							   MouseCurs 0
							   catch "zip close $zHandle"
							   return
				   			}
							set z 0
							dispMSG $msgText(ftp.unzip)
							foreach inhalt $files {
								ProgressFile $z $max
								catch "zip set $zHandle $inhalt"
								catch "zip read $zHandle" content
   								writeFile $dir/$inhalt $content
   								incr z
							}
							catch "zip close $zHandle"
							set FTPdest($win) $dir
							set help 1
						}
					}
				} elseif {[regexp -nocase {GZ} $ext] && ![regexp -nocase {TGZ} $ext]} {
					dispMSG $msgText(ftp.unzip)
				  	unzip "/[string trim $FTPdest($win) /]/[string trim $datei /]"
				  	set help 1
				}
				if {$help>0} {
					refreshFTP $win
					#Modus (local/FTP) des aktiven Windows auslesen
					if {[chkMode $win]=="local"} {
						readLocalDir $win $FTPdest($win)
					} else {
						readRemoteDir $win $FTPdest($win)
					}
					displayTag $win
				}
		} else {
			#All the rest (Movie, PDF, etc.)
			MouseCurs 0
			ChangeMode 3
			setHTMLactive $activeHTM 0
			set urltext /[string trim $FTPdest($win) /]/[string trim $datei /]
#			LoadFile $urltext
			preSolve
		}
	}
	MouseCurs 0
	dispMSG $msgText(fiq.ready)
	#update idletasks
	update
}

#Baut Fenster (local/Remote) auf (bzw. erzeugt diese)
proc refreshFTP {win} {
	global FTPrender debug FTPfont fontsize FTPimages FTPdir normLight listColor fgColor linkmark cancel
	if {$debug>2} {puts "refreshFTP get: $win"}
	set window .tile.top.ftp.tile.local.local
	set w 1
	set side left
	if {$win=="remote"} {
		set window .tile.top.ftp.tile.remote.remote
		set w 2
		set side right
	}
	#CreateListBox (left/right , local/remote)
	if {$FTPrender==0} {
		if {[winfo exists $window]} {
			destroy $window
			if {[info exists FTPimages($win)]} {
				if {$debug>3} {puts "FTPimages $win: $FTPimages($win)"}
				set i 0
				foreach inhalt $FTPimages($win) {
				if {$cancel==1} {break}
				if {$debug>3} {puts "ClearImage: $inhalt"}
					#if {$i<2} continue
					catch {image delete $inhalt}
					incr i
				}
				catch {unset FTPimages}
			}
			set FTPimages($win) ""
			if {$debug>5} {puts "Images: [image names]"}
		}
		if {$debug>4} {puts "FontSize: $FTPfont($fontsize)"}
#Set FTPwindow(s) size (sash-Pannels), regarding Fontsize H29 W46
		text $window -cursor {} -wrap none -relief sunken \
			-xscrollcommand [subst ".tile.top.ftp.tile.$win.frm.xscroll set"] \
			-yscrollcommand [subst ".tile.top.ftp.tile.$win.yscroll set"] \
			-foreground white -background $listColor -selectbackground $normLight -selectforeground $fgColor \
			-selectbackground $listColor -selectforeground white -selectborderwidth 0 \
			-height 29 -width 46 \
			-font "\"gothic i\" $FTPfont($fontsize)"
		pack $window -in .tile.top.ftp.tile.$win -side $side -fill both -expand true
	} else {
		if {![winfo exists $window]} {
			regsub -nocase {^.} $window {} window
			set dummy [lindex [split $window .] end]
			regsub -nocase .$dummy $window {} window
			createHTML $window $win 1 2
			.$window.$win configure -foreground white -background $listColor -relief sunken
			pack .$window.$win -in .tile.top.ftp.tile.$win -side $side -fill both -expand true
			#bind HtmlClip <Motion> {colorize .$window.$win %x %y}
			#bind HtmlClip <Motion> {colorize %W %x %y}
		} else {
			$window clear
		}
		set linkmark 1
	}
	set FTPdir($win) ""
}

#currently unused !
proc clearFTP {win} {
	global FTPdir FTPrender
	set window .tile.top.ftp.tile.local.local
	if {$win=="remote"} {
		set window .tile.top.ftp.tile.remote.remote
	}
	if {[llength $FTPdir($win)]<=0} return
	if {$FTPrender==0} {
		$window delete 1.0 end
	} else {
		$window clear
	}
}

#FTPmessages (DebugMode)
proc ftp::DisplayMsg {s msg {state normal}} {
	global FTPstatus FTPdebug
	switch $state {
		data    {if {$FTPdebug==2} {puts $msg} else {return}}
		control {if {$FTPdebug>=1} {puts $msg} else {return}}
		normal  {if {$FTPdebug>=1} {puts $msg} else {return}}
		error   {if {$FTPdebug>=1} {puts $msg} else {return}}
	}
}

#FTP:fileType $datei ermittelt anzuzeigendes Image je Dateiendung
proc getImage {dir datei index} {
	global homeDir debug imgSize linktext FTPpreview prevSize thumbSize divZoom imgPrev msgText cacheLocation
	if {$debug>4} {puts "getImage: $dir $datei $index"}
	mkCacheDir
	if {$FTPpreview==0} {
		dispMSG $msgText(ftp.dir)
		set back [fileType $datei]
	} else {
		set ext [getEXT $datei]
		if {[chkIMG $ext] && [regexp -nocase {\.} $datei]} {
			set filename [string trimright $dir /]/[string trimleft $datei /]
			set merkfile $filename
			if {[file exists $filename]} {
				#Image aus DB nehmen, oder createn
				if {$index==-1} {
				#DirTabelle stimmt nicht mit akt. Dir, oder exitiert nicht, also Image createn
					dispMSG $msgText(ftp.preview.create.1)
					set size $prevSize
					set dfile [lindex [split $datei .] 0].jpg
					set such [string trimright $dir /]/thumbs/[string trimleft $dfile /]
					if {[file exists $such]} {
					#Falls Dir "thumbs" (BildGalerie) vorhanden, nimm Pics daraus (geht schneller)
						set filename $such
						if {$divZoom==1} {
							set size 1
							#set imgSize 1
							switch $thumbSize {
								1 {set imgSize 2}
								2 {set imgSize 1}
								3 {set imgSize 0}
							}
						} else {
							set size $thumbSize
							set imgSize 2
						}
					} else {
						set such [string trimright $dir /]/\.xvpics/[string trimleft $datei /]
						#Lese .xvpics wenn possible
						if {[file exists $such]} {
							set filename $such
						}
					}
					set linktext "$msgText(ftp.preview.create.2) $filename"
					set back [image create photo]
catch {image create photo -format {jpeg -fast} -file $filename} imDummy
#catch {image create photo -file $filename} imDummy
#set imDummy [image create photo -format {jpeg -fast -grayscale} -file $filename]
#set imDummy imFTunknown
#puts "IMAGE: $imDummy"
					if {[string length $imDummy]<=0} {
						#Wenn Image nicht erstellt werden konnte (FileType unknown)
						set back imFTunknown
					} else {
#set back [resizeIMG $imDummy 80 80]
						if {[catch {::$back copy $imDummy -subsample $size -shrink}]!=0} {
								set back imFTunknown
							}
					}
					catch {image delete $imDummy}
					unset imDummy
				} else {
				#Image aus DB-File lesen
					dispMSG $msgText(ftp.preview.dir)
					set back [image create photo -data [lindex $imgPrev [expr $index + 1]] -format jpeg]
#					set back [image create photo -fast -data [lindex $imgPrev [expr $index + 1]] -format jpeg]
				}
			} else {
			#File existiert nicht, also FTP
				dispMSG $msgText(ftp.dir)
				set back [fileType $datei]
			}
		} else {
			dispMSG $msgText(ftp.dir)
			set back [fileType $datei]
		}
	}
	if {$index==-1} {
	#DBs schreiben
		set cdir [string trim $dir /]
		set cfile [acode encode $cdir]
		set prevdir [string trimright $cacheLocation /]/cache/preview
		set cachedir ${prevdir}/[getCachedir $cfile]
		if {![file isdirectory $cachedir]} {file mkdir $cachedir}
		set filename ${cachedir}/${cfile}.FQV
		#ImageDB-File
		if {![catch {open $filename a} write]} {
			puts $write "$datei [list [$back data -format jpeg]]"
			close $write
		}
	}
	update
	#NEU310504: Images heller machen, wenn "hidden" (geht nich)
	set dummy [string trimleft $datei /]
	if {[regexp -nocase {$~} $dummy]} {
		::$back configure -gamma 3
	}
	#Image dunkler, wenn fhrende Tilde
	if {[regexp -nocase {^~} $dummy]} {
		::$back configure -gamma 0.6
	}
	#Zoom Preview
	if {$FTPpreview==1} {
		if {![regexp -nocase {^/\.} $datei]} {
			if {$imgSize>2} {
				set imgX [expr int ([image width $back]*2)]
				set imgY [expr int ([image height $back]*2)]
				::dummyIMG copy $back
				::$back configure -width $imgX -height $imgY
				::$back copy dummyIMG -zoom 2
				::dummyIMG blank
			}
			if {$imgSize<2} {
				set imgX [expr int ([image width $back]/2)]
				set imgY [expr int ([image height $back]/2)]
				::dummyIMG copy $back
				::$back configure -width $imgX -height $imgY
				::$back copy dummyIMG -subsample 2
				::dummyIMG blank
			}
		}
		update
	}
	return $back
}

#simple TextEditor in FTPmode
proc EditText {} {
	global FTPedit FTPdir FTPdest selected msgText appText sysFont backColor
	#NEW220505: TextEditor (experimental !!!)
	set window .tile.top.ftp.tile.remote.remote
	set win [chkFTPactive]
	if {$win=="remote"} {
		set window .tile.top.ftp.tile.local.local
		set win "local"
	} else {
		set win "remote"
	}
	if {$FTPedit==0} {
		set FTPedit 1
		set FTPselect $selected
		set anz [llength $FTPselect]
		if {$anz<=0} {
			set FTPedit 0
			dispMSG $msgText(ftp.edit.1)
			setLED orange
			return
		}
		set datei [lindex $FTPselect 0]
		set ext [getEXT $datei]
			#Nur Dateien NICHT vom Typ IMG, ANI, SND, ARC, etc. zum Editieren zulassen
			if {![chkIMG $ext] && ![chkAPP $ext] && ![chkANI $ext] && ![chkSND $ext] && ![chkARC $ext]} {
				.tile.bottom.pane.f4.box.btEdit configure -text $appText(.tile.bottom.pane.f4.box.btEdit.2)
				.tile.top.ftp.tile.${win}.title.lbMode configure -text "Edit:" -relief groove -cursor hand2 -image imEdit -compound left -font $sysFont(4) -background $backColor
				activateFTP $win
				set FTPdest($win) $datei
				set edittext [ReadFile $datei]
				refreshFTP $win
				set i 0
				$window insert 0.0 $edittext
				#$window mark set insert 0.0
				catch {$window configure -state enabled -relief sunken -setgrid 1 -undo 1 -autosep 1}
			} else {
				set FTPedit 0
				dispMSG $msgText(ftp.edit.2)
				setLED orange
			}
	} else {
		set edittext [$window get 0.0 end]
		#Save File
		if {![catch {open $FTPdest($win) "w"} fileid]} {
			puts $fileid $edittext
			close $fileid
		}
		closeFTP
	}
}

#Activate one FTPwindow
proc activateFTP {win} {
	global FTPedit
	set turn "local"
	if {$win=="local"} {
		set turn "remote"
	}
	if {$FTPedit==1} {
		bind .tile.top.ftp.tile.${win}.title.lbMode <1> {}
		bind .tile.top.ftp.tile.${win}.frm.rbButton <1> {}
		bind .tile.top.ftp.tile.${win}.frm.rbButton <3> {}
		foreach inhalt [winfo children .tile.bottom.pane.f4.box] {
			if {![grep {screw prgBar lb btEdit btClose} $inhalt]} {
				$inhalt configure -state disabled
			}
		}
	} else {
		bind .tile.top.ftp.tile.${win}.title.lbMode <1> {changeFTPmode local}
		bind .tile.top.ftp.tile.${win}.frm.rbButton <1> {wideFTP 1; setActive $turn}
		bind .tile.top.ftp.tile.${win}.frm.rbButton <3> {setActive $turn}
		foreach inhalt [winfo children .tile.bottom.pane.f4.box] {
			if {![grep {screw prgBar lb btEdit btClose} $inhalt]} {
				$inhalt configure -state normal
			}
		}
	}
}
