package provide FIQHLP 1.0
#Help-Texte f&uuml;r Frenzy's Inquisitor
#(C) 2004 by: Frenzy Softworks
#Written by: Jens Timmermann

#NEW300105: ReadLanguageText for Inquisitor
proc readAppText {} {
        global homeDir appText msgText language
        set listText [openFile $homeDir/SYSTEM/FIQGUI.FQL]
        foreach inhalt $listText {
                set appText([lindex $inhalt 0]) [lindex $inhalt $language]
        }
        set listMsg [openFile $homeDir/SYSTEM/FIQMSG.FQL]
        foreach inhalt $listMsg {
                set msgText([lindex $inhalt 0]) [lindex $inhalt $language]
        }
        unset inhalt listText listMsg
}

#NEW301004: BubbleHelp for TopMenuBar
proc bubbleHelp {} {
	global homeDir winSYS language
        set bubbleMenu [openFile $homeDir/SYSTEM/FIQTIP.FQL]
        label .l -textvariable varinfo
        pack .l
        # associate all entries of menu .mbar to variable varinfo
        DynamicHelp::add .mbar menu varinfo
        foreach inhalt $bubbleMenu {
#puts "BUBBLE: $inhalt"
             DynamicHelp::add [lindex $inhalt 0] -text [lindex $inhalt $language]
        }
        unset bubbleMenu inhalt
}

#FCI (Frenzy's CommandInterpreter) Help
proc helpCMD {args} {
     #set cmd [string toupper [lindex $args 0]]
     set param [string toupper [string trim [join $args]]]
     set helpList {ADD ANI ARY CAL CDR CLR CLS COM DIR DOM DSP ERR EXT HLP HOM HST IFO KIL LIB LST MOD MSG OPN OUT PTH PRG PRO QIT RMT SET SRC STP SUB TRC VAR VER}
     set back "Commands: $helpList"
     if {$param != ""} {
                switch $param {
                       ADD {set back "ADD var : Add 1 to Variable (var)"}
                       ALL {set out ""; foreach inhalt $helpList {append out "[helpCMD $inhalt]\n"}; set back $out}
                       ANI {set back "ANI val : Animation 0=off / >0=AnimationDelay"}
                       ARY {set back "ARY (pattern) : Display Array (pattern)"}
                       CAL {set back "CAL cmd (arg1) (arg2) ... : Call Command (cmd) with (arg1) (arg2) ..."}
                       CDR {set back "CDR path : Change Directory (path)"}
                       CLR {set back "CLR : Clear HTML Screens"}
                       CLS {set back "CLS : Clear Output Buffer"}
                       COM {set back "COM (pattern) : Display Procedures (pattern)"}
                       CUT {set back "CUT : Cut URL with redirection"}
                       DCD {set back "DCD : Decode encoded URL"}
                       DIR {set back "DIR : Display Directory"}
                       DSP {set back "DSP var : Display content of Variable (var)"}
                       DOM {set back "DOM : Delete actual Domain from Cache"}
                       ERR {set back "ERR : Display last Error"}
                       END {set back "END : Leave Inquisitor without cleaning"}
                       EXT {set back "EXT : Exit FCI (Frenzy's Command Interpreter)"}
                       FCI {set back "FCI = Frenzy's Command Interpreter (TM)"}
                       KIL {set back "KIL : Kill Inquisitor anyway"}
                       LIB {set back "LIB : Position of Inquisitor Libraries"}
                       LST {set back "LST list arg : Append (arg) to List (list)"}
                       HLP {set back "HLP (arg) / (ALL) : Help on Command (arg) or (ALL) Commands"}
                       HOM {set back "HOM : Display Home Directory"}
                       HST {set back "HST : Display Hostname"}
                       IFO {set back "IFO var : Do Variable (var) exists ?"}
                       MOD {set back "MOD arg : Change Mode to (arg)"}
                       MSG {set back "MSG arg : Display Message (arg)"}
                       OPN {set back "OPN arg : Open and Display File or Page (arg)"}
                       OUT {set back "OUT : Move Output Buffer to HTML-Screen"}
                       PTH {set back "PTH : Display Package Path"}
                       PRG {set back "PRG (pattern) : Display Procedure(s) (pattern)"}
                       PRO {set back "PRO procedure : Display Arguments of (procedure)"}
                       QIT {set back "QIT : Quit Inquisitor"}
                       RMT {set back "RMT var : Remove previous Variable Trace (var)"}
                       SET {set back "SET var arg2 : SET Variable (var) with (arg2)"}
                       SRC {set back "SRC procedure : Display Source of (procedure)"}
                       STP {set back "STP : Stop all actions"}
                       SUB {set back "SUB var : Decrease 1 from Variable (var)"}
                       TRC {set back "TRC var : Set Trace on Variable (var)"}
                       VAR {set back "VAR (pattern) : Display Variables Info of (pattern)"}
                       VER {set back "VER : Display OS Information"}
                       default {set back "Unknown Comand: $param"}
                }
     }
     return $back
}

#Menu-Meldungen
proc QSaskActivate {args} {
	global quickSave msgText
	switch $quickSave {
		0 {
			dispMSG $msgText(quick.save.1)
		}
		1 {
			dispMSG $msgText(quick.save.2)
		}
	}
}

#activates KidZmode
proc KidZmodeActivate {args} {
        global kidZprotect msgText ignoreReDir
	switch $kidZprotect {
		0 {
			dispMSG $msgText(kid.mode.1)
                        if {$ignoreReDir==0} {
                                 .mbar.lbAnim configure -image imAnim
                        } else {
                                 .mbar.lbAnim configure -image imTuxInfiltrate
                        }
		}
		1 {
			dispMSG $msgText(kid.mode.2)
			.mbar.lbAnim configure -image imKidTux
		}
	}
}

#called when FICS (TM) was activated
proc FicsActivate {args} {
	global fics msgText
	switch $fics {
		0 {
			dispMSG $msgText(fics.mode.1)
		}
		1 {
			dispMSG $msgText(fics.mode.2)
		}
	}
}

#Called when RenderMode was activated
proc renderActivate {args} {
	global renderIMG msgText
	switch $renderIMG {
		0 {
			dispMSG $msgText(render.html.1)
		}
		1 {
			dispMSG $msgText(render.html.2)
		}
	}
}

#About-Menu
proc HELPabout {} {
#HelpMenu/Tux: Display "About Inquisitor"
	global version animReader sysFont urltext language
	catch {stop_anigif .mbar.lbAnim} err
#	catch {show_anigif [list -data [getAnim water22]] .mbar.lbAnim} err
	switch $language {
		1 {
			#Language = english
			set mtext "$version \n -The Darker Age of Internet- \n (C) 2007 by: Frenzy Softworks \n Written by: Jens Timmermann\n(eMail: frenzy7@freenet.de)\n\n\n\n \
			Use this Freeware as it is, \n on your own risk. \n The Author is not responsible \n for any damage that may occur \n by using this Software !"
		}
		2 {
			#Language = deutsch
			set mtext "$version \n -The Darker Age of Internet- \n (C) 2007 by: Frenzy Softworks \n Written by: Jens Timmermann\n(eMail: frenzy7@freenet.de)\n\n\n\n \
			Benutzung dieser Freeware wie sie ist, \n und auf eigene Gefahr. \n Der Autor ist nicht verantwortlich \n fr mgliche Schden, \
			die durch \n Benutzung dieser Software \n entstehen knnten !"
		}
	}

#NEW090705: own MessageBox instead of tk_messagesbox cause tk had wrong colors
#	tk_messageBox -title $version -icon info -type ok -message $mtext
optionBox -title $version -icon info -type okhome -message $mtext -image imStartFIQ
	unset mtext
	catch {stop_anigif .mbar.lbAnim} err
}

#General Information from HELP-Menu
proc HELPgeneral {} {
   global mainHTML htmlBG language homeDir urltext
    clearPage
	switch $language {
		1 {
			#Language = english
                        set helpfile [string trimright $homeDir /]/help/ENG/InfoENG1.html
                        if {[file exists $helpfile]} {
                                LoadPage $helpfile
                        } else {
                                set urltext "http://inquisitor.sourceforge.net/help/ENG/InfoENG1.html"
                                goEnter
                        }
		}
		2 {
			#Language = german
                        set helpfile [string trimright $homeDir /]/help/GER/InfoGER1.html
                        if {[file exists $helpfile]} {
                                LoadPage $helpfile
                        } else {
                                set urltext "http://inquisitor.sourceforge.net/help/GER/InfoGER1.html"
                                goEnter
                        }
		}
	}
}

#Help-Information from HELP-Menu
proc HELPinhalt {} {
    global mainHTML htmlBG language homeDir urltext
    clearPage
	switch $language {
		1 {
			#Language = english
                        set helpfile [string trimright $homeDir /]/help/ENG/HelpENG1.html
                        if {[file exists $helpfile]} {
                                LoadPage $helpfile
                        } else {
                                set urltext "http://inquisitor.sourceforge.net/help/ENG/HelpENG1.html"
                                goEnter
                        }
		}
		2 {
			#Language = german
                        set helpfile [string trimright $homeDir /]/help/GER/HelpGER1.html
                        if {[file exists $helpfile]} {
                                LoadPage $helpfile
                        } else {
                                set urltext "http://inquisitor.sourceforge.net/help/GER/HelpGER1.html"
                                goEnter
                        }
		}
	}
}

#show HELP-News
proc HELPnews {} {
   global mainHTML htmlBG language homeDir urltext
    clearPage
    #Clear
	switch $language {
		1 {
			#Language = english
                        set urltext "http://inquisitor.sourceforge.net/help/ENG/NewsENG1.html"
		}
		2 {
			#Language = german
                        set urltext "http://inquisitor.sourceforge.net/help/GER/NewsGER1.html"
		}
	}
     goEnter
}

#Little (hidden) Joke
proc goofBox {} {
        global ANIdelay fics BookMarks
        if {$fics != 1} {dispMSG "'GOD' Mode not enabled !"; return}
        dispMSG "Inquisitor 'GOD' Mode enabled !"
        set merk $ANIdelay
        set ANIdelay 30
       	set w .goofbox
	toplevel $w
	wm title $w "Fatal Error !"
	wm iconname $w "Fatal Error !"
	wm protocol $w WM_DELETE_WINDOW {set ANIdelay 140; catch {snd stop; snd flush}; catch {stop_anigif .goofbox.lbAnim}; destroy .goofbox}
	wm geometry $w +240+240
	label $w.lbAnim
	pack $w.lbAnim -fill both
        catch {file join $starkit::topdir itchy4.wav} wav
        catch {show_anigif [list -data [getAnim goofANI]] $w.lbAnim}
        if {[file exists $wav]} {
               snd config -load $wav
               snd play -start 0 -block 1 -command {catch {snd stop; snd flush}} -blocking false
        }
#        catch {show_anigif [list -data [getAnim goofANI]] $w.lbAnim}
        after 9400 {
              if {[winfo exists .goofbox.lbAnim]} {
                         catch {stop_anigif .goofbox.lbAnim}
                         .goofbox.lbAnim configure -background darkblue -foreground white -image imWinLogo -compound top -font "clean 9" \
                         -text " Microflop Wingoofs \n\n An unknown (?!) invalid Exeption is occured \n in Memory Segmentation Fault: C0000007 ?\n\n Press 'OK' to Destroy your Operating-System !\n\n\n\n (And whatever you want to install Linux instead)\n\n\n\n Oops; where's the 'OK' Button ?!\n"
              }
        }
}

#Print out some statistics on HTMLscreen (called from HELPmenu)
proc statistics {} {
	 global ByteCount maxBytes mainHTML htmlBG htmlFG version tokCount histry idxHistry anzDest cacheSpace destSpace fTypes cacheLocation plugINs \
	 		errNo errMerk destDir cookieCount homeDir blacklistDIR system userDir
	 if {[string length $blacklistDIR]<=0} {
	 	set black "[string trimright $homeDir /]/SYSTEM/Targets.nfo"
	 	if {![file exists $black]} {set black ""}
 	 } else {
 	   	set black $blacklistDIR
 	 }
 	 set z 0
 	 set ausgabe "PlugIN-Name, GUID, Mime = Types<br>\n"
     foreach inhalt $plugINs {
     	   incr z
  		   append ausgabe "$z.: [lindex $inhalt 2], [lindex $inhalt 3], [lindex $inhalt 4] = [lindex $inhalt 5]<br>\n"
	 }
	 Clear
	 SetDefColor
	 $mainHTML parse "
		<BODY bgcolor=$htmlBG color=$htmlFG><br>\n
		<h1><b>$version</b></h1><br>\n<br>\n
		<b>Statistics:</b><br>\n
        Total Traffic:          $ByteCount KBytes ([expr $ByteCount / 1024] MB)<br>\n
		Total Requests:         $tokCount<br>\n
		Total Sites visited:    [llength $histry]<br>\n
		Total Cookies:          $cookieCount<br>\n<br>\n

		Cache location:         [string trimright $cacheLocation /]/cache/<br>\n
		Total free Cachesize:   $cacheSpace KBytes<br>\n
		Destination Directory:  $destDir<br>\n
		Total free Destination: $destSpace KBytes ($anzDest Files)<br>\n<br>\n

		Total known Filetypes:  [llength $fTypes(All_Files)]<br>\n
		Image Types:   $fTypes(Images)<br>\n
		Audio Types:   $fTypes(Audio)<br>\n
		Video Types:   $fTypes(Video)<br>\n
		Text Types:    $fTypes(Text)<br>\n
		Table Types:   $fTypes(Tables)<br>\n
		HTML Types:	   $fTypes(HTML)<br>\n
		Applet Types:  $fTypes(Applets)<br>\n
		Archive Types: $fTypes(Archives)<br>\n<br>\n

   		Total known PlugINs:    [llength $plugINs]<br>\n
   		$ausgabe<br>\n<br>\n

		Used Blacklist-File:    $black<br>\n
		Total blacklisted URLs: [llength [split $fTypes(DDOM) {|}]]<br>\n
		Total Command calls:    [info cmdcount]<br>\n
		Last known Error:       $errMerk<br>\n<br>\n

		System:					[winfo server .] ($system)<br>\n
		Hostname:               [info hostname]<br>\n
		Executable:             [info nameofexecutable]<br>\n
		Process ID:             [pid]<br>\n
		Working Directory:      $homeDir<br>\n
		User Directory:         $userDir<br>\n
		Screen Resolution:		[winfo screenwidth .]x[winfo screenheight .]<br>\n
		Window Resolution:		[lindex [split [winfo geometry .] +] 0] (ID:[winfo id .])<br>\n<br>\n
		</BODY>
	 "
}

#Set Valus which should NOT be in HTMLpage to protect little children
set kidlist [openFile $homeDir/SYSTEM/FIQKID.FQL]
regsub -nocase -all { } [join $kidlist] {|} kidlist
regsub -nocase -all {} $kidlist { } kidlist
#puts "KidZ: $kidlist"

#CHNG040506: deleted "%2A" = "\*"; %20 = " "
set encodelist {
	%21 {!}
	%22 {"}
	%23 {#}
	%24 {\$}
	%26 {&}
	%27 {'}
	%28 {\(}
	%29 {\)}
	%2B {\+}
	%2C {,}
	%2F {/}
	%3A {:}
	%3B {;}
	%3C {<}
	%3D {=}
	%3E {>}
	%40 {@}
	%5B {\[}
	%5C {\\}
	%5D {\]}
	%5E {\^}
	%7C {\|}
	%7E {~}
	%C4 {}
	%D6 {}
	%DC {}
	%DF {}
	%E4 {}
	%F6 {}
	%FC {}
}
#"
