package provide FIQHTM 1.0
#FIQHTM V211106
#HTML Functions 4 Frenzy's Inquisitor
#(C) 2004 by: Frenzy Softworks
#Written by: Jens Timmermann

#called when User Changes not to show underlined HyperLinks
proc ChangeUnderline {args} {
	global underlineHyper active mainHTML msgText
	if {$active==1} return
	switch $underlineHyper {
		0 {
			dispMSG $msgText(underline.hyper.1)
			setLED blue
		}
		1 {
			dispMSG $msgText(underline.hyper.2)
			setLED blue
		}
	}
	$mainHTML config -underlinehyperlinks $underlineHyper
	Refresh
}

#called when User changes TableStructView
proc ShowTableStruct {args} {
	global showTableStruct active mainHTML msgText
	if {$active==1} return
	if {$showTableStruct} {
		if {$args!=0 || $args==""} {
		   dispMSG $msgText(tablestructure.show.1)
		   setLED blue
		}
		$mainHTML config -tablerelief flat
	} else {
		if {$args!=0 || $args==""} {
			dispMSG $msgText(tablestructure.show.2)
			setLED blue
		}
		$mainHTML config -tablerelief raised
	}
}

#HTML SubProcedures (HTMLwidget-Handlers)
#DisplayFonts in HTML
proc PickFont {size attrs} {
	global debug fontsize fonts fontcount useSiteFonts lastFont
	if {$size==$fontsize} return
	if {$debug>4} {puts "FontCmd: $size $attrs"}
#puts "FontCmd: $size $attrs"
	set a [expr {-1<[lsearch $attrs fixed]?{courier}:{charter}}]
	set b [expr {-1<[lsearch $attrs italic]?{italic}:{roman}}]
	set c [expr {-1<[lsearch $attrs bold]?{bold}:{normal}}]
	set d [expr {int(12*pow(1.2,$size - $fontsize))}]
#	set d [expr {int(6*pow(1.2,$size - $fontsize))}]
#set d [expr $size * 4]
        #NEW160406: new FontChooser (choses now real TCLFont from created FontList)
#puts "Fonts: $fonts $fontcount"
        if {$useSiteFonts>0} {
		       	set d [expr {int(8*pow(1.2,$size - $fontsize))}]
                set back [lindex $fonts $fontcount]
                if {[string length $back]>0} {
                     incr fontcount
                     set lastFont [list $back $d $b $c]
                } else {
                     set lastFont [list $a $d $b $c]
                }
        } else {
                set lastFont [list $a $d $b $c]
        }
#puts "Font $size: $lastFont $a $d $b $c"
	return $lastFont
}

#proc PickFont2 {attr} {
#puts "PickFont2: $attr"
#}

#NEW211106: recalculates Font-PixelSizes in HTMLSizes 1-7
proc fontPick {size} {
	 set fsize 3
	 if {$size>0 && $size<7} {set fsize 1}
	 if {$size>=8 && $size<12} {set fsize 2}
	 if {$size>=12 && $size<16} {set fsize 3}
	 if {$size>=16 && $size<20} {set fsize 4}
	 if {$size>=20 && $size<26} {set fsize 5}
	 if {$size>=26 && $size<34} {set fsize 6}
	 if {$size>=34} {set fsize 7}
	 return $fsize
}

#cgiDecode/cgiEncode to translate HEXmapping (taken friom nCGIpackage, so the whole package incl. fileutil and cmd is not needed)
proc cgiDecode {str} {
	global map
    set str [string map [list + { } "\\" "\\\\"] $str]
    regsub -all -- {%([A-Fa-f0-9][A-Fa-f0-9])} $str {\\u00\1} str
    return [subst -novar -nocommand $str]
}

proc cgiEncode {string} {
    global map
    regsub -all -- \[^a-zA-Z0-9\] $string {$map(&)} string
    regsub -all -- {[][{})\\]\)} $string {\\&} string
    return [subst -nocommand $string]
}

#Test only (unused)
proc testHandler {args} {
	 puts "TestHandler: $args"
}

#FORMhandler called from HTMLwidget
proc FormCmd {n cmd args} {
	global debug HTMLquery HTMLmethod HTMLaction formOptions menuEntrys winSYS htmlBG htmlFG fontsize form mainHTML urltext linktext lastFont
	#set args [join $args]
	if {$debug>3} {puts "FormCmd: n=$n cmd=$cmd args=$args"}
    if {$winSYS==0} {
       	set w [lindex $args 1]
	} else {
		set w [lindex $args 1]
	}
	set cmd [string tolower $cmd]
	regsub -nocase -all {[^0-9a-zA-Z]} $cmd {} cmd
	switch -regexp $cmd {
		button {
			if {$debug>3} {puts "FormCMD: button = $args"}
			button $w -text [lindex $args 2] -background "#c0c0c0" -foreground "#000000"
		}
		fieldset {
			if {$debug>3} {puts "FormCMD: fieldset = $args"}
			   	#Draws a Box around a Group of Controls
                frame $w -relief ridge
		}
		form {
			if {$debug>3} {puts "FormCMD: form"}
	      	set dummy [lindex $args 0]
#puts "DUMMY: $n:$dummy"
			if {[regexp -nocase {marquee|blink|medit|background} $dummy]} {
				set form($n) $dummy
	        } else {
				set HTMLmethod [string toupper [lindex $args 1]]
				set HTMLaction [getValue action [join $args]]
            }
		}
		flush {
  	                set HTMLquery ""
	                set HTMLenter ""
                 	set HTMLaction ""
                 	catch {unset form}
		}
		input {
			if {$debug>3} {puts "FormCMD: input"}
			#Fehler in HTMLwidget ausgleichen: hat auf Linux andere Indexe, als in Windoof
            if {$winSYS==0} {
			        HTMLinput [lindex $args 1] [concat [lindex $args 2]] [lindex $args 0]
			} else {
			        HTMLinput [lindex $args 0] [concat [lindex $args 1]] [lindex $args 2]
			}
		}
		isindex {
			if {$debug>3} {puts "FormCMD: isindex"}
			#Same as Input (old)
			if {$winSYS==0} {
                    HTMLinput [lindex $args 1] [concat [lindex $args 2]] [lindex $args 0]
            } else {
			        HTMLinput [lindex $args 0] [concat [lindex $args 1]] [lindex $args 2]
       		}
		}
		label {
			if {$debug>3} {puts "FormCMD: label = $args"}
			label $w -text [lindex $args 2]
		}
		legend {
			if {$debug>3} {puts "FormCMD: legend = $args"}
                        # TextLabel for FieldSet
			label $w -text [lindex $args 2]
		}
		option {
			if {$debug>3} {puts "FormCMD: option = $args"}
			#Options for Select/Listbox
                        lappend formOptions $args
                        lappend menuEntrys $args
		}
		select {
			if {$debug>3} {puts "FormCMD: select = $args"}
			if {$winSYS==0} {
			    #alle "Select"-Widgets bringen HTMLwidget zum Abkacheln unter Linux, unter Windoof geht's !!!!
				#set fields [join [lrange $args 2 end]]
				#set formOptions ""
				#set menuEntrys ""
				#foreach inhalt $fields {
				#	set name [lindex $inhalt 2]
				#	lappend menuEntrys $name
				#}
				#label $w -text "FormOptions"
				#tk_optionMenu $w formOptions $menuEntrys
				#ComboBox $w -values $menuEntrys
			} else {
				set item [lindex $args 0]
				set props [join [lindex $args 1]]
				set fields [join [lrange $args 2 end]]
				set formOptions ""
				set menuEntrys ""
				foreach inhalt $fields {
					set idx [lindex $inhalt 0]
					set action [lindex $inhalt 1]
					set name [lindex $inhalt 2]
					lappend formOptions $name $action
					lappend menuEntrys $name
				}
				set name [getValue name $props]
				set color [getValue color $props]
				if {$debug>4} {puts "SelectBox = $item $name $color $props"}
				spinbox $w -text $name -values $menuEntrys -command {set action %s}
				set default [list bgcolor #ffffff color #000000]
				if {[llength $color]>0} {
					if {![setColor $item $color]} {
						setColor $item $default
					}
				} else {
				        setColor $item $default
				}
			}
		}
		textarea {
			if {$debug>3} {puts "FormCMD: textarea = $args"}
			set bgcolor [$mainHTML cget -background]
			set color [$mainHTML cget -foreground]
			set words [acode resolv [lindex $args 2]]
			set href [getValue href $words]
			set font ""
			if {[regsub -nocase -all {<b>|</b>} $words {} words]} {lappend font {bold}}
			if {[regsub -nocase -all {<i>|</i>} $words {} words]} {lappend font {italic}}
			if {[regsub -nocase -all {<u>|</u>} $words {} words]} {lappend font {underline}}
			if {[regsub -nocase -all {<strike>|</strike>} $words {} words]} {lappend font {overstrike}}
			if {[regsub -nocase -all {<big>|</big>|<small>|</small>} $words {} words]} {lappend font {normal}}
			set words [extractText $words]
			set values "[lindex $args 0] [lindex $args 2]"
#puts "VALUES: $values"
			set rows [stripValue [getValue rows $values] 1]
			set size [stripValue [getValue size $values] 11]
			set calc [expr [string length $words] * $fontsize]
			set cols [stripValue [getValue cols $values] $calc]
		    set height [stripValue [getValue height $values] 1]
            set width [stripValue [getValue width $values] 1]
#NEW280107:
#			if {[regexp -nocase {%} $width]} {
#			   regsub -nocase -all {[^0-9]} $width {} width
#			   set width [expr [$mainHTML cget -width] / 100 * $width]
#			}
#			if {[regexp -nocase {%} $height]} {
#			   regsub -nocase -all {[^0-9]} $height {} height
#			   set height [expr [$mainHTML cget -height] / 100 * $height]]
#			}
			if {[info exists form($n)]} {
				if {$debug>3} {puts "FormCMD: specialTextArea $form($n)"}
			   	if {[regexp -nocase {marquee} $form($n)]} {
				#create marquee Text Scroller activated by FormAction=marquee
					set direction [getValue directions $values]
					if {[string length $direction]<=0} {set direction [getValue behavior $values]}
					set speed [stripValue [getValue scrolldelay $values] 3]
					#calc Textsize in PixelSize 4 canvasWidget
					set fsize [expr $size + $fontsize]
					set height [expr $rows * $fsize + 8]
					canvas $w -height $height -width $cols -background $bgcolor -highlightbackground $bgcolor
					$w create text 0 0 -text $words -anchor nw -fill $color -font $lastFont
					if {[string length $href]>0} {
					   		 $w configure -cursor hand2
							 bind $w <1> [subst "set urltext $href; goEnter"]
							 bind $w <3> [subst "AddSelected $href 0"]
							 bind $w <Any-Enter> [subst "set linktext \"$href\"; chkDanger $href"]
							 bind $w <Any-Leave> [subst "set linktext {}"]
					}
					set tWidth [font measure [$w itemcget 1 -font] $words]
					$w delete text
					if {[string length $direction]<=0} {set direction left}
					if {[regexp -nocase {right} $direction]} {
      					   	    $w create text -$tWidth 0 -text $words -anchor nw
      					} else {
					       	    #otherwise scroll ever to left even when alternate (start from right 2 left)
      					   	    $w create text $cols 0 -text $words -anchor nw
      					}
      					scrollMarq $w $direction $speed $tWidth
				} elseif {[regexp -nocase {blink} $form($n)]} {
				  	#blinkTAG activated by FormAction=blink
				    label $w -text $words -borderwidth 0 -background $bgcolor -foreground $color -relief flat -font $lastFont
   					if {[string length $href]>0} {
					   		 $w configure -cursor hand2
							 bind $w <1> [subst "set urltext $href; goEnter"]
							 bind $w <3> [subst "AddSelected $href 0"]
							 bind $w <Any-Enter> [subst "set linktext \"$href\"; chkDanger $href"]
							 bind $w <Any-Leave> [subst "set linktext {}"]
					}
					blink $w
				} elseif {[regexp -nocase {medit} $form($n)]} {
					#MUST be TextWidget cause Frame only supports PixelHeight instead of CharacterHeight
					text $w -width $cols -height $rows -bd 0 -relief flat -cursor {}
					text $w.text -background $bgcolor -foreground $color -bd 2 -relief sunken -wrap word -autosep 1 -yscrollcommand "$w.scroll set"
					$w.text insert 0.0 $words
					scrollbar $w.scroll -command "$w.text yview" -cursor {}
					pack $w.scroll -side right -fill y
					pack $w.text -expand 1 -fill both
			    } elseif {[regexp -nocase {background} $form($n)]} {
				#Text over Image (Table Background) WON'T WORK for now (must be activated in preParser)
				        set values [lindex $args 1]
#puts "IMGFORM: $values"
                        set background [getValue bg $values]
                        if {$background!=""} {
#						    set height [stripValue [getValue height $values] 1]
#	                        set width [stripValue [getValue width $values] 1]
#							image create photo img -file [getFileURL $background] -width $width -height $height
#				    		canvas $w -relief ridge -width $width -height $height -background $bgcolor
#							$w create image -image $img
#							$w create text -text "\n $words \n" -justify center
#set wand [magick create wand]
#set draw [magick create draw]
#set img [image create photo]
#$wand ReadImage [getFileURL $background]
#catch {$wand ResizeImage $height $width cubic}
#  $draw SetFontSize 12
#  $draw fillcolor "red"
#  $draw Annotation 70 70 "\n $words \n"
#$wand DrawImage $draw
#magicktophoto $wand $img
#magick delete $wand
#magick delete $draw
#label $w -image $img -width $width -height $height
#pack $w
						}
			    }
			} else {
#puts "oder da"
#puts "W:$w BG:$bgcolor CO:$color WI:$width R:$rows"
#                               label $w -text "$words\n" -background $bgcolor -foreground $color -relief sunken -borderwidth 2 -width $width -height $height -autosep 1
                               label $w -text "$words\n" -background $bgcolor -foreground $color -relief sunken -borderwidth 2 -width $width -height $rows
	  		}
		}
	}
}

#Decode HTMLcoding 2 GermanText
#Sonderzeichen, dt. Umlaute korrigieren (z.B. bei "Google")
proc encode {data} {
	set back $data
	#regsub -nocase -all {%26} $data {&} back
	regsub -all {\xc3\xa4||\xc3\x83\xc2\xa4|\xc3\x83\xa4|&#228;|ä} $back {\&auml;} back
	regsub -all {\xc3\xb6||\xc3\x83\xc2\xb6|\xc3\x83\xb6|&#246;|ö} $back {\&ouml;} back
	regsub -all {\xc3\xbc||\xc3\x83\xc2\xbc|\xc3\x83\xbc|&#252;|ü} $back {\&uuml;} back
	regsub -all {\xc3\x84||\xc3\x83\xc2\x84|\xc3\x83\x84|&#196;|Ä} $back {\&Auml;} back
	regsub -all {\xc3\x96||\xc3\x83\xc2\x96|\xc3\x83\x96|&#214;|Ö} $back {\&Ouml;} back
	regsub -all {\xc3\x9c||\xc3\x83\xc2\x9c|\xc3\x83\x9c|&#220;|Ü} $back {\&Uuml;} back
	regsub -all {\xc3\x9f||\xc3\x83\xc2\x9f|\xc3\x83\x9f|\xc3\x3f|&#223;|ß} $back {\&szlig;} back
#NEW101106: german encodings ("\xc3\x3f" stands for , , , or )
	regsub -nocase -all {\&szlig;ber} $back {\&Uuml;ber} back
	regsub -nocase -all {DF\&szlig;} $back {DF\&Uuml;} back
	regsub -nocase -all {\&szlig;lter} $back {\&Auml;lter} back
	regsub -nocase -all {\&szlig;ffent} $back {\&Ouml;ffent} back
#German Encodings End
	regsub -all {\xc3\xa2\x80\x93|&#126;|&tilde;|&#732;|&permil;&#8240;|&sim;|&#8764;|&ne;|&#8800;} $back {~} back
	regsub -all {\xc3\x80|\xc3\x83\xc2\x80|\xc3\x83\x80|&euro;|%80|\x80|\xc3\xa2\x82\xac|\x3f\xac|&#8364;} $back { EUR} back
	regsub -nocase -all {&copy;|&#169;|\xa9} $back "(C)" back
    regsub -nocase -all {&#x2019;|&x2019;|&rsquo;|&#8217;|&lsquo;|&#8216;|&sbquo;|&#8218;|\xc3\x92|\xc2\x92|\xc3\x83\xc2\x92|\x92|&#39;|&#039;|&ldquo;|&#8220;|&rdquo;|&#8221;|&bdquo;|&#8222;} $back {'} back
#NEW211006: some special english encodings
        regsub -nocase -all {\?s } $back {'s } back
        regsub -nocase -all {\?re } $back {'re } back
        regsub -nocase -all {\?m } $back {'m } back
        regsub -nocase -all {\?ve } $back {'ve } back
        regsub -nocase -all {\?t } $back {'t } back
        regsub -nocase -all {\?d } $back {'d } back
        regsub -nocase -all {\?ll } $back {'ll } back
	regsub -nocase -all {&quot;|&#0*34;|\?\?} $back {"} back; #"
	regsub -nocase -all {&gt;|&#0*62;|&ge;|&#8805;} $back {>} back
	regsub -nocase -all {&lt;|&#0*60;|&le;|&#8804;} $back {<} back
	regsub -nocase -all {&rarr;|&#8594;} $back {->} back
	regsub -nocase -all {&larr;|&#8592;} $back {<-} back
	regsub -nocase -all {&amp;|&amp\;|&#0*38;} $back {\&} back
	regsub -nocase -all {&asymp;|&asymp\;|&#8773;} $back {~} back
    regsub -nocase -all {&lsaquo;|&#8249;|&rsaquo;|&#8250;} $back {#} back
    regsub -nocase -all {&raquo;|\x20\xbb|\xbb|&rArr;|&#8658;} $back {>>} back
	regsub -nocase -all {&laquo;|&lArr;|&#8656;} $back {<<} back
	regsub -nocase -all {&ldquo;} $back {;} back
	regsub -nocase -all {&ndash;} $back {:} back
	regsub -nocase -all {&nbsp;|&nbsp|\xc2|&#160;|&ensp;|&#8194;|&emsp;|&#8195;|&thinsp;|&#8201;} $back { } back
	regsub -nocase -all {&cent;|&#162;} $back {c} back
	regsub -nocase -all {&reg;|&#174;} $back "(R)" back
	regsub -nocase -all {&trade;|&#8482;} $back "TM" back
	regsub -nocase -all {&deg;|&#176;} $back {} back
	regsub -nocase -all {&sup2;|&#178;|&prime;|&#8242;|&#8243;|&sup3;|&#179;} $back {} back
	regsub -nocase -all {&sect;|&#167;|\xa7|&#a7;|&#0a7;} $back {par.} back
	regsub -nocase -all {&times;|&#215;|&divide;|&#247;} $back {x} back
	regsub -nocase -all {&middot;|&bull;|&#183;|\xb7|&#b7;|&#0b7;|&lowast;|&#8727;|&sdot;|&#8901;} $back {*} back
	regsub -nocase -all {&micro;|&#181;|&circ;|&#710;} $back {} back
	regsub -nocase -all {&hellip;|&#8230;} $back {...} back
regsub -nocase -all {&dagger;|&#8224;|&#8225;|&plusmn;|&#177;} $back {+} back
regsub -nocase -all {&ndash;|&#8211;|&mdash;|&#8212;|&oline;|&#8254;|&frasl;|&#8260;|&shy;|&#173;|&macr;|&#175;|&brvbar;|&#166;} $back {-} back
#NEW140707: CardSymbols (int. IMG SRC)
regsub -nocase -all {&spades;|&#9824;} $back {<img src='FIQ:pik'>} back
regsub -nocase -all {&clubs;|&#9827;} $back {<img src='FIQ:kreuz'>} back
regsub -nocase -all {&hearts;|&#9829;} $back {<img src='FIQ:heart'>} back
regsub -nocase -all {&diams;|&#9830;} $back {<img src='FIQ:karo'>} back
	regsub -all {\xc3|\xc2|\x83|\x82|\xa0|\x09|} $back {} back
	return $back
}

#NEW080907: decode german HTML-Tags (used by importBook)
proc decode {data} {
	set back $data
 	regsub -all {\&auml;} $back {} back
	regsub -all {\&ouml;} $back {} back
	regsub -all {\&uuml;} $back {} back
	regsub -all {\&Auml;} $back {} back
	regsub -all {\&Ouml;} $back {} back
	regsub -all {\&Uuml;} $back {} back
	regsub -all {\&szlig;} $back {} back
	return $back
}

#Sucht $value in $props, und gibt lindex $props+1 zurck (sucht z.B. "color" in Liste: {src 20 color 10}, gibt 10 zurck)
#VERY IMPORTANT function, cause it will called from nearly everywhere
proc getValue {value props} {
	#Wenn Java in Props enthalten
	if {[regexp -nocase {^.*!--} $props] || ![regexp -nocase $value $props]} {return ""}
	global debug killCHR
	set kill "\"|\'|\<|\>|\,|$killCHR"
	regsub -nocase -all $kill $props { } props; #"
	regsub -nocase "$value *=*" $props " $value " props; #"
	regsub -nocase -all { +} $props { } props
	regsub -nocase -all {\? src} $props {?src} props
	regsub -nocase -all {src= } $props {src } props
	regsub -nocase -all {href= } $props {href } props
	if {$debug>8} {puts "getValue get: value=$value props=$props"}
	set back ""
	set value [string tolower [string trim $value]]
	set dummy [string tolower [string trim $props]]
	catch {lsearch -exact $dummy $value} type
	if {$type>=0} {
		catch {lindex $props [expr $type + 1]} back
		set back [string trim $back]
	} else {
		set back ""
	}
	if {$debug>8} {puts "getValue returns: $back"}
	unset dummy type value
	regsub -nocase -all { } $back {%20} back
	return $back
}

#NEU110404 callCMD (args)
#Command Substitution callCMD [name value) wenn INet-Button geklickt wird
#used by: HTMLinput Button (submit)
proc callCMD {args} {
#Tricky Command Substitution cause Variable (Name/Value) dosn't exist anymore, if Button clicked !
	global debug urltext urlpath HTMLaction mainHTML HTMLquery HTMLenter query Name
	if {$debug>3} {puts "callCMD get: $args"}
	set dummy [lindex $args 0]
	set name [lindex $dummy 0]
	set value [join [lindex $dummy 1]]
	regsub -nocase -all { } $value {\&} value
	set ausgabe ""
	foreach inhalt $name {
		regsub -nocase -all {=} $query($inhalt) {%3} dummy
		regsub -nocase -all { } $dummy {\&} dummy
		if {[string length $inhalt]>=1 && [string length $dummy]>=1} {
		#Nur an URL anhngen, wenn Value gefllt
			lappend ausgabe $inhalt=$dummy
		}
	}
	if {[string length $value]>=1} {
		#Nur an URL anhngen, wenn Value gefllt
		set ausgabe "$HTMLaction $ausgabe $name=$value"
	} else {
		#Sonst nicht
		if {[string length [lindex [split $HTMLenter =] 0]]>=1 && [string length [lindex [split $HTMLenter =] end]]>=1} {
			set ausgabe "$HTMLaction $ausgabe $HTMLenter"
		} else {
			set ausgabe "$HTMLaction $ausgabe"
		}
	}
	#Liste fr nchste Query wieder leer machen
	regsub -nocase { } $ausgabe {?} ausgabe
	regsub -nocase -all { } $ausgabe {\&} ausgabe
	set HTMLquery [reslvURL $ausgabe 1]
	regsub -nocase -all {"} $HTMLquery {} HTMLquery
	if {$debug>4} {puts "callCMD query: $HTMLquery"}
	set urltext [upperHTTP $HTMLquery]
	#NEU210804: clearQuery
	set Name ""
	set ausgabe ""
	set HTMLquery ""
	set HTMLenter ""
	set HTMLaction ""
	preSolve
}

#FormTAG Input (called from FormHandler)
proc HTMLinput {item props color} {
	global debug HTMLenter query htmlBG htmlFG merkName merkValue Name normLight winSYS HTMLsync
	if {$debug>4} {puts "HTMLinput get: item=$item props=$props color=$color"}
	if {[string length $item]==0 || ![regexp -nocase {^\.} $item]} return
        regsub -nocase -all {"} $props {} props; # "
	set kind [string tolower [getValue type $props]]
	regsub -nocase -all {%20} $kind { } kind
	regsub -nocase -all {[^0-9a-zA-Z]} $kind {} kind
	if {[string length $kind]<=0} {set kind text}
	set value [getValue value $props]
	regsub -nocase -all {%20} $value { } value
	set size [stripValue [getValue size $props] 12]
	set name [getValue name $props]
	regsub -nocase -all {%20} $name { } name
	set default [list bgcolor $htmlBG color $htmlFG]
	switch -regexp $kind {
		text {
			if {$debug>4} {puts "HTMLinput: text"}
			if {$merkName!=$name} {
				lappend Name $name
				set query($name) $value
			}
			entry $item -relief sunken -width $size -insertbackground black -textvariable query($name)
			set ndummy [lindex [split $HTMLenter =] 0]
			set vdummy [lindex [split $HTMLenter =] end]
			bind $item <Return> [subst "callCMD {$ndummy {$vdummy}}"]
			set default [list bgcolor #ffffff color #000000]
		}
		submit {
			if {$debug>4} {puts "HTMLinput: submit"}
			set command ""
			if {[string length $name]<=0} {
				set name $kind
			} else {
				if {$merkValue==0} {
					set merkValue 1
					#nur setzen, wenn Button einen Namen hat (und damit mehrere Buttons zur Auswahl stehen)
					set HTMLenter "$name=$value"
					set command {$name {$value}}
				}
			}
			button $item -text $value -relief raised -activebackground $normLight -command [subst "callCMD $command"]
			unset command
			set default {bgcolor #c0c0c0 color #000000}
			#Buttons grundstzlich Grau machen
			set color $default
		}
		reset {
			if {$debug>4} {puts "HTMLinput: reset"}
			if {$merkName!=$name} {
				lappend Name $name
				set query($name) $value
			}
			#Reset
			label $item -image imFileBroken -relief flat -text "Reset: $value"
		}
		file {
			if {$debug>4} {puts "HTMLinput: file"}
			if {$merkName!=$name} {
				lappend Name $name
				set query($name) $value
			}
			#File
			label $item -image imFileDownload -relief flat -text "File: $value"
		}
		hidden {
			if {$debug>4} {puts "HTMLinput: hidden"}
			if {$merkName!=$name} {
				lappend Name $name
				set query($name) $value
			}
			#Hidden
			label $item -relief flat
		}
		password {
			if {$debug>4} {puts "HTMLinput: password"}
			if {$merkName!=$name} {
				lappend Name $name
				set query($name) $value
			}
			entry $item  -show "*" -relief sunken -width $size -insertbackground black -textvariable query($name)
			set ndummy [lindex [split $HTMLenter =] 0]
			set vdummy [lindex [split $HTMLenter =] end]
			bind $item <Return> [subst "callCMD {$ndummy {$vdummy}}"]
			set default {bgcolor #ffffff color #000000}
			#set default [list bgcolor $htmlBG color $htmlFG]
		}
		radio {
			if {$debug>4} {puts "HTMLinput: radio"}
			if {$merkName!=$name} {
				lappend Name $name
				set query($name) $value
			}
			radiobutton $item -anchor center -relief flat -selectcolor white -background $htmlBG -activebackground $normLight -variable query($name) -value $value
			#Check/RadioButtons
			if {$winSYS==1} {
			#NEW120506: only on Windows
				if {[lsearch $props checked]>0} {
					$item select
				} else {
					$item deselect
				}
			}
			set default "bgcolor $htmlBG color #000000 alink #0000ff highlightbackground #ff0000"
		}
		checkbox {
			if {$debug>4} {puts "HTMLinput: check $item"}
			if {$merkName!=$name} {
				lappend Name $name
				set query($name) $value
			}
			checkbutton $item -anchor center -relief ridge -background $htmlBG -activebackground $normLight -variable query($name) -onvalue $value
			#Check/RadioButtons
			if {$winSYS==1} {
			#NEW120506: only on Windows
				if {[lsearch $props checked]>0} {
					$item select
				} else {
					$item deselect
				}
			}
			set default "bgcolor $htmlBG color #000000 alink #0000ff highlightbackground #ff0000"
		}
		button {
			if {$debug>4} {puts "HTMLinput: button"}
			button $item -text $value -relief raised -activebackground $normLight -command [subst "callCMD {$name {$value}}"]
			set default {bgcolor #c0c0c0 color #000000}
			set color $default
		}
		image {
			if {$debug>4} {puts "HTMLinput: image"}
			if {$merkName!=$name} {
				lappend Name $name
				set query($name) $value
			}
            #new121104: ImageTag
	        set value [getValue title $props]
#puts "Name=$name value=$value"
			set src [getValue src $props]
			set width [stripValue [getValue width $props] 0]
			set height [stripValue [getValue height $props] 0]
			if {$width>0 && $height>0} {
				if {$HTMLsync<=0} {
					if {[catch {image create photo $item.gfx -file [getFileURL [reslvURL $src]] -width $width -height $height}]==0} {
						button $item -image $item.gfx -relief flat -text $value -width $width -height $height -cursor hand2 -activebackground $normLight -command [subst "callCMD {$name {$value}}"]
					} else {
						button $item -image imFTunknown -relief flat -text $value -width $width -height $height -cursor hand2 -activebackground $normLight -command [subst "callCMD {$name {$value}}"]
					}
				} else {
#puts "$width $height <img src='$src'> 0"
				#SYNCmode
					set img [ImageCmd $width $height "<img src='$src'>" 0]
					if {[string length $img]>0} {
						button $item -image $img -relief flat -text $value -width $width -height $height -cursor hand2 -activebackground $normLight -command [subst "callCMD {$name {$value}}"]
					} else {
						button $item -image imFTunknown -relief flat -text $value -width $width -height $height -cursor hand2 -activebackground $normLight -command [subst "callCMD {$name {$value}}"]
					}
				}
			} else {
				if {$HTMLsync<=0} {
					if {[catch {image create photo $item.gfx -file [getFileURL [reslvURL $src]]}]==0} {
						#label $item -image $item.gfx -relief flat -text $value -cursor hand2
						button $item -image $item.gfx -relief flat -text $value -cursor hand2 -activebackground $normLight -command [subst "callCMD {$name {$value}}"]
					} else {
						button $item -image imFileBroken -relief flat -text $value -cursor hand2 -activebackground $normLight -command [subst "callCMD {$name {$value}}"]
					}
				} else {
				#SYNCmode
#puts "$width $height <img src='$src'> 1"
					set img [ImageCmd 0 0 "<img src='$src'>" 0]
					if {[string length $img]>0} {
						button $item -image $img -relief flat -text $value -cursor hand2 -activebackground $normLight -command [subst "callCMD {$name {$value}}"]
					} else {
						button $item -image imFileBroken -relief flat -text $value -cursor hand2 -activebackground $normLight -command [subst "callCMD {$name {$value}}"]
					}
				}
			}
		}
	}

	if {[llength $color]>0} {
		if {![setColor $item $color]} {
			setColor $item $default
		}
	} else {
	        setColor $item $default
	}
	set merkName $name
}

# This routine is called for every (Java) <SCRIPT> markup (currently unused ?)
proc ScriptCmd {args} {
	global debug
#Hier evtl EIGENE JAVA-Engine
	if {$debug>6} {puts "ScriptCmd: $args"}
}

#called for every <APPLET>/<EMBED> Tag
proc AppletCmd {w args} {
# "Applet" = ist sowas wie ein "Player" (Abspieler) fr entspr. Dateityp (z.B.: ".SWF" = ShockWaveFlash)
	global video sound applet debug renderIMG useApplet useVideo useFrames stream winSYS remSTR linktext playSounds onceSounds HTMLsync msgText \
		   thumbsOnly urltext mainHTML baseurl activeHTM htmlBG
	if {$debug>2} {puts "AppletCmd: w=$w args=$args"}
#puts "AppletCmd: w=$w args=$args"
	set args [lindex $args 0]
set dummy $args
if {[regexp -nocase {%3F|%26|\?|&} $args]} {
	regsub -nocase -all { } $args {%20} dummy
	regsub -nocase -all {(%20)*src(%20)*} $dummy { src } dummy
	regsub -nocase -all {(%20)*type(%20)*} $dummy { type } dummy
	regsub -nocase -all {(%20)*quality(%20)*} $dummy { quality } dummy
	regsub -nocase -all {(%20)*width(%20)*} $dummy { width } dummy
	regsub -nocase -all {(%20)*height(%20)*} $dummy { height } dummy
	regsub -nocase -all {(%20)*align(%20)*} $dummy { align } dummy
	regsub -nocase -all {(%20)*name(%20)*} $dummy { name } dummy
	regsub -nocase -all {(%20)*bgcolor(%20)*} $dummy { bgcolor } dummy
	regsub -nocase -all {(%20)*loop(%20)*} $dummy { loop } dummy
	regsub -nocase -all {(%20)*autostart(%20)*} $dummy { autostart } dummy
	regsub -nocase -all {(%20)*pluginspage(%20)*} $dummy { pluginspage } dummy
	regsub -nocase -all {(%20)*allowScriptAccess(%20)*} $dummy { allowScriptAccess } dummy
#NEW250807:
	regsub -nocase -all {(%20)*flashvars(%20)*} $dummy { flashvars } dummy
	regsub -nocase -all {\.SWF(%20)|\.SWF[a-zA-Z]+[0-9]+} $dummy {.SWF } dummy
}
 	set type [getValue type $dummy]
 	set src [getValue src $dummy]

#NEW010907: extended FlashVars
    set para ""
if {[regexp -nocase "FlashVars" $args]} {
   foreach {var par} $args {
   		   if {[regexp -nocase "FlashVars" $var]} {
		   	  set para $par
		   	  break
   		   }
   }
}

#puts "SWF: $flashVars"
	set url [reslvURL $src 1]
#	set href [acode decode [regSTR $remSTR $url 0]]
    set link [acode decode $url]
    set href [regSTR $remSTR $link 0]
    if {$href==""} {set href $src}
	set fn [acode encode [string trim $href]]
#set fn $url
	set fake [lindex [split $fn /] end]
#	set fn [string toupper [getFileURL $fn]]
	set width [stripValue [getValue width $args] 80]
	set height [stripValue [getValue height $args] 16]
#NEW280107:
#	if {[regexp -nocase {%} $width]} {
#	   regsub -nocase -all {[^0-9]} $width {} width
#	   set width [expr [$mainHTML cget -width] / 100 * $width]
#	}
#	if {[regexp -nocase {%} $height]} {
#	   regsub -nocase -all {[^0-9]} $height {} height
#	   set height [expr [$mainHTML cget -height] / 100 * $height]]
#	}
	set plugin [getValue pluginspage $args]
    if {$plugin==""} {set plugin "about:blank"}
	set bgcolor [getValue bgcolor $args]
	if {[string length $bgcolor]<=0 || [regexp -nocase {\?|&} bgcolor]} {set bgcolor [$mainHTML cget -background]}
	set linkcolor [$mainHTML cget -unvisitedcolor]
	if {[string length $linkcolor]<=0} {set linkcolor blue}
#	set visitedlink [$mainHTML cget -visitedcolor]
#	if {[string length $visitedlink]<=0} {set visitedlink DarkBlue}
	set dummy [getValue loop $args]
	set loop 0
	if {$dummy!="" && [string length $dummy]>0 && [regexp -nocase {true|[1-9]+|t|infinite} $dummy] && $onceSounds<=0} {set loop 1}
	set dummy [getValue autostart $args]
	set start 0
	if {$dummy!="" && [string length $dummy]>0 && [regexp -nocase {true|1|t} $dummy]} {set start 1}
	if {$debug>2} {puts "APPfile: $fn $width $height"}
if {[regexp -nocase {%3F|%26|\?|&} $fn]} {
    regsub -nocase -all {%3F|%26|\?|&} $fn {} ext
    set ext [lindex [split $ext ] 0]
    set ext [transType .[string trim [getEXT $ext] .]]
	set fn [acode decode $fn]
	set fn [cutFile $fn]
	set fn [acode encode $fn]
	regsub -all {=http:/+} $url {=http://} url
} else {
    set ext [transType .[string trim [getEXT $fn] .]]
}
#puts "File: $fn $ext"
	if {[chkAPP $ext]} {
	    set icon [fileType $ext]
		if {$useApplet<=0} {
			labelframe $w -text "Applet: $fake" -borderwidth 2 -relief sunken -width $width -height $height -background $bgcolor
		   		label $w.link -text $link -image $icon -compound left -background $bgcolor -foreground $linkcolor -cursor hand2 -relief groove
				bind $w.link <1> [subst "set urltext $href; goEnter"]
				bind $w.link <3> [subst "AddSelected $href 0"]
				bind $w.link <Any-Enter> [subst "set linktext \"$href\"; chkDanger $href"]
				bind $w.link <Any-Leave> [subst "set linktext {}"]
		   		pack $w.link -in $w -side bottom -anchor w -expand 1 -fill x
			pack $w
			return $w
		}
		frame $w -relief sunken -borderwidth 2 -width $width -height $height
                # -background $bgcolor
		pack $w -expand 1
#NEW280107:
		if {$thumbsOnly>0} {
		   		set icon [fileType $ext]
		   		label $w.link -text $link -image $icon -compound left -background $bgcolor -foreground $linkcolor -cursor hand2 -relief groove
				bind $w.link <1> [subst "set urltext $href; goEnter"]
				bind $w.link <3> [subst "AddSelected $href 0"]
				bind $w.link <Any-Enter> [subst "set linktext \"$href\"; chkDanger $href"]
				bind $w.link <Any-Leave> [subst "set linktext {}"]
		   		pack $w.link -in $w -side bottom -anchor w -expand 1 -fill x
		}
		if {$winSYS>0} {
			#Windooze only
			if {[winfo exists $w.flash]} {destroy $w.flash}
			set swf [createAPP $w.flash $ext]
            if {![regexp -nocase {UNK:0} $swf]} {
				$w.flash config -width $width -height $height
				pack $w.flash -expand 1 -fill both
				setColor $w.flash [list bgcolor $bgcolor]
			    if {$stream<=0} {
       				if {$HTMLsync>0} {
					   	if {[lsearch $applet $fn]>=0} {
					   	     lappend applet $fn $w $start $swf $para
					   	     return $w
						}
				   	    lappend applet $fn $w $start $swf $para
						getSyncURL $url
						return $w
					} else {
						set linktext "$msgText(fiq.loading): $url"
						set url [getFileURL $url]
					}
				}
		        playAPP $url $w $start $swf $para
		    } else {
				label $w.plugin -text "$msgText(applet.download):\n$plugin" -image imPlugin -compound left -borderwidth 2 -relief groove -background $bgcolor -cursor hand2
				bind $w.plugin <1> [subst "set urltext $plugin; goEnter"]
				bind $w.plugin <3> [subst "AddSelected $plugin 0"]
				bind $w.plugin <Any-Enter> [subst "set linktext \"$plugin\"; chkDanger $plugin"]
				bind $w.plugin <Any-Leave> [subst "set linktext {}"]
				pack $w.plugin -in $w -side top -anchor w -expand 1
		   		set icon [fileType $ext]
		   		label $w.link -text $href -image $icon -compound left -background $bgcolor -foreground $linkcolor -cursor hand2 -relief groove
				bind $w.link <1> [subst "set urltext $href; goEnter"]
				bind $w.link <3> [subst "AddSelected $href 0"]
				bind $w.link <Any-Enter> [subst "set linktext \"$href\"; chkDanger $href"]
				bind $w.link <Any-Leave> [subst "set linktext {}"]
		   		pack $w.link -in $w -side bottom -anchor w -expand 1 -fill x
			}
		}
	    return $w
	} elseif {[chkANI $ext]} {
		if {$useVideo<=0} {
		   #When no Video is wanted; show only Frame with selectable Link and LinkTypeIcon
			labelframe $w -text "Video: $fake" -borderwidth 2 -relief sunken -width $width -height $height -background $bgcolor
		   		set icon [fileType $ext]
		   		label $w.link -text $link -image $icon -compound left -background $bgcolor -foreground $linkcolor -cursor hand2 -relief groove
				bind $w.link <1> [subst "set urltext $href; goEnter"]
				bind $w.link <3> [subst "AddSelected $href 0"]
				bind $w.link <Any-Enter> [subst "set linktext \"$href\"; chkDanger $href"]
				bind $w.link <Any-Leave> [subst "set linktext {}"]
		   		pack $w.link -in $w -side bottom -anchor w -expand 1 -fill x
			pack $w
			return $w
		}
		frame $w -relief sunken -borderwidth 0 -width $width -height $height
                # -background $bgcolor
		pack $w -expand 1
#Show allways selectable Link under embedded Video
		if {$thumbsOnly>0} {
		   		set icon [fileType $ext]
		   		label $w.link -text $link -image $icon -compound left -background $bgcolor -foreground $linkcolor -cursor hand2 -relief groove
				bind $w.link <1> [subst "set urltext $href; goEnter"]
				bind $w.link <3> [subst "AddSelected $href 0"]
				bind $w.link <Any-Enter> [subst "set linktext \"$href\"; chkDanger $href"]
				bind $w.link <Any-Leave> [subst "set linktext {}"]
		   		pack $w.link -in $w -side bottom -anchor w -expand 1 -fill x
		}
		if {$winSYS>0} {
			#Windooze only
			if {[winfo exists $w.movie]} {destroy $w.movie}
			set vcd [createAPP $w.movie $ext]
#			setColor $w.movie [list bgcolor $bgcolor]
            if {![regexp -nocase {UNK:0} $vcd]} {
#				$w.movie config -width $width -height $height
				pack $w.movie -fill both -expand 1
               if {$stream<=0} {
	       			if {$HTMLsync>0} {
						if {[lsearch $video $fn]>=0} {
						     lappend video $fn $w $start $vcd
						     return $w
						}
						lappend video $fn $w $start $vcd
						getSyncURL $url
						return $w
					} else {
							set linktext "$msgText(fiq.loading): $url"
							set url [getFileURL $url]
					}
			   }
		        playAPP $url $w $start $vcd ""
   			} else {
   			#Unable to recognize VideoFormat, or unable to load VideoPlayer
				label $w.plugin -text "$msgText(applet.download):\n$plugin" -image imPlugin -compound left -borderwidth 2 -relief groove -background $bgcolor -cursor hand2
				bind $w.plugin <1> [subst "set urltext $plugin; goEnter"]
				bind $w.plugin <3> [subst "AddSelected $plugin 0"]
				bind $w.plugin <Any-Enter> [subst "set linktext \"$plugin\"; chkDanger $plugin"]
				bind $w.plugin <Any-Leave> [subst "set linktext {}"]
#				$w.plugin configure -wraplength [$w.plugin cget -width]
				pack $w.plugin -in $w -side top -anchor nw -expand 1
			}
	    }
                return $w
	} elseif {[chkSND $ext]} {
	  	#if file is Soundfile
		if {$playSounds<=0} {
			labelframe $w -text "Sound: $fake" -borderwidth 2 -relief sunken -width $width -height $height -background $bgcolor
		   		set icon [fileType $ext]
		   		label $w.link -text $link -image $icon -compound left -background $bgcolor -foreground $linkcolor -cursor hand2 -relief groove
				bind $w.link <1> [subst "set urltext $href; goEnter"]
				bind $w.link <3> [subst "AddSelected $href 0"]
				bind $w.link <Any-Enter> [subst "set linktext \"$href\"; chkDanger $href"]
				bind $w.link <Any-Leave> [subst "set linktext {}"]
		   		pack $w.link -in $w -side bottom -anchor w -expand 1 -fill x
			pack $w
			return $w
		}
		frame $w -relief sunken -borderwidth 2 -width $width -height $height
                # -background $bgcolor
		pack $w -expand 1
		   		set icon [fileType $ext]
		   		label $w.link -text $link -image $icon -compound left -background $bgcolor -foreground $linkcolor -cursor hand2 -relief groove
				bind $w.link <1> [subst "set urltext $href; goEnter"]
				bind $w.link <3> [subst "AddSelected $href 0"]
				bind $w.link <Any-Enter> [subst "set linktext \"$href\"; chkDanger $href"]
				bind $w.link <Any-Leave> [subst "set linktext {}"]
				pack $w.link -in $w -side bottom -anchor w -expand 1 -fill x
        if {[winfo exists $w.sound]} {destroy $w.sound}
		set wav [createAPP $w.sound $ext]
           if {![regexp -nocase {UNK:0} $wav]} {
#				$w.sound config -width $width -height $height
				pack $w.sound -fill both -expand 1
              if {$stream<=0} {
	       		if {$HTMLsync>0} {
						if {[lsearch $sound $fn]>=0} {
						   	    lappend sound $fn $w $start $wav
							    return $w
					        }
						lappend sound $fn $w $start $wav
						getSyncURL $url
						return $w
				} else {
						set linktext "$msgText(fiq.loading): $url"
						set url [getFileURL $url]
			    }
			}
		playAPP $url $w $start $wav ""
		} else {
				label $w.plugin -text "$msgText(applet.download):\n$plugin" -image imPlugin -compound left -borderwidth 2 -relief groove -background $bgcolor -cursor hand2
				bind $w.plugin <1> [subst "set urltext $plugin; goEnter"]
				bind $w.plugin <3> [subst "AddSelected $plugin 0"]
				bind $w.plugin <Any-Enter> [subst "set linktext \"$plugin\"; chkDanger $plugin"]
				bind $w.plugin <Any-Leave> [subst "set linktext {}"]
				pack $w.plugin -in $w -side top -anchor w -expand 1
		}
		return $w
	} elseif {$type!="" && [regexp -nocase {iframe|frame} $type]} {
	  	 #Inline Frames (generated by preParser)
	  	 if {$useFrames<=0} {
			labelframe $w -text "Frame: $fake" -borderwidth 2 -relief sunken -width $width -height $height -background $bgcolor
		   		set icon [fileType $ext]
		   		label $w.link -text $link -image $icon -compound left -background $bgcolor -foreground $linkcolor -cursor hand2 -relief groove
				bind $w.link <1> [subst "set urltext $href; goEnter"]
				bind $w.link <3> [subst "AddSelected $href 0"]
				bind $w.link <Any-Enter> [subst "set linktext \"$href\"; chkDanger $href"]
				bind $w.link <Any-Leave> [subst "set linktext {}"]
		   		pack $w.link -in $w -side bottom -anchor w -expand 1 -fill x
			pack $w
			return $w
		 }

		set x [getValue width $args]
		set y [getValue height $args]
		if {[regexp -nocase {%} $x]} {
		   regsub -nocase -all {[^0-9]} $x {} x
		   set width [expr [$mainHTML cget -width] / 100 * $x]
		}
		if {[regexp -nocase {%} $y]} {
		   regsub -nocase -all {[^0-9]} $y {} y
		   set height [expr [$mainHTML cget -height] / 100 * $y]]
		}
		 set h [string trimleft $w .]
		 set name [string tolower [getValue iFrame $args]]
		 if {[string length $name]<=0} {set name [lindex [split $w .] end]}
set name $activeHTM
		 set base [cutFile [regSTR $remSTR $url]]
		 set merkBase $baseurl($activeHTM)
		 setBase $base
		 frame $w -width $width -height $height
                 # -background $bgcolor
#		 if {$thumbsOnly>0} {
		   		set icon [fileType $ext]
		   		label $w.link -text $link -image $icon -compound left -background $bgcolor -foreground $linkcolor -cursor hand2 -relief groove
				bind $w.link <1> [subst "set urltext $href; goEnter"]
				bind $w.link <3> [subst "AddSelected $href 0"]
				bind $w.link <Any-Enter> [subst "set linktext \"$href\"; chkDanger $href"]
				bind $w.link <Any-Leave> [subst "set linktext {}"]
		   		pack $w.link -in $w -side bottom -anchor w -expand 1 -fill x
#		 }
#NEW030207:
set scroll [stripValue [getValue Scrollbars $args] 1]
set border [stripValue [getValue frameborder $args] 1]
		 createHTML $h $name $scroll $border
		 catch {$w.$name configure -base $base -width $width -height $height -background $bgcolor}
#		 $w.$name configure -width $width -height $height -background $bgcolor

#LoadFile $url
#puts "Frame: $src $url $w $href"
	  	if {[chkIMG $ext]} {
	  	    set htm "<BODY bgcolor=\"$htmlBG\"><img src=\"$url\"/>"
		} else {
#Es msste LoadFile an dieser Stelle aufgerufen werden, soda iFrames genau wie "normale" HTML-Seiten behandelt werden
#evtl mit 2. "LoadFile" Funktion die im SyncMode erst aufgerufen wird, NACHDEM das HTMfile eingetroffen ist (LoadFile ld es selbst)
		    set src [getFileURL $url]
			set htm [ReadFile $src]
			set HTMLsplit [splitHTM $htm]
			set htm [preParse $HTMLsplit]
			set htm [encode $htm]
			catch {unset HTMLsplit}
		}
#NEW180807: remove METArefresh
regsub -nocase -all "<META http-equiv='refresh' content='2; URL=" $htm "<META http-dummy='dummy' dummy='2; dummy=" htm
		$w.$name parse $htm
		catch {unset htm}
		setBase $merkBase
	} elseif {![regexp -nocase {about:blank|about%3Ablank} $plugin]}  {
 	#Unknown FileType for Applet; show PlugIn an Link URL
		labelframe $w -text "$msgText(applet.unkown): $fake" -borderwidth 2 -relief raised -width $width -height $height -background $bgcolor
				label $w.plugin -text "$msgText(applet.download):\n$plugin" -image imPlugin -compound left -borderwidth 2 -relief groove -background $bgcolor -cursor hand2
				bind $w.plugin <1> [subst "set urltext $plugin; goEnter"]
				bind $w.plugin <3> [subst "AddSelected $plugin 0"]
				bind $w.plugin <Any-Enter> [subst "set linktext \"$plugin\"; chkDanger $plugin"]
				bind $w.plugin <Any-Leave> [subst "set linktext {}"]
				pack $w.plugin -in $w -side top -anchor w -expand 1
		   		set icon [fileType $ext]
		   		label $w.link -text $link -image $icon -compound left -background $bgcolor -foreground $linkcolor -cursor hand2 -relief groove
				bind $w.link <1> [subst "set urltext $href; goEnter"]
				bind $w.link <3> [subst "AddSelected $href 0"]
				bind $w.link <Any-Enter> [subst "set linktext \"$href\"; chkDanger $href"]
				bind $w.link <Any-Leave> [subst "set linktext {}"]
		   		pack $w.link -in $w -side bottom -anchor w -expand 1 -fill x
		pack $w
		return $w
	}
	set linktext ""
}

#maybe Unused ?
proc HyperCmd {args} {
# "HyperLink" = anklickbarer Link auf HTML-Seite
	global debug
	if {$debug>4} {puts "HyperCmd: $args"}
}

#NEW110605: SoundHandler for BGsound (could directly called by HTML-Widget if a "bgsound"-Tag found)
#CHNG: 061106: currently unused !
proc sndHandler {args} {
	global playSounds onceSounds
	set datei [getValue src $args]
	set datei [getFileURL [reslvURL $datei]
	set ext .[string trim [lindex [split $datei .] end] .]
	if {[string length $ext]<=1} {set ext $datei}
	set loop [getValue loop $args]
	if {[string length $loop]<=0} {set loop 0}
	if {[chkSND $ext] && $playSounds==1} {
		catch {snd stop}
		#ConfigureSnackSound
		snd config -file $datei -skip 0
		if {$onceSounds==1} {
			snd play -start 0 -block 1 -command {catch {snd stop}} -blocking false
		} else {
			snd play -start 0 -block $loop -command {catch {snd stop}} -blocking false
		}
	}
}

# Liste Visit=Besuchte Links farbig Makrieren (isvisited)
proc IsVisited {args} {
	if {[string length $args]==0} {return 0}
	global histry debug
	if {$debug>6} {puts "Visited: $args"}
	set args [acode resolv [lindex [concat $args] 0]]
	#NEU150404: Querys in $args abfangen
	regsub -nocase -all {\?} $args {} args
	regsub -nocase -all {&} $args {} args
	if {[regexp -nocase {java} $args] || [regexp -nocase {script} $args]} {
		return 0
	}
	set args [lindex [split $args !] 0]
	set dummy $histry
	set dummy [acode encode [lsort -unique $dummy]]
	if {[lsearch -regexp $dummy [acode encode $args]]>-1} {
		# Suchbegriff (besuchte Seite) aus HTML-Seite in History gefunden
		return 1
	} else {
		return 0
	}
}

#NEU190304: BASE-Handler (wenn baseURL durch HTML-Page gesetzt)
proc baseHandler {args} {
	global debug
	if {$debug>1} {puts "baseHandler get: $args"}
	if {[string length $args]==0} return
	if {[regexp -nocase "base" [lindex $args 1]]} {
		setBase [getValue href [lindex $args 2]]
	}
}

# "BODY"-Tag Handler (Changes Colors on HTML-Display)
proc bodyHandler {args} {
	global debug changeBack htmldisplay htmlBG htmlFG mainHTML backImage colorSet styleParsed
	if {$changeBack==0 || $styleParsed==1} return
	if {$debug>3} {puts "BodyHandler get: $args"}
	set body [lindex $args 2]
	if {$debug>5} {puts "BODY: $body"}
	if {$debug>8} {puts "HTML: $htmldisplay"}
	#NEW020706: if Body doesn't contain "color" then don't check for colors
	if {[llength $body]>0} {
#	   	if {![regexp -nocase -all "$htmlBG|$htmlFG" $body]} {
			if {![setColor $mainHTML $body]} {
				setColor $mainHTML [list bgcolor $htmlBG color $htmlFG]
				set styleParsed 1
			}
			regsub -nocase -all {#} [$mainHTML cget -background] {} bgdummy
			regsub -nocase -all {#} [$mainHTML cget -foreground] {} fgdummy
			if {![regexp -nocase $bgdummy $htmlBG]} {set colorSet 1}
#		}
	} else {
return
		#NEU160304: Background durch (JAVA ?) Script-Tag ndern, wenn Color nicht durch HTML gesetzt wurde
		regsub -nocase -all {#} [$mainHTML cget -background] {} bgdummy
		regsub -nocase -all {#} [$mainHTML cget -foreground] {} fgdummy
		if {[regexp -nocase $bgdummy $htmlBG] || [regexp -nocase $fgdummy $htmlFG]} {
		#Wenn BG oder FG durch HTML nach "parsen" nicht verndert wurde
			set seite [split $htmldisplay \n]
			set lstart [lsearch -regexp $seite "<!--BODY"]
			if {$lstart>0} {
				set bgcolor #$htmlBG
				set fgcolor #$htmlFG
				set dummy [lindex $seite $lstart]
				set dummy [split $dummy { }]
				#BackgroundColor
				set bgidx [lsearch -regexp $dummy "background:"]
				if {$bgidx<=0} {set bgidx [lsearch -regexp $dummy "background-color:"]}
				if {$bgidx<=0} {set bgidx [lsearch -regexp $dummy "background="]}
				regsub -nocase -all {;} [lindex $dummy [expr $bgidx + 1]] {} bgcolor
				if {$debug>5} {puts "BGidx: $bgidx $bgcolor"}
				#ForegroundColor
				set fgidx [lsearch -regexp $dummy color:]
				if {$fgidx<=0} {set fgidx [lsearch -regexp $dummy color=]}
				regsub -nocase -all {;} [lindex $dummy [expr $fgidx + 1]] {} fgcolor
				if {$debug>5} {puts "FGidx: $fgidx $fgcolor"}
			   	if {![regexp -nocase -all "$htmlBG|$htmlFG" "$bgcolor $fgcolor"]} {
					if {![setColor $mainHTML [list bgcolor $bgcolor color $fgcolor]]} {
						setColor $mainHTML [list bgcolor $htmlBG color $htmlFG]
					}
					regsub -nocase -all {#} [$mainHTML cget -background] {} bgdummy
					regsub -nocase -all {#} [$mainHTML cget -foreground] {} fgdummy
					if {![regexp -nocase $bgdummy $htmlBG]} {set colorSet 1}
				}
			}
			unset seite lstart
		}
	}
}

#NEW111205: StyleHandler for CSS Styles if no Body Styles defined (works like BodyHandler)
proc styleHandler {args} {
	global changeBack debug msgText remSTR HTMLsync getCSS getBG filtVars
	if {[llength $args]<=0 || $changeBack==0} return
#NEW091206: recognize more than 1 StyleSheet
regsub -nocase -all {\} \{} $args "\}\n\{" dummy
set dummy [split $dummy \n]
if {[llength $dummy]>1} {set args [lindex $dummy end]}

	if {$debug>3} {puts "StyleHandler gets: $args"}
	set url ""
	regsub -nocase -all {\{+|\}+|<+|>+|\(+|\)+|\]+|\[+|\n|!--} $args { } styles
	regsub -nocase {^\-|,$} $styles {} styles
	catch {join $styles} styles
	if {[string length $styles]<=0} return
	if {[regexp -nocase { href} $styles]} {
		set url [getValue href $styles]
	} elseif {[regexp -nocase {@import} $styles]} {
	  	if {[regexp -nocase {url} $styles]} {
				set url [getValue url $styles]
	    } else {
				set url [getValue {@import} $styles]
	    }
	}
	if {[string length $url]>0} {
		set ext .[string trim [getEXT $url] .]
		if {[regexp -nocase {\.css$} $ext] && ![regexp -nocase $filtVars $url]} {
			set url [string trim [reslvURL $url 1] /]
			if {$HTMLsync>0} {
			    set getCSS 1
				getSyncURL $url
			   	return
			} else {
				dispMSG $msgText(style.get)
				set dummy [getFileURL $url]
				if {[string length $dummy]>0} {
					set styles [openFile $dummy]
#					regsub -nocase -all {\{+|\}+|<+|>+|\(+|\)+|\]+|\[+|\n|\.} $styles { } styles
				}
			}
#puts "style: $styles"
		}
	}
	setStyle $styles
	catch {unset styles dummy url}
}

#interprets parsed CSSstyle and defines Colors (called from StyleHandler, will call SetColor)
proc setStyle {styles} {
   	global changeBack htmlBG htmlFG msgText mainHTML colorSet styleParsed getCSS killCHR
   	if {$changeBack==0} {set getCSS 0; return}
	dispMSG $msgText(style.parse)
	setLED cyan
	set bgcolor ""
	set fgcolor ""
	set bgimage ""
	set link ""
	set vlink ""
	set alink ""
	regsub -nocase -all {\{+|\}+|<+|>+|\(+|\)+|\]+|\[+|\n} $styles { } styles
	regsub -nocase -all {&#44;} $styles {} styles
	set styles [string trim $styles -]
	regsub -nocase -all {body} $styles {;body} styles
	regsub -nocase {^\-|,$|\n|\t} $styles {} styles
	regsub -nocase -all {;} $styles "\n" styles
	set styles [split $styles \n]
#puts "Styles: $styles"
	set check [llength $styles]
	if {$check<=0} {set getCSS 0; return}
	set z 0
	set help ""
	set hilf 0
	foreach inhalt $styles {
		ProgressFile $z $check
		incr z
		if {[regexp -nocase {\*/} $inhalt] && ![regexp -nocase {/\*} $inhalt]} {set hilf 1; continue}
		if {[regexp -nocase {/\*} $inhalt]} {set hilf 0; continue}
		if {$hilf>0} continue
		#NEW171206: body background:rgb(29,33,12);
		if {[regexp -nocase {^.+:.*rgb.*} $inhalt]} {
			regsub -nocase -all {[^0-9,]|,} $inhalt {} dummy
			set dummy [split $dummy ]
			regsub -nocase {[^0-9]} [lindex $dummy 0] {} r
			regsub -nocase {[^0-9]} [lindex $dummy 1] {} g
			regsub -nocase {[^0-9]} [lindex $dummy 2] {} b
			if {$r!="" && $r>=0} {set r [format "%02x" $r]}
			if {$g!="" && $g>=0} {set g [format "%02x" $g]}
			if {$b!="" && $b>=0} {set b [format "%02x" $b]}
			if {$r!="" && $g!="" && $b!=""} {
				set dummy "#$r$g$b"
				regsub -nocase -all {:.+} $inhalt {} inhalt
				set inhalt "$inhalt color $dummy"
			}
		}

		regsub -nocase -all {:|,} $inhalt { } inhalt
		set merk $inhalt
#		regsub -nocase {^\-|^#[a-zA-Z0-9]+ |\(|\)|\[|\]|\"|\'|\-} $inhalt {} inhalt
        regsub -nocase {[^0-9a-zA-Z]} $inhalt { } inhalt
   		regsub -nocase -all { +} $inhalt { } inhalt
		set inhalt [string trim $inhalt "\-"]
		set inhalt [string trim $inhalt]
		regsub -nocase -all $killCHR $inhalt {} inhalt
#puts "Zeile: $inhalt"
		if {[string length $inhalt]<=0} continue
		switch -regexp $inhalt {
			"^body|bg" {set help "body"}
			"^a hover" {set help "hover"}
			"^a link" {set help "link"}
			"^a color" {set help "color"}
			"^a visited" {set help "visited"}
			"^a active" {set help "active"}
		}
#puts "Style: $merk"
		switch -regexp $help {
			"body" {
				if {[regexp -nocase {background-color} $inhalt]} {
					if {[string length $bgcolor]<=0} {
						set bgcolor [getValue background-color $inhalt]
					}
				} elseif {[regexp -nocase {backgroundcolor} $inhalt]} {
					if {[string length $bgcolor]<=0} {
						set bgcolor [getValue backgroundcolor $inhalt]
					}
				} elseif {[regexp -nocase {background color} $inhalt]} {
					if {[string length $bgcolor]<=0} {
						set bgcolor [getValue color $inhalt]
					}
				} elseif {[regexp -nocase {background} $inhalt]} {
					if {[string length $bgcolor]<=0} {
					    if {[regexp -nocase {url} $inhalt]} {
							set bgimage [getValue url $merk]
					    } else {
						  	set bgcolor [getValue background $inhalt]
						}
					}
				} elseif {[regexp -nocase {body color} $inhalt]} {
					if {[string length $bgcolor]<=0} {
						set bgcolor [getValue color $inhalt]
					}
				} elseif {[regexp -nocase {bgcolor} $inhalt]} {
					if {[string length $bgcolor]<=0} {
					    if {[regexp -nocase {url} $inhalt]} {
							set bgimage [getValue url $merk]
					    } else {
							set bgcolor [getValue bgcolor $inhalt]
						}
					}
				} elseif {[regexp -nocase {foreground} $inhalt]} {
					if {[string length $fgcolor]<=0} {
						set fgcolor [getValue foreground $inhalt]
					}
				} elseif {[regexp -nocase {color} $inhalt]} {
					if {[string length $fgcolor]<=0} {
						set fgcolor [getValue color $inhalt]
					}
				}
			}
			"color" {
				if {[string length $fgcolor]<=0} {
					set fgcolor [getValue color $inhalt]
				}
			}
			"hover" {
				if {[string length $fgcolor]<=0} {
					set fgcolor [getValue color $inhalt]
				}
			}
			"link" {set link [getValue color $inhalt]}
			"color" {
					if {$fgcolor=""} {
							set fgcolor [getValue color $inhalt]
					} else {
							set ctext [getValue color $inhalt]
					}
			}
			"visited" {set vlink [getValue color $inhalt]}
			"active" {set alink [getValue color $inhalt]}
		}
	}
	if {[string length $bgcolor]<=0} {set bgcolor $htmlBG}
	if {[string length $bgimage]<=0} {set bgimage ""}
	if {[string length $link]<=0} {set link blue}
	if {[string length $vlink]<=0} {set vlink LightBlue}
	if {[string length $fgcolor]<=0} {set fgcolor $vlink}
	if {[string length $alink]<=0} {set alink DarkBlue}
	regsub -nocase -all {#} [string trim $bgcolor] {} bgdummy
#	regsub -nocase -all {#} [string trim $fgcolor] {} fgdummy
	set bgcolor #$bgdummy
#	set fgcolor #$fgdummy
	if {$colorSet==0} {
		if {![setColor $mainHTML [list bgcolor $bgcolor color $fgcolor link $link vlink $vlink alink $alink bgimage $bgimage]]} {
			setColor $mainHTML [list bgcolor $htmlBG color $htmlFG]
		} else {
		  	  if {$bgcolor!=$htmlBG} {set styleParsed 1}
 		}
	}
	regsub -nocase -all {#} [$mainHTML cget -background] {} bgdummy
	regsub -nocase -all {#} [$mainHTML cget -foreground] {} fgdummy
	if {![regexp -nocase $bgdummy $htmlBG]} {set colorSet 1}
#	set styleParsed 1
	set getCSS 0
	ProgressFile 0 0
}

# MetaHandler wird aufgerufen wnn HTMLwidget "<meta>"-Tag enthlt
proc metaHandler {tag meta alist} {
	global debug urltext ignoreReDir maxDepth maxcount mainHTML filtVars msgText appText metaREDIR cancel baseurl activeHTM
	if {$cancel==1} {return}
	if {$debug>3} {puts "metaHandler: $tag $meta $alist"}
#	if {$ignoreReDir==1} {return}
	set url ""
	set help 0
	set wait 1
	foreach {name value} $alist {
#puts "NAME: $name / VAL: $value"
		if {[regexp -nocase {CONTENT} $name] && [regexp -nocase {URL} $value] && $help>0} {
			#set dummy [getValue content [join $alist]]
			set wait [lindex [split $value ";"] 0]
			set url [getValue url [join $value]]
			if {[string length $url]>0} break
		}
		if {[regexp -nocase {HTTP-EQUIV} $name] && [regexp -nocase {REFRESH} $value]} {set help 1}
#puts "META: $name / $value / $url \ $wait"
	}
	if {[string length $url]>0} {
		if {[regexp -nocase $filtVars $url]} return
		set url [reslvURL $url 1]
#puts "URL: $url / Base: $baseurl($activeHTM)"
		regsub -nocase -all {^[^0-9]+} $wait {} wait
#		if {(![regexp -nocase $baseurl($activeHTM) $url] && ![regexp -nocase $url $baseurl($activeHTM)]) && ($ignoreReDir<=0 || $maxcount<=$maxDepth)} {}
		if {![regexp -nocase $url $baseurl($activeHTM)] && ($ignoreReDir<=0 || $maxcount<=$maxDepth)} {
			if {![regexp -nocase -all $url $metaREDIR] && $url!=""} {
				incr maxcount
				set metaREDIR [list $wait $url]
			} else {
				incr maxcount
				set metaREDIR ""
			}
		} else {
			dispMSG $msgText(maximum.redir)
			setLED orange
			set inhalt "&nbsp;&nbsp;&nbsp;&nbsp;$msgText(maximum.redir)<br><a href=\"$url\">$url</a>"
			if {[winfo exists $mainHTML.info]} {destroy $mainHTML.info}
			label $mainHTML.info -image imHelp -background [$mainHTML cget -background]; pack $mainHTML.info -side top -anchor nw
			clearPage
			$mainHTML parse $inhalt
			catch {stop_anigif .mbar.lbAnim}
			.mbar.lbAnim configure -image imTuxAttention
			#.mbar.lbAnim configure -image imTuxUnallowed
		}
	}
}

#minimal HTMLparser
proc parseHTML {parent htmfile} {
	if {[string length $htmfile]<=0} return
	global debug htmlBG htmlFG urltext mainHTML remSTR htmldisplay HTMLsplit mainHTML urltext
	setLED cyan
	set dummy [regSTR $remSTR $htmfile]
	set ext .[string trim [getEXT $htmfile] .]
        if {[chkEXT $ext] || [chkTXT $ext] || [regexp -nocase -all {\?|&|=} $htmfile]} {
		# Seite nur laden, wenn ".htm(l)"-Seite; chkEXT prft das
		set fakefile [getFileURL $htmfile 0]
		set dummy [encode [ReadFile $fakefile]]
		set splitDummy [splitHTM $dummy]
		set dummy [preParse $splitDummy]
		if {[string length $dummy]>0} {
			if {[chkTXT $ext]} {set dummy "<BODY bgcolor=\"$htmlBG\"><plaintext>$dummy<plaintext\>"}
			if {[catch {$parent parse $dummy} err]} {
				onError "HTML_Parse Error: $err"
				return
			}
			if {$debug>9} {puts "HTMLdisplay: $dummy"}
			catch {createImgLinks $dummy}
			setTokens
		} else {
			dispMSG "Error: No File !"
			setLED red
		}
		append htmldisplay $dummy
		append HTMLsplit $splitDummy
		catch {unset splitDummy fakefile}
	}
	catch {unset dummy}
}

#Experimentell !!!!!
# <FRAMESET> Handler
# "Frameset" besteht aus mehreren "Frames" s.o.
proc setHandler {args} {
	global debug FRMcols FRMrows useFrames
	if {$debug>4} {puts "FrameSET: $args"}
	if {!$useFrames} return
	set dummy [lindex $args 2]
	#set FRMcols [lindex $dummy [expr [lsearch -regexp $dummy "cols"]+1]]
	#set FRMrows [lindex $dummy [expr [lsearch -regexp $dummy "rows"]+1]]
	foreach {wert para} $dummy {
		switch -regexp $wert {
			cols {
				set FRMcols [split $para ,]
			}
			rows {
				set FRMrows [split $para ,]
			}
		}
	}
#Hier msste ggf. der "FrameHandler" aufgerufen werden, NICHT durch parsen der HTML-Page !!!
#(Den "Token find FrameHandler"-Command also aus HTMLwidget wegnehmen !!!)
#	return 1
}

# <FRAME> Handler (currently unused !)
proc frmHandler {args} {
	global debug FRMcols FRMrows zlrFRM baseurl useFrames FRMargs backColor normLight mainHTML merkX merkY htmldisplay HTMLsplit
	if {$debug>4} {puts "Frame: $args"}
	if {!$useFrames} return
	set dummy [lindex $args 2]
	set name "none"
	set src "irgendwas"
	foreach {wert para} $dummy {
		switch -regexp $wert {
			name {
				set name [string tolower $para]
			}
			src {
				set src $para
			}
		}
	}
	set datei [reslvURL $src 1]
	if {$debug>4} {puts "Frame: $name $datei"}
	set fakefile [getFileURL $datei 0]
	set htmldisplay [encode [ReadFile $fakefile]]
	if {[string length $htmldisplay]<=0} return
	set HTMLsplit [splitHTM $htmldisplay]
	set x [lindex $FRMcols $zlrFRM]
	set y [lindex $FRMrows $zlrFRM]
	createHTML [string trim $mainHTML {\.}] [subst "$name"] 1 2
	set htmldisplay [preParse $HTMLsplit]
	if {[catch {$mainHTML.$name parse $htmldisplay} err]} {
		onError "$err FrameHandler: HTML_Parse Error: $err"
	}
	incr zlrFRM
	if {$x=="" || $x=="*"} {
		set merkX $x
	}

	if {$y=="" || $y=="*"} {
		set merkY $y
	}
}

#inlineFramehandler (experimental)
proc iFrameHandler {args} {
	global debug mainHTML htmlBG htmlFG useFrames baseurl activeHTM refererBACK HTMLreferer urltext remSTR newPage filtVars msgText
	if {$useFrames==0} return
	set args [join $args]
	#iFrame gets: 24 iframe {src index.html width 90% height 400 name iFrame1}
	if {$debug>2} {puts "iFrame gets: $args"}
#	set merk $urltext
	set mrkzlr 0
	set htmzlr 0
	set help 0
#CHNG220106:
set merkBase $baseurl($activeHTM)
	foreach dummy $args {
		set inhalt [join $dummy]
#puts "Inhalt: $inhalt"
		set name [getValue name $inhalt]
		set src [getValue src $inhalt]
		if {[regexp -nocase $filtVars $src]} {continue}
		if {[string length $src]>0} {
			setLED green
			dispMSG $msgText(parsing.frame)
		#puts "src: $src"
			set htm [reslvURL $src 1]
			LoadFile $htm
		}
	}
setBase $merkBase
#	set urltext $merk
}

#NEW231106: called by HTMLwidget
proc tFrameHandler {args} {
	 global mainHTML
puts "tFrame: $args"
	 set item [lindex $args 0]
	 set dummy [lindex $args 2]
	 set src [getValue src $dummy]
	 set name [getValue name $dummy]
	 if {[string length $name]<=0} {set name $item}
	 set width [stripValue [getValue width $dummy] 10]
	 set heigth [stripValue [getValue height $dummy] 10]
	 createHTML $mainHTML.$item $name 1 2
     set htm [getFileURL [reslvURL $src 1]]

}

#sets HTMLcolors (called from body and style Handler)
proc setColor {item props} {
	global debug showTableStruct backImage changeBack colorSet styleParsed useFrames mainHTML linktext msgText bgImage HTMLsync activeHTM \
	getCSS getBG filtVars
	if {[string length $item]<=0} {return 0}
	if {$styleParsed==1 && $useFrames==1} {return 1}
	if {![winfo exists $item]} {
		if {$debug>0} {puts "NOTexists: $item"}
		return 0
	}
	if {$debug>3} {puts "SetColor: item=$item props=$props"}
	set back 0
	foreach {area color} $props {
#puts "Area: $area $color"
        if {[regexp -nocase {margin} $area]} continue
		set area [string trim [string tolower $area]]
		regsub -nocase -all {#|-|<} $color {} color
		#regsub -nocase -all {#|-|<} $area {} area
		regsub -nocase -all {[^0-9a-zA-Z]} $area {} area
		set color [lindex [split $color >] 0]
		regsub -nocase -all {\x0a|\x0d} $color {} color
		#ColorTranslationTable
		regsub -nocase -all {aqua} $color {aquamarine} color
		regsub -nocase -all {silver} $color {gray80} color
		set chk [string length $color]
		if {$chk>2 && $chk<4} {
			set dummy [binary scan $color "a1a1a1" r g b]
			set color "#${r}0${g}0${b}0"
		} elseif {$chk>0 && $chk<=6} {
			if {![chkEXT $color] && ![chkIMG $color]} {
				# eventuelle Hintergrundbilder NICHT setzen
				if {[string is xdigit $color]} {
					set color [string trim $color]000000
					set color \#[string range $color 0 5]
				}
			}
		} elseif {$chk<2} {
		  	continue
		}
		if {$changeBack && $backImage && [chkIMG $color] && ![regexp -nocase $filtVars $color]} {
			if {[regexp -nocase {background|bgimage} $area] || [regexp -nocase { url} $color]} {
			#Load & Display Background Image
				regsub -nocase -all {url|\(|\)|\'|\"} $color {} color
				set color [reslvURL $color 1]
	  	   	    if {$HTMLsync>0} {
				   	if {[regexp -nocase $color $bgImage]} {continue}
					set getBG 1
					set bgImage $color
					getSyncURL $color
					continue
				}
				set linktext "$msgText(fiq.loading): $color"
				set fn [getFileURL $color 0]
				if {[file exists $fn]} {
					if {[info exists background($activeHTM)]} {image delete $background($activeHTM)}
					if {[catch {image create photo background($activeHTM) -file $fn}]==0} {
						$mainHTML bgimage background($activeHTM)
						set getBG 0
						set back 1
					}
				}
			}
		} else {
			if {[string length $color]<=0} {set color #FFFFFF}
			set bd 0
			if {$showTableStruct} {set bd 1}
			switch -exact $area {
				bgcolor {
					if {[catch {$item configure -background $color -highlightthickness $bd}]==0} {set back 1}
				}
				color {
					if {[catch {$item configure -foreground $color -highlightthickness $bd}]==0} {set back 1}
				}
				text {
					if {[catch {$item configure -foreground $color -highlightthickness $bd}]==0} {set back 1}
				}
				link {
					if {[catch {$item configure -unvisitedcolor $color}]==0} {set back 1}
				}
				vlink {
					if {[catch {$item configure -visitedcolor $color}]==0} {set back 1}
				}
				alink {
					if {[catch {$item configure -highlightcolor $color}]==0} {set back 1}
				}
				highlightbackground {
					if {[catch {$item configure -highlightbackground $color}]==0} {set back 1}
				}
			}
		}
	}
	catch {unset color item area}
	return $back
}

#currentlyUnused !!!
proc chkVisited {link htm} {
	global visitedGFX Images
	if {[lsearch -exact $visitedGFX $link]>=0} {
		set memgfx $Images($htm,$link)
		markImage $memgfx blue
	}
}

#AutoScrolls the Page (called mostly from synPic)
proc autoScroll {high} {
	global autoscroll shrinkBigSize maxImgSize minImgSize maxMarkSize mainHTML imScroll
	if {$autoscroll<=0} return
	set dummy 440
	if {$shrinkBigSize>0} {
		set dummy $shrinkBigSize
	}
	set gigahigh [expr $maxImgSize * 2]
	if {$high <= $maxImgSize} {
		if {$high > $minImgSize || $imScroll==0} {
			update
			$mainHTML yview scroll 1 units
		}
		if {$imScroll==0} {
			set imScroll 1
		} elseif {$imScroll==1} {
            set imScroll 2
		} else {
			set imScroll 0
		}
	} elseif {$high > $maxImgSize && $high <= $maxMarkSize} {
		update
		$mainHTML yview scroll 2 units
	} elseif {$high > $maxMarkSize && $high <= $dummy} {
		update
		$mainHTML yview scroll 3 units
	} elseif {$high > $dummy && $high <= $gigahigh} {
		update
		$mainHTML yview scroll 4 units
	} elseif {$high > $gigahigh} {
		update
		$mainHTML yview scroll 5 units
	}
}

#NEW170207: dummyHandler called from HTMLwidget on "DIV"-Tag (needed to prevent parsing Errors)
proc dummyHandler {args} {
     return ""
}
