package provide FIQIMG 1.0
#Frenzys Inquisitor GIF-Animation Functions V150504
#Replaces buggy "AniGIF"-Package (which provide errors, over errors...)
#GIF-Animation Routines from IMG1.3 Package (from ActiveTCL-Package)

#GIFanimator (based on ANIgifPackage); called for every Frame and only used with Tux on TopRight
proc update_anigif {w option num} {
	global imgPriv GIFdelay cancel waitANI menuSize
	#Cancel
	if {$cancel==1 || $num==-1 || $menuSize==1} {
		set num -1
		return
	}
	if {[info exists imgPriv($w,args)]} {
		set im [image create photo "${w}_[expr $num+1]"]
		$im copy $imgPriv($w,$num)
		incr num
		if {[catch "$im configure $imgPriv($w,args) -format \{gif -index $num\}"]} {
		unset imgPriv($w,args)
			if {$num>1} {
				set num 0
				catch {set im $imgPriv($w,$num)}
			} else {
				# this is not an animated GIF; just stop
				catch {unset imgPriv($w,0)}
				return
			}
		} else {
			#free storage
			catch {$im configure -data {} -file {}}
			catch {set imgPriv($w,$num) $im}
		}
	} else {
		incr num
		if {![info exists imgPriv($w,$num)]} {
			set num 0
		}
		catch {set im $imgPriv($w,$num)}
	}
	if {![info exists im]} {
		set num -1
		catch {unset imgPriv}
		return
	}
	if {[catch "$w $option $im"]} {
		catch {unset imgPriv($w,args)}
		foreach im [array names imgPriv $w,*] {
			catch {image delete $imgPriv($im)}
			catch {unset imgPriv($im)}
		}
	} else {
		update idletasks
		if {$GIFdelay>0} {
                      set waitANI [after $GIFdelay [list update_anigif $w $option $num]]
                }
	}
}

#Plays GIFanimation (TUX)
proc show_anigif {args w} {
	global imgPriv GIFdelay waitANI msgText menuSize
	if {$menuSize==1 || [regexp -nocase {imTuxmeter} [.mbar.lbAnim cget -image]]} {return}
	if {[catch "image create photo ${w}_0 $args -format \{gif -index 0\}" image]} {
		dispMSG "$msgText(display.animation) $image"
		return
	} else {
		#free storage
		catch {$image configure -data {} -file {} -format {}}
		$w configure -image $image
		set imgPriv($w,0) $image
		set imgPriv($w,args) $args
		update idletasks
		if {$GIFdelay>0} {
         		set waitANI [after $GIFdelay [list update_anigif $w {configure -image} 0]]
         	}
	}
	return $w
}

#Stops GIFanimation
proc stop_anigif {w} {
	global waitANI imgPriv kidZprotect ignoreReDir menuSize active
	if {$menuSize==1 || [regexp -nocase {imTuxmeter} [.mbar.lbAnim cget -image]]} {return}
	update_anigif $w {configure -image} -1
	catch {after cancel $waitANI}
	#Restore Normal Still-Image
	if {$kidZprotect==1} {
                $w configure -image imKidTux
        } else {
                if {$ignoreReDir==0} {
                       $w configure -image imAnim
                } else {
                       $w configure -image imTuxInfiltrate
                }
        }
	catch {unset imgPriv}
}

#GIF: -file G:/cache/html/yc/www.yoursexyteens.com%2Fimages%2Fblock4_09.gif image116 0
#GIF-Animations within HTML-Widget (works a litte bit different than ANIgif)
proc show_htmgif {args w link} {
	global seq ANIdelay waitHTM cancel playAnim thumbsOnly ficsVars
#if {[regexp -nocase {title.gif} $args]} return
	set chk [chkGIF $args]
#puts "GIF: $args $w $chk $link"
	if {$chk>1 && $playAnim>0} {
		for {set n 0} {$n < 64} {incr n} {
	  		if {$cancel>0} break
			if {![catch "image create photo $args -format \{gif -index $n\}" dummyGFX]} {
#puts "IMG1: $n"
			   set seq($w,$n) $dummyGFX
			} else {
			   catch "image create photo $args" dummyGFX
#			   incr n -1
#puts "IMG2: $n"
			   set seq($w,$n) $dummyGFX
			   break
			}
			set width [image width $dummyGFX]
			set height [image height $dummyGFX]
			if {$width<=6 || $height<=6} break
			if {$width>=300 || $height>=300} break
		}
		catch {$w copy $seq($w,0)}
#$w copy $seq($w,0)
		if {$ANIdelay>0 && $n>1} {
	       	set waitHTM [after $ANIdelay "animgif $w 1"]
		} elseif {$n<=1} {
			if {$thumbsOnly==1} {
				catch "$w copy imOPTthumbnail"
			} else {
			  	if {$link!=""} {
				  	set icon [fileType [transType .[getEXT $link]]]
					if {$icon!=""} {catch {$w copy $icon}}
					catch {image height $w} high
					autoScroll $high
				}
			}
		}
	} else {
	  	catch "image create photo $args" dummyGFX
		if {$thumbsOnly==1} {
			catch "$dummyGFX copy imOPTthumbnail"
		} else {
		  	if {$link!=""} {
			  	set icon [fileType [transType .[getEXT $link]]]
				if {$icon!=""} {catch "$dummyGFX copy $icon"}
				catch {image height $w} high
				autoScroll $high
			}
		}
		catch "$w blank"
#		catch "$w copy $dummyGFX"
		set width [image width $dummyGFX]
		set height [image height $dummyGFX]
		if {$width>6 && $height>6 && ![regexp -nocase -all $ficsVars $args]} {catch "$w copy $dummyGFX"}
#		if {$dummyGFX=="" || [catch "$w copy $dummyGFX"]!=0} {$w blank}
	}
	catch "$dummyGFX configure -data {} -file {} -format {}"
	catch {unset dummyGFX}
	return $w
}

#FrameHandler for each GIFframe
proc animgif {w n} {
	global seq ANIdelay waitHTM cancel onceAnim
	if {![info exists seq($w,$n)]} {set n 0}
	if {$onceAnim>0 && $n<=0} return
	if {$cancel>0} return
	catch {$w copy $seq($w,$n)}
    incr n
    update
	if {$ANIdelay>0} {
       	set waitHTM [after $ANIdelay "animgif $w $n"]
	}
}

#stops HTML GIFanimation
proc stop_htmgif {w} {
	global waitHTM seq
	catch {animgif $w 0}
	catch {after cancel $waitHTM}
	foreach im [array names seq $w,*] {
		catch {image delete $seq($w,$im)}
	}
	catch {unset seq}
}

#NEW231206: Check for corrupted GIF-Animation which allmost may CRASH Inquisitor
proc chkGIF {args} {
	 set args [join $args]
	 set back 0
	 if {[regexp -nocase {file} $args]} {
		 set datei [lindex $args 1]
		 if {$datei=="" || ![regexp -nocase {\.gif} $datei]} {return 0}
		 if {![file exists $datei] || [file size $datei]<1024} {return 0}
#TclMagick (unused cause of clouldn't used within EXE-File)
#set wand [magick create wand]
#$wand ReadImage $datei
#set back [$wand GetNumberImages]
#magick delete $wand
#return $back
#		 if {![catch {open $datei r} fp]} {
#			 fconfigure $fp -translation binary
#			 catch {read $fp} r
#		 	 catch {close $fp}
#		 }
#NEW210707: use GIFblock package 2 recognize number of GIFframes
		catch {::gifblock::gif.load gifarray $datei}
		foreach name [::gifblock::gif.blocknames gifarray] {
			if {[regexp -nocase "Image Descriptor" $name]} {
			   incr back
			}
		}
		catch {unset gifarray}
		return $back
	 } else {
       	 set r [lindex $args 1]
	 }
	 if {[regexp -nocase {netscape} $r]} {
	 #Count Images/Frames within a GIF
	    set count [regsub -nocase -all {\x2c} $r {} r]
		catch "expr $count / 3" back
	 }
	 catch {unset r}
	 return $back
}

#Display normal GIFimage
proc show_image {format type data} {
        global msgText
	if {![winfo exists .$format]} {
		frame .$format
		pack .$format -side top -expand y -fill x
		label .$format.l -text "[string toupper ${format}]: "
		pack .$format.l -side left
	}
	set w .$format.$type
	catch {destroy $w}
	if {[catch {image create photo [list $format $type] -data $data} image]} {
		dispMSG "$msgText(display.image) $type: $image"
	} else {
		$image configure -data {}
		label $w -image $image
	}
	pack $w -side left
	update idletasks
}

#Audio Levelmeter with DancingTUX
proc tuxOmeter {} {
        global cancel GIFdelay winSYS
        set l [expr [s max -start 0 -end -1 -channel 0] + 1]
        set r [expr [s max -start 0 -end -1 -channel 1] + 1]
        s length 0
	if {$winSYS==1} {
	#Windoof
		if {$l>$r} {
			if {$l>0 && $l<150} {.mbar.lbAnim configure -image imTuxmeter1; ProgressFile 20 100}
			if {$l>150 && $l<250} {.mbar.lbAnim configure -image imTuxmeter2; ProgressFile 40 100}
			if {$l>250 && $l<325} {.mbar.lbAnim configure -image imTuxmeter3; ProgressFile 60 100}
			if {$l>325 && $l<400} {.mbar.lbAnim configure -image imTuxmeter4; ProgressFile 80 100}
		} else {
			if {$r>0 && $r<150} {.mbar.lbAnim configure -image imTuxmeter5; ProgressFile 30 100}
			if {$r>150 && $r<250} {.mbar.lbAnim configure -image imTuxmeter6; ProgressFile 50 100}
			if {$r>250 && $r<325} {.mbar.lbAnim configure -image imTuxmeter7; ProgressFile 70 100}
			if {$r>325 && $r<400} {.mbar.lbAnim configure -image imTuxmeter8; ProgressFile 90 100}
		}
	} else {
	#Linux
		if {$l>$r} {
			if {$l>0 && $l<2000} {.mbar.lbAnim configure -image imTuxmeter1; ProgressFile 20 100}
			if {$l>2000 && $l<5000} {.mbar.lbAnim configure -image imTuxmeter2; ProgressFile 40 100}
			if {$l>5000 && $l<7000} {.mbar.lbAnim configure -image imTuxmeter3; ProgressFile 60 100}
			if {$l>7000 && $l<9000} {.mbar.lbAnim configure -image imTuxmeter4; ProgressFile 80 100}
		} else {
			if {$r>0 && $r<2000} {.mbar.lbAnim configure -image imTuxmeter5; ProgressFile 30 100}
			if {$r>2000 && $r<5000} {.mbar.lbAnim configure -image imTuxmeter6; ProgressFile 50 100}
			if {$r>5000 && $r<7000} {.mbar.lbAnim configure -image imTuxmeter7; ProgressFile 70 100}
			if {$r>7000 && $r<9000} {.mbar.lbAnim configure -image imTuxmeter8; ProgressFile 90 100}
		}
	}
        if {$cancel<1} {
                update idletasks
                #update
                after [expr $GIFdelay * 2] tuxOmeter
                #after $ANIdelay tuxOmeter
        } else {
                catch {snd stop; s stop}
                set cancel 0
                .mbar.lbAnim configure -image imAnim
		ProgressFile 0 0
        }
}

#Movie4Linux
proc playLNX {movie} {
	global msgText
	set root .movieholder
        if {![winfo exists $root]} {toplevel $root}
        wm title $root $msgText(display.movie.1)
		frame $root.f -height 300 -width 300
        $root.f configure -background black
		pack $root.f -side top -fill both -expand 1
        #place $root -x 270 -y 120
        update idletasks
        set frameid [winfo id $root.f]
        catch {exec xanim +Ze -Zr +Av75 +W$frameid /$movie}
        destroy $root
	#.movieholder
}

#Wird fr jedes <IMG SRC> vom HTMLwidget aufgerufen
proc ImageCmd {args} {
	global MapMode FTPrender activeHTM debug TableIDX ImageIDX htmlTD useApplet mainHTML renderIMG Images chkCHR ficsVars \
	showImages zlrGFX anzGFX anzSEL gamma maxDepth unknownGFX altTAG cancel tempFile tempMiniFile tempIcons killCHR
	if {$cancel==1 || [llength $args]<=0} {return}
	regsub -nocase -all {\\"} $args {} args
	if {$debug>2} {puts "Image get: $args"}
	if {!$showImages} {
		incr zlrGFX
		return imFileDownload
	}
	set idx [lindex $args end]
	regsub -nocase -all {"} $idx {} idx; #"
	set dummy [acode resolv [lindex $args 3]]

#CHNG161206: (only works with HTMLwidget>=2.0 cause it makes use of bgimagecommand)
#if {![regexp -nocase {src} $dummy]} {
#	set fn [getValue background $dummy]
#set fn [lindex $args 0]
#} else {
	set fn [getValue src $dummy]
#}

#NEW150707: internalImages
if {[regexp -nocase {^FIQ:} $fn]} {
   switch -regexp $fn {
   		  FIQ:pik {return imPik}
   		  FIQ:kreuz {return imKreuz}
   		  FIQ:heart {return imHeart}
   		  FIQ:karo {return imKaro}
   }
}

regsub -nocase -all {&#44;|&#044;|#44;|/?44;|&44;|44;} $fn {,} fn

#OUT041206:
#	set dummy [lindex [split $fn {\.}] end]
#	#new100606: Images bei Spiegel.DE
#	if {[chkALL [getEXT $fn]] && [regexp -nocase {,|;|\?|=} $dummy]} {
#		regsub -nocase {,|;|\?|=} $dummy {} dummy
#		set ext [lindex [split $dummy ] end]
#		regsub -nocase -all $ext$ $fn {} fn
#		set fn [string trim $fn {,|;|\?|=}]
#	}

	set fn [reslvURL $fn 0]
	set alt [getValue alt [lindex $args 3]]
	regsub -nocase -all {%20} $alt { } alt
	regsub -nocase -all "$killCHR|%28|%29|%5B|%5D" $alt {} alt
	lappend ImageIDX($activeHTM) [list $fn $idx]
	if {[llength $TableIDX($activeHTM)]<=0} {
		set TableIDX($activeHTM) [$mainHTML token find TD]
		set dummy [expr [lindex [lindex $TableIDX($activeHTM) end] 0] + $maxDepth]
		lappend TableIDX($activeHTM) $dummy
	}
	if {$FTPrender==1 && $MapMode==4} {
		set back [getImage "" $fn $zlrGFX]
		incr zlrGFX
		set Images($activeHTM,$fn) image${zlrGFX}
		#set Images($activeHTM,[transType [acode resolv $fn]]) image${zlrGFX}
		return $back
	}
#	set ext [getEXT $fn]
set ext [transType .[string trim [getEXT $fn] .]]
	#NEU090304 renderImage (vorab HTML-Seite whrend GFX DwnLoad anzeigen)
	if {$renderIMG>0} {
		set dummy $fn
		set width [lindex $args 1]
		set height [lindex $args 2]

#NEW050107:
		if {[regexp -nocase {%} $width]} {
		   regsub -nocase -all {[^0-9]} $width {} width
		   set width [expr [$mainHTML cget -width] / 100 * $width]
		}
		if {[regexp -nocase {%} $height]} {
		   regsub -nocase -all {[^0-9]} $height {} height
		   set height [expr [$mainHTML cget -height] / 100 * $height]]
		}

#		if {[regexp -nocase {%} $width]} {set width 0}
#		if {[regexp -nocase {%} $height]} {set height 0}
		regsub -nocase -all {[^0-9]} $width {} width
		regsub -nocase -all {[^0-9]} $height {} height
		#NEW120306: if width/heigth > 999 (bei Java mglich) nur die ersten 3 Zeichen nehmen
		set width [string range $width 0 3]
		set height [string range $height 0 3]
		#NEW160406:
		if {[string length $width]<=0} {set width 1}
		if {[string length $height]<=0} {set height 1}
		if {[expr $width * $height]>480000} {
		          set width 800
		          set height 600
		}
		if {[chkIMG $ext]} {
#NEW311206: only Images which are not in ficsVars (such as "spacer.gif")
if {![regexp -nocase $ficsVars $dummy]} {
			AddBuffer $dummy
}
			#NEU190304: ImageGrsse nur bei GFX setzen, deren Gre bekannt ist
			set img image${zlrGFX}
#puts "IMAGE: $dummy:$ext:$img"
#			set icon [fileType $ext]
#			if {$icon==""} {set icon imMiniTempFile}
			if {$width>22 && $height>22} {
				if {$tempIcons==1} {
					catch {image create photo -width $width -height $height -gamma $gamma} img
		#catch {image create photo -gamma $gamma} img
					if {![regexp -nocase $ficsVars $fn]} {
							#catch {::$img copy imTempFile}
							catch {::$img copy imMiniTempFile}
							#catch {::$img copy $icon}
							markImage $img grey
					}
				} else {
					catch {image create photo -width $width -height $height -gamma $gamma} img
	#catch {image create photo -gamma $gamma} img
#puts "IMG1"
				}
			} else {
				if {$tempIcons==1} {
					if {$width>16 && $height>16} {
#							catch {image create photo -gamma $gamma -data $tempMiniFile} img
	      	    				catch {image create photo -width $width -height $height -gamma $gamma} img
		#catch {image create photo -gamma $gamma} img
#puts "IMG2"
						if {![regexp -nocase $ficsVars $fn]} {
							catch {::$img copy imMiniTempFile}
							#catch {::$img copy $icon}
							markImage $img grey
						}
					} else {
	      				       	catch {image create photo -gamma $gamma} img
#puts "IMG3"
#Wenn aktiv, werden ALLE IMGs ohne Size um 1/2 verkleinert, weil sich FIQ spter die IMGsize holt !!!!!!!!!!!!!!!!!!
#if {$tempIcons==1} {catch {::$img copy imMiniTempFile}}
					}
				} else {
	#				catch {image create photo -gamma $gamma} img
					catch {image create photo -width $width -height $height -gamma $gamma} img
#puts "IMG4"
				}
			}
		} elseif {[chkALL $ext]} {
				AddBuffer $dummy
				catch {image create photo -width $width -height $height -gamma $gamma} img
#puts "IMG5"
#set icon imFileDownload
				set icon [fileType $ext]
				if {$icon==""} {set icon imMiniTempFile}
				catch {::$img copy $icon}
			#	catch {::$img copy imFTvideo}
				markImage $img grey
#				return $img
		} else {
		#FileType unknown, also KEIN GFX !
			incr zlrGFX
			if {$unknownGFX==1} {
				#return imFileBroken
if {$tempIcons==1} {catch {::$img copy imFileBroken}}
				return
			} else {
if {$tempIcons==1} {catch {::$img copy imFTunknown}}
				return
			}
		}
	} else {
		set link [expr [lindex $args end] - 1]
		set dummy $fn
		set fn [getFileURL $fn $link]
		if {[file exists $fn]} {
			set fsize [file size $fn]
			if {$fsize<=0} {
				incr zlrGFX
				return imFileBroken
			} else {
#CHNG010506:
#				set ext [getEXT $fn]
				set ext [lindex [split $fn .] end]
				if {[chkIMG $ext]} {
					if {[catch {image create photo -file $fn -gamma $gamma} img]} {
						#Image konnte nicht angezeigt werden
						incr zlrGFX
						if {$unknownGFX==1} {
							#return imFileBroken
							return
						} else {
							return imFTunknown
						}
					}
					set icon [fileType $fn]
					catch {::$img copy $icon}
				} elseif {[chkALL $ext]} {
					incr zlrGFX
					set icon [fileType $fn]
#set icon imFileDownload
#					catch {::$img copy $icon}
				  	return $icon
				} else {
				#FileType unknown, also KEIN GFX !
					incr zlrGFX
					if {$unknownGFX==1} {
						#return imFileBroken
						return
					} else {
						return imFTunknown
					}
				}
			}
		} else {
		#GFX-Datei gibt es nicht !
			incr zlrGFX
			if {$unknownGFX==1} {
				#return imFileBroken
				return
			} else {
				return imFTunknown
			}
		}
		set fn $dummy
	}
	set fn [acode resolv $fn]
if {![info exists Images($activeHTM,$fn)]} {
	set Images($activeHTM,$fn) $img
} else {
  	set img $Images($activeHTM,$fn)
}
	if {$debug>4} {puts "Image return: $fn = $img"}
	incr zlrGFX
	if {$alt!=""} {lappend altTAG($activeHTM,$img) $alt}

#Experimental: TextOverImages created by preParser
#	if {[regexp -nocase "text=" $args]} {
#	   set mtext [getValue text $args]
#puts "IMGTXT: $mtext"
#		canvas $w -relief flat -background black -width [image width $img] -height [image height $img]
#		$w create image 0 0 -image $img
#		$w create text 0 0 -text $mtext -font "arial 11 bold" -fill white -justify center
#		catch {image create photo -format window -data $w} img
#	}

	return $img
}

#Erstellt Zuordnung Thumb > Link Liste (zum Auflsen der HREF/SRC Images auf HTMlpage)
proc createImgLinks {html} {
	global debug TableIDX maxDepth mainHTML activeHTM liste htmlTD htmlIMG htmlIDX anzGFX tableOnly urltext remSTR cancel HTMLsplit backImage \
		filtVars codeCHNG htmlDIR textIMG
	if {$debug>6} {puts "HTML: $html"}

#NEW160706: show directory Listing
#if {$textIMG<1} {
	if {$htmlDIR==1 || [regexp -nocase {<title>(Index of /|directory|contents|verzeichnis)} $HTMLsplit]} {
		regsub -nocase -all {<img } $HTMLsplit "\n<img " dummy
		set htmlDIR 1
	} else {
		regsub -nocase -all {<a } $HTMLsplit "\n<a " dummy
		set htmlDIR 0
	}
#}
#NEW020107: break on DIVtag cause, if a href and 2 imgsrc in line, only last image will stored in array: liste
if {[regsub -nocase -all {<div class='imagethumb'>} $dummy "\n<div class='imagethumb'>" dummy]<=0} {
        regsub -nocase -all {<div} $dummy "\n<div" dummy
        regsub -nocase -all {</div>} $dummy "\n</div>\n" dummy
}
#	regsub -nocase -all {#44;} $dummy {,} dummy
#	regsub -nocase -all {;} $dummy {%3B} dummy
    regsub -nocase -all {<|>} $dummy { } dummy
regsub -nocase -all {\(} $dummy {%28} dummy
regsub -nocase -all {\)} $dummy {%29} dummy
regsub -nocase -all {\[} $dummy {%5B} dummy
regsub -nocase -all {\]} $dummy {%5D} dummy
	set html [split $dummy \n]
	set max [llength $html]
	set z 0
	setLED cyan
	set href ""
	set hsrc ""
	foreach zeile $html {
#puts "$z Zeile: $zeile"
		if {$cancel==1} {break}
		if {$debug>8} {puts "crtIMG Zeile: $zeile"}
		ProgressFile $z $max
		incr z
                regsub -nocase -all {\n| +} $zeile { } zeile
                if {[string length $zeile]<=0} continue
		if {[regexp -nocase {td } $zeile]} {
			if {[regexp -nocase {background} $zeile] && $backImage==1} {
				regsub -nocase {background} $zeile {src} zeile
			}
		}
            if {[regexp -nocase { href} $zeile] && [regexp -nocase { src} $zeile]} {
			set dummy [getValue href $zeile]
			set href ""
			if {[string length $dummy]>0} {
				set href [reslvURL $dummy 0]
				set href [acode encode $href]
#                                regsub -nocase -all $codeCHNG $href {} href
                                #regsub -nocase -all {%00+} $href {%00} href
			}
			set dummy [getValue src $zeile]
			set hsrc ""
			if {[string length $dummy]>0} {
				set hsrc [reslvURL $dummy 0]
				set hsrc [acode encode $hsrc]
				#regsub -nocase -all $codeCHNG $hsrc {%00} hsrc
				#regsub -nocase -all {%00+} $hsrc {%00} hsrc
			}
#NEW160607: chk4 "header.|footer.": 1. link XY = img1, 2. link XY = Footer.gif berschreibt 1. Link
			if {[string length $href]>0} {
                           if {[info exists liste($activeHTM,$href)]} {
                                    if {[string length $liste($activeHTM,$href)]<[string length $hsrc] || ![regexp -nocase -all {header\.|footer\.} $hsrc]} {
                                                set liste($activeHTM,$href) $hsrc
                                    }
                           } else {
                                    set liste($activeHTM,$href) $hsrc
                           }
                        }
#puts "Liste: [array get liste]"
#puts "Liste: $href \nSRC: $hsrc \nDummy: $dummy"
#puts "CTRL: $liste($activeHTM,$href)"
#puts "crtIMG Zeile: $zeile"
#			set hsrc ""
		} elseif {[regexp -nocase {src} $zeile] && [regexp -nocase {usemap} $zeile]} {
			set dummy [getValue src $zeile]
			set hsrc ""
			if {[string length $dummy]>0} {
				set hsrc [reslvURL $dummy 0]
				set hsrc [acode encode $hsrc]
#				regsub -nocase -all $codeCHNG $href {} href
				#regsub -nocase -all {%00+} $href {%00} href
			}
			set dummy [getValue usemap $zeile]
			regsub -nocase -all {#} $dummy {} dummy
			set maplist ""
			foreach hilf $html {
				if {[regexp -nocase -all { map } $hilf]} {
					lappend maplist $hilf
				}
			}
			set mapref [fGrep $dummy $maplist]
			if {[regexp -nocase {map} $mapref] && [regexp -nocase { href} $mapref]} {
				set dummy [getValue href $mapref]
				set href ""
				if {[string length $dummy]>0} {
					set href [reslvURL $dummy 0]
					set href [acode encode $href]
#                                        regsub -nocase -all $codeCHNG $href {} href
                                        #regsub -nocase -all {%00+} $href {%00} href
				}
				if {[string length $href]>0} {set liste($activeHTM,$href) $hsrc}
			}
		} elseif {[regexp -nocase { src} $zeile]} {
#Das KANN eigentlich nicht mehr eintreten, da jetzt GRUNDSTZLICH HREFs zu jedem SRC erzeugt werden in nonLinks
		#HTM-Seite enthlt NUR SRC Image OHNE Link (HREF) !
			set dummy [getValue src $zeile]
			set hsrc ""
			if {[string length $dummy]>0} {
				set hsrc [reslvURL $dummy 0]
				set hsrc [acode encode $hsrc]
			}
			if {[string length $href]>0} {
				set dummy [fileDIR $href]
				set file [lindex [split $hsrc /] end]
				set href [acode encode [encode [string trimright $dummy /]/$file]]
			}
		}
	}
	if {$cancel==1} {return}
	setLED cyan
	#NEU160304: TableBackground anstatt Image laden
	set dummy $TableIDX($activeHTM)
	set tabStart [lindex [lindex $dummy 0] 0]
	set tabStop [expr [lindex [lindex $dummy end] 0] + $maxDepth]
	if {$debug>6} {puts "TabStart: $tabStart $tabStop"}
	set htmlTD ""
	foreach inhalt $dummy {
		if {$cancel==1} {break}
#		if {[regexp -nocase {background} $inhalt]} {}
		if {[regexp -nocase {background} $inhalt] && $backImage==1} {
			regsub -nocase {background} $inhalt {src} inhalt
			set inhalt [regSTR $remSTR $inhalt]
			if {$debug>7} {puts "an Image: $inhalt"}
			set idx [lindex $inhalt 0]
			set src [getValue src $inhalt]
#NEW230106:
if {[grep $filtVars $src]>0} {continue}
			set width [stripValue [getValue width $inhalt] 0]
			set height [stripValue [getValue height $inhalt] 0]
			regsub -nocase -all {%20} $src { } src
			regsub -nocase -all {%20} $inhalt { } inhalt
#puts "IMAGEcmd: $src"
          	ImageCmd $src $width $height $inhalt $idx
			lappend htmlTD $inhalt
		}
	}
	if {$cancel==1} {return}
	set htmlIMG [concat [$mainHTML token find img] $htmlTD]
	if {$debug>8} {puts "htmlIMG: $htmlIMG"}
	set anzGFX [llength $htmlIMG]
	set htmlIDX($activeHTM) ""
	set i 0
	setLED cyan
	set ext .[getEXT $urltext]
	foreach inhalt $htmlIMG {
		if {$cancel==1} {break}
		set inhalt [acode resolv $inhalt]
		set imgIDX [acode resolv [lindex [lindex $htmlIMG $i] 0]]
		incr i
		set inhalt [regSTR $remSTR $inhalt]
		set dummy [reslvURL [getValue src $inhalt] 0]
#NEW140106:
if {[grep $filtVars $dummy]>0} {continue}
		if {$tableOnly==1 && [chkEXT $ext]} {
			if {$imgIDX>=$tabStart && $imgIDX<=[expr $tabStop + $maxDepth]} {
				if {$debug>3} {puts "imgIDX: $inhalt $imgIDX"}
				lappend htmlIDX($activeHTM) $dummy
			} else {
				lappend htmlIDX($activeHTM) $dummy
			}
		} else {
			lappend htmlIDX($activeHTM) $dummy
		}
	}
	if {$debug>8} {
		puts "htmlIDX: $htmlIDX($activeHTM)"
		puts "HTML: $href"
		puts "HSRC: $hsrc"
	}
	ProgressFile 0 0
}

#NEW260904: MarkImage Blue if Viseted
proc markImage {memgfx border} {
	global underlineHyper keepColor gamma winSYS
	if {[string length $memgfx] <= 0} return
#puts "MarkImg get: $memgfx $border"
	set rand 2
	catch {image width $memgfx} width
	catch {image height $memgfx} height
	if {[string length $width]>0} {
		if {$width<=1} {set width 0}
	} else {
                set width 0
	}
	if {[string length $height]>0} {
		if {$height<=1} {set height 0}
	} else {
	        set height 0
	}
	if {[expr $width * $height]>480000} {
               set width 800
               set height 600
	}
	set img ""
	switch $border {
		blue {
			set color DarkBlue
			set color2 Blue
			set img imMarkicon
		}
		green {
			set color LightGreen
			set color2 Green
			set img imOKbutton
		}
		orange {
			set color yellow
			set color2 orange
			set img imEscape
		}
		yellow {
			set color red
			set color2 red3
			set img imFTforbid
		}
		red {
			set color red
			set color2 red3
			set img imCancel
		}
		grey {
			set color grey31
			set color2 grey71
			set rand 1
		}
		default {
			set color DarkBlue
			set color2 Blue
			set img imMarkicon
		}
	}
	if {$underlineHyper==1} {
		if {$keepColor==1} {
			#farbiger Rahmen um Image
			if {$width>10 && $height>10} {
				catch {::$memgfx put $color2 -to $width 0 [expr $width - $rand] $height}
				catch {::$memgfx put $color2 -to 0 $height $width [expr $height - $rand]}
				catch {::$memgfx put $color -to 0 0 $width $rand}
				catch {::$memgfx put $color -to 0 0 $rand $height}
#                                #NEW250406: cross over TempImages
#	                        if {$border=="grey"} {
#                			catch {::$memgfx put $color -to 0 0 $width $height}
#                      			catch {::$memgfx put $color2 -to $width 0 0 $height}
#                                }

#puts "MARKimg: $memgfx"
				catch {unset width height}
			}
		} else {
			#Nur 4 Punkte in Ecken
			if {$width>12 && $height>12} {
				set x1 [expr $width-10]
				set x2 [expr $x1+5]
				set y1 [expr $height-10]
				set y2 [expr $y1+5]
				catch {::$memgfx put $color -to 5 5 10 10}
				catch {::$memgfx put $color2 -to $x1 5 $x2 10}
				catch {::$memgfx put $color2 -to 5 $y1 10 $y2}
				catch {::$memgfx put $color -to $x1 $y1 $x2 $y2}
				catch {unset width height x1 x2 y1 y2}
			}
		}
		if {[string length $img]>0} {
			catch {::$memgfx copy $img}
			#catch {::$memgfx copy $img -shrink}
		}

	}
	catch {::$memgfx configure -gamma $gamma}
	#::$memgfx copy imFileBroken
        #disable 4 WinDoof otherwise CRASH !!!
        if {$winSYS==0} {update idletasks}
}

#Colorize macht Thumbs heller/dunkler, wenn Maus darber fhrt
proc colorize {parent x y} {
	global active activeHTM linkmark linktext mouseOver MapMode merk onLink gamma underlineHyper debug remSTR altTAG bHelp sMode \
	       winSYS maxMarkSize backColor msgText fTypes fgColor backColor showDecode killCHR thumbsOnly
	if {$MapMode!=3} return
	regsub -nocase {\.x$} $parent {} parent
	if {!$active} {
		set mouseOver [lindex [split $parent .] end]
		set link [$parent href $x $y]
		if {$debug>8} {puts "colorize link: $link"}
		set merkHTM $activeHTM
		set activeHTM $mouseOver
		set dummy [string trim [reslvURL [lindex $link 0]]]
		set activeHTM $merkHTM
		set linkdummy [acode decode $dummy]
		if {$winSYS>0} {regsub -nocase {^/|^%20} $linkdummy {} linkdummy}
#CHNG241106:
		set dummy [freezeURL $linkdummy]
		set danger [chkDanger $dummy]
#NEW101106:
#		regsub -nocase {[0-9]+$} $dummy {} linktext
#CHNG211206:
		set help [cutLink $dummy]
		regsub -nocase -all $killCHR $help {\.} help
#		regsub -nocase -all $killCHR $dummy {} chk
		if {[regexp -nocase $help $dummy]} {
		   		set linkdummy $help
		} else {
				set linkdummy $dummy
		}

		if {$showDecode<=0} {
		   		set linktext $dummy
		} else {
		   		set linktext $help
		}
		#set linkdummy [transType $linkdummy]
		if {[string length $linktext] > 0} {
			#Maus steht auf einem Link
			if {[$parent cget -cursor]!="watch"} {
				$parent configure -cursor hand2
			}
            set onLink 1
			if {$underlineHyper==1} {
        			set memgfx [getLink $linkdummy $mouseOver]
        			if {$linkmark == 1 && [string length $memgfx] > 0} {
        				# alte GFXselection deaktivieren (GFX wieder "normal")
        				if {[string length $merk] > 0} {
        					#alte GFXselection deaktivieren, wenn Maus im leeren Bereich
        					if {[info exists merk]} {
						   catch {::$merk configure -gamma $gamma} err
   	   					   .imHTTPS configure -background $backColor
						}
        				}
        				# neue GFXselection aktivieren (heller; norm: gamma=2)
        				if {[info exists merk]} {
							#Image nur dann heller machen, wenn kleiner als $maxImgSize PX
	        				catch {image width $memgfx} width
							catch {image height $memgfx} height
							#set imgsize [expr $width * $height]
							catch {expr $width * $height} imgsize
							set check [expr $maxMarkSize * $maxMarkSize]
						   	if {[cacheExists $linkdummy]>0} {
						   	   .imHTTPS configure -background yellow
 	      	   				   set linktext "$msgText(site.cache.exists): $linktext"
						   	}
							if {$imgsize <= $check} {
								if {$danger>0} {
									catch {::$memgfx configure -gamma 0.5} err
								} else {
									catch {::$memgfx configure -gamma 2} err
								}
								set merk $memgfx
							}
							set dummy ""
							catch {set dummy [join $altTAG($mouseOver,$memgfx)]}
							if {[string length $dummy]>0 && $dummy!="\{\}" && $bHelp==1 && ![regexp -nocase {a href} $dummy]} {dispINF $dummy}
	        			}
					if {$sMode > 0} {$parent selection clear}
        			} else {
				#TextLinks farbig (oder mit "*") markieren
					set tid [getToken [join $link]]
					if {$tid > 0} {
						if {$winSYS == 0} {
                            $parent selection set $tid.0 $tid.end
                        } else {
                            $parent selection set $tid [expr $tid + 2]
                        }
					}
#				   	if {[cacheExists $linkdummy]>0} {
#				   	   .imHTTPS configure -background yellow
#				   	} else {
#					   .imHTTPS configure -background $backColor
#				   	}
				}
        		}
		} else {
			#Maus NICHT "ber" Link
			$parent configure -cursor {}
			if {$sMode > 0} {$parent selection clear}
			set onLink 0
			if {$underlineHyper==1} {
                                if {$linkmark == 1 && [string length $merk] > 0} {
        				if {[string length $merk] > 0} {
        					#alte GFXselection deaktivieren, wenn Maus im leeren bereich
        					if {[info exists merk]} {
						   catch {::$merk configure -gamma $gamma} err
	   					   .imHTTPS configure -background $backColor
						}
        				}
        				set merk ""
        			}
        		}
		}
	}
}

proc copyPic {datei url check} {
	#"normal"-Zustand (GFX download)
	global destDir homeDir activeHTM cutGfx cutType dontaccept fileOK FTPrealprev etryBack backColor crtThumbs convert FTPask \
		autoscroll mainHTML minFileSize debug msgText thumbsOnly cacheLocation volumes remSTR downMode selected destSpace
	if {[string length $datei]<=0 || ![file exists $datei]} return
	if {$debug>2} {puts "copyPIC: get: $datei $url $check"}

#NEW251106: change url if FileURL is other then requested URL (if file was redirected)
if {![regexp -nocase $url $selected]} {
	set dummy [lindex [split $datei /] end]
	set dummy [acode resolv $dummy]
	if {[string length $dummy]>=[string length $url] && ![regexp -nocase $url $dummy]} {
	   set url [cutFile $dummy]
	} elseif {[string length $dummy]<[string length $url] && ![regexp -nocase $dummy $url]} {
	   set test [string trim [lindex [split $dummy /] 1]]
	   if {[regsub -nocase -all {/} $dummy {/} dummy]!=2 || ([string length $test]!=10 || ![regexp -nocase -all {[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]} $test])} {
	      set url [cutFile $dummy]
	   }
	}
}

	#NEW110606:
	if {$downMode>0} {set fileOK $check}
#puts "copyPIC: get: $datei $url"
	#1. Eintrag markieren (weil akt, Download)
	.tile.bottom.foot.box.selected tag configure 1 -foreground $etryBack -background $backColor -relief ridge -borderwidth 2
	#set fn [lindex [split $datei ?] 0]
#	set datei [acode decode $datei]
	set fn [acode decode $datei]
#	set srcurl [getFileURL $fn 0]
	set srcurl $datei
	set srcFile [acode encode [lindex [split $fn /] end]]
#NEW100606: If a Image is redirected, use the URL from the (Cache-) Filename, NOT the redirected URL !
	set dummy [regSTR $remSTR $url]
	set chkURL [acode decode [lindex [split $datei /] end]]
#puts "chkURL: $chkURL"
#puts "dummy : $dummy"
	if {$dummy!=$chkURL && [string length $dummy]==[string length $chkURL]} {set url $chkURL}
#puts "URL: $url"
	set destFile [string trimright $destDir /]/$srcFile
	if {[string length $srcFile]<=6} {
	# WENN FileName sehr kurz, hnge vorherigen DirName vorweg
		set dir [string trimright [fileDIR $fn] /]
		set dir [lindex [split $dir /] end]
		set destFile [string trimright $destDir /]/${dir}_$srcFile
	}
	set extension [getEXT $destFile]
	if {$cutGfx==1} {
		if {$cutType=="All Selected" || $cutType=="All_Files"} {
			regsub -nocase -all {\-} [clock clicks] {} code
			set destFile [string trimright $destDir /]/$code.$extension
		} else {
			if {[regexp -nocase $cutType $extension]} {
				regsub -nocase -all {\-} [clock clicks] {} code
				set destFile [string trimright $destDir /]/$code.$extension
			} else {
				if {[reGrep $cutType [array names fTypes]]} {
					if {[reGrep $extension $fTypes($cutType)]>0} {
						regsub -nocase -all {\-} [clock clicks] {} code
						set destFile [string trimright $destDir /]/$code.$extension
					}
				}
			}
		}
	}
	if {[file exists $destFile]} {
		#File existiert im Zielordner bereits, also umbenennen
		set zielname [lindex [split $destFile .] 0 ]
		regsub -nocase -all {\-} [clock clicks] {} code
		set destFile $zielname\_$code.$extension
	}
#puts "copyPIC: $srcurl $destFile $fileOK $dontaccept"
	if {$fileOK>$dontaccept} {
		#Convert Type of Image
		set fake [convertGFX $srcurl $convert]
		set ext [getEXT $srcurl]
		if {![chkIMG $ext]} {
#puts "CopyPIC: $srcurl $ext [file size $srcurl] $minFileSize"
#			set fileOK 1
#			set srcurl [readHTML $srcurl $url]
#			if {![chkIMG [getEXT $srcurl]]} {
				return $url
#			}
		}

#Error090711: 
#could not read "/home/frenzy/Inquisitor/cache/...F6.jpg": no such file or directory
#    while executing
#"file size $srcurl"
#		set fSize [file size $srcurl]
#if {![file exists $srcurl]} return
set fSize -1
catch {file size $srcurl} fSize
		if {$fSize<=$minFileSize && $check > 0} {
			if {$downMode>0} {
				AddSelected $url $check
			} else {
				AddSelected $url 1
			}
			return $url
		}
#		if {[chkEXT $srcurl]} {return $srcurl}
		if {[regexp -nocase {\?|&|%} [lindex [split $destFile .] end]]} {
			regsub -nocase {\?|&} $destFile {} destFile
			set destFile [lindex [split $destFile ] 0]
		}
		if {$debug>3} {puts "copyPIC: copies: $srcurl $destFile"}
		if {[catch {file copy $srcurl $destFile}]!=0} {set fileOK 1; set check 1}
#catch {file copy $srcurl $destFile}
		set back 0
		set kSize [expr $fSize / 1024]
        set destSpace [expr $destSpace - $kSize]
        if {$destSpace < 102400} {set back 1; .tile.bottom.pane.f3.box.prgBar configure -background red; setLED red; dispMSG $msgText(warning.destSpace)}
		if {$back > 0 && $FTPask > 0} {
				optionBox -title $msgText(warning.lowSpace.1) -icon warning -type ok -message $msgText(warning.lowSpace.2)
		}

#NEW160106:
#if {$thumbsOnly<=0} {
#	dispMSG $msgText(picture.copied)
#}
#puts "copy: $srcurl $destFile $url"
		if {$downMode>0} {
			AddSelected $url $check
		} else {
			AddSelected $url 1
		}
#		if {$autoscroll > 0} {update idletasks; $mainHTML yview scroll 1 units}
		if {$FTPrealprev>0} {
		#NEW031005: Create RealTime FTP-Preview while Download
			set dfile [string trim [lindex [split $destFile /] end] /]
			set cfile [acode encode [string trim [fileDIR $destFile] /]]
			set prevdir [string trimright $cacheLocation /]/cache/preview
			set cachedir ${prevdir}/[getCachedir $cfile]
			if {![file isdirectory $cachedir]} {file mkdir $cachedir}
			set filename ${cachedir}/${cfile}.FQV
			if {[file exists $filename]} {
			#Do PreviewFile exists ?
				set thumb [getLink $url $activeHTM]
				if {[string length $thumb]>0} {
					if {![catch {open $filename a} write]} {
						puts $write "$dfile [list [$thumb data -format jpeg]]"
						close $write
					}
				}
			} else {
				set thumb [getLink $url $activeHTM]
				if {[string length $thumb]>0} {
					if {![catch {open $filename a} write]} {
						puts $write "/. [list [imHomePNG data -format jpeg]]"
						puts $write "/.. [list [imFTopen data -format jpeg]]"
						foreach inhalt $volumes {
                             				     if {[file isdirectory $inhalt]} {
                                                                       puts $write "/[string trim $inhalt /] [list [imFThdd data -format jpeg]]"
                                                             }
						}
						if {$crtThumbs>0} {puts $write "/thumbs [list [imFTfolder data -format jpeg]]"}
						puts $write "$dfile [list [$thumb data -format jpeg]]"
						close $write
					}
				}
			}
		}
		#NEU100604: create KQ compatible ThumbPreviews
		if {$crtThumbs>0} {
			set thumbdir [string trimright $destDir /]/thumbs/
                        set thumbfile [string trimright $thumbdir /]/THUMBS.HTML
			if {![file isdirectory $thumbdir]} {
				if {$debug>5} {puts "creating Thumbdir: $thumbdir"}
				catch {file mkdir $thumbdir}
			}
#			set thumb [getLink $url $activeHTM]
                        set thumb [link2thumb $url]
			if {[string length $thumb]>0} {
				if {$debug>8} {puts "Thumbname: $thumb"}
					set destDummy [lindex [split $destFile .] 0].jpg
					regsub -nocase -all $destDir $destDummy $thumbdir destThumb
					regsub -nocase -all {/+} $destThumb {/} destThumb
					set destDummy [lindex [split $destFile /] end]
                        		set chart [getCachedir $thumb]
                        		set srcThumb [string trimright $cacheLocation /]/cache/html/[string trim $chart]/$thumb
					if {$debug>5} {puts "write Thumb: $destThumb"}
					#catch {::$thumb write $destThumb -format jpeg}
					catch  {file copy -force $srcThumb $destThumb}
                                        #NEW180406: write THUMBS.HTML file
                        	 	if {![catch {open $thumbfile "a+"} write]} {
                                		puts $write "<a href=\"../$destDummy\"><img src=\"$destDummy\">$destDummy</a>"
                                		close $write
                                	}
					catch {unset thumb}
			}
		}
	} else {
		if {$downMode>0} {
			AddSelected $url $check
		} else {
			AddSelected $url 1
		}
	}
	#NEW240905: Autoscroll
	#if {$autoscroll > 0} {update idletasks; $mainHTML yview scroll 1 units}
	return $srcurl
}

#Download all Pics of List: "$selected"
proc grabPIC {datei mode} {
	global convert dontaccept fileOK debug TableIDX ImageIDX playAnim backColor etryBack normLight mainHTML htmlTD maxMarkSize \
               waitID tableOnly grabMode renderIMG renderUPD Images activeHTM active destDir buffer cancel winSYS \
               linktext url zlrGFX anzGFX anzSEL cutGfx linkmark markIcons cutType fTypes anzDest msgText bytesTotal filtVars \
	       thumbsOnly ByteCount maxBytes autoscroll FTPrealprev homeDir tempIcons maxImgSize minImgSize shrinkBigSize imScroll
	if {$datei == ""} return
	set datei [acode resolv $datei]
	if {$debug>3} {puts "grabPIC bekommt: $datei $mode"}
	if {![file isdirectory $destDir]} {
		catch {file mkdir $destDir}
		dispMSG $msgText(dir.create)
		setLED cyan
		set anzDest 0
	}
#	set active 1
	set icon ""
	set check 0
	set anzGFX [llength $buffer]
	if { $anzGFX > 0 } {
		if {!$mode} {
			catch {stop_anigif .mbar.lbAnim}
			catch {show_anigif [list -data [getAnim penguinL22]] .mbar.lbAnim}
		}
		set zlrGFX 0
		set imScroll 0
		foreach inhalt $buffer {
			set fn [lindex [split $inhalt ] 0]
			set fn [acode resolv $fn]
#puts "GP: $inhalt"
			set ext [getEXT $fn]
			#NormalZustand GFXdownload aus anzuzeigender HTMLseite
			set lidx [lindex [fGrep $fn $ImageIDX($activeHTM)] 1]
			if {$debug>4} {puts "GrabPic: $fn $lidx"}
			if {$cancel==1} {
				$mainHTML configure -cursor {}
				.tile.bottom.foot.box.selected configure -cursor {}
				break
			}
			set erg [expr $anzGFX - $zlrGFX]
			if {$mode>=0} {
				wm title . "FIQ: $zlrGFX/$anzGFX ($erg)"
				wm iconname . "FIQ: $zlrGFX/$anzGFX ($erg)"
			}
			if {$erg<10} {
				set anzSEL [format "%02u" $erg]
			} else {
				set anzSEL $erg
			}
			.lbAnzSelGfx configure -width [string length $anzSEL]
			setLED cyan
			if {$renderIMG} {
				#NEU170304: Download only Images within Table (tableOnly=1)
				if {$tableOnly} {
					if {$lidx>0} {
						set tabidx [lindex [lindex $TableIDX($activeHTM) 0] 0]
						set endidx [lindex [lindex $TableIDX($activeHTM) end] 0]
						if {$debug>4} {puts "TableOnly: $inhalt = $lidx; $tabidx; $endidx"}
						if {($lidx>=$tabidx && $lidx<=$endidx) || $mode} {
							if {[lsearch -regexp $htmlTD $fn]} {
      							        set srcurl [getFileURL $fn 0]
#CHNG010506:
#								set ext [getEXT $srcurl]
                            					set ext [lindex [split $srcurl .] end]
							}
						} else {
							if {$debug>4} {puts "TableOnly: jumped $fn"}
							AddBuffer $fn
							continue
						}
					}
				} else {
					if {$debug>4} {puts "TableOnly: NoTableOnly"}
					set srcurl [getFileURL $fn 0]
#CHNG010506:
#					set ext [getEXT $srcurl]
					set ext [lindex [split $srcurl .] end]
				}
				#GFX vorab anzeigen, und erst hier laden (whrend GFX Download)
				#gerade heruntergeladenes IMG in HTML-Dummy-Image kopieren
				if {$debug>4} {puts "GrabPIC: $fn $ext"}
#puts "GrabPIC: $fn $ext"
#				catch {set memgfx $Images($activeHTM,$fn)}
if {[catch {set memgfx $Images($activeHTM,$fn)}]!=0} {
	set search [lindex [array names Images "$activeHTM,[cutEXT $fn]*"] 0]
#puts "IMGs: [array names Images "$activeHTM,*"]"
	set fn [lindex [split $search ,] 1]
	catch {set memgfx $Images($activeHTM,$fn)}
	set icon [fileType ".cgi"]
}
				#catch {::$memgfx blank}
				set check [regexp -nocase $filtVars $fn]
				if {[chkIMG $ext] && $check<=0} {
				#NUR wenn Datei Image is !
					if {[catch {image create photo -file $srcurl} dummyGFX]==0} {
						if {[info exists Images($activeHTM,$fn)]} {
							if {$debug>4} {puts "GrabPIC AddSelected: $fn"}
							AddBuffer $fn
							if {[regexp -nocase {\.gif$} $srcurl] && $playAnim==1} {
								show_htmgif [list -file $srcurl] $Images($activeHTM,$fn) [getThumb [acode decode $fn]]
							} else {
								#NEW091004: show LinkType in Thumb
								set linkname [getThumb [acode decode $fn]]
								set check [string length $linkname]
								if {$markIcons==1} {
									#Nur wenn Thumb ein Link ist, dann TypeIcon anzeigen
									if {$check>0} {
										if {$tableOnly} {
											if {$lidx>0} {
												set tabidx [lindex [lindex $TableIDX($activeHTM) 0] 0]
												set endidx [lindex [lindex $TableIDX($activeHTM) end] 0]
												if {$debug>4} {puts "TableIcon: $inhalt = $lidx; $tabidx; $endidx"}
												if {($lidx>=$tabidx && $lidx<=$endidx) || $mode} {
													if {[lsearch -regexp $htmlTD $fn]} {
														if {$thumbsOnly==1} {
															catch {::$dummyGFX copy imOPTthumbnail}
														} else {
															if {$fileOK==100} {
																set icon [fileType $linkname]
															} else {
																set icon imFTerror
															}
#															catch {::$dummyGFX copy $icon}
														}
													}
												}
											}
#puts "Hier."
										} else {
#Drfte NUR dann gesetzt werden, wenn es auch einen Link gibt
#puts "Dort."
											if {$thumbsOnly==1} {
												catch {::$dummyGFX copy imOPTthumbnail}
											} else {
#CHNG250606:
#												if {$fileOK==100} {
													set icon [fileType $linkname]
#												} else {
#													set icon imFTerror
#												}
#												catch {::$dummyGFX copy $icon}
											}
										}
									} else {
										#Alle Link-Types anzeigen
										if {$thumbsOnly==1} {
											catch {::$dummyGFX copy imOPTthumbnail}
										} else {
										#	set icon [fileType [reslvURL $linkname 0]]
										#	catch {::$dummyGFX copy $icon}
										}
									}
								}
								catch {image height $dummyGFX} high
								#NEW240905: Autoscroll
								#set check [string length $linkname]
								if {$check>0} {autoScroll $high}
								#NEW220106: (crashes under Windoofs !!!!)
								if {$renderUPD} {
                                                                        if {$winSYS==0} {update}
                                                                        #update idletasks
                                                                }
                                                                #catch {set memgfx $Images($activeHTM,$fn)}
								catch {::$memgfx blank}
								#NEW271205: auto shrink IMG if Height > shrinkBigSize
								if {$shrinkBigSize>0 && $thumbsOnly>0 && $high > $shrinkBigSize} {
									catch {::$memgfx copy $dummyGFX -subsample 2}
#									catch {::$memgfx copy imMagnify}
									#ggf. IMG noch resizen, wenn IMG size z.B. 520, aber shrinked IMG = 240 !
									#NEW140106: resizeIMG
									catch {::$memgfx configure -width [image width $memgfx] -height [image height $memgfx]}
									#catch {::$memgfx configure -width [::$dummyGFX width] -height [::$dummyGFX height]}
									catch {::$memgfx copy imMagnify}
								} else {
								        #CHNG220406:
								        set width [image width $memgfx]
								        set height [image height $memgfx]
								        set dwidth [image width $dummyGFX]
								        set dheight [image height $dummyGFX]
                                                                        if {$width>0 && $height>0} {
#puts "Bin Hier."
        								        if {$dwidth<=$width && $dheight<=$height} {
#puts "evtl dort"
        									           #catch {::$memgfx copy $dummyGFX}
#        									           catch {::$memgfx copy $dummyGFX -from 0 0 $dwidth $dheight}
													   set dummyGFX [resizeIMG $dummyGFX $width $height]
													   catch {::$memgfx copy $dummyGFX}

#        									           catch {::$memgfx copy $dummyGFX -subsample 2}
        									} else {
#puts "oder da."
          									           #catch {::$memgfx copy $dummyGFX -from 0 0 $width $height}
#CHNG101206: resize (shrink) larger Images to fit in Site
												if {$dwidth>=[expr $width * 2] && $dheight>=[expr $height * 2]} {
													catch {::$memgfx copy $dummyGFX -subsample 2}
												} else {
												    set dummyGFX [resizeIMG $dummyGFX $width $height]
													catch {::$memgfx copy $dummyGFX}
												}
        									}
       									} else {
#puts "evtl. Hier"
#                                            set dummyGFX [resizeIMG $dummyGFX $width $height]
											catch {::$memgfx copy $dummyGFX}
                                        }
								}
								catch {image delete $dummyGFX}
if {$icon!=""} {catch {::$memgfx copy $icon}}
								catch {unset dummyGFX memgfx}
								incr zlrGFX
								ProgressBar $zlrGFX $anzGFX
								if {$renderUPD} {
                                                                        #if {$winSYS==0} {update idletasks}
                                                                        #update idletasks
                                                                        update
								}
							}
						} else {
							#Image existiert nicht
							#catch {::$memgfx blank}
                                                        catch {::$memgfx copy imFTerror}
						}
					} else {
						#Image konnte nicht erstellt werden (File defekt, oder falsches Format)
						#catch {::$memgfx blank}
                                                catch {::$memgfx copy imFileBroken}
					}
				} else {
					#Image ist kein ImageFile (z.B. HTM)
					if {$fileOK==100} {
						if {[chkEXT $ext] && ![regexp -nocase $ext$ $fn] && $check<=0} {
							set icon imFThtml
						} elseif {$check>0} {
							set icon imFTdll
						} else {
							set icon imFTunknown
						}
					} else {
						if {$check>0} {
							set icon imFTdll
						} else {
                            set icon imFileBroken
                        }
						#catch {::$memgfx blank}
					}
					catch {::$memgfx copy $icon}
				}
			}
		}
		if {$cancel==1} {return}
#		MouseCurs 0
		set linktext ""
		if {!$mode} {
			catch {stop_anigif .mbar.lbAnim}
			.imHTTPS configure -image imUnLock -background $backColor
			setLED blue
			dispMSG "$msgText(download.4) $zlrGFX = $bytesTotal KBytes"
			wm title . "Inquisitor"
			wm iconname . "FIQ"
			set ByteCount [expr $ByteCount + $bytesTotal]
			if {$maxBytes > 0 && $ByteCount > $maxBytes} {
				setLED red
				dispINF "$msgText(download.5)"
				.tile.bottom.pane.f3.box.btRip configure -activebackground red -background red
			}
		} else {
			setLED green
		}
	}
#	set active 0
	set grabMode 0
}

#Frenzy's incredible Zoomin' Functions
proc ZoomIn {} {
	global MapMode debug maxDepth TableIDX ImageIDX tableOnly mainHTML urltext htmlIDX active fontsize HTMLwin activeHTM \
	zoomText Images activeHTM dummyIMG imgSize kidZprotect msgText ignoreReDir selected maxZoomImg foncount vSize
	if {$debug>4} {puts [array names Images "$activeHTM,*"]}
	if {$active==1} return
	set size $fontsize
	if {$zoomText} {
                set fontcount 0
		incr size -1
		if {$size > 0} {
			set fontsize [expr $fontsize - 1]
		} else {
			set fontsize 0
		}
		if {$MapMode==4} {
			enterFTP [chkFTPactive]
		} else {
			Refresh
		}
	} else {
		set w $HTMLwin($activeHTM).video
	    if {[winfo exists $w]} {
		   if {$vSize($activeHTM) == "0x0"} {
		   		   set vSize($activeHTM) "[$w.video cget -width]x[$w.video cget -height]"
		   		   pack configure $w -fill both
		   		   pack configure $w.video -fill both
		   }
		   return
		}
		if {$imgSize<4} {
			#Sanduhr
			MouseCurs 1
			incr imgSize +1
			if {$debug>7} {puts $imgSize}
			if {$MapMode==4} {
				#ZoomFTPin
				enterFTP [chkFTPactive]
			} else {
                                .mbar.lbAnim configure -image imSkater
				if {[llength $selected]>0} {
					set dummy ""
					foreach inhalt $selected {
						lappend dummy [acode decode [link2thumb $inhalt]]
					}
					if {[llength $dummy]<=0} {
						set dummy $htmlIDX($activeHTM)
					}
				} else {
					set dummy $htmlIDX($activeHTM)
				}
				if {[llength $dummy]>$maxZoomImg} {
					dispMSG $msgText(zoom.more)
					unset dummy
					setLED orange
					MouseCurs 0
					return
				}
				set ext [getEXT $urltext]
				foreach search $dummy {
					if {$tableOnly && ![chkIMG $ext]} {
						set lidx [lindex [fGrep $search $ImageIDX($activeHTM)] 1]
						set tabidx [lindex [lindex $TableIDX($activeHTM) 0] 0]
						set endidx [lindex [lindex $TableIDX($activeHTM) end] 0]
						catch {expr $endidx + $maxDepth} endidx
						if {($lidx<=$tabidx || $lidx>=$endidx)} continue
					}
					if {[info exists Images($activeHTM,$search)]} {
						set memgfx $Images($activeHTM,$search)
						if {[string length $search]>0} {
						#DummyImage doppelter Grsse anlegen
							set imgX [expr int ([image width $memgfx]*2)]
							set imgY [expr int ([image height $memgfx]*2)]
							::dummyIMG copy $memgfx
							::$memgfx configure -width $imgX -height $imgY
							::$memgfx copy dummyIMG -zoom 2
							::dummyIMG blank
						}
					} else {
						set imgSize 2
					}
				}
				if {$imgSize==4} {
					.mbar.zoomin configure -state disabled
				}
				unset dummy
				.mbar.zoomout configure -state normal
				$mainHTML xview moveto 0
				$mainHTML yview moveto 0
			}
			MouseCurs 0
		}
	}
	if {$kidZprotect==1} {
                if {$ignoreReDir==0} {
                         .mbar.lbAnim configure -image imAnim
                } else {
                         .mbar.lbAnim configure -image imTuxInfiltrate
                }
        } else {
                .mbar.lbAnim configure -image imAnim
        }
}

#and make Page smaller by ZoomOut
proc ZoomOut {} {
	global MapMode debug maxDepth TableIDX ImageIDX tableOnly mainHTML urltext htmlIDX active maxZoomImg HTMLwin activeHTM \
	fontsize zoomText Images activeHTM dummyIMG imgSize kidZprotect msgText ignoreReDir selected fontcount vSize
	if {$active==1} return
	set size $fontsize
	if {$zoomText} {
                set fontcount 0
		incr size
		if {$size < 6} {
			set fontsize [expr $fontsize + 1]
		} else {
			set fontsize 5
		}
		if {$MapMode==4} {
			enterFTP [chkFTPactive]
		} else {
			Refresh
		}
	} else {
		set w $HTMLwin($activeHTM).video
	    if {[winfo exists $w]} {
		   set dummy [split $vSize($activeHTM) x]
		   set width [lindex $dummy 0]
		   set height [lindex $dummy 1]
		   if {$width>0 && $height>0} {
		   	   pack configure $w -fill none
			   pack configure $w.video -fill none
			   $w.video configure -width $width -height $height
			   $w configure -width $width -height $height
		   }
		   set vSize($activeHTM) "0x0"
		   return
		}
		if {$imgSize>0} {
			#Sanduhr
			MouseCurs 1
			incr imgSize -1
			if {$debug>7} {puts $imgSize}
			if {$MapMode==4} {
				#ZoomFTPout
				enterFTP [chkFTPactive]
			} else {
    	        .mbar.lbAnim configure -image imSkater
				if {[llength $selected]>0} {
					set dummy ""
					foreach inhalt $selected {
						lappend dummy [acode decode [link2thumb $inhalt]]
					}
					if {[llength $dummy]<=0} {
						set dummy $htmlIDX($activeHTM)
					}
				} else {
					set dummy $htmlIDX($activeHTM)
				}
				if {[llength $dummy]>$maxZoomImg} {
					dispMSG $msgText(zoom.more)
					unset dummy
					setLED orange
					MouseCurs 0
					return
				}
				set ext [getEXT $urltext]

				foreach search $dummy {
					if {$tableOnly && ![chkIMG $ext]} {
						set lidx [lindex [fGrep $search $ImageIDX($activeHTM)] 1]
						set tabidx [lindex [lindex $TableIDX($activeHTM) 0] 0]
						set endidx [lindex [lindex $TableIDX($activeHTM) end] 0]
						catch {expr $endidx + maxDepth} endidx
						if {($lidx<=$tabidx || $lidx>=$endidx)} continue
					}
					if {[info exists Images($activeHTM,$search)]} {
						set memgfx $Images($activeHTM,$search)
						if {[string length $search]>0} {
						#DummyImage halber Grsse anlegen
							set imgX [expr int ([image width $memgfx]/2)]
							set imgY [expr int ([image height $memgfx]/2)]
							catch {::dummyIMG copy $memgfx}
							catch {::$memgfx configure -width $imgX -height $imgY}
							catch {::$memgfx copy dummyIMG -subsample 2}
							catch {::dummyIMG blank}
						}
					} else {
						set imgSize 2
					}
				}
				unset dummy
				if {$imgSize==0} {
					.mbar.zoomout configure -state disabled
				}
				.mbar.zoomin configure -state normal
				$mainHTML xview moveto 0
				$mainHTML yview moveto 0
			}
			MouseCurs 0
		}
	}
	if {$kidZprotect==1} {
                if {$ignoreReDir==0} {
                         .mbar.lbAnim configure -image imAnim
                } else {
                         .mbar.lbAnim configure -image imTuxInfiltrate
                }
        } else {
                .mbar.lbAnim configure -image imAnim
        }
}

#Reset to normal Zoom
proc Zoom {} {
	global MapMode fontsize imgSize fontcount HTMLwin activeHTM vSize
	#.mbar.lbAnim configure -image imSkater
	set fontsize 3
	set imgSize 2
        set fontcount 0
	if {$MapMode==4} {
		enterFTP [chkFTPactive]
	} else {
		set w $HTMLwin($activeHTM).video
		if {[winfo exists $w]} {
		   set dummy [split $vSize($activeHTM) x]
		   set width [lindex $dummy 0]
		   set height [lindex $dummy 1]
   		   if {$width>0 && $height>0} {
   		   	   pack configure $w -fill none
			   pack configure $w.video -fill none
			   $w.video configure -width $width -height $height
			   $w configure -width $width -height $height
		   }
   		   set vSize($activeHTM) "0x0"
		   return
		}
		Refresh
	}
	Buttons 1
	#.mbar.lbAnim configure -image imAnim
}

#HyperSpeed ZoomReset
proc resetZoom {} {
#Wird nur von Forw/Back aufgerufen (geht schneller, als geZOOMte Page erst zurckzusetzen !)
	global fontsize imgSize fontcount
	set fontsize 3
	set imgSize 2
    set fontcount 0
}

#Load a Skin (with or without an Image, so "Color-Only"-Skins may loaded too)
proc loadSkin {f} {
	global lastDir msgText skinFile fgColor backColor normLight etryBack listColor htmlBG htmlFG barColor
	if {[string length $f]<=0} {
		set filetypes {
			{{Images/Skins} {.jpg .png .gif .SKN}}
			{{All Files} *}
		}
		catch {stop_anigif .mbar.lbAnim} err
		catch {show_anigif [list -data [getAnim floater22]] .mbar.lbAnim} err
		set f [tk_getOpenFile -title $msgText(skin.load.1) -initialdir $lastDir -filetypes $filetypes]
	        catch {stop_anigif .mbar.lbAnim} err
	}
	update idletasks
	if {[string length $f]>1} {
		if {![file exists $f]} return
		set lastDir [string trimright [fileDIR $f] /]/
		set ext [getEXT $f]
		if {[regexp -nocase {SKN$} $f]} {
		#Frenzy's SkinFile
			set dummy [ReadFile $f]
			set color [lindex $dummy 0]
			set backColor     [lindex $color 0]
			set fgColor       [lindex $color 1]
			set barColor      [lindex $color 2]
			set normLight     [lindex $color 3]
			set etryBack      [lindex $color 4]
			set listColor     [lindex $color 5]
			set htmlBG        [lindex $color 6]
			set htmlFG        [lindex $color 7]
			set inhalt [lindex $dummy 1]
			if {[string length $inhalt]>0} {
				#dummyIMG configure -data $inhalt
				set skinFile $f
				dummyIMG put $inhalt
				setLED green
			} else {
	  			set skinFile "dummy"
			}
		} else {
			dummyIMG configure -file $f
		}
	}
}

#and Save a Skin with or without an Image (=Color-Only)
proc saveSkin {f} {
	global lastDir msgText skinFile fgColor backColor normLight etryBack listColor htmlBG htmlFG barColor
	if {[string length $f]<=0} {
		set filetypes {
			{{Images/Skins} {.jpg .png .gif .SKN}}
			{{All Files} *}
		}
		catch {stop_anigif .mbar.lbAnim} err
		catch {show_anigif [list -data [getAnim faller22]] .mbar.lbAnim} err
		set f [tk_getSaveFile -title $msgText(skin.save.1) -initialdir $lastDir -filetypes $filetypes]
	    catch {stop_anigif .mbar.lbAnim} err
	}
	update idletasks
	if {[string length $f]>1} {
		set lastDir [string trimright [fileDIR $f] /]/
		if {[regexp -nocase {SKN$} $f]} {
			set color [list $backColor $fgColor $barColor $normLight $etryBack $listColor $htmlBG $htmlFG]
			set inhalt [imSkin data]
			if {[string length $inhalt]>0} {
			   	set inhalt [imSkin data -format jpeg]
				writeFile $f "[list $color $inhalt]"
				set skinFile $f
				dispMSG $msgText(skin.save.2)
				setLED green
			} else {
			    catch {unset inhalt}
				writeFile $f "[list $color ""]"
				set skinFile ""
				dispMSG $msgText(skin.save.2)
				setLED green

#				dispMSG $msgText(skin.save.3)
#				setLED red
			}
		}
	}
}

#Called when a Skin has to be applied (or not = reset)
proc setSkin {} {
	global skinFile msgText merkColor backColor fgColor barColor normLight etryBack listColor htmlBG htmlFG
	if {[string length $skinFile]>1} {
		setPalette
		setLED blue
		dispMSG $msgText(skin.load.2)
		if {[string length [dummyIMG data]]<=0} return
		.mbar configure -image imSkin
		.tile.bottom.pane.f2.box configure -image imSkin
		.tile.bottom.pane.f3.box configure -image imSkin
		.tile.bottom.pane.f4.box configure -image imSkin
		set resoX [winfo screenwidth .mbar]
		set width [image width dummyIMG]
		if {$width >= $resoX} {
			imSkin copy dummyIMG
		} else {
			set x 0
			while {$x < $resoX} {
				imSkin copy dummyIMG -to $x 0 [expr $x + $width] 40
				incr x $width
			}
		}
		dummyIMG blank
		if {[regexp -nocase {^dummy} $skinFile]} {set skinFile ""}
	} else {
		imSkin blank
		.mbar configure -image {}
		.tile.bottom.pane.f2.box configure -image {}
		.tile.bottom.pane.f3.box configure -image {}
		.tile.bottom.pane.f4.box configure -image {}
		set backColor $merkColor(backColor)
		set fgColor $merkColor(fgColor)
		set barColor $merkColor(barColor)
		set normLight $merkColor(normLight)
		set etryBack $merkColor(etryBack)
		set listColor $merkColor(listColor)
		set htmlBG $merkColor(htmlBG)
		set htmlFG $merkColor(htmlFG)
		setPalette
		setLED blue
		dispMSG $msgText(skin.load.3)
	}
}

#Funktion zum Zuordnen von Links2Thumbs (VERY IMPORTANT Function, while called from nearly everywhere)
proc getLink {linkin chk} {
	global debug liste Images remSTR cancel codeCHNG
	set linkin [uniqType [acode encode $linkin]]
#regsub -nocase -all $codeCHNG $linkin {} linkin
#set linkdummy [transType $linkin]
#regsub -nocase -all {%00+} $linkin {%00} linkin
	if {$debug>6} {puts "getLink get: $linkin"}
	set back ""
	set len [string length $linkin]
	set such [array get liste]
	if {$debug>8} {
		puts "Such: $such"
		puts "Images: [array names Images $chk,*]"
	}
	foreach {linkname thmbname} $such {
		if {$cancel==1} {break}
		set linkname [lindex [split $linkname ,] end]
#regsub -nocase -all $codeCHNG $linkname {} linkname
		if {$debug>8} {puts "Link: $linkname"}
		set transLink [uniqType $linkname]
#puts "$linkin = $transLink"
	        if {[string length $transLink]>=$len} {
			if {[regexp -nocase -all $linkin $transLink] || [regexp -nocase -all $transLink $linkin]} {
				set thmbname [acode resolv [acode decode $thmbname]]
				regsub -nocase -all {#44;} $thmbname {,} thmbname
#puts "Thumb: $thmbname"
				catch {set back $Images($chk,$thmbname)}
				if {$debug>8} {puts "Thumb: $thmbname"}
				break
			}
                } else {
			if {[regexp -nocase -all $linkin $transLink]} {
				set thmbname [acode resolv [acode decode $thmbname]]
				regsub -nocase -all {#44;} $thmbname {,} thmbname
	#puts "Thumb: $thmbname"
				catch {set back $Images($chk,$thmbname)}
				if {$debug>8} {puts "Thumb: $thmbname"}
				break
			}
                }
	}
	#NEW291105: search in Thumbs if Link not found
	#Evtl. nur setzen, wenn nonLinks=1 (oder onlyThumbs=1)
	if {[string length $back]<=0} {
		set thmbname [acode resolv [acode decode $linkin]]
		catch {set back $Images($chk,$thmbname)}
	}

	if {$debug>6} {puts "getLink returns: $back"}
	catch {unset such linkname thmbname merk}
	return $back
}

#Funktion zum Zuordnen von Thumbs2Links
proc getThumb {linkin} {
	global debug liste cancel codeCHNG
	set linkin [uniqType [acode encode $linkin]]
#NEW170406:
#regsub -nocase -all $codeCHNG $linkin {} linkin
#regsub -nocase -all {%00+} $linkin {%00} linkin
	if {$debug>5} {puts "getThumb get: $linkin"}
	set back ""
	set such [array get liste]
	set len [string length $linkin]
#if {[regexp -nocase {15\.} $linkin]} {
#puts "GetThumb: $linkin"
#puts "Such: $such"
#error 13
#}
	foreach {linkname thmbname} $such {
		if {$cancel==1} {break}
		set thmbname [uniqType [acode encode $thmbname]]
#regsub -nocase -all $codeCHNG $thmbname {} thmbname
		if {$debug>8} {puts "Thumb: $thmbname"}
#puts "Thumb: $thmbname"
#NEW141006: check String lengths
	        if {[string length $thmbname]>=$len} {
			if {[regexp -nocase -all $linkin $thmbname] || [regexp -nocase -all $thmbname $linkin]} {
	#puts "Thumb: $thmbname"
				set linkname [acode encode [lindex [split $linkname ,] end]]
				set back $linkname
				if {$debug>8} {puts "Link: $linkname"}
				break
			}
		} else {
			if {[regexp -nocase -all $linkin $thmbname]} {
	#puts "Thumb: $thmbname"
				set linkname [acode encode [lindex [split $linkname ,] end]]
				set back $linkname
				if {$debug>8} {puts "Link: $linkname"}
				break
			}
		}
	}
	if {$debug>5} {puts "getThumb returns: $back"}
	catch {unset such linkname thmbname}
	return $back
}

#NEW210505: link2thumb (lst Link zu Thumbname auf)
proc link2thumb {linkin} {
	global debug liste cancel codeCHNG
	set linkin [uniqType [acode encode $linkin]]
#NEW150106: workaround to preserve wrong encoding
#getLink gets www.irgendwas.de/test.php%3Fx=1 but List contains www.irgendwas.de/test.php%26x=1
#regsub -nocase -all $codeCHNG $linkin {} linkin
	if {$debug>5} {puts "link2thumb get: $linkin"}
	set back ""
	set such [array get liste]
puts "Such: $such"
	set len [string length $linkin]
	foreach {linkname thmbname} $such {
		set linkname [uniqType $linkname]
#regsub -nocase -all $codeCHNG $linkname {} linkname
		if {$cancel==1} {break}
		if {$debug>8} {puts "Thumb: $thmbname"}
#NEW141006: check String lengths
	        if {[string length $linkname]>=$len} {
			if {[regexp -nocase -all $linkin $linkname] || [regexp -nocase -all $linkname $linkin]} {
				set back [acode encode $thmbname]
				if {$debug>8} {puts "Link: $linkname"}
				break
			}
		} else {
			if {[regexp -nocase -all $linkin $linkname]} {
				set back [acode encode $thmbname]
				if {$debug>8} {puts "Link: $linkname"}
				break
			}
		}
	}
	if {$debug>5} {puts "link2thumb returns: $back"}
	catch {unset such linkname thmbname}
	return $back
}

#NEW250406: Snapshot HTMLwindow
proc snapshot {win} {
       global destDir msgText convert quickSave lastDir fTypes
       regexp {([0-9]*)x([0-9]*)\+([0-9]*)\+([0-9]*)} [winfo geometry $win] - w h x y
       # Make the base image based on the window
       set capture [image create photo -format window -data $win]
       foreach child [winfo children $win] {
                snap $child $capture 0 0
       }
       set filetypes ""
       foreach inhalt $fTypes(Images) {lappend filetypes "$inhalt $inhalt"}
       regsub -nocase -all {\-} [clock clicks] {} code
       set fname [string trimright $destDir /]/SCR_$code.JPG
	if {$quickSave} {
		set fname [lindex [split $fname /] end]
        	set destFile [tk_getSaveFile -title $msgText(save.page) -initialdir $destDir -filetypes $filetypes -initialfile $fname]
		set lastDir [string trimright [fileDIR $destFile] /]/
                set type [getEXT $destFile]
	} else {
                set destFile $fname
                if {![regexp -nocase {none} $convert]} {
                                set type $convert
                } else {
                                set type "jpeg"
                }
        }

        if {![regexp -nocase [transType $type] $fTypes(Images)]} {
                     regsub -nocase "\.$type$" destFile {.JPG} destFile
                     set type "jpeg"
        }
        catch {$capture write -format $type $destFile}
        catch {image delete $capture}
	catch {unset capture}
	LoadFile $destFile
	dispMSG $msgText(snapshot.created)
	setLED green
}

#Helper called from Snapshot
proc snap {win image px py} {
       if {![winfo ismapped $win]} return
       regexp {([0-9]*)x([0-9]*)\+([0-9]*)\+([0-9]*)} [winfo geometry $win] - w h x y
       incr px $x
       incr py $y
       # Make an image from this widget
       set tempImage [image create photo -format window -data $win]
       # Copy this image into place on the main image
       $image copy $tempImage -to $px $py
       image delete $tempImage
       foreach child [winfo children $win] {
                snap $child $image $px $py
       }
}

#experimental (currently unused)
proc playWMV {datei} {
        global HTMLwin activeHTM
	set w $HTMLwin($activeHTM).video
        if {[winfo exists $w]} {destroy $w}
        frame $w -relief sunken -borderwidth 2
        pack $w
set vcd [optcl::new -window $w.vcd ShockwaveFlash.ShockwaveFlash]
#	set vcd [optcl::new -window $w.vcd WMPlayer.OCX.7]
#	set vcd [optcl::new -window $w.vcd WMprayer]
	#$w.vcd config -width 640 -height 480
#puts [typelib::loaded]
#puts [typelib::isloaded WMPlib]
#puts [typelib::libdetail WMPlayer.OCX.7]
#puts [optcl::isobject WMPlib]
#	set vcd [optcl::new -window $w.vcd c]
#puts [winfo exists $vcd]
	pack $w.vcd
#puts "OCX: [$vcd Visible]"
#puts [$w.vcd Visible]
	$vcd : Movie $datei
}

#proc playAPP {datei win start handle} {
#     global msgText cancel debug
#     if {$debug>3} {puts "playAPP: $handle $datei $win"}
#     $handle : Movie $datei
#}

#Windows MoviePlayer (called from LoadFile if a Movie should play directly in it's own Window)
proc playMOV {datei} {
      global msgText activeHTM HTMLwin urltext stream cacheLocation QTcount debug winSYS backColor fgColor remSTR videoSize
	  if {$debug>3} {puts "playMOV: $datei"}
	  if {$winSYS>0} {
	    set link [acode decode $datei]
	    set href [regSTR $remSTR $link 0]
	    set href [string trimleft $href /]
	    set datei [string trimleft $datei /]
#		regsub -nocase -all {^file://|^file:/} $datei {} datei
		set ext [transType .[string trim [getEXT $datei] .]]
	        if {[chkANI $ext]} {
		      	set w $HTMLwin($activeHTM).video
			    if {[winfo exists $w]} {destroy $w}
			    frame $w -relief sunken -borderwidth 2 -width $videoSize -height $videoSize
			    pack $w -anchor center -expand 1
			    set vhs [createAPP $w.video $ext]
				if {![regexp -nocase {UNK:0} $vhs]} {
				   	$w.video configure -width $videoSize -height $videoSize
			   		set icon [fileType $ext]
			   		label $w.link -text $link -image $icon -compound left -anchor w -background $backColor -foreground $fgColor -cursor hand2 -relief ridge
					bind $w.link <1> [subst "set urltext $href; goEnter"]
					bind $w.link <3> [subst "AddSelected $href 0"]
					bind $w.link <Any-Enter> [subst "set linktext \"$href\"; chkDanger $href"]
					bind $w.link <Any-Leave> [subst "set linktext {}"]
			   		pack $w.link -side bottom -fill x
   				    pack $w.video -in $w -side top -anchor center -expand 1 -fill both
				    playAPP $datei $w.video 1 $vhs ""
				} else {
			   		label $w.link -text "$msgText(applet.unkown):\n$href" -image imPlugin -compound left -background $backColor -foreground $fgColor -cursor hand2
			   		pack $w.link -in $w -side bottom -anchor w -expand 1
				}
	        } else {
	            dispMSG $msgText(display.movie.2)
			    setLED orange
	        }
	}
}

#Plays APPLETvideo (with MS-MediaPlayer for now)
proc playAPP {datei win start handles para} {
     global msgText cancel cacheLocation QTcount debug remSTR
     if {$debug>3} {puts "playAPP: $datei $win $start $handles $para"}
     set handles [split $handles :]
     set type [lindex $handles 0]
     set handle [lindex $handles 1]
     set datei [string trimleft [acode recode $datei] /]
     switch $type {
     	WMV {
			#MediaPlayer7
	    	$handle : URL $datei
	    }
	    AVI {
	     	#old MediaPlayer
            $handle : filename $datei
            if {$start>0} {$handle Play}
	    }
	    MOV {
	    	#QuickTime
			#Workaround to solve shit Bug in QuickTime which is NOT able to handle simple "%" in filenames !
			   if {[regexp -nocase {^file:/|^[a-zA-Z]+:/} $datei] && [regexp -nocase {%} $datei]} {
					set fake [regSTR $remSTR $datei 0]
					if {[file exists $fake]} {
						regsub -nocase {^[a-zA-Z]+://} $datei {} dummy
						regsub -nocase $dummy$ $datei {} prot
						regsub -nocase -all {%} $fake {~} ziel
						if {![file exists $ziel]} {
						   	   file copy $fake $ziel
						}
						set datei $prot[string trimleft $ziel /]
						regsub -nocase -all {:///+} $datei {://} datei
					}
			   }
		       $handle SetURL $datei
		    }
	    SWF {
	     	#ShockWave Flash
			regsub -nocase -all {^file:/+} $datei {} datei
   		    set datei [string trimleft $datei /]
            $handle : Movie $datei
#puts "SWF: $datei"
	  		if {[string length $para]>0} {
#            $handle : FlashVars "file=http://www.clubhaus.de/index.php%3Fid%3D1%26type%3D900%26slideshow%3D1%26random%3D1%26transition%3Dfade%26timer%3D6%26navigation%3D0"
			 		  set dummy [split $para =]
					  set var [lindex $dummy 0]
					  set par [reslvURL [lindex $dummy 1] 1]
					  set para "[string trim $var]=[acode encode [string trim $par]]"
					  if {$debug>3} {puts "AddSWF: $para"}
					  $handle : FlashVars "$para"
			 }
#            $handle : swliveconnect false
	    }
	    RMP {
			#RealMedia
			$handle SetSource $datei
			if {$start>0} {$handle DoPlay}
	    }
     }
}

#Plays a Sound
proc playSND {datei win start handle} {
     global msgText cancel onceSounds
     #Use MPlayer instead
     $handle : filename $datei
     if {$start>0} {$handle Play}
}

#NEW181106: createsOCX-Object within HTMLwidget to play Applet/MediaFiles based uppon plugINs-VariableList
proc createAPP {win ext} {
     global mediaCTRL plugINs msgText mainHTML
     regsub -nocase -all {\.} [string toupper $ext] {} ext
     #Search for needed PlugIn to play requested extension
     set type "UNK"
     set handle 0
     foreach inhalt $plugINs {
     #shortName Class RealName GUID MIMEtype(unused) FileType(s)
             set fileType [lindex $inhalt 5]
     	     if {[regexp -nocase $ext $fileType]} {
				  set type [lindex $inhalt 0]
				  set class [lindex $inhalt 1]
				  regsub -nocase {\.[0-9]$} [lindex $inhalt 2] {} obj
				  set handle [optcl::new -window $win "$obj"]
				  if {[catch {typelib::types $class}]!=0} {
				  		 if {[winfo exists $win]} {destroy $win}
				  		 set handle 0
				  		 set type "UNK"
				  } else {
						 break
				  }
	         }
     }
     #Set Object specific Properties for each OCX object
     switch $type {
         WMV {
		     #MediaPlayer7
		     if {$mediaCTRL>0} {
		     #possible CTRLvalues for >=MediaPlayer7: none full mini invisible custom
		          $handle : uiMode full
#				  $handle : uiMode mini
		     } else {
		          $handle : uiMode none
		     }
			 #$handle : AllowChangeDisplaySize 1
		     #$handle : StretchToFit 0
			 #$handle : AutoSize 1
			 #$handle : DisplaySize 0
	     }
	     AVI {
		     #old MediaPlayer (should run on W98 too)
	     }
	     MOV {
		     #QuickTime
	     }
	     SWF {
		     #ShockWave Flash
	     }
	     RMP {
		     #RealMedia
     	     if {$mediaCTRL>0 && ![regexp -nocase "SWF" $ext]} {
			      $handle SetControls "ImageWindow,PlayOnlyButton"
#			      $handle : Controls "ImageWindow,PlayOnlyButton,PauseButton,StopButton,MuteCtrl,PositionSlider"
#				  $handle SetControls "ImageWindow,All"
		     }
	     }
	     UNK {
		 	 labelframe $win -text "$msgText(applet.unkown): $ext" -borderwidth 2 -relief raised
	     }
     }
     return "$type:$handle"
}

#NEW140707: TkMagickResizer
proc resizeIMG {img height width} {
	if {$height<=0} return
	if {$width<=0 || [string length $img]<=0} {return $img}
#	set wand [magick create wand]
set dummyGFX [image create photo]
#	phototomagick $img $wand
#	catch {$wand ResizeImage $height $width cubic}
#	magicktophoto $wand $img
#	magick delete $wand
catch {tkImageTools::resize $img $dummyGFX $height $width}
	return $dummyGFX
}
