package provide FIQNET 1.0
#FIQNET.tcl V210404
#Additional Net-Functions for Frenzy's Inquisitor
#(c) by: Frenzy Softworks
#written by: Jens Timmermann

#HauptProc; holt HTML-file (sofern in URL angegeben !) aus INet
proc getFileURL {args} {
# getFileURL "holt" grundstzlich File in lokalen Cache (aus INet) WENN file nicht schon lokal existiert !
# Sonst wird lokaler Filename zurckgeliefert, oder Cache FileName (nachdem in Cache geholt)
	global homeDir fileOK activeHTM TableIDX ImageIDX debug createMirror newPage mainHTML htmlTD variHead link filtVars cacheLocation \
		   refererBACK HTMLAccept HTMLnorm HTMLimg HTMLuseragent HTMLheader HTMLreferer askServer grabMode fics token linktext fTypes msgText \
           zlrGFX baseurl maxcount maxDepth winSYS HTProxy FTPask remSTR bytesTotal autoscroll urltext translateFiles killCHR
	set basefile [lindex $args 0]
	#regsub -nocase -all { } $basefile {} basefile
	set basefile [string trim $basefile]
	set url $basefile
	set basefile [acode resolv $basefile]
	set datei [cutFile $basefile]
#NEW010706:
	regsub -nocase {/\?} $datei {?} datei
	set fileOK 100
	if {$debug>4} {puts "getFileURL get: $args"}
	if {[string length $datei]==0 || [regexp -nocase $filtVars $datei]} return
#NEW200806:
	if {[regexp -nocase {FIQdummy[0-9]*|^[a-zA-Z]:} $datei]} {return $datei}
	if {[file exists $datei]} {return $datei}
	set imgidx [lindex $args 1]
	set maxcount 0
	set HTMLAccept $HTMLnorm
	set ext .[string trim [getEXT $datei] .]
	if {[chkIMG $ext]} {
	#Wenn URL-Datei Image ist, setze REQ-Header fr Images
		set HTMLAccept $HTMLimg
	}
	set HTMLuseragentDummy $HTMLuseragent
	if {$variHead>1} {
		set wert [lindex [split [expr {rand () * 5}] .] 0]
		switch -regexp $wert {
			1 {set HTMLuseragentDummy "MSIE/6.0 (compatible; MSIE/6.0; Windows)"}
			2 {set HTMLuseragentDummy "Mozilla/5.0 (compatible; Konqueror/3.0.0; Linux)"}
			3 {set HTMLuseragentDummy "Mozilla/5.0 (compatible; Mozilla/2.41; Linux)"}
			4 {set HTMLuseragentDummy "Opera/3.4 (compatible; Opera/3.4.1; Linux)"}
			5 {set HTMLuseragentDummy "Netscape/7.0 (compatible; Netscape/7.0; Linux)"}
		}
	}
#	::http::config -useragent $HTMLuseragentDummy -accept $HTMLAccept -proxyhost $HTProxy(serv) -proxyport $HTProxy(port) -proxyfilter ProxyCommand
	::http::config -useragent $HTMLuseragentDummy -proxyhost $HTProxy(serv) -proxyport $HTProxy(port) -proxyfilter ProxyCommand
	set datei [regSTR $remSTR $datei 0]
    if {$winSYS==1} {regsub -nocase -all {^/} $datei {} datei}
	set gfx [transType $datei]
	set gfx [cutFile $gfx]
	set path [URLsplit $url]
	set path [lindex $path 2]
	if {[string length $path]<=0 || (![chkALL .[string trim [getEXT $path] .]] || [regexp -nocase {/$} $path]) && ![regexp -nocase {^/} $path]} {set gfx [string trimright $datei /]/index.htm}
#NEW050506: append "http://" if not exists; required by copyURL
        if {![regexp -nocase {^[a-zA-Z]+t[a-zA-Z]+\://} $url]} {set url "http://$url"}
	set geturl $url
        set filename $datei
	if {![file exists $datei]} {
		# WENN file NICHT lokal vorhanden
		set chart [getCachedir $datei]
		mkCacheDir
		set cachedir [string trimright $cacheLocation /]/cache/html/$chart
		if {[regexp -nocase {favicon.ico} $datei]} {
			set cachedir [string trimright $cacheLocation /]/cache/favicons/$chart
			if {![file isdirectory $cachedir]} {file mkdir $cachedir}
		}
		set gfx [acode encode $gfx]
		regsub -nocase -all { } [join $fTypes(HTML)] {$|} check
		regsub -nocase -all { } [join $fTypes(Images)] {$|} chk
		regsub -nocase -all { } [join $fTypes(All_Files)] {$|} all
		set ext .[string trim [getEXT $gfx] .]
		if {([chkEXT $ext] && ![regexp -nocase $check$ $gfx] && ![regexp -nocase $chk$ $gfx]) || (![chkEXT $ext] && ![regexp -nocase $all$ $gfx])} {
			set gfx $gfx.htm
		}
		# Wenn file auch NICHT lokal im Cache existiert
		set zipfile [string trim $cachedir/$gfx].gz
		if {[file exists $zipfile] && ![file exists $cachedir/$gfx]} {unzip $zipfile}
		if {![file exists $cachedir/$gfx]} {
			if {$debug>3} {puts "getFileURL NICHT im Cache: $cachedir/$gfx"}
		# WENN File NICHT existiert (weil im WEB)
			# ****** Frenzy's Intelligent Caching System ("FICS") (TM) ******
			if {!$grabMode && ![chkEXT .[string trim [getEXT $gfx] .]]} {
			#NUR "FICS" (TM) benutzen, wenn nicht ge"Grabbed" wird, und KEIN ".HTML"-File
				if {$fics>0 && ![regexp -nocase {favicon.ico} $datei]} {
					set lidx [lindex [fGrep $geturl $ImageIDX($activeHTM)] 1]
					set tabidx [lindex [lindex $TableIDX($activeHTM) 0] 0]
					set endidx [lindex [lindex $TableIDX($activeHTM) end] 0]
					set gfx [getFics $cachedir $gfx $lidx $tabidx $endidx]
				}
			}
			#NEW271205: chk4htm
			if {![file exists $cachedir/$gfx] && ![chkEXT $gfx]} {
				if {[file exists $cachedir/$gfx.htm]} {
					if {[file size $cachedir/$gfx.htm]>0} {
						set gfx $gfx.htm
					} else {
#CHNG100106:
						catch {file delete -force $cachedir/$gfx}
					}
				}
			}
		# DANN lade erst file lokal in Cache
			if {![file exists $cachedir/$gfx]} {
				if {![file isdirectory $cachedir]} {catch {file mkdir $cachedir}}
				set maxcount 0
				if {$newPage==1} {
					set refererBACK [string trimright $HTMLreferer /]
					set newPage 2
				}
				if {$newPage==0} {set newPage 1}
				if {$debug>3} {puts "getFileURL copyURL: $geturl; $cachedir/$gfx"}
				if {[regexp -nocase {^https:} $geturl]} {
					.imHTTPS configure -image imLock -background Red
				} else {
					.imHTTPS configure -image imUnLock -background LightGreen
				}
				set filename [copyURL $geturl $cachedir/$gfx]
				if {[string length $filename]>0} {
					set gfx [lindex [split $filename /] end]
					regsub -nocase $gfx$ $filename {} cachedir
					set cachedir [string trimright $cachedir /]
					set gfx [string trimleft $gfx /]
				} else {
				       return
				}
				if {$debug>3} {puts "getFileURL Ziel: $cachedir/$gfx"}
				catch {http::cleanup $token} err
#				lappend translateFiles $url $filename
				if {![file exists $cachedir/$gfx]} {
#puts "Nicht im Cache"
					#NEW240106:
					set fileOK 1
					#Nee, File aus INet nicht im Cache
					if {$FTPask==1} {
						onError "4 getFileURL: Filetransfer $datei aborted !"
						setLED orange
						return
					} else {
#URL not Found/does not exists
#						dispMSG "File broken: $datei"
#						setLED orange
						return
					}
				} else {
				#Jou, File ist im Cache
#puts "im Cache"
					set ext .[string trim [getEXT $gfx] .]
					if {[chkEXT $ext] && ![regexp -nocase {favicon} $gfx]} {
					#NUR bei HTML-Seite .INI-Datei mit speichern
						set ini [cutEXT $gfx]
						SaveScript [string trimright $cachedir /]/[string trimleft $ini /].INI
					} else {
						#NEW240905: autoscroll
						#if {$autoscroll > 0 && $newPage == 2} {set newPage 3; $mainHTML yview moveto 0.0}
					}
					catch {file size $cachedir/$gfx} fsize
					if {$fsize<=0} {
						#NEW240106:
						set fileOK 1
					#File hat aber Lnge von 0 Bytes
						#file delete -force $cachedir/$gfx
						if {$FTPask==1} {
							onError "5 getFileURL: HTML_File: $cachedir/$gfx size: $fsize bytes !"
							return
						} else {
							dispMSG "Filesize: $fsize bytes !"
							Stop $token
							setLED red
							return
							}
					}
					set linktext "$msgText(site.cache.loaded): [string range $datei 0 120] ($fsize bytes)"
					#set linktext "[string range $url 0 120] ($fsize bytes)"
					set filename $cachedir/$gfx
					set kSize [expr $fsize / 1024]
					set bytesTotal [expr $bytesTotal + $kSize]
				}
			}
			set filename $cachedir/$gfx
		}
		#Datei im Cache
		set filename $cachedir/$gfx
		if {$newPage==1} {
			set refererBACK [string trimright $HTMLreferer /]
			set newPage 2
		}
		if {$newPage==0} {set newPage 1}
#		if {$askServer} {
#		#Frage vorher Server, ob Datei noch aktuell, sonst hole erneut
#			AskServer $filename
#		}
	} else {
	#File existiert in Cache
		catch {file size $filename} fsize
		if {$fsize<=0} {
			#NEW240106:
			set fileOK 1
		#File hat aber Lnge von 0 Bytes
			#file delete -force $cachedir/$gfx
			if {$FTPask==1} {
				onError "5 getFileURL: HTML_File: $cachedir/$gfx size: $fsize bytes !"
				return
			} else {
				dispMSG "Filesize: $fsize bytes !"
				setLED red
				return
			}
		}
		set linktext "$msgText(site.cache.loaded): [string range $datei 0 120] ($fsize bytes)"
		set kSize [expr $fsize / 1024]
		set bytesTotal [expr $bytesTotal + $kSize]
	}
	if {$createMirror} {copyMirror $filename}
	if {$debug>4} {puts "getFileURL return: $filename"}
	return $filename
}

#NEW270904 check for recieved FileType (if not same as Requested, load new File)
#Fr HTMLseiten, die statt GFX nur HTMdateien senden (also kein GFX-Link, sondern PHP-link unter Thumbnail)
#Also man klickt einen Thumbnail-Link, erhlt aber keine ".JPG", sondern eine durch PHP erstellte HTM-Seite
#mit der ".JPG"-GFX darin enthalten (PHP-Link)
proc checkType {infile outfile} {
	global fTypes fileTypes
	set win .tile.bottom.pane.f3.box.spStype
	set type [$win get]
	#Wenn alle Dateitypen, geholt werden sollte = alles OK
	if {[regexp {All} $type]} {return $outfile}
	#Hat Outfile gleiche Endung wie Infile; ja = OK
	set inx [string toupper [string trim [lindex [split $infile .] end]]]
	set otx [string toupper [string trim [lindex [split $outfile .] end]]]
	if {$inx == $otx} {return $outfile}
	#anderenfalls check FileGroup, WENN geholtes File in gleicher Gruppe
	if {[lsearch {"All Selected" All_Files Images Audio Video Text Tables HTML Applets Archives} $type]} {
		#is Type eine DateiGruppe ?
		if {[lsearch $fTypes($type) $otx]} {return $outfile}
	}
	#Sonst prfe, ob geholtes File gleiche Endung wie vorgegeben hat, wenn nicht hole neues File
	if {[regexp -nocase $type $otx]} {return $outfile}
#	if {[chkEXT $otx]} {
#		puts "HTMLparse: $outfile"
#	}
}

#currentlyUnused
#preSelect sollte bei klick auf unterer SelectBox oberen Eintrag in FTPwin wieder deselectieren
proc preSelected {inhalt} {
	global etryBack FTPdir FTPfont fontsize linkmark
	set linkmark 1
	AddSelected $inhalt 0
	set win [chkFTPactive]
	set tag [lsearch -regexp $FTPdir($win) $inhalt]
	set window .tile.top.ftp.tile.local.local
	if {$win=="remote"} {
		set window .tile.top.ftp.tile.remote.remote
	}
	if {[$window tag cget $tag -foreground]==$etryBack} {
		$window tag configure $tag -foreground white -font "\"gothic i\" $FTPfont($fontsize)"
	} else {
		$window tag configure $tag -foreground $etryBack -font "\"gothic i\" $FTPfont($fontsize) bold"
	}
}

#Copy a URL to a File and Print META-Data
#Norm: chunk=14136,7068,6144,5120,4096,3072,2048,1024
proc copyURL {url file} {
	global debug fileOK blocksize fsizeWarn datafile HTMLmethod variTime cancel rbytes tbytes header htmlBG htmlFG mainHTML tokCount \
	maxcount token maxDepth HTMLheader refererBACK HTMLtimeout baseurl writeTempIcons fTypes HTMLpwd toknHandles synCount liste cookie \
	activeHTM HTMLreferer newPage urltext sendCookies msgText remSTR home ignoreReDir homeDir askServer killCHR filter cacheLocation
	if {$file==""} return
	#NEW111106: check for Dangerous Domain AND FileType
	if {[regexp -nocase $fTypes(DDOM) $url] && [regexp -nocase $fTypes(Danger) $url]} return
#	if {[regexp -nocase {FIQdummy[0-9]*} $file]} {
#	   if {![file exists $file]} {
#	   	writeFile $file $url
#	   }
#	   return $file
#       }
	#code in %code wandeln
	set url [acode decode $url]
	#%code in orig. CHR wandeln
	set url [acode recode $url]
#NEW260806:
#regsub -nocase -all {%20} $url { } url
	regsub -nocase -all {:/+} $url {://} url
        set url [lowerHTTP [regchn $url]]
	if {$debug>3} {puts "copyURL bekommt: $url $file"}
	#set back $file
#CHNG290406: set fileOK from 100 to 1
	set merkFile $file
	set fileOK 1
	set fsize 0
	set erg 0
	set pro 0
	set tbytes($erg) 0
	set type ""
	set coding ""
	set status ""
	set meta ""
	set returnCode ""
	dispWAIT $msgText(request.send.1)
	setLED green
	#NEW070805: reset ProgressBar
	ProgressFile 0 0
	set dummy [concat [sendCookie $url]]
	if {$debug>4} {puts "Cookie: $dummy"}
	set dummyURL [regSTR $remSTR $url]
	set origURL $dummyURL
	regsub -nocase -all {^[a-zA-Z0-9]*\.} $dummyURL {} dummyURL
	set dummyURL [lindex [split $dummyURL /] 0]
	regsub -nocase -all {^[a-zA-Z0-9]*\.} $refererBACK {} chkURL
	set chkURL [lindex [split $dummyURL /] 0]
#CHNG010506:
#	if {$askServer==1} {}
	if {$askServer==1 && ([regexp -nocase $dummyURL $refererBACK] || [regexp -nocase $chkURL $url])} {
		if {[string length $HTMLpwd]<=0} {
        		set sendheader [concat $refererBACK $HTMLheader]
		} else {
        		set sendheader [concat $refererBACK $HTMLheader $HTMLpwd]
		}
	} else {
		if {[string length $HTMLpwd]<=0} {
			set sendheader $HTMLheader
		} else {
			set sendheader [concat $HTMLheader $HTMLpwd]
		}
	}
	if {$sendCookies==1 && [llength $dummy]>0} {
		set dummy [acode solve [join $dummy]]
		if {[string length $dummy]>0} {
#CHNG010506:
#			if {$askServer==1} {}
			if {$askServer==1 && ([regexp -nocase $dummyURL $refererBACK] || [regexp -nocase $chkURL $url])} {
				if {[string length $HTMLpwd]<=0} {
					set sendheader [concat $refererBACK $HTMLheader Cookie $dummy]
				} else {
					set sendheader [concat $refererBACK $HTMLheader $HTMLpwd Cookie $dummy]
				}
			} else {
				if {[string length $HTMLpwd]<=0} {
					set sendheader [concat $HTMLheader Cookie $dummy]
				} else {
					set sendheader [concat $HTMLheader $HTMLpwd Cookie $dummy]
				}
			}
		}
	}
	if {$debug>3} {puts "copyURL Header: $sendheader"}

	if {![catch {open $file w} out]} {
		set chk .[string trim [getEXT $file] .]
#puts "chk: $chk"
		if {$HTMLtimeout>0 && ([chkEXT $chk] || [chkIMG $chk])} {
        		#Timeout aktiviert
			#if {[catch {set token [::http::geturl $url -channel $out -progress progress -blocksize $blocksize -timeout $HTMLtimeout -headers $sendheader]}]} {}
#regsub -nocase -all {@} $url {%40} url
#set token [::http::geturl $url -channel $out -progress progress -blocksize $blocksize -timeout $HTMLtimeout -headers $sendheader]
			if {[catch {::http::geturl $url -channel $out -progress progress -blocksize $blocksize -timeout $HTMLtimeout -headers $sendheader} token]} {
				#set token [::http::geturl $url -channel $out -progress progress -blocksize $blocksize -timeout $HTMLtimeout -headers $sendheader]
				catch {close $out}
				if {[file exists $file]} {catch {file delete -force $file}}
				catch {http::cleanup $token} err
				dispWAIT $msgText(request.send.2)
				if {[winfo exists $mainHTML.info]} {destroy $mainHTML.info}
				label $mainHTML.info -image imInfo -background [$mainHTML cget -background]; pack $mainHTML.info -side top -anchor nw
				$mainHTML parse "&nbsp;&nbsp;&nbsp;&nbsp;$msgText(request.send.2)\n"
				setLED red
				#return $file
				return
			}
		} else {
			#if {[catch {set token [::http::geturl $url -channel $out -progress progress -blocksize $blocksize -headers $sendheader]}]} {}
			if {[catch {::http::geturl $url -channel $out -progress progress -blocksize $blocksize -headers $sendheader} token]} {
				catch {close $out}
				if {[file exists $file]} {catch {file delete -force $file}}
				catch {http::cleanup $token} err
				dispWAIT $msgText(request.send.2)
				if {[winfo exists $mainHTML.info]} {destroy $mainHTML.info}
				label $mainHTML.info -image imInfo -background [$mainHTML cget -background]; pack $mainHTML.info -side top -anchor nw
				$mainHTML parse "&nbsp;&nbsp;&nbsp;&nbsp;$msgText(request.send.2)\n"
				setLED red
				#return $file
				return
			}
		}
		catch {close $out}
	} else {
 	  	  dispMSG $msgText(unable.write.file)
		  setLED red
		  return
	}
	if {[file exists $file]} {
		if {[file size $file]<=1} {
			catch {file delete -force $file}
#			set input "<BODY bgcolor=$htmlBG color=$htmlFG><h1><b>Not Found !</b></h1><br><b>The requested site does not exists.</b><br></BODY>"
#			writeFile $file $input
		}
	}
#puts "weiter"
#NEW211006:
regsub -nocase -all {[^0-9]} $token {} erg
if {[string length $erg]<=0 || ![regexp -nocase {[0-9]} $erg]} {set erg 0}
set tokCount $erg
	if {[info exists token]} {
		if {[string length $token]>0} {lappend toknHandles $token}
		upvar #0 $token state
		set status timeout
		catch {set type $state(type)}
		catch {set coding $state(coding)}
		catch {set tbytes($erg) $state(totalsize)}
		catch {set fsize $state(currentsize)}
		catch {set status $state(status)}
#CHNG030711: t-online.de conains: ETag {"2da36-4a7263ca6c1c0"-gzip} which must be: ETag {"2da36-4a7263ca6c1c0" -gzip} 
#				catch {set meta $state(meta)}
catch {regsub -nocase -all "\-gzip" $state(meta) " \-gzip" meta}
		catch {set returnCode $state(http)}
		if {$debug>4} {
			catch {puts "State: $meta"}
			#catch {puts "Body: $state(body)"}
			catch {puts "Error: $state(error)"}
			catch {puts "Charset: $state(charset)"}
		}
		if {$debug>2} {
			catch {puts "CurrentSize: $fsize"}
			catch {puts "HTTP: $returnCode"}
			catch {puts "Status: $status"}
			catch {puts "Totalsize: $tbytes($erg)"}
			catch {puts "Type: $type"}
			catch {puts "Coding: $coding"}
		}
	}
	set max 0
	set rbytes($erg) 0
	catch {::http::cleanup $token} err
#	catch {::http::reset $token} err
#HIER ggf. ignoreRedir prfen, wenn 1 und gelieferte URL ist NICHT = geforderte URL dann Datei lschen und erneuter Request bis MaxDepth erreicht !
	#NEW281105: User/Password Authentication
    set check [lindex [split $returnCode { }] 1]
	if {[regexp -nocase {401} [lindex [split $returnCode { }] 1]] && [string length $HTMLpwd]<=0} {
		#User/Password Authentication required
		dispMSG $msgText(auth.req.0)
		setLED orange
		set HTMLpwd [getPasswd]
		if {[string length $HTMLpwd]>1} {
			set HTMLpwd "Authorization {Basic $HTMLpwd}"
			return [copyURL $url $file]
		}
	}
	#NEW010706: requery if Site not found (404) and URL contains "?"
#	if {$newPage==0} {
	   if {[regexp -nocase {\?} $url]} {
			if {[regexp -nocase {404} $check]} {
				if {[regexp -nocase {/\?} $url]} {
					regsub -nocase {/\?} $url {?} url
				} else {
					regsub -nocase {\?} $url {/?} url
				}
				setBase $url
				return [copyURL $url $file]
			} elseif {[regexp -nocase {400} $check]} {
#NEW010907: clearCookie if "400 Bad request" encounters
			   set cookie ""
			   if {[regexp -nocase {\?} $url] && ![regexp -nocase {=} $url]} {
					set url [lindex [split $url "\?"] 0]
			   }
			   return [copyURL $url $file]
		    }
		}
#	}

	#NEU200408:WarningMessage if File<Totalsize
	if {$fsize<$tbytes($erg) && $tbytes($erg)>0} {
		set ext [transType .[string trim [getEXT $url] .]]
		#Nur bei Images, Warning ausgeben  (tdlich, wenn z.B. MPGs downgeloaded werden !!!)
			if {$fsizeWarn==1} {
				set mtext "File: $url Size: $fsize / $tbytes($erg)"
				optionBox -title $msgText(request.warning.1) -icon warning -type ok -message $mtext
				unset mtext
			} else {
				dispMSG "$msgText(request.warning.2) $fsize / $tbytes($erg)"
				setLED red
			}
			if {$tbytes($erg) > 0 && $fsize > 0} {
                                    set pro [expr 100.0 / [expr $tbytes($erg).0 / $fsize.0]]
                        } else {
                                    set pro 0
                        }
			set fileOK [expr round($pro)]
	} elseif {![regexp -nocase {401} $check]} {
		set fileOK 100
	}
	#NEU:160304: variTime (TM)
	if {$variTime>1} {
		dispMSG "variTime (TM) in use !"
		setLED magenta
		set warte [lindex [split [expr {rand () * $variTime}] .] 0]
		after [expr $warte * 1000]
	}

	#NEU210304: Coding von HTML-Antwort (z.B. gZip; also gepackte HTML-Pages, wie z.B. von "Google" !)
	if {[chkARC $coding]} {
		set zipfile [string trim $file].gz
		catch {file rename -force $file $zipfile}
#puts "ZIP: $file $zipfile"
                unzip $zipfile
	}

	set dummy .[string trim [getEXT [acode decode $file]] /]
#puts "Dummy: $dummy $file"
#	if {[string length $dummy]<2} {
#		if {[catch {chkType data $state(body)} ext]} {
			set ext [chkType file $file]
#		}
#	} else {}
	if {[string length $ext]<2} {
#Dateieindung IMMER dem aus dem INet geholten ContentType anpassen
		set urlext [lindex [split $type /] 1]
		set urlext .[lindex [split $urlext {\;}] 0]
		set urlext [transType $urlext]
		set ext $urlext
	}
#puts "EXT: $ext"
#puts "URL: $url $dummy"
	if {([chkALL $ext] && ![chkANI $ext]) || [regexp -nocase {favicon.ico$} $file]} {
#puts "chkEXT: $ext"
		if {![regexp -nocase $ext$ $dummy] && ![regexp -nocase $ext$ $file] && ![regexp -nocase {favicon.ico$} $file]} {
#			catch {file copy -force $file $dummy$ext}
			set dummy [cutEXT $file]
			if {$dummy==$file && [string length $ext]>1} {
                              regsub -nocase {\.htm$} $dummy {} dummy
			}
			#puts "rename: $file $dummy"
			#NEW240106:
			setLED orange
			#NEW170606: chk for 40x/50x Errors
			if {[regexp -nocase {^4|^5} $check]} {
				set fileOK 1
			}
			#catch {file delete -force $dummy.INI}
#CHNG050606:
#			catch {file rename -force $file $dummy$ext}
#			set file $dummy$ext
		} elseif {[regexp -nocase {favicon.ico$} $file]} {
			if {$writeTempIcons==1} {
				if {[file exists $file]} {
                                   catch {file delete -force $file}
                                }
				::imFavicon write $file
			}
		}
	}
	if {$debug>3} {puts "Meta: $meta"}
	set modified ""
	set etag ""
        foreach {name value} $meta {
		if {[string length $name] > $max} {
			set max [string length $name]
		}
		#Notfall Abbruch (oder HTML-Header hat "EOF" geliefert)
		if {$cancel==1} {
			dispMSG $msgText(abbruch)
			setLED yellow
			if {[info exists token]} {
				catch {::http::cleanup $token} err
#				catch {::http::reset $token} err
			}
			break
		}
		regsub -nocase -all {\n} $value {} value
		#NEU:010304 Cookie-Handler
		if {[regexp -nocase {set-cookie} $name]} {
		#Jou, Cookie soll gesetzt werden
			if {$debug>1} {puts "SetCookie: $name $value"}
			#NEW140206:
			regsub -nocase -all $killCHR $value {} value
			regsub -nocase -all { ">} $value {} value; #"
			#getCookie $url [join $value]
			catch {join $value} value
			getCookie $url $value
		}
		#NEU060304: P3P;(Proxy)
		if {[regexp -nocase p3p $name]} {
			if {$debug>1} {puts "P3P: $name $value"}
			writeP3P $url $value
		}
		#NEU120304: Meta: eTag, LastModified je Domain speichern
		#Anhand des eTag & LastModified, erkennt der Browser, ob das File im Cache noch aktuell ist
		#Rckmeldung vom Server: 304 Not Modified since...
       		if {[regexp -nocase ^last-modified$ $name]} {
       			if {$value!=""} {set modified [join $value]}
       		}
       		if {[regexp -nocase ^etag$ $name]} {
       			if {$value!=""} {set etag [join $value]}
       		}
#		if {[regexp -nocase {eof|timeout} $status]} {
#			dispMSG $msgText(timeout)
#			setLED magenta
#			continue
#		}
#CHNG090106:
#		if {$maxcount < $maxDepth} {}
#CHNG140707:
#		if {$maxcount <= $maxDepth && $ignoreReDir<=0} {}
		if {$maxcount <= $maxDepth && $ignoreReDir<=0 && ![regexp -nocase {forbidden|reset|403} $value$status]} {
#puts "Bin hier: $newPage"
		#Max Anzahl "redirections"
			if {[regexp -nocase -all {^location} $name] && ![regexp -nocase {favicon.ico|\.css$|\.js$} $url]} {
       				setLED cyan
#puts "Value: $value"
                                set ext [transType .[string trim [getEXT $value] .]]
				#if {[string length $ext]<=1} {set ext ".htm"}
#puts "vExt: $ext"
        					#OK, Dateinamen an new Location anhngen
					incr maxcount
						if {[regexp -nocase -all {/$} $url]} {
							set filename $url
						} else {
							set filename [lindex [split $url /] end]
						}
						set filename [acode encode $filename]
						if {$debug>1} {puts "Redirect Filename1: $value"}
						set value [reslvURL $value 1]
						if {[regexp -nocase {\?|&} $value]} {set value [string trimright $value /]}
#NEW281106
#set value [cutLink $value]
if {[regexp -nocase {^\.\./} $value]} {
   set value [string trimright $baseurl($activeHTM) /]/$value
}
#						set dummy [cutLink $value]
set dummy $value
						set origEXT [getEXT $filename]
						regsub -nocase -all {\.+} $origEXT {} origEXT
						set origEXT .$origEXT
						regsub -nocase {/$|\.html$|\.htm$|\.phtml$|\.phtm$|\.shtml$|\.shtm$|\.php[0-9]$|\.php$|\.aspx$|\.asp$|\.cgi$|\.css$|\.js$} $origEXT {.htm} origEXT
						set redirEXT .[string trimleft [getEXT $dummy] .]
						regsub -nocase -all {\.+} $redirEXT {} redirEXT
						set redirEXT .$redirEXT
						regsub -nocase {/$|\.html$|\.htm$|\.phtml$|\.phtm$|\.shtml$|\.shtm$|\.php[0-9]$|\.php$|\.aspx$|\.asp$|\.cgi$|\.css$|\.js$} $redirEXT {.htm} redirEXT
#puts "EXT: $origEXT $redirEXT $ext $check"
						#NEW140106: only setBase if requested FileType == redirectedFileType
						#also requested wird .gif redirected wird zu .htm
						if {([regexp -nocase "\.css$|\.js$" $ext] && [regexp -nocase $origEXT $redirEXT]) || [regexp -nocase $redirEXT $origEXT] || [regexp -nocase {^30[0-9]} $check]} {
							#CHNG180206: chk Base AND 1st Directory
							set chkBase [regSTR $remSTR $baseurl($activeHTM)]
							set chkBase [string trim $chkBase /]
                            set dumBase [split $chkBase /]
                            catch {expr [llength $dumBase] - 1} dumErg
                            if {$dumErg<=0} {set dumErg 0}
							set chkBase [join [lrange $dumBase 0 $dumErg]]
							regsub -nocase { +} $chkBase {/} chkBase
							set newBase [regSTR $remSTR $dummy]
 							set newBase [string trim $newBase /]
                            set dumBase [split $newBase /]
                            catch {expr [llength $dumBase] - 1} dumErg
                            if {$dumErg<=0} {set dumErg 0}
							set newBase [join [lrange $dumBase 0 $dumErg ]]
							regsub -nocase { +} $newBase {/} newBase
#puts "redirectionA1: $newBase $chkBase $ext $url"
							if {![regexp -nocase $newBase $chkBase] && ([chkEXT [transType .[string trim $ext .]]] || [string length $ext]<=1)} {
#							if {[chkEXT $ext] || [string length $ext]<=1} {}
#puts "redirectionA2: $newBase $chkBase $ext $url"
								setBase $value
								#NEW060806:
								set dummy [acode decode $value]
								#set value [upperHTTP $value]
								set newPage 0
								set merkurl $dummy
								set urltext [upperHTTP $value]
								set dummy [cutEXT [lindex [split $file /] end]]
								set chart [getCachedir $value]
								set cachedir [string trimright $cacheLocation /]/cache/html/$chart
								if {![file isdirectory $cachedir]} {file mkdir $cachedir}
								SaveScript $cachedir/$dummy.INI
								set urltext $merkurl
								if {$value!=""} {
									if {$ignoreReDir<=0} {
									   		set home $urltext
											set inhalt "<html><meta http-equiv=\"refresh\" content=\"1; URL=$value\">"
									} else {
											set inhalt "<html>\n<head>\n<title>FIQ Redirected</title>\n<meta http_equiv=\"refresh\" content=\"1; URL=$value\">\n</head>\n</html>"
									}
								}
#								set inhalt "$inhalt\n$msgText(maximum.redir.2)<br><a href=\"$value\">$value</a></html>"
								writeFile $cachedir/$dummy.HTM $inhalt
							}
						}
						if {$newPage==0} {
							set help [acode recode $value]
							#NEW050606:
							if {![regexp -nocase -all {/\?} $help]} {
								regsub -nocase -all {\?|&|#} $help {} help
								set help [string trim [lindex [split $help ] 0]]
							}
#							set HTMLreferer "Referer [lowerHTTP $help]"
							set HTMLreferer "Referer [lowerHTTP [cutFile $help]]"
#puts "HELP1: $help"
							set newPage 1
							set refererBACK [string trimright $HTMLreferer /]
						}
#NEW091206: if filename is NOT in new Location, append it
if {![regexp -nocase "/$|$filename" $value] && ![regexp -nocase {^http:/|^\.\./} $filename]} {
   if {![regexp -nocase {\?|&} $value]} {
      set value [string trimright $value /]/$filename
   }
}
					set chart [getCachedir $value]
					set cachedir [string trimright $cacheLocation /]/cache/html/$chart
					if {![file isdirectory $cachedir]} {file mkdir $cachedir}
					set dummy [regSTR $remSTR $value]
					set file [cutFile [transType $dummy]]
					set file [acode encode $file]
					set file [string trim $cachedir]/[string trim $file]
					#NEW070105: only follow Redirections, if Site does not exists in Cache
					#if {[file exists $file]} {return $file}

#NEW031206: handle redirected Links/Images
if {[info exists liste($activeHTM,$origURL)]} {
	set hsrc $liste($activeHTM,$origURL)
	if {[string length $hsrc]>0} {set liste($activeHTM,$dummy) $hsrc}
}
#CHNG250606:
#				return [copyURL $value $file]
				return [copyURL $value $merkFile]
				break
               		} elseif {[chkEXT .[string trim [getEXT $url] .]] && [chkEXT $ext] && $newPage>=2 && ![regexp -nocase {favicon.ico$|\.css$|\.js$|/$} $url] && ![regexp -nocase {location } $meta]} {
#puts "redirection2: $url $ext $newPage"
#NEW261205: if Selected HTM file which contains JPG
				setBase [fileDIR $url]
				set help [acode recode $url]
#NEW050606:
				if {![regexp -nocase -all {/\?} $help]} {
					regsub -nocase -all {\?|&|#} $help {} help
					set help [string trim [lindex [split $help ] 0]]
				}
#				set HTMLreferer "Referer [lowerHTTP $help]"
				set HTMLreferer "Referer [lowerHTTP [cutFile $help]]"
#puts "HELP2: $help"
				set newPage 1
				set refererBACK [string trimright $HTMLreferer /]
			}
       		} elseif {$maxcount > $maxDepth || $ignoreReDir > 0} {
#puts "oder da: $newPage"
			if {[regexp -nocase -all {^location} $name]} {
				catch {stop_anigif .mbar.lbAnim}
				.mbar.lbAnim configure -image imTuxUnallowed
				dispMSG $msgText(maximum.redir)
				set file $file.HTM
				set inhalt "$msgText(maximum.redir)<br><a href=\"$value\">$value</a>"
				writeFile $file $inhalt
			}
			setLED orange
			#break
			return $file
			break
       		}
		if {[regexp -nocase {eof|timeout} $status]} {
			dispWAIT $msgText(timeout)
			setLED magenta
#			continue
		}
	}
	if {[regexp -nocase timeout $status]} {
		dispWAIT $msgText(request.send.3)
		setLED orange
                if {$fsize>=$tbytes($erg)} {
                        set fileOK 100
                } else {
                        set fileOK 1
                }
	}
	catch {::http::cleanup $token} err
	set rbytes($erg) 0
	#NEU150403: Datei "heile" angekommen ?
        if {[file exists $file]} {
		catch {file size $file} fsize
#		if {$fsize<=0 || [regexp -nocase {favicon} $file]} {}
		if {$fsize<=0} {
			#File hat aber Lnge von 0 Bytes
			#CHNG100106:
			catch {file delete -force $file}
			#NEW180206:
			set inhalt "<BODY bgcolor=$htmlBG color=$htmlFG><h1><b>&nbsp;&nbsp;&nbsp;&nbsp;$msgText(request.warning.5)</b></h1><br><b>&nbsp;&nbsp;&nbsp;&nbsp;$msgText(request.warning.6)</b><br><a href=\"$url\">$url</a></BODY>"
#			set inhalt "$msgText(maximum.redir)<br><a href=\"$url\">$url</a>"
			if {[winfo exists $mainHTML.info]} {destroy $mainHTML.info}
			label $mainHTML.info -image imWarning -background [$mainHTML cget -background]; pack $mainHTML.info -side top -anchor nw
			$mainHTML parse $inhalt
			incr maxcount
			if {$maxcount<=$maxDepth} {
				dispMSG "$msgText(maximum.retry) $maxcount"
				setLED red
				return [copyURL $url $file]
			} else {
				if {$fsizeWarn==1} {
					onError "5 copyURL: HTML_File: $file size: $fsize bytes !"
				} else {
					dispMSG "$msgText(request.warning.2) $fsize / $tbytes($erg)"
					setLED red
				}
				#NEW220106:
				set fileOK 1
				return
			}
		}
	} else {
		if {$fsizeWarn==1} {
			onError "5 copyURL: HTML_File: $file dosn't exists !"
		} else {
			dispMSG $msgText(request.warning.4)
			setLED red
		}
		#NEW220106:
		set fileOK 1
		return
	}
#	writeCache $file $fsize
        if {$debug>3} {puts "copyURL returns: $file = $url"}
	return $file
}

proc ProxyCommand {args} {
	global debug HTProxy
    if {$debug>8} {puts "ProxyCMD gets: $args"}
    return [list $HTProxy(serv) $HTProxy(port)]
}

# HTML-Lib RckinfoProc
proc progress {intoken total sofar} {
	global rbytes tbytes msgText HTMLsync downMode synCount noTimeout token anzSEL saveTimeout picture
#	global msgText HTMLsync downMode synCount noTimeout
	#NEW120806: chk if array exists
	if {$synCount<0} return
#NEW181006:
regsub -nocase -all {[^0-9]} $intoken {} erg
#	set synDummy $synCount
#prevent defective files by setting following value instead of above (see also below $synDummy>0) and it MUST reset ALL arrays rbytes/tbytes($token) !
	set synDummy $erg
#	if {![info exists tbytes($synDummy)]} return
	set tbytes($synDummy) $total
#	set tdummy $total
#	if {![info exists rbytes($synDummy)]} return
	set rbytes($synDummy) $sofar
#	set rdummy $sofar

	if {$total != 0} {
		if {$total > 2000} {
			ProgressFile $rbytes($synDummy) $tbytes($synDummy)
			if {$HTMLsync>0} {
#				regsub -nocase -all {[^0-9]} $intoken {} erg
				#NEW100606:
				if {$rbytes($synDummy)==0} {
					#empfange
					dispWAIT "$msgText(retrieve.bytes) $tbytes($synDummy) / $tbytes($synDummy) bytes ($synCount/$synDummy)"
					setLED green
				} else {
					#fortschritt
#					if {$downMode<=0} {
						dispWAIT "$msgText(retrieve.bytes.1) $rbytes($synDummy) / $tbytes($synDummy) bytes ($synCount/$synDummy)"
#					} else {
#						dispMSG "request: $total bytes ($synCount/$erg)"
#					}
				}
			} else {
				dispWAIT "$msgText(retrieve.bytes) $rbytes($synDummy) / $tbytes($synDummy) bytes"
				setLED green
			}
#			setLED green
		}
	} else {
		if {$tbytes($synDummy)>0} {dispMSG "$tbytes($synDummy) bytes $msgText(recieved.bytes)"}
		#setLED cyan
	}
	#NEW190806: immediate Timeout when Filesize reached (if "$synDummy/anzSEL>1 && $intoken<$token" then FIQ will wait for timeout at last file)
#	if {$noTimeout>0 && $tbytes($synDummy)>0 && $rbytes($synDummy)>0 && $anzSEL>=$saveTimeout} {}
	if {$noTimeout>0 && $tbytes($synDummy)>0 && $rbytes($synDummy)>0} {
	   if {$rbytes($synDummy)>=$tbytes($synDummy)} {
	      	catch {http::reset $intoken}
	   }
	} elseif {$anzSEL>=$saveTimeout && $tbytes($synDummy)>0 && $rbytes($synDummy)>0} {
	   if {$rbytes($synDummy)>=$tbytes($synDummy)} {
	      	catch {http::reset $intoken}
	   }
	}
}

#sendCookie liefert CookieInhalt zurck
#sofern ein passender Cookie zu der Domain auf HD gefunden wurde, ansonsten CookieVariable
proc sendCookie {url} {
	global debug homeDir sendCookies cookie cookieHeader remSTR cacheLocation merkDOM
	if {$sendCookies==0 || [string length $url]<=0} {return $url}
	if {$debug>4} {puts "sendCookie get: $url"}
	#set merkURL $url
	set url [regSTR $remSTR $url 0]
	set dummy [lindex [split $url ?] 0]
	set basedom [lindex [split $dummy /] 0]
	regsub -nocase -all {\{|\}} $cookie {} cookie
	#set back [string trim [join [concat $cookie]]]
	mkCacheDir
	#NEW211104: createCookieSubDirectory
	set chart [getCachedir $basedom]
	set dir [string trimright $cacheLocation /]/cache/cookies/$chart
	set filename [acode encode $basedom]
	set filename [cutFile $filename]
	set filename [string trimright $filename /]
	set filename $dir/[string trim $filename].CKI
	if {[file exists $filename] && [string length [join $cookie]]<=0} {
		if {$debug>4} {puts "CookieFile: $filename"}
		#Jou, Cookie gibt es fr diese Domain also Cookie ffnen und auslesen
		set dummy [split [openFile $filename] \n]
		set domain [string trim [lindex $dummy 0]]
		set path   [string trim [lindex $dummy 1]]
		set expire [string trim [lindex $dummy 2]]
		set secure [string trim [lindex $dummy 3]]
		set cookie [lrange $dummy 4 end]
		set cookieHeader [list $domain $path $expire $secure]
	}
	set back [string trim [join [concat $cookie]]]
	regsub -nocase -all { +} $back { } back
	regsub -nocase {^; *} $back {} back
	set back [list [acode decode $back]]
#NEW260807: clearCookie if it's another Domain
#if {[regexp -nocase $basedom $merkDOM]} {
#   set cookie ""
#   set back ""
#}
	set merkDOM $basedom
	if {$debug>2} {puts "sendCookie returns: $back"}
#puts "sendCookieReturns $back"
	return $back
}

#Setzt Cookie; liefert nichts zurck ($cookie enthlt kompletten Cookie-Inhalt)
proc getCookie {urlIN cookin} {
	global debug homeDir writeCookie cookie cookieHeader remSTR cookieCount killCHR
	if {[string length $urlIN]<=0 || [string length $cookin]<=0} return
	if {$debug>2} {puts "getCookie get: $cookin"}
	regsub -nocase -all $killCHR $cookin {} cookin
	incr cookieCount
	set urlIN [acode encode $urlIN]
	set cookin [acode decode $cookin]
	set dummy [URLsplit $urlIN]
	set urlIN [regSTR $remSTR $urlIN 0]
	set cookin [split $cookin {;}]
	foreach inhalt $cookin {
#		set inhalt [string trim $inhalt]
		regsub -nocase -all { *= *} $inhalt {=} inhalt
		regsub -nocase -all { +} $inhalt { } inhalt
		set inhalt [string trim $inhalt]
		if {[regexp -nocase {domain=} $inhalt]} {
			lappend domain $inhalt
			continue
		} elseif {[regexp -nocase {path=} $inhalt]} {
			lappend path $inhalt
			continue
		} elseif {[regexp -nocase {expires=} $inhalt]} {
			lappend expire $inhalt
			continue
		} elseif {[regexp -nocase {secure=} $inhalt]} {
			lappend secure $inhalt
			continue
		} elseif {[string length $inhalt]>0} {
			#NEW180505: preserve Errors with unmatched open brace in inhalt
			regsub -nocase -all {;} $inhalt {} inhalt
#			set inhalt [string trim $inhalt]
			set chk [lindex [split $inhalt =] 0]
			regsub -nocase -all {\{|\}} $cookie {} cookie
			regsub -nocase -all {\{|\}} $chk {} chk
			catch {lsearch -regexp $cookie $chk} idx
#			set idx [lsearch -regexp $cookie $inhalt]
			if {$idx >= 0} {
			   catch {lreplace $cookie $idx $idx {}} cookie
			}
            if {[regexp -nocase $inhalt $cookie]} {
				regsub -nocase $inhalt $cookie {} cookie
				if {[string length $inhalt]>0} {
						lappend cookie "$inhalt; "
				}
			} else {
				lappend cookie "$inhalt; "
			}
		}
	}
	if {[catch {llength $domain}]!=0} {lappend domain "domain=[regsub -nocase -all {www\.|www[0-9]\.} [lindex $dummy 1] {}]"}
	if {[catch {llength $path}]!=0} {lappend path "path=[lindex $dummy 2]"}
	if {[catch {llength $expire}]!=0} {lappend expire "expires=0"}
	if {[catch {llength $secure}]!=0} {lappend secure "secure=0"}
#puts "Domain: $domain"
#puts "Path: $path"
#puts "Expire: $expire"
#puts "Secure: $secure"
	lappend cookieHeader [list $domain $path $expire $secure]
#OUT260807:
#regsub -nocase -all { +} [join [concat $cookie]] { } cookie
#puts "HEADER: $cookieHeader"
#puts "COOKIE: $cookie"
#set cookieHeader [lsort -index 1 -decreasing $cookieHeader]
#puts "CookieHeader: $cookieHeader"
	if {$debug>2} {puts "getCookie sets: $cookie"}
}


proc writeCookie {url} {
	global homeDir debug cookieHeader cookie writeCookie remSTR cacheLocation
	if {$writeCookie==0 || [string length $url]<=0 || [llength $cookie]<=0} return
	if {$debug>2} {puts "writeCookie get: $url"}
	mkCacheDir
	set url [regSTR $remSTR $url 0]
	set dummy [lindex [split $url ?] 0]
	set basedom [lindex [split $dummy /] 0]
	#NEW211104: createCookieSubDirectory
	set fake [trimFile $basedom]
#	set fdir [string trimleft $fake .]
#	set chart [lindex [split $fdir {}] 0]
	set chart [getCachedir $fake]
	set dir [string trimright $cacheLocation /]/cache/cookies/$chart
	if {![file isdirectory $dir]} {file mkdir $dir}
	set filename [acode encode $dummy]
	set filename [cutFile $filename]
	set filename [string trimright $filename /]
	set filename $dir/[string trim $filename /].cki
	#Schreibe Cookie on HD domain, path, expire, secure, values
	if {![catch {open $filename w} write]} {
		puts $write [lindex $cookieHeader 0]
		puts $write [lindex $cookieHeader 1]
		puts $write [lindex $cookieHeader 2]
		puts $write [lindex $cookieHeader 3]
		puts $write $cookie
		close $write
	}
	#NEW211104: writeCookieExpireList on HD
	set filename [string trimright $cacheLocation /]/cache/cookies/cookies.FQL
	set ausgabe ""
	set expire [lindex [split [lindex $cookieHeader 2] =] end]
	if {[file exists $filename]} {
		set ausgabe [concat [split [openFile $filename] \n]]
		if {[llength $ausgabe]>0} {
			set idx [lsearch -regexp $ausgabe $basedom]
			if {$idx>=0} {
				set ausgabe [lreplace $ausgabe $idx $idx [list $basedom $expire]]
			} else {
				lappend ausgabe [list $basedom $expire]
			}
		} else {
			set ausgabe [list $basedom $expire]
		}
	} else {
		lappend ausgabe [list $basedom $expire]
	}
	set dummy ""
	foreach inhalt $ausgabe {
		if {[string length $inhalt]>0} {lappend dummy $inhalt}
	}
	if {![catch {open $filename w} write]} {
		puts $write $dummy
		close $write
	}
	#NEW211104end
	if {$debug>2} {puts "writeCookie write: $cookie"}
#	set cookie ""
#	set cookieHeader ""
	catch {unset ausgabe dummy expire basedom filename}
}

#TEST!!!!!!!!!!!!!!!!!!
proc HTTPcallback {intoken} {
	upvar #0 $intoken state
	puts "HTTPcall: $state"
}

proc HTTPhandler {sock intoken} {
	puts "HTTPhandlerSOCK: $sock"
	puts "HTTPhandlerTKEN: $intoken"
	set data [read $sock 1000]
	set bytes [string length $data]
	puts "Data: $data"
	puts "Bytes: $bytes"
}

proc HTTPquery {intoken tbytes rbytes} {
	puts "HTTPqueryTKEN: $intoken"
	puts "HTTPqueryTOTL: $tbytes"
	puts "HTTPquerySOFA: $rbytes"
}
#TestENDE

#NEW300304: FileMenu > MirrorPage
proc MirrorPage {arg} {
	global MapMode createMirror urltext selected destDir msgText
	if {$MapMode==4} {
	#Mirror whole FTPsite
		mirrorFTP 0
	} else {
	#Mirror only selected Page(s)
		if {[string length [string trim $urltext]]<=0} {
			dispMSG $msgText(mirror.page.1)
			setLED orange
			return
		}
		set createMirror 1
		if {[llength $selected]<=0} {
		#Wenn nix ausgewhlt nur akt. Seite
			if {$arg==0} {
				goEnter
				dispMSG $msgText(mirror.page.2)
				setLED blue
			} else {
				MirrorSite 0
			}
		} else {
		#Sonst alle ausgewhlten
			set merksel $selected
			set merkurl $urltext
			goEnter
			set selected $merksel
			set max [llength $selected]
			set z 0
			foreach link $selected {
				ProgressBar $z $max
				set urltext [upperHTTP [reslvURL [lindex $link 0]]]
				if {$arg==0} {
					goEnter
				} else {
					MirrorSite 0
				}
				if {$cancel==1} {break}
				incr z
			}
			if {$cancel==1} {return}
			#Wieder aus, weil Seite sonst nochmal "geMirrored" wird
			set createMirror 0
			set urltext $merkurl
			goEnter
			unset merkurl merksel
		}
		set createMirror 0
	}
	ProgressBar 0 0
	dispMSG $msgText(mirror.page.3)
	setLED blue
}

proc MirrorSite {arg} {
	global fileTypes MapMode createMirror mainHTML urltext baseurl maxDepth cancel msgText
	if {$MapMode==4} {
	#Mirror selected FTPfiles
		mirrorFTP 1
	} else {
	#Mirror selected HTMLfiles
		if {[string length [string trim $urltext]]<=0} {
			dispMSG $msgText(mirror.page.1)
			setLED orange
			return
		}
		set createMirror 1
		set merkurl $urltext
		set dom [lindex [split $urltext /] 0]
		set depth 0
		goEnter
		set HTMLlinks [$mainHTML token find a]
		set max [llength $HTMLlinks]
		set z 0
		foreach link $HTMLlinks {
			ProgressBar $z $max
			set urlfilename [reslvURL [lindex $link 2]]
			if {[lindex $fileTypes 0]=="*"} {
				if {![regexp -nocase {#} $urlfilename]} {
					set urltext [upperHTTP $urlfilename]
					goEnter
				}
			} else {
				if {[grep $fileTypes $urlfilename]} {
				#Nur ausgewhlte FileTypes zulassen
					if {![regexp -nocase {#} $urlfilename]} {
						set urltext [upperHTTP $urlfilename]
						goEnter
					}
				}
			}
			if {$arg>0} {
				set ext .[string trim [getEXT $urlfilename] .]
				if {[chkEXT $ext]} {
				#Wenn HTMLfile
					if {$depth<=$maxDepth} {
					#Und gleicher Domain
						set hLinks [$mainHTML token find a]
						lappend $HTMLlinks $hLinks
						set max [llength $HTMLlinks]
						if {$maxDepth!=0} {
							incr depth
						}
					}
				}
			}
			if {$cancel==1} {break}
			incr z
		}
		if {$cancel==1} {return}
		set createMirror 0
		set urltext $merkurl
		goEnter
		unset merkurl
	}
	ProgressBar 0 0
	dispMSG $msgText(mirror.page.4)
	setLED blue
}

#NEU100404 copyMirror ($cachePfad)
proc copyMirror {datei} {
#Legt zu jeden von "getFileURL" geholten File eine Mirror-Copy an
#Wird also am Ende von "getFileURL" (sofern createMirror=1) aufgerufen, um Kopie des akt. Files zu erstellen
	global debug baseurl urltext destDir anzDest
	set urlfilename [lindex [split $datei /] end]
	set filename [lindex [split $urlfilename #] end]
	set destination $destDir
	#create Mirror-Directory Structure
	foreach dir [split $urlfilename #] {
		set destination [string trimright $destination /]/[string trim $dir /]
		set destination [reslvDIR $destination]
		if {$dir != $filename} {
		#Dirs nur erstellen, wenn nicht LastFile
			if {![file isdirectory $destination]} {
			# WENN destDir noch nicht existiert, DANN lege es an
				catch {file mkdir $destination}
				if {$debug>2} {puts "MkDir: $destination"}
				set anzDest 0
			}
		} else {
			catch {file copy -force $datei $destination}
			if {$debug>2} {puts "MirrorCopy: $datei NACH: $destination"}
		}
	}
}

proc downSync {} {
	global debug mainHTML fileTypes fTypes selected cancel destDir linkmark followLinks msgText remSTR bytesTotal zlrGFX linktext \
	thumbsOnly ByteCount maxBytes urltext autoscroll backColor grabMode active minFileSize anzSEL anzGFX HTMLtimeout \
	maxDepth cookie FTPask followLinks globalCount ignoreReDir baseurl activeHTM synCount DOWNsync msgText
	if {$debug>2} {puts "DOWNload: $fileTypes"}
#	set gesZLR 0
	set max [llength $selected]
	if {$max<=0} {
		dispMSG $msgText(download.1)
		setLED orange
		return
	}
	if {$FTPask==1 && $thumbsOnly==1} {
		set answer [optionBox -title $msgText(download.thumbs.1) -icon warning -type yesno -message $msgText(download.thumbs.2)]
		if {[string length $answer]<=0 || [regexp -nocase {no} $answer]} return
	} elseif {$thumbsOnly==1} {
		dispMSG $msgText(download.thumbs.1)
	}
	if {$FTPask==1 && ($maxDepth<=0 || $followLinks>0)} {
		set answer [optionBox -title $msgText(download.maxdepth.1) -icon warning -type yesno -message $msgText(download.maxdepth.2)]
		if {[string length $answer]<=0 || [regexp -nocase {no} $answer]} return
	} elseif {$maxDepth<=0 || $followLinks>0} {
		dispMSG $msgText(download.maxdepth.3)
		setLED orange
	}
	catch {show_anigif [list -data [getAnim penguinL22]] .mbar.lbAnim} err
	if {$autoscroll > 0} {$mainHTML yview moveto 0.0}
#	MouseCurs 1
	set active 1
	set zlrGFX 0
	set grabMode 1
	set synCount 0
	set bytesTotal 0
	set toknHandles ""
	ProgressBar 0 0
	set anzGFX [string trimleft $anzSEL 0]
	if {$followLinks<=0} {
		wm title . "FIQ: 0/$anzGFX ($anzGFX)"
		wm iconname . "FIQ: 0/$anzGFX ($anzGFX)"
	}
	dispMSG $msgText(request.send.4)
	setLED cyan
	set buffer $selected
	regsub -nocase -all { } [join [concat $fTypes(HTML) {\\? \\& %3F %26}]] {|} chk
#	set max [llength $buffer]
	foreach inhalt $buffer {
#puts "downSync Buffer: $inhalt"
		if {$cancel==1} {break}
#NEW101106:
#regsub -nocase {[0-9]+$} $inhalt {} inhalt
#if {$winSYS>0} {regsub -nocase {^/} $dummy {} dummy}

		set dummy ""
		set url [reslvURL $inhalt 1]
		incr synCount
		if {$synCount>=$DOWNsync} {
				dispMSG $msgText(request.send.5)
				setLED cyan
	#			after [expr $HTMLtimeout * 2] {incr synCount -1}
				vwait synCount
		}
#NEW260807:
	if {$followLinks>0} {
			incr zlrGFX
			set erg [expr $anzGFX - $zlrGFX]
			wm title . "FIQ: $zlrGFX/$anzGFX ($erg)"
			wm iconname . "FIQ: $zlrGFX/$anzGFX ($erg)"
	}

#NEW160906: LoadPage internal if HTML with InlineImages
#		set linktext "$msgText(request.send.6): $url"
#		if {[regexp -nocase $chk $url]} {
#			    set activeHTM "internal"
#			    LoadFile $url
#			    set fn [getFileURL $url]
#			    set src [downHTML $fn $url]
#			    if {[llength $src]>0} {
#				    foreach req $src {
#			    	    getSyncURL $url
#				    }
#			    }
    		    #set fn [getFileURL $url]
			    #set src [readHTML $fn $inhalt]
#  			    AddSelected $inhalt 100
#puts "downHTML: $url $chk"
#		} else {
			    getSyncURL $url
#		}
	}
	set buffer ""
#	set selected ""
	if {$synCount>0} {
		set chk 0
		setLED cyan
		after [expr $HTMLtimeout] {set chk 1}
		while {$synCount>0 && $cancel<=0 && $chk<=0} {
			vwait synCount
		}
	}
	clearSelected
#	MouseCurs 0
	set active 0
}

proc downASync {} {
	global debug mainHTML fileTypes fTypes selected cancel destDir linkmark followLinks msgText remSTR bytesTotal \
	thumbsOnly ByteCount maxBytes urltext autoscroll backColor linktext grabMode active minFileSize anzSEL liste \
	maxDepth cookie FTPask followLinks globalCount ignoreReDir baseurl activeHTM maxcount
	if {$debug>2} {puts "downLOAD: $fileTypes"}
#	set gesZLR 0
	set max [llength $selected]
	if {$max<=0} {
		dispMSG $msgText(download.1)
		setLED orange
		return
	}
	if {$FTPask==1 && $thumbsOnly==1} {
		set answer [optionBox -title $msgText(download.thumbs.1) -icon warning -type yesno -message $msgText(download.thumbs.2)]
		if {[string length $answer]<=0 || [regexp -nocase {no} $answer]} return
	} elseif {$thumbsOnly==1} {
		dispMSG $msgText(download.thumbs.1)
	}
	if {$FTPask==1 && ($maxDepth<=0 || $followLinks>0)} {
		set answer [optionBox -title $msgText(download.maxdepth.1) -icon warning -type yesno -message $msgText(download.maxdepth.2)]
		if {[string length $answer]<=0 || [regexp -nocase {no} $answer]} return
	} elseif {$maxDepth<=0 || $followLinks>0} {
		dispMSG $msgText(download.maxdepth.3)
		setLED orange
	}
	catch {show_anigif [list -data [getAnim penguinL22]] .mbar.lbAnim} err
	if {$autoscroll > 0} {$mainHTML yview moveto 0.0}
#	MouseCurs 1
	set active 1
	set zlrGFX 0
	set grabMode 1
	set maxcount 0
	set buffer $selected
	set anzGFX [llength $buffer]
	set merkAnz $anzGFX
	set merkBase $baseurl($activeHTM)
	set lockfile "FIQ.LOCK"
	wm title . "FIQ: 0/$anzGFX ($anzGFX)"
	wm iconname . "FIQ: 0/$anzGFX ($anzGFX)"
	foreach inhalt $buffer {
		if {$cancel==1} {break}
#NEW101106:
#regsub -nocase {[0-9]+$} $inhalt {} url
#if {$winSYS>0} {regsub -nocase {^/} $dummy {} dummy}

		set erg [expr $anzGFX - $zlrGFX]
		if {$erg>=0} {
			ProgressBar $zlrGFX $anzGFX
#			#NEW200806:
			wm title . "FIQ: $zlrGFX/$anzGFX ($erg)"
			wm iconname . "FIQ: $zlrGFX/$anzGFX ($erg)"
#			ProgressBar $zlrGFX $anzGFX
			if {$erg<10} {
				set anzSEL [format "%02u" $erg]
			} else {
				set anzSEL $erg
			}
			.lbAnzSelGfx configure -width [string length $anzSEL]
		}
		set dummy ""
		set ext .[getEXT $inhalt]
		if {([lindex $fileTypes 0]=="*" || [reGrep $ext $fileTypes]>0) && $followLinks==0 || $thumbsOnly>0} {
		#Alle DateiTypen ausgewhlt, also alles speichern, was da kommt
			set url [reslvURL $inhalt 1]
			set linktext "$msgText(request.send.6): $url"
			set dummy [getFileURL $url 0]
#NEW190206:
set lockfile [string trimright [file dirname $dummy] /]/FIQ.LOCK
if {![file exists $lockfile]} {
	writeFile $lockfile "FIQ LockFile"
}
			set ext .[getEXT $dummy]
			set ftype [chkType file $dummy]
			if {[string length $ftype]<=1} {set ftype $dummy}
			if {[chkEXT $ext] || [regexp -nocase {.htm$} $ftype] || ([chkIMG $ext] && [regexp -nocase {\?|&|=|%3F|%26|%3D} $url])} {
#NEW190806:
setBase $url
				set dummy [readHTML $dummy $url]
				set cookie ""
			} elseif {[chkIMG $ext]} {
				set dummy [copyPic $dummy $inhalt 0]
			}
			#Wenn JPG angefordert, aber kommen tut HTM
#puts "Bin hier"
		} else {
		#nur bestimmter Filetype ausgewhlt, aber anderer Dateityp gefordert
		#z.B. .JPG gewhlt, es soll aber HTM, oder PHP heruntergeladen werden
#puts "oder auch hier"
			#Seite "unsichtbar" im Hintergrund rendern, um daraus gewnschte IMGs zu downloaden
			set url [reslvURL $inhalt 1]
			set linktext "$msgText(request.send.6): $url"
			set dummy [getFileURL $url 0]
#NEW190206:
set lockfile [string trimright [file dirname $dummy] /]/FIQ.LOCK
if {![file exists $lockfile]} {
	writeFile $lockfile "FIQ LockFile"
}
#CHNG010506:
#			set ext [getEXT $dummy]
			#set ext [lindex [split $dummy .] end]
#puts "Dummy: $dummy $ext"

			set ext .[getEXT $dummy]
			set ftype [chkType file $dummy]
			if {[string length $ftype]<=1} {set ftype $dummy}
			if {[chkEXT $ext] || [regexp -nocase {.htm$} $ftype] || ([chkIMG $ext] && [regexp -nocase {\?|&|=|%3F|%26|%3D} $url])} {
				setLED cyan
#NEW220106:
setBase $url
				readHTML $dummy $url
				set cookie ""
			}
		}
		incr zlrGFX
		if {[file exists $lockfile]} {
		   catch {file delete -force $lockfile}
                }
#		if {![regexp -nocase $ext $dummy]} {
#		#bestimmter Dateityp gefordert, aber aus INet kommt vllig anderer
#		}
	}
#CHNG190206:
	setBase $merkBase
	catch {stop_anigif .mbar.lbAnim}
#	set selected ""
#	MouseCurs 0
#	set anzSEL 00
	set active 0
	set grabMode 0
	.imHTTPS configure -image imUnLock -background $backColor
#	.lbAnzSelGfx configure -width [string length $anzSEL]
#        incr zlrGFX
        if {$anzSEL<=0} {
               ProgressBar 0 0
	} else {
 	       ProgressBar $zlrGFX $anzGFX
        }
	setLED blue
	wm title . "Inquisitor"
	wm iconname . "FIQ"
#	refreshTotal
	set ByteCount [expr $ByteCount + $bytesTotal]
	if {$maxBytes > 0 && $ByteCount > $maxBytes} {
		setLED red
		dispINF "$msgText(download.5)"
		.tile.bottom.pane.f3.box.btRip configure -activebackground red -background red
	}
	dispMSG "$msgText(download.4) $zlrGFX = $bytesTotal KBytes"
	set linktext ""
	set buffer ""
#	setBase $urltext
	ProgressFile 0 0
}

proc readHTML {inhalt url} {
	global urltext cancel fileTypes fics ficsVars filtVars minFileSize remSTR cookie maxDepth msgText fileOK followLinks anzDest selected \
		   liste activeHTM
#puts "readHTML gets: $inhalt $url"
#set merkBase $urltext
set merkUrl $url
#setBase $url
	set url [regSTR $remSTR $url]
#	setBase $inhalt
	if {![chkEXT .[string trim [getEXT $inhalt] .]]} return
	set dummy $inhalt
	set srcfiles ""
	set back ""
	set count 0
	set htmlpage [encode [ReadFile $dummy]]
#	set htmlpage [preParse [splitHTM $htmlpage]]
#puts "HTML1: $htmlpage"
	set htmlpage [splitHTM $htmlpage]
#puts "HTML2: $htmlpage"
	set htmlpage [split $htmlpage \n]
#puts "HTML: $htmlpage"
#writeFile /home/frenzy/originalSRC.txt $htmlpage
	foreach zeile $htmlpage {
#puts "Zeile: $zeile"
		set chklen [string trim [string length $zeile]]
		if {$chklen<=0 || ($chklen<3 && [regexp -nocase {^.>|^>} [string trim $zeile]])} continue
		if {$cancel==1} {break}
		if {[regexp -nocase { href} $zeile]} {
			set href [reslvURL [getValue href $zeile] 1]
			if {[string length $href]<=0} {set href [reslvURL [getValue " *src" $zeile] 1]}
			if {[regexp -nocase $filtVars $href]} continue
			if {$fics>0} {
	   	     			if {[regexp -nocase $ficsVars $href]} continue
			}
			set ext [string trim [getEXT $href] "\."]
#puts "HREF: $href $ext"
			if {[reGrep $ext $fileTypes]>0 && [string length $href]>0} {
				#WENN FileType in HREF enthalten (bei PHP)

#NEW031206: handle redirected Links/Images
if {[info exists liste($activeHTM,$url)]} {
	set hsrc $liste($activeHTM,$url)
	set origURL [regSTR $remSTR $href]
	if {[string length $hsrc]>0} {set liste($activeHTM,$origURL) $hsrc}
}
				set dummy [getFileURL $href 0]
			          if {$followLinks<=0} {
				          lappend srcfiles $dummy $href
				  } else {
				          #set back [AddSelected $href 0]
				       	  set back [copyPic $dummy $href 100]
				       	  #incr anzDest
				  }

				incr count
#puts "Lappend: $dummy"
			} else {
				#WENN FileType in SRC enthalten (meist bei HTML)
				set src [reslvURL [getValue src $zeile]]
				if {[regexp -nocase $filtVars $src]} continue
				if {$fics>0} {
		   	     			if {[regexp -nocase $ficsVars $src]} continue
				}
#puts "SRC: $src"
      	    			set ext [string trim [getEXT $src] "\."]
				if {[reGrep $ext $fileTypes]>0 && [string length $src]>0} {

#NEW031206: handle redirected Links/Images
if {[info exists liste($activeHTM,$url)]} {
	set hsrc $liste($activeHTM,$url)
	set origURL [regSTR $remSTR $src]
	if {[string length $hsrc]>0} {set liste($activeHTM,$origURL) $hsrc}
}
					set dummy [getFileURL $src 0]
				          if {$followLinks<=0} {
					          lappend srcfiles $dummy $src
					  } else {
       					         #set back [AddSelected $src 0]
						 set back [copyPic $dummy $src 100]
						 #incr anzDest
					  }
					incr count
#puts "Lappend: $dummy"
				} elseif {[string length $href]>0} {

#NEW031206: handle redirected Links/Images
if {[info exists liste($activeHTM,$url)]} {
	set hsrc $liste($activeHTM,$url)
	set origURL [regSTR $remSTR $href]
	if {[string length $hsrc]>0} {set liste($activeHTM,$origURL) $hsrc}
}
					set dummy [getFileURL $href 0]
				          if {$followLinks<=0} {
					          lappend srcfiles $dummy $href
					  } else {
					          #set back [AddSelected $href 0]
					       	  set back [copyPic $dummy $href 100]
					       	  #incr anzDest
					  }
					incr count
				}
			}
		} elseif {[regexp -nocase {img } $zeile] && [regexp -nocase {src} $zeile]} {
			#WENN FileType in SRC enthalten (meist bei HTML)
			set src [reslvURL [getValue src $zeile] 1]
#puts "IMGSRC: $src"
			if {[regexp -nocase $filtVars $src]} continue
			if {$fics>0} {
	   	     			if {[regexp -nocase $ficsVars $src]} continue
			}
			set ext [string trim [getEXT $src] "\."]
			if {[reGrep $ext $fileTypes]>0 && [string length $src]>0} {

#NEW031206: handle redirected Links/Images
if {[info exists liste($activeHTM,$url)]} {
	set hsrc $liste($activeHTM,$url)
	set origURL [regSTR $remSTR $src]
	if {[string length $hsrc]>0} {set liste($activeHTM,$origURL) $hsrc}
}
				set dummy [getFileURL $src 0]
			          if {$followLinks<=0} {
				          lappend srcfiles $dummy $src
				  } else {
    				          #set back [AddSelected $src 0]
					  set back [copyPic $dummy $src 100]
					  #incr anzDest
				  }
				incr count
#puts "Lappend: $dummy"
			} elseif {[chkEXT .$ext]} {

#NEW031206: handle redirected Links/Images
if {[info exists liste($activeHTM,$url)]} {
	set hsrc $liste($activeHTM,$url)
	set origURL [regSTR $remSTR $src]
	if {[string length $hsrc]>0} {set liste($activeHTM,$origURL) $hsrc}
}
				set dummy [getFileURL $src 0]
#puts "PHPSRC: $dummy"
#CHNG010506:
#				if {[reGrep [getEXT $dummy] $fileTypes]>0 && [string length $src]>0} {}
				if {[reGrep [lindex [split $dummy .] end] $fileTypes]>0 && [string length $src]>0} {
    				          if {$followLinks<=0} {
					          lappend srcfiles $dummy $src
					  } else {
       					          #set back [AddSelected $src 0]
					      	  set back [copyPic $dummy $src 100]
					      	  #incr anzDest
      					  }
				}
				incr count
			}
		}
		set cookie ""
	}
	catch {unset htmlpage zeile dummy}
	if {$cancel==1} {return}
		set max [llength $srcfiles]
		if {$max==1} {
#puts "SRCfile: $srcfiles"
			set dummy [lindex $srcfiles 0]
			set srcfile [lindex $dummy 0]
			set src [lindex $dummy 1]
			if {[string length $srcfile]>0} {
				set back [copyPic $srcfile $src 1]
			}
		} elseif {$max>1} {
#puts "SRCfileS: $srcfiles"
			set files ""
			set merksize 0
				foreach {datei furl} $srcfiles {
					if {$cancel==1} {break}
					if {[string length $datei]<=0 || [string length $furl]<=0} continue
					set ext [string trim [getEXT $datei] "\."]
					if {[reGrep $ext $fileTypes]<=0} continue
#puts "Filezeile: $datei $furl"
					if {[file exists $datei]} {
#puts "File: $datei exists"
						catch {file size $datei} filesize
						if {$filesize >= $minFileSize} {
#puts "Filesize: $filesize $url"
							lappend files [list $filesize $datei]
						}
					}
				}
				if {[llength $files]>0} {
					set srcfiles [lsort -integer -index 0 $files]
#puts "SRCfiles: $srcfiles"
					ProgressFile 100 100
					set dummy [lindex $srcfiles end]
					set srcfile [lindex $dummy 1]
#puts "dummyURL: $dummy $srcfile $url"
					#NEW120206: standardmig fileOK auf 100 setzen, weil es sein kann, da die zuletzt angefragte Datei NICHT ok sein knnte
					#aber die vorherige (mit dem JPG) in Ordnung ist, und an dieser Stelle auch existiert, und grer 0 ist
					set fileOK 100
					set back [copyPic $srcfile $url $fileOK]
#puts "Dummy: $dummy $srcfile"
				}
                }
	if {$followLinks>0} {
		set fileOK 100
		#set back [copyPic $inhalt $url $fileOK]
		set back [AddSelected $merkUrl $fileOK]
		incr anzDest -1
		clearSelected
        }
#puts "Files: $files"
	catch {unset srcfiles files srcfile url max merkUrl}
#	setBase $merkBase
	return $back
}

proc grabSYNC {} {
#called from LoadFile if HTTPsync-Mode is set
	global cancel buffer debug maxDepth homeDir synCount token HTMLsync cacheLocation anzSEL anzGFX zlrGFX toknHandles HTMLtimeout bytesTotal \
	urltext msgText getCSS getBG chkWait
	set bytesTotal 0
	set synCount 0
	set toknHandles ""
	ProgressBar 0 0
	set zlrGFX 0
	set anzGFX [llength $buffer]
	if {$anzGFX>0} {
#puts "GrabSYNC: $anzGFX"
		wm title . "FIQ: 0/$anzGFX ($anzGFX)"
		wm iconname . "FIQ: 0/$anzGFX ($anzGFX)"
	#NEW081106:
		if {$anzGFX<10} {
			set anzSEL [format "%02u" $anzGFX]
		} else {
			set anzSEL $anzGFX
		}
		.lbAnzSelGfx configure -width [string length $anzSEL]
		dispMSG $msgText(request.send.4)
		setLED cyan
		foreach inhalt $buffer {
			if {$cancel>0} break
			if {$inhalt==""} continue
			if {$debug>3} {puts "grabSync: $inhalt"}
	#		set fn [lindex [split $inhalt ] 0]
	#		set fn [acode resolv $fn]
	#		set ext [getEXT $fn]
			incr synCount
			if {$synCount>=$HTMLsync} {
				dispMSG $msgText(request.send.5)
				setLED cyan
	#			after [expr $HTMLtimeout * 2] {incr synCount -1}
				vwait synCount
			}
			getSyncURL [reslvURL $inhalt 1]
		}
	#puts "grabSYNC here"
		set buffer ""
		if {$synCount>0} {
			set chk 0
			setLED cyan
			after [expr $HTMLtimeout] {set chk 1}
			while {$synCount>0 && $cancel<=0 && $chk<=0} {
				vwait synCount
			}
		}
		ShowTableStruct 0
		if {$getCSS>0} {
			set chkWait 0
			setLED cyan
			after [expr $HTMLtimeout] {set chkWait 1}
			while {$getCSS && $cancel<=0 && $chkWait<=0} {
				vwait getCSS
			}
		}
		if {$getBG>0} {
			set chkWait 0
			setLED cyan
			after [expr $HTMLtimeout] {set chkWait 1}
			while {$getBG && $cancel<=0 && $chkWait<=0} {
				vwait getBG
			}
		}
	}
#puts "OR grabSYNC here"
	exitLoadFile $urltext
	#set anzSEL 00
	#.lbAnzSelGfx configure -width [string length $anzSEL]
}

proc syncHandler {out socket token} {
#called while HTTP-Sync transfer is active (currently unused !)
	global synCount
	upvar #0 $token state
	set data [read $socket 1000]
#puts "syncHandler: $data"
#writeFile $out $data
#datacall $out $token
	set nbytes [string length $data]
	return $nbytes
}

#HTML-Lib RckinfoProc (nur wenn "aSync"-Mode !)
proc synCall {file url token} {
#called when HTTP transfer is complete
	global synCount linktext cancel debug activeHTM playAnim renderUPD Images anzSEL zlrGFX downMode toknHandles bytesTotal downMode chkSTR Images \
	fsizeWarn HTMLmethod variTime rbytes tbytes header htmlBG htmlFG mainHTML maxScount maxDepth HTMLheader refererBACK HTMLtimeout baseurl reqURL \
	writeTempIcons fTypes HTMLpwd HTMLreferer newPage urltext sendCookies msgText remSTR home ignoreReDir homeDir askServer killCHR filter liste \
	cacheLocation followLinks cookie
	if {$debug>3} {puts "synCall get: $file $url $token"}
#puts "ANS: $url $file"
#	catch {close $out}
	catch {::http::data $token} data
	#NEW290506:
	set src [lsearch $toknHandles $token]
	if {$src>=0} {set toknHandles [lreplace $toknHandles $src $src]}
	set meta ""
	set merkFile $file
	set fileOK 1
	set erg 0
	set pro 0
#puts "HTTP: [::http::ncode $token] $file"
	if {[regexp -nocase {favicon.ico$} $file]} {
	   	if {[chkType data [string range $data 0 16]]!=".ico"} return
	}
	set chk [string length $data]
	if {$chk>0 && ![regexp -nocase $url $reqURL]} {
		if {[file exists $file]} {catch {file delete -force $file}}

#puts "FILE1: $file"
if {![regexp -nocase {\.css|\.ico} $file]} {
#puts "DAT: [string range $data 0 16]"
#puts "HEX: [hexDump [string range $data 0 16]]"
	set ext [chkType data [string range $data 0 16]]
#puts "EXT: $ext"
#	if {![regexp -nocase $ext $url] || ![regexp -nocase $ext $file]} {set fileOK 1}
	set file [string trim [cutEXT $file]]$ext
}
#set url [string trim [cutEXT $url]]$ext
#puts "FILE2: $file $ext"

		if {![catch {open $file w} out]} {
			#writeFile $file $data
			fconfigure $out -translation binary
			puts -nonewline $out $data
			catch {close $out}
			set fileOK 100
			append reqURL "$url "
#set chk [chkType file $file]
#if {![regexp -nocase $chk$ $file]} {
#   set file [cutEXT $file]$chk
#}
		} else {
			set fileOK 1
		}
		set linktext "$msgText(site.cache.loaded): [acode decode [lindex [split $file /] end]] ($chk bytes)"
	} else {
		set file ""
		set fileOK 1
	}
#			set fileOK 100
#			set linktext "[acode decode [lindex [split $file /] end]] ($chk)"
#Hier mssten smtliche Checks von "copyURL" rein !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#				if {[file exists $file]} {
#					if {[file size $file]<=1 || [regexp -nocase {404} [lindex [split $returnCode { }] 1]} {
#						catch {file delete -force $file}
#					}
#				}

set origURL [regSTR $remSTR $url]

#NEW211006:
regsub -nocase -all {[^0-9]} $token {} erg
if {[string length $erg]<=0 || ![regexp -nocase {[0-9]} $erg]} {set erg 0}
			if {[info exists token]} {
				upvar #0 $token state
				set status timeout
				catch {set type $state(type)}
				catch {set coding $state(coding)}
				catch {set tbytes($erg) $state(totalsize)}
				catch {set fsize $state(currentsize)}
				catch {set status $state(status)}
#CHNG030711: t-online.de conains: ETag {"2da36-4a7263ca6c1c0"-gzip} which must be: ETag {"2da36-4a7263ca6c1c0" -gzip} 
#				catch {set meta $state(meta)}
catch {regsub -nocase -all "\-gzip" $state(meta) " \-gzip" meta}
#puts "META lautet: $meta"
				catch {set returnCode $state(http)}
				if {$debug>3} {
					catch {puts "State: $meta"}
					#catch {puts "Body: $state(body)"}
					catch {puts "Error: $state(error)"}
					catch {puts "Charset: $state(charset)"}
				}
				if {$debug>2} {
					catch {puts "CurrentSize: $fsize"}
					catch {puts "HTTP: $returnCode"}
					catch {puts "Status: $status"}
					catch {puts "Totalsize: $tbytes($erg)"}
					catch {puts "Type: $type"}
					catch {puts "Coding: $coding"}
				}
			}
		if {[string length $meta]>0} {
			set max 0
			set rbytes($erg) 0
#			catch {::http::cleanup $token} err
		    set check [lindex [split $returnCode { }] 1]
			if {[regexp -nocase {401} $check] && [string length $HTMLpwd]<=0} {
				#User/Password Authentication required
				dispMSG $msgText(auth.req.0)
				setLED orange
				set HTMLpwd [getPasswd]
				if {[string length $HTMLpwd]>1} {
					catch {::http::cleanup $token} err
					set src [lsearch $toknHandles $token]
					if {$src>=0} {set toknHandles [lreplace $toknHandles $src $src]}
					set HTMLpwd "Authorization {Basic $HTMLpwd}"
					incr synCount
					return [getSyncURL $url]
#syncURL $url $file
					#return
				}
			}
			#NEW010706: requery if Site not found (404) and URL contains "?"
			if {$newPage==0} {
			   if {[regexp -nocase {\?} $url]} {
					if {[regexp -nocase {404} $check]} {
						if {[regexp -nocase {/\?} $url]} {
							regsub -nocase {/\?} $url {?} url
						} else {
							regsub -nocase {\?} $url {/?} url
						}
						catch {::http::cleanup $token} err
						setBase $url
						return [getSyncURL $url $file]
					} elseif {[regexp -nocase {400} $check]} {
					   #NEW010907: clearCookie if "400 Bad request" encounters
					   set cookie ""
					   if {[regexp -nocase {\?} $url] && ![regexp -nocase {=} $url]} {
					   	  set url [lindex [split $url "\?"] 0]
			   		   }
					   return [getSyncURL $url $file]
				    }
				}
			}

			#NEU200408:WarningMessage if File<Totalsize
			if {$fsize<$tbytes($erg) && $tbytes($erg)>0} {
				#set ext .[getEXT $url]
				set ext [transType .[string trim [getEXT $url] .]]
				#Nur bei Images, Warning ausgeben  (tdlich, wenn z.B. MPGs downgeloaded werden !!!)
					if {$fsizeWarn==1} {
						dispMSG "$msgText(request.warning.2) $fsize / $tbytes($erg)"
						setLED red
						set mtext "File: $url Size: $fsize / $tbytes($erg)"
						optionBox -title $msgText(request.warning.1) -icon warning -type ok -message $mtext
						unset mtext
					} else {
						dispMSG "$msgText(request.warning.2) $fsize / $tbytes($erg)"
#puts "REQWARN4"
						setLED red
					}
					if {$tbytes($erg) > 0 && $fsize > 0} {
						set pro [expr 100.0 / [expr $tbytes($erg).0 / $fsize.0]]
					} else {
						set pro 0
					}
					set fileOK [expr round($pro)]
			} elseif {![regexp -nocase {^4|^5} $check]} {
#puts "1OK"
				set fileOK 100
			}
			#NEU:160304: variTime (TM)
			if {$variTime>1} {
				dispMSG "variTime (TM) in use !"
				setLED magenta
				set warte [lindex [split [expr {rand () * $variTime}] .] 0]
				after [expr $warte * 1000]
			}
			#NEU210304: Coding von HTML-Antwort (z.B. gZip; also gepackte HTML-Pages, wie z.B. von "Google" !)
			if {[chkARC $coding]} {
				set zipfile [string trim $file].gz
				catch {file rename -force $file $zipfile}
		#puts "ZIP: $file $zipfile"
				unzip $zipfile
			}
			set dummy .[string trim [getEXT [acode decode $file]] /]
			set ext [chkType file $file]
#puts "real FileType: $ext"
			if {[string length $ext]<2} {
		#Dateiendung IMMER dem aus dem INet geholten ContentType anpassen
				set urlext [lindex [split $type /] 1]
				set urlext .[lindex [split $urlext {\;}] 0]
				set urlext [transType $urlext]
				set ext $urlext
			}
			if {([chkALL $ext] && ![chkANI $ext]) || [regexp -nocase {favicon.ico$} $file]} {
		#puts "chkEXT: $ext"
				if {![regexp -nocase $ext$ $dummy] && ![regexp -nocase $ext$ $file] && ![regexp -nocase {favicon.ico$} $file]} {
		#			catch {file copy -force $file $dummy$ext}
					set dummy [cutEXT $file]
					if {$dummy==$file && [string length $ext]>1} {
						regsub -nocase {\.htm$} $dummy {} dummy
					}
					#NEW240106:
					setLED orange
					#NEW170606: chk for 40x/50x Errors
					if {[regexp -nocase {^4|^5} $check]} {
						set fileOK 1
					}
#CHNG050606:
#					catch {file rename -force $file $dummy$ext}
					#catch {file delete -force $dummy.INI}
#					set file $dummy$ext
				} elseif {[regexp -nocase {favicon.ico$} $file]} {
					if {$writeTempIcons==1} {
						if {[file exists $file]} {
							catch {file delete -force $file}
						}
						::imFavicon write $file
					}
				}
			}
			if {$debug>3} {puts "Meta: $meta"}
			set modified ""
			set etag ""
				foreach {name value} $meta {
					if {[string length $name] > $max} {
						set max [string length $name]
					}
					#Notfall Abbruch (oder HTML-Header hat "EOF" geliefert)
					if {$cancel==1} {
						dispMSG $msgText(abbruch)
						setLED yellow
						break
					}
					regsub -nocase -all {\n} $value {} value
					#NEU:010304 Cookie-Handler
					if {[regexp -nocase {set-cookie} $name]} {
					#Jou, Cookie soll gesetzt werden
						if {$debug>4} {puts "SetCookie: $name $value"}
						#NEW140206:
						regsub -nocase -all $killCHR $value {} value
						regsub -nocase -all { ">} $value {} value; #"
						#getCookie $url [join $value]
						catch {join $value} value
						getCookie $url $value
					}
					#NEU060304: P3P;(Proxy)
					if {[regexp -nocase p3p $name]} {
						if {$debug>1} {puts "P3P: $name $value"}
						writeP3P $url $value
					}
					#NEU120304: Meta: eTag, LastModified je Domain speichern
					#Anhand des eTag & LastModified, erkennt der Browser, ob das File im Cache noch aktuell ist
					#Rckmeldung vom Server: 304 Not Modified since...
					if {[regexp -nocase ^last-modified$ $name]} {
						if {$value!=""} {set modified [join $value]}
					}
					if {[regexp -nocase ^etag$ $name]} {
						if {$value!=""} {set etag [join $value]}
					}
#					if {[regexp -nocase {eof|timeout} $status]} {
#						dispMSG $msgText(timeout)
#						setLED magenta
#						continue
#					}
					#CHNG090106:
#puts "$name $value"
					if {$maxScount($token) <= $maxDepth && $ignoreReDir<=0 && ![regexp -nocase {forbidden|reset|403} $value$status]} {
#puts "Bin hier: $newPage"
					#Max Anzahl "redirections"
						if {[regexp -nocase -all {^location} $name] && ![regexp -nocase {favicon.ico|\.css$|\.js$} $url]} {
							setLED cyan
							#set ext .[getEXT $value]
			                set ext [transType .[string trim [getEXT $value] .]]
							#OK, Dateinamen an new Location anhngen
							incr maxScount($token)
							set filename [lindex [split $url /] end]
							if {$debug>2} {puts "Redirect Filename2: $value"}
							if {![regexp -nocase $chkSTR $value]} {
								set value [reslvURL $value 1]
								set value [acode decode $value]
							}
							if {[regexp -nocase {\?|&} $value]} {set value [string trimright $value /]}
#puts "VALUE1: $value"
#NEW281106:
#set value [cutLink $value]
if {[regexp -nocase {^\.\./} $value]} {
   set value [string trimright $baseurl($activeHTM) /]/$value
}
#set dummy [cutLink $value]
set dummy $value
#puts "VALUE2: $value"
							set origEXT [getEXT $filename]
							regsub -nocase -all {\.+} $origEXT {} origEXT
							set origEXT .$origEXT
							regsub -nocase {/$|\.html$|\.htm$|\.phtml$|\.phtm$|\.shtml$|\.shtm$|/$|\.php[0-9]$|\.php$|\.aspx$|\.asp$|\.cgi$} $origEXT {.htm} origEXT
							set redirEXT .[string trimleft [getEXT $dummy] .]
							regsub -nocase -all {\.+} $redirEXT {} redirEXT
							set redirEXT .$redirEXT
							regsub -nocase {/$|\.html$|\.htm$|\.phtml$|\.phtm$|\.shtml$|\.shtm$|/$|\.php[0-9]$|\.php$|\.aspx$|\.asp$|\.cgi$} $redirEXT {.htm} redirEXT
#puts "EXT: $origEXT $redirEXT $ext $check"
							#NEW140106: only setBase if requested FileType == redirectedFileType
							#also requested wird .gif redirected wird zu .htm
							if {([regexp -nocase "\.css$|\.js$" $ext] && [regexp -nocase $origEXT $redirEXT]) || [regexp -nocase $redirEXT $origEXT] || [regexp -nocase {^30[0-9]} $check]} {
								#CHNG180206: chk Base AND 1st Directory
								set chkBase [regSTR $remSTR $baseurl($activeHTM)]
								set chkBase [string trim $chkBase /]
								set dumBase [split $chkBase /]
								catch {expr [llength $dumBase] - 1} dumErg
								if {$dumErg<=0} {set dumErg 0}
								set chkBase [join [lrange $dumBase 0 $dumErg]]
								regsub -nocase { +} $chkBase {/} chkBase
								set newBase [regSTR $remSTR $dummy]
								set newBase [string trim $newBase /]
								set dumBase [split $newBase /]
								catch {expr [llength $dumBase] - 1} dumErg
								if {$dumErg<=0} {set dumErg 0}
								set newBase [join [lrange $dumBase 0 $dumErg ]]
								regsub -nocase { +} $newBase {/} newBase
#puts "B_redirectionB1: $newBase $chkBase $ext $url"
								if {![regexp -nocase $newBase $chkBase] && ([chkEXT $ext] || [string length $ext]<=1)} {
#puts "B_redirectionB2: $newBase $chkBase $ext $url"
									setBase $value
									#set value [upperHTTP $value]
									set newPage 0
									set merkurl $urltext
									set urltext [upperHTTP $value]
									SaveScript [cutEXT $file].INI
									set urltext $merkurl
									if {$value!=""} {
										if {$ignoreReDir<=0} {
										   set home $urltext
										   set inhalt "<html><meta http-equiv=\"refresh\" content=\"1; URL=$value\">"
							   			} else {
										   set inhalt "$inhalt\n$msgText(maximum.redir.2)<br><a href=\"$value\">$value</a></html>"
		   								}
		   							}
									#writeFile $file $inhalt
									writeFile [cutEXT $file].HTM $inhalt
								}
							}
							if {$newPage==0} {
								set help [acode recode $value]
								#NEW050606:
								if {![regexp -nocase -all {/\?} $help]} {
									regsub -nocase -all {\?|&|#} $help {} help
									set help [string trim [lindex [split $help ] 0]]
								}
#								set HTMLreferer "Referer [lowerHTTP $help]"
								set HTMLreferer "Referer [lowerHTTP [cutFile $help]]"
								set newPage 1
								set refererBACK [string trimright $HTMLreferer /]
							}
							set chart [getCachedir $value]
							set cachedir [string trimright $cacheLocation /]/cache/html/$chart
							if {![file isdirectory $cachedir]} {file mkdir $cachedir}
							set dummy [regSTR $remSTR $value]
							set file [cutFile [transType $dummy]]
							set file [acode encode $file]
							set file [string trim $cachedir]/[string trim $file]
							#NEW070105: only follow Redirections, if Site does not exists in Cache
							#if {[file exists $file]} {return $file}
							#incr synCount
#							AddSelected [regSTR $remSTR $url] 1
#							copyPic $file [regSTR $remSTR $url] 0
							#NEW100606: replace the OLD Cachefile with NEW, redirected URL
							setLED cyan
#CHNG250606:
#writeFile $file $data
#puts "Return redirect: $value"

#NEW031206: handle redirected Links/Images
if {[info exists liste($activeHTM,$origURL)]} {
	set hsrc $liste($activeHTM,$origURL)
	if {[string length $hsrc]>0} {set liste($activeHTM,$dummy) $hsrc}
}
							if {[file exists $merkFile]} {file delete -force $merkFile}
							return [syncURL $value $merkFile]
#							return [syncURL $value $file]
#							return [getSyncURL $value]
#							AddBuffer $url
							#set url $value
#syncURL $url $file
							break
						} elseif {[chkEXT .[string trim [getEXT $url] .]] && [chkEXT $ext] && $newPage>=2 && ![regexp -nocase {favicon.ico$|\.css$|\.js$|/$} $url] && ![regexp -nocase {location } $meta]} {
#puts "redirection3: $url $ext $newPage"
			#NEW261205: if Selected HTM file which contains JPG
							setBase [fileDIR $url]
							set help [acode recode $url]
							#NEW050606:
							if {![regexp -nocase -all {/\?} $help]} {
								regsub -nocase -all {\?|&|#} $help {} help
								set help [string trim [lindex [split $help ] 0]]
							}
#							set HTMLreferer "Referer [lowerHTTP $help]"
							set HTMLreferer "Referer [lowerHTTP [cutFile $help]]"
							set newPage 1
							set refererBACK [string trimright $HTMLreferer /]
						}
					} elseif {$maxScount($token)>$maxDepth || $ignoreReDir>0} {
			#puts "oder da: $newPage"
						if {[regexp -nocase -all {^location} $name]} {
							catch {stop_anigif .mbar.lbAnim}
							.mbar.lbAnim configure -image imTuxUnallowed
							dispMSG $msgText(maximum.redir)
							set file $file.HTM
							set inhalt "$msgText(maximum.redir)<br><a href=\"$value\">$value</a>"
							writeFile $file $inhalt
						}
						setLED orange
						#break
						#return $file
						break
					}
					if {[regexp -nocase {eof|timeout} $status]} {
						dispWAIT $msgText(timeout)
						setLED magenta
						if {$fsize>=$tbytes($erg)} {
                                                       set fileOK 100
                                                } else {
                                                       set fileOK 1
                                                }
#						continue
					}
				}
				#TimeOut Message
#				if {[regexp -nocase timeout $status]} {
#					dispMSG $msgText(request.send.3)
#					setLED orange
#					set fileOK 1
#				}
#				catch {::http::cleanup $token} err
				set rbytes($erg) 0
				#NEU150403: Datei "heile" angekommen ?
				if {[file exists $file]} {
					catch {file size $file} fsize
			#		if {$fsize<=0 || [regexp -nocase {favicon} $file]} {}
	#				if {$fsize<=0 || [regexp -nocase {404} [lindex [split $returnCode { }] 1]} {}
					if {$fsize<=0} {
						#File hat aber Lnge von 0 Bytes
						#CHNG100106:
						catch {file delete -force $file}
						set file ""
						#NEW180206:
						set inhalt "<BODY bgcolor=$htmlBG color=$htmlFG><h1><b>&nbsp;&nbsp;&nbsp;&nbsp;$msgText(request.warning.5)</b></h1><br><b>&nbsp;&nbsp;&nbsp;&nbsp;$msgText(request.warning.6)</b><br><a href=\"$url\">$url</a></BODY>"
			#			set inhalt "$msgText(maximum.redir)<br><a href=\"$url\">$url</a>"
						if {[winfo exists $mainHTML.info]} {destroy $mainHTML.info}
						label $mainHTML.info -image imWarning -background [$mainHTML cget -background]; pack $mainHTML.info -side top -anchor nw
						$mainHTML parse $inhalt
						incr maxScount($token)
						if {$maxScount($token)<=$maxDepth} {
							dispMSG "$msgText(maximum.retry) maxScount($token)"
							setLED red
							catch {::http::cleanup $token} err
							set src [lsearch $toknHandles $token]
							if {$src>=0} {set toknHandles [lreplace $toknHandles $src $src]}
							incr synCount
							return [getSyncURL $url]
#syncURL $url $file
#							return
						} else {
							if {$fsizeWarn==1} {
								onError "5 sybCall: HTML_File: $file size: $fsize bytes !"
							} else {
								dispMSG "$msgText(request.warning.2) $fsize / $tbytes($erg)"
								setLED red
							}
							#NEW220106:
							set fileOK 1
#							return
						}
					}
				} else {
					if {$fsizeWarn==1} {
						onError "5 synCall: HTML_File: $file dosn't exists !"
					} else {
						dispMSG $msgText(request.warning.4)
#puts "WARNREQ2"
						setLED red
					}
					#NEW220106:
					set fileOK 1
#					return
				}
			#	writeCache $file $fsize
				if {$debug>3} {puts "synCall returns: $file = $url"}
				#return $file
#				return
		}

	# "copyURL"-Functions Ende
	#set bytesTotal [expr $bytesTotal + $chk]
set kSize [expr $chk / 1024]
set bytesTotal [expr $bytesTotal + $kSize]
#	set bytesTotal [expr $bytesTotal + $chk / 1024]
	catch {http::cleanup $token} err
	set src [lsearch $toknHandles $token]
	if {$src>=0} {set toknHandles [lreplace $toknHandles $src $src]}
	if {$cancel>0} return
#	chkSyncFile $file $url $fileOK
	if {$downMode<=0} {
		chkSyncFile $file $url $fileOK
	} else {
		chkSync $file $url $fileOK
	}
#puts "COUNT: $synCount $token"
	if {$synCount>0} {incr synCount -1}
}

#currently UNUSED !!!!!!!!!!!!!!!!!!!
proc downCall {file url token} {
	global synCount bytesTotal linktext toknHandles msgText
#puts "DownCall: $synCount $file $token"
	#close Handles
	catch {::http::data $token} data
	set chk [string length $data]
	if {$chk>0} {
		if {![catch {open $file w} out]} {
			#writeFile $file $data
			fconfigure $out -translation binary
			puts -nonewline $out $data
			catch {close $out}
			set fileOK 100
#			set linktext "[acode decode [lindex [split $file /] end]] ($chk)"
		} else {
			set file ""
			set fileOK 1
		}
		set linktext "$msgText(site.cache.loaded): [acode decode [lindex [split $file /] end]] ($chk bytes)"
		set kSize [expr $chk / 1024]
		set bytesTotal [expr $bytesTotal + $kSize]
#		set bytesTotal [expr $bytesTotal + $chk / 1024]
	} else {
		set file ""
		set fileOK 1
	}
	catch {http::cleanup $token} err
	set src [lsearch $toknHandles $token]
	if {$src>=0} {set toknHandles [lreplace $toknHandles $src $src]}
	chkSync $file $url $fileOK
	if {$synCount>0} {incr synCount -1}
#	if {[file exists $lockfile]} {file delete -force $lockfile}
}

proc chkSync {file url fileOK} {
	global fileTypes followLinks thumbsOnly cookie anzSEL anzGFX zlrGFX remSTR baseurl activeHTM downMode
#	set dummy [lindex [split $file /] end]
#	set url [acode decode $dummy]
	set merkBase $baseurl($activeHTM)
#puts "chkSync get: $file $url $fileOK"
#	if {[string length $file]<=0 || ![file exists $file]} return
	set url [regSTR $remSTR $url]
	set ext [string trim [getEXT $file] .]
	set uxt [string trim [getEXT $url] .]
	if {([lindex $fileTypes 0]=="*" || [reGrep $ext $fileTypes]>0) && $followLinks==0 || $thumbsOnly>0} {
#		set lockfile [string trimright [file dirname $dummy] /]/FIQ.LOCK
#		if {![file exists $lockfile]} {
#			writeFile $lockfile "FIQ LockFile"
#		}
		if {$ext==$uxt && [chkEXT .$ext]} {
#puts "vielleicht hier"
#NEW270806:
setBase $url
#			set datei [readHTML $file $url]
#			readHTML $file $url
set activeHTM "internal"
LoadFile $url
syncHTML $file $url
setBase $merkBase
#NEW221006:
incr zlrGFX
set erg [expr $anzGFX - $zlrGFX]
if {$erg>=0} {
	wm title . "FIQ: $zlrGFX/$anzGFX ($erg)"
	wm iconname . "FIQ: $zlrGFX/$anzGFX ($erg)"
	if {$erg<10} {
		set anzSEL [format "%02u" $erg]
	} else {
		set anzSEL $erg
	}
	.lbAnzSelGfx configure -width [string length $anzSEL]
	ProgressBar $zlrGFX $anzGFX
}
#NEW221006end
			set cookie ""
		} elseif {[chkIMG .$ext] || [chkIMG .$uxt]} {
#puts "oder dort"
#			set datei [copyPic $file $url $fileOK]
			copyPic $file $url $fileOK
			incr zlrGFX
			set erg [expr $anzGFX - $zlrGFX]
			if {$erg>=0} {
				wm title . "FIQ: $zlrGFX/$anzGFX ($erg)"
				wm iconname . "FIQ: $zlrGFX/$anzGFX ($erg)"
				if {$erg<10} {
					set anzSEL [format "%02u" $erg]
				} else {
					set anzSEL $erg
				}
				.lbAnzSelGfx configure -width [string length $anzSEL]
				ProgressBar $zlrGFX $anzGFX
			}
		}
	} else {
#puts "oder auch hier: $ext/$uxt"
#		set lockfile [string trimright [file dirname $dummy] /]/FIQ.LOCK
#		if {![file exists $lockfile]} {
#			writeFile $lockfile "FIQ LockFile"
#		}
		if {$ext==$uxt && [chkEXT $ext]} {
			setLED cyan
			setBase $url
			syncHTML $file $url
            set cookie ""
            setBase $merkBase
		} elseif {[chkIMG .$uxt]} {
  		  	#Error wenn Downzuloadendes IMG nicht gefunden wird = 404
			set file [cutEXT $file].$uxt
			copyPic $file $url $fileOK
		}
	}
}

#Pastes retrieved Image into HTMLwidget (same as "grabPic" but in SyncMode)
proc synPic {datei url} {
#same as grabPIC
	global convert debug TableIDX ImageIDX playAnim backColor etryBack normLight mainHTML htmlTD maxMarkSize winSYS \
		waitID tableOnly grabMode renderIMG renderUPD Images activeHTM active destDir cancel winSYS getFavIcon \
		zlrGFX anzGFX anzSEL cutGfx linkmark markIcons cutType fTypes anzDest msgText filtVars remSTR imFavIcon \
		thumbsOnly ByteCount maxBytes autoscroll FTPrealprev homeDir tempIcons maxImgSize minImgSize shrinkBigSize
	if {[string length $datei]<=0 || $cancel>0} return
	if {$winSYS==1} {set datei [string trimleft $datei /]}
	if {![file exists $datei] && ![regexp -nocase {FIQdummy[0-9]*} $datei]} return
#	set datei [acode resolv $datei]
	if {$debug>3} {puts "synPic: $datei $url"}
#puts "synPic: $datei $url"
	set icon ""
	if {$renderIMG} {
#		set fn [lindex [split $datei /] end]
set fn [regSTR $remSTR $url]
#		set linkname [acode decode $fn]
set linkname $fn
		set fn [acode resolv $fn]
#		set ext [transType .[string trim [getEXT $fn] .]]
#set dummy [acode decode [lindex [split $datei /] end]]
set ext [transType .[string trim [getEXT $datei] .]]
set uxt [transType .[string trim [getEXT $url] .]]

#set ext [lindex [split $fn .] end]
if {[chkEXT $fn]} {set fn [cutEXT $fn]$ext}
#set fn [cutEXT $fn]*
#puts "FN1: $fn"
		set srcurl $datei
#puts "scrurl: $datei"
		#NormalZustand GFXdownload aus anzuzeigender HTMLseite
		set lidx [lindex [fGrep $fn $ImageIDX($activeHTM)] 1]
		#NEW250606:
		if {$lidx<0} {
			set fn [lindex [split $datei /] end]
			set fn [acode decode $fn]
			set linkname $fn
			set fn [acode resolv $fn]
			set lidx [lindex [fGrep $fn $ImageIDX($activeHTM)] 1]
		}

#set dummy .[lindex [split $fn "\."] end]
#regsub -nocase $dummy$ $fn $uxt fn
#puts "FN2: $fn"
#puts "IMAGES: $ImageIDX($activeHTM)"
		#NEU170304: Download only Images within Table (tableOnly=1)
#CHNG251206: recognize also such URLs like: "www.somewhere.com/images/clever&smart.jpg"
##if {[regexp -nocase {\?|&|%3F|%3D|%26} $datei]} {set fn [cutEXT $fn]}
if {[regexp -nocase {\?|%3F|%3D} $datei] || $ext!=$uxt} {set fn [cutEXT $fn]$uxt}
regsub -nocase -all {%26} $fn {\&} fn
		if {$debug>3} {puts "synPICx: $fn $ext"}
		set check 0
		set memgfx ""
if {[catch {set memgfx $Images($activeHTM,$fn)}]!=0} {
	set search [lindex [array names Images "$activeHTM,[cutEXT $fn]*"] 0]
#puts "IMGs: [array names Images "$activeHTM,*"]"
	set fn [lindex [split $search ,] 1]
	catch {set memgfx $Images($activeHTM,$fn)}
#puts "FN: $fn:$memgfx"
	set icon [fileType ".cgi"]
}
		set check [regexp -nocase $filtVars $fn]
#puts "CHK: $check $ext $fn"
		if {[chkIMG $ext] && $check<=0} {
		#NUR wenn Datei Image is !
			if {[catch {image create photo -file $srcurl} dummyGFX]==0} {
#puts "SRC: $srcurl"
#if {[regexp {007} $fn]} {puts [array names Images $activeHTM,*]}
				if {[info exists Images($activeHTM,$fn)]} {
					if {$debug>3} {puts "synPIC AddSelected: $fn"}
					if {[regexp -nocase {\.gif$} $ext] && $playAnim==1} {
						show_htmgif [list -file $srcurl] $memgfx [getThumb $linkname]
#show_QTgif $srcurl $Images($activeHTM,$fn)
					} else {
						#NEW091004: show LinkType in Thumb
#puts "Link1: $linkname"
						set linkname [getThumb $linkname]
#						catch {::$memgfx blank}
#puts "Link2: $linkname"

						#NEW101106:
#	   					regsub -nocase {[0-9]+$} $linkname {} linkname
#puts "ext: [getEXT $linkname]"
#puts "Link2: $linkname $markIcons"
						if {$markIcons==1} {
							#Nur wenn Thumb ein Link ist, dann TypeIcon anzeigen
							set check [string length $linkname]
							if {$check>0} {
								if {$tableOnly} {
									if {$lidx>0} {
										set tabidx [lindex [lindex $TableIDX($activeHTM) 0] 0]
										set endidx [lindex [lindex $TableIDX($activeHTM) end] 0]
										if {$debug>4} {puts "TableIcon: $inhalt = $lidx; $tabidx; $endidx"}
										if {($lidx>=$tabidx && $lidx<=$endidx) || $mode} {
											if {[lsearch -regexp $htmlTD $fn]} {
												if {$thumbsOnly==1} {
													catch {::$dummyGFX copy imOPTthumbnail}
												} else {
#puts "Icon1: $linkname"
													set icon [fileType [transType .[getEXT $linkname]]]
#													if {$icon!=""} {catch {::$dummyGFX copy $icon}}
												}
											}
										}
									}
								} else {
#Drfte NUR dann gesetzt werden, wenn es auch einen Link gibt
									if {$thumbsOnly==1} {
										catch {::$dummyGFX copy imOPTthumbnail}
									} else {
#puts "Icon2: $linkname"
										set icon [fileType [transType .[getEXT $linkname]]]
#										if {$icon!=""} {catch {::$dummyGFX copy $icon}}
									}
								}
							} else {
								#Alle Link-Types anzeigen
								if {$thumbsOnly==1} {
									catch {::$dummyGFX copy imOPTthumbnail}
								}
							}
						}
						catch {image height $dummyGFX} high
						#NEW240905: Autoscroll
						if {$check>0} {autoScroll $high}
						#NEW220106: (crashes under Windoofs !!!!)
						if {$renderUPD} {
							if {$winSYS==0} {update}
						}
						catch {::$memgfx blank}
						#NEW271205: auto shrink IMG if Height > shrinkBigSize
						if {$shrinkBigSize>0 && $thumbsOnly>0 && $high > $shrinkBigSize} {
							catch {::$memgfx copy $dummyGFX -subsample 2}
							catch {::$memgfx configure -width [image width $memgfx] -height [image height $memgfx]}
							catch {::$memgfx copy imMagnify}
						} else {
						        #CHNG220406:
						        set width [image width $memgfx]
						        set height [image height $memgfx]
						        set dwidth [image width $dummyGFX]
						        set dheight [image height $dummyGFX]
							if {$width>1 && $height>1} {
#puts "Bin Hier."
								if {$dwidth<=$width && $dheight<=$height} {
#puts "evtl dort"
									set dummyGFX [resizeIMG $dummyGFX $width $height]
									catch {::$memgfx copy $dummyGFX}
#									catch {::$memgfx copy $dummyGFX -from 0 0 $dwidth $dheight}
								} else {
#puts "oder da."
#CHNG101206: resize (shrink) larger Images to fit in Site
#NEW210107: resize MemoryGFX (dummy) with real Size of retrieved Image
#set dummyGFX [resizeIMG $dummyGFX $width $height]
#catch {::$memgfx configure -width $dwidth -height $dheight}
									if {$dwidth>=[expr $width * 2] && $dheight>=[expr $height * 2]} {
										catch {::$memgfx copy $dummyGFX -subsample 2}
									} else {
									  	set dummyGFX [resizeIMG $dummyGFX $width $height]
										catch {::$memgfx copy $dummyGFX}
									}
								}
							} else {
#puts "vielleicht hier"
#							    set dummyGFX [resizeIMG $dummyGFX $width $height]
catch {::$memgfx configure -width $dwidth -height $dheight}
								catch {::$memgfx copy $dummyGFX}
							}
						}
						catch {image delete $dummyGFX}
if {$icon!=""} {catch {::$memgfx copy $icon}}
						catch {unset dummyGFX memgfx}
#						incr zlrGFX
#						ProgressBar $zlrGFX $anzGFX
						if {$renderUPD} {update}
					}
				} else {
#puts "imFTerror"
					#Image existiert nicht
					catch {::$memgfx copy imFTerror}
				}
			} else {
				#Image konnte nicht erstellt werden (File defekt, oder falsches Format)
#puts "imFileBroken"
				catch {::$memgfx copy imFileBroken}
			}
		} else {
			#Image ist kein ImageFile (z.B. HTM)
#puts "NOimg: $memgfx $ext:$uxt"
#			set icon imFileBroken
			if {[chkEXT $ext] && ![chkIMG $uxt] && ![regexp -nocase $ext$ $linkname] && $check<=0} {
				set icon imFThtml
			} elseif {[chkEXT $ext] && [chkIMG $uxt] && $check<=0 && ![regexp -nocase "$ext$|$uxt$" ".gif"]} {
				set icon imFileBroken
			} elseif {$check>0} {
				set icon imFTdll
			} else {
#				set icon imFTunknown
#				set icon imFileBroken
#				catch {::$memgfx blank}
			}
#catch {::$memgfx blank}
			if {$icon!=""} {catch {::$memgfx copy $icon}} else {catch {::$memgfx blank}}
		}
#puts "Icon: $icon $linkname"
		incr zlrGFX
		set erg [expr $anzGFX - $zlrGFX]
#puts "Maybe here"
		if {$erg>=0} {
			wm title . "FIQ: $zlrGFX/$anzGFX ($erg)"
			wm iconname . "FIQ: $zlrGFX/$anzGFX ($erg)"
			if {$erg<10} {
				set anzSEL [format "%02u" $erg]
			} else {
				set anzSEL $erg
			}
			.lbAnzSelGfx configure -width [string length $anzSEL]
			ProgressBar $zlrGFX $anzGFX
		}
	}
}

#SYNCrequest for given URL
proc syncURL {url file} {
#Same as copyURL
	global debug blocksize fsizeWarn datafile HTMLmethod variTime cancel header htmlBG htmlFG mainHTML tbytes synCount msgText \
	maxScount maxDepth HTMLheader refererBACK HTMLtimeout syncToken baseurl writeTempIcons fTypes HTMLpwd downMode toknHandles tokCount \
	activeHTM HTMLreferer newPage urltext sendCookies msgText remSTR home ignoreReDir homeDir askServer killCHR filter cacheLocation
	if {$file=="" || $cancel>0} return
	#NEW111106: check for Dangerous Domain AND FileType
	if {[regexp -nocase $fTypes(DDOM) $url] && [regexp -nocase $fTypes(Danger) $url]} return
#	if {[regexp -nocase {FIQdummy[0-9]*} $file]} {
#	   if {![file exists $file]} {
#	   	writeFile $file $url
#	   }
#	   return $file
#       }
	#code in %code wandeln
	set url [acode decode $url]
	#%code in orig. CHR wandeln
	set url [acode recode $url]
#NEW260806:
#regsub -nocase -all {%20} $url { } url
#CHNG050605: this site won't work if ":/" not replaced by: "://": HTTP://blog.babes-world.com/liebesregen-sanja/
	regsub -nocase -all {:/+} $url {://} url
        set url [lowerHTTP [regchn $url]]
	if {$debug>3} {puts "syncURL bekommt: $url $file"}

#if {[regexp -nocase -all {\[[0-9]+\]} $url]} {
#puts "REQ: $url $file"
#}
	#set back $file
#CHNG290406: set fileOK from 100 to 1
#	set fileOK 1
	set fsize 0
	set tbytes($synCount) 0
	set type ""
	set coding ""
	set status ""
	set meta ""
	set returnCode ""
#	dispMSG $msgText(request.send.4)
	setLED green
	#NEW070805: reset ProgressBar
	ProgressFile 0 0
	set dummy [concat [sendCookie $url]]
	if {$debug>4} {puts "Cookie: $dummy"}
	set dummyURL [regSTR $remSTR $url]
	regsub -nocase -all {^[a-zA-Z0-9]*\.|:url\(} $dummyURL {} dummyURL
	set dummyURL [lindex [split $dummyURL /] 0]
	regsub -nocase -all {^[a-zA-Z0-9]*\.|:url\(} $refererBACK {} chkURL
	set chkURL [lindex [split $dummyURL /] 0]
#CHNG010506:
#	if {$askServer==1} {}
	if {$askServer==1 && ([regexp -nocase $dummyURL $refererBACK] || [regexp -nocase $chkURL $url])} {
		if {[string length $HTMLpwd]<=0} {
        		set sendheader [concat $refererBACK $HTMLheader]
		} else {
        		set sendheader [concat $refererBACK $HTMLheader $HTMLpwd]
		}
	} else {
		if {[string length $HTMLpwd]<=0} {
			set sendheader $HTMLheader
		} else {
			set sendheader [concat $HTMLheader $HTMLpwd]
		}
	}
	if {$sendCookies==1 && [llength $dummy]>0} {
		set dummy [acode solve [join $dummy]]
		if {[string length $dummy]>0} {
#CHNG010506:
#			if {$askServer==1} {}
			if {$askServer==1 && ([regexp -nocase $dummyURL $refererBACK] || [regexp -nocase $chkURL $url])} {
				if {[string length $HTMLpwd]<=0} {
					set sendheader [concat $refererBACK $HTMLheader Cookie $dummy]
				} else {
					set sendheader [concat $refererBACK $HTMLheader $HTMLpwd Cookie $dummy]
				}
			} else {
				if {[string length $HTMLpwd]<=0} {
					set sendheader [concat $HTMLheader Cookie $dummy]
				} else {
					set sendheader [concat $HTMLheader $HTMLpwd Cookie $dummy]
				}
			}
		}
	}
	if {$debug>3} {puts "syncURL Header: $sendheader"}
	if {$cancel>0} return
	#set token [::http::geturl $cookie -command datacall -progress progress -blocksize $blocksize -timeout $HTMLtimeout -headers $sendheader]
#	if {![catch {open $file w} out]} {
		#if {[catch {set token [::http::geturl $url -channel $out -progress progress -blocksize $blocksize -headers $sendheader]}]} {}
#		if {$downMode<=0} {
#			catch {::http::geturl $url -channel $out -command [list synCall $file $out] -progress progress -timeout $HTMLtimeout -headers $sendheader} token
			if {$HTMLtimeout>0} {
				if {[catch {::http::geturl $url -command [list synCall $file $url] -progress progress -timeout $HTMLtimeout -headers $sendheader} token]} {
					#Error
					catch {http::cleanup $token} err
	#				dispMSG $msgText(request.send.2)
					setLED red
					return
				}
			} else {
				if {[catch {::http::geturl $url -command [list synCall $file $url] -progress progress -headers $sendheader} token]} {
					#Error
					catch {http::cleanup $token} err
	#				dispMSG $msgText(request.send.2)
					setLED red
					return
				}
			}
#		} else {
#			catch {::http::geturl $url -command [list downCall $file $url] -progress progress -timeout $HTMLtimeout -headers $sendheader} token
#		}
		if {[string length $token]>0} {lappend toknHandles $token}
regsub -nocase -all {[^0-9]} $token {} erg
set tokCount $erg
		set maxScount($token) 0
#		catch {close $out}
		return $token
#	} else {
#		dispMSG $msgText(request.send.2)
#		catch {close $out}
#	}
}

#Prepares Sync HTTP-Request for each URL
proc getSyncURL {input} {
#same as getFileURL
	global homeDir cancel activeHTM TableIDX ImageIDX debug createMirror newPage mainHTML htmlTD variHead link filtVars cacheLocation \
	refererBACK HTMLAccept HTMLnorm HTMLimg HTMLuseragent HTMLheader HTMLreferer grabMode fics fTypes synCount downMode remSTR picture \
    zlrGFX baseurl maxDepth winSYS HTProxy FTPask remSTR autoscroll urltext translateFiles killCHR token HTMLsync followLinks
	if {$cancel>0} return
#	set basefile [acode decode $input]
	set basefile [acode resolv $input]
	#regsub -nocase -all { } $basefile {} basefile
	set basefile [string trim $basefile]
	set url $basefile
	set fakeurl [regSTR $remSTR $url 0]
#	set basefile [acode resolv $basefile]
#set url $basefile
	set datei [cutFile $basefile]
	set fileOK 100
	if {[string length $datei]==0 || [regexp -nocase $filtVars $datei]} {
		if {$synCount>0} {incr synCount -1}
		return
	}
	if {$debug>3} {puts "getSyncURL get: $url"}
#NEW200806:
	if {[regexp -nocase {FIQdummy[0-9]*} $datei]} {
#		if {$downMode<=0} {
			synPic $datei $url
			if {$synCount>0} {incr synCount -1}
#		} else {
#			chkSync $datei $url $fileOK
#			if {$synCount>0} {incr synCount -1}
#		}
	        return
#	}
	if {[regexp -nocase {^file:/+|^/|^[a-zA-Z]:/} $url] || [file exists $datei]} {
		if {$downMode<=0} {
			chkSyncFile $datei $url 100
	   	} else {
			chkSync $datei $url 100
		}
		set synCount 0
		return
	}
	set HTMLAccept $HTMLnorm
	set ext .[string trim [getEXT $datei] .]
	if {[chkIMG $ext]} {
	#Wenn URL-Datei Image ist, setze REQ-Header fr Images
		set HTMLAccept $HTMLimg
	}
	set HTMLuseragentDummy $HTMLuseragent
	if {$variHead>1} {
		set wert [lindex [split [expr {rand () * 5}] .] 0]
		switch -regexp $wert {
			1 {set HTMLuseragentDummy "MSIE/6.0 (compatible; MSIE/6.0; Windows)"}
			2 {set HTMLuseragentDummy "Mozilla/5.0 (compatible; Konqueror/3.0.0; Linux)"}
			3 {set HTMLuseragentDummy "Mozilla/5.0 (compatible; Mozilla/2.41; Linux)"}
			4 {set HTMLuseragentDummy "Opera/3.4 (compatible; Opera/3.4.1; Linux)"}
			5 {set HTMLuseragentDummy "Netscape/7.0 (compatible; Netscape/7.0; Linux)"}
		}
	}
#	::http::config -useragent $HTMLuseragentDummy -accept $HTMLAccept -proxyhost $HTProxy(serv) -proxyport $HTProxy(port) -proxyfilter ProxyCommand
	::http::config -useragent $HTMLuseragentDummy -proxyhost $HTProxy(serv) -proxyport $HTProxy(port) -proxyfilter ProxyCommand
	set datei [regSTR $remSTR $datei 0]
        if {$winSYS==1} {regsub -nocase -all {^/} $datei {} datei}
	if {![file exists $datei]} {
		# WENN file NICHT lokal vorhanden
		set gfx [transType $datei]
		set gfx [cutFile $gfx]
		set path [URLsplit $url]
		set path [lindex $path 2]
		if {[string length $path]<=0 || (![chkALL .[string trim [getEXT $path] .]] || [regexp -nocase {/$} $path]) && ![regexp -nocase {^/} $path]} {set gfx [string trimright $datei /]/index.htm}
		#NEW050506: append "http://" if not exists; required by copyURL
		if {![regexp -nocase {^[a-z]+t[a-z]+\://} $url]} {set url "http://$url"}
		set geturl $url
		set filename $datei
		set chart [getCachedir $datei]
		mkCacheDir
		set cachedir [string trimright $cacheLocation /]/cache/html/$chart
		if {[regexp -nocase {favicon.ico} $datei]} {
			set cachedir [string trimright $cacheLocation /]/cache/favicons/$chart
			if {![file isdirectory $cachedir]} {file mkdir $cachedir}
		}
		set gfx [acode encode $gfx]
		regsub -nocase -all { } [join $fTypes(HTML)] {$|} check
		regsub -nocase -all { } [join $fTypes(Images)] {$|} chk
		regsub -nocase -all { } [join $fTypes(All_Files)] {$|} all
		set ext .[string trim [getEXT $gfx] .]
		if {([chkEXT $ext] && ![regexp -nocase $check$ $gfx] && ![regexp -nocase $chk$ $gfx]) || (![chkEXT $ext] && ![regexp -nocase $all$ $gfx])} {
			set gfx $gfx.htm
		}
		# Wenn file auch NICHT lokal im Cache existiert
		set zipfile [string trim $cachedir/$gfx].gz
		if {[file exists $zipfile] && ![file exists $cachedir/$gfx]} {unzip $zipfile}
		if {![file exists $cachedir/$gfx]} {
			if {$debug>3} {puts "getSyncURL NICHT im Cache: $cachedir/$gfx"}
		# WENN File NICHT existiert (weil im WEB)
			# ****** Frenzy's Intelligent Caching System ("FICS") (TM) ******
			if {!$grabMode && ![chkEXT .[string trim [getEXT $gfx] .]]} {
			#NUR "FICS" (TM) benutzen, wenn nicht ge"Grabbed" wird, und KEIN ".HTML"-File
				if {$fics>0 && ![regexp -nocase {favicon.ico} $datei]} {
					set lidx [lindex [fGrep $geturl $ImageIDX($activeHTM)] 1]
					set tabidx [lindex [lindex $TableIDX($activeHTM) 0] 0]
					set endidx [lindex [lindex $TableIDX($activeHTM) end] 0]
					set gfx [getFics $cachedir $gfx $lidx $tabidx $endidx]
				}
			}
			#NEW271205: chk4htm
			if {![file exists $cachedir/$gfx] && ![chkEXT $gfx]} {
				if {[file exists $cachedir/$gfx.htm]} {
					if {[file size $cachedir/$gfx.htm]>0} {
						set gfx $gfx.htm
					} else {
						catch {file delete -force $cachedir/$gfx}
					}
				}
			}
			# DANN lade erst file lokal in Cache
			if {![file exists $cachedir/$gfx]} {
				if {![file isdirectory $cachedir]} {catch {file mkdir $cachedir}}
				if {$newPage==1} {
					set refererBACK [string trimright $HTMLreferer /]
					set newPage 2
				}
				if {$newPage==0} {set newPage 1}
				if {$debug>3} {puts "getSyncURL: $geturl; $cachedir/$gfx"}
				if {[regexp -nocase {^https:} $geturl]} {
					.imHTTPS configure -image imLock -background Red
				} else {
					.imHTTPS configure -image imUnLock -background LightGreen
				}
#				if {![lsearch $picture $gfx]} {
					set token [syncURL $geturl $cachedir/$gfx]
#				}
				if {$synCount>=$HTMLsync} {
					if {[string length $token]>0} {
						catch {::http::wait $token}
					}
				}
			} else {
#puts "BIN HIER"
				if {$downMode<=0} {
#					lappend picture $gfx
					chkSyncFile $cachedir/$gfx $url $fileOK
	   			} else {
					chkSync $cachedir/$gfx $url $fileOK
				}
				if {$synCount>0} {incr synCount -1}
			}
		} else {
#puts "Oder dort"
			if {$downMode<=0} {
#				lappend picture $gfx
		  		chkSyncFile $cachedir/$gfx $url $fileOK
	   		} else {
				chkSync $cachedir/$gfx $url $fileOK
			}
			if {$synCount>0} {incr synCount -1}
		}
	} else {
#puts "Oder hier"
		if {$downMode<=0} {
#			lappend picture $gfx
			chkSyncFile $datei $url $fileOK
	   	} else {
			chkSync $datei $url $fileOK
		}
		if {$synCount>0} {incr synCount -1}
	}
#	lappend picture $fakeurl
#	if {$synCount>0} {incr synCount -1}
#puts "synCOUNT: $synCount"
}

#NEW081106: will called after a FileDownload is complete (copies file to destination, or into HTML)
proc chkSyncFile {cachefile url ok} {
   	global downMode applet video sound remSTR stream bgImage mainHTML activeHTM getCSS getBG winSYS backImage filtVars
#NEW290907:
#if {[string length $cachefile]<=0 && $ok<=1} return
   	if {$winSYS==1} {set cachefile [string trimleft $cachefile /]}
#puts "chkSyncFile gets: $cachefile $url $ok"
#if {$ok<=1 || [regexp -nocase {forbidden|403} $cachefile$url]} return
#	set fake [acode encode [string trim [regSTR $remSTR $url 0]]]
set fake $cachefile
#CHNG241106: getEXT returns .htm if cachefile is invalid .jpg file, so synPic isn't called
#   	set ext .[string trim [getEXT $cachefile] .]
set ext .[lindex [split $cachefile .] end]
set uxt .[lindex [split $url .] end]
#puts "chkSYNC: $cachefile $ext"
	if {[string length $cachefile]>0 && [regexp -nocase {.css$} $cachefile]} {
		#set StyleSheets
		set styles [openFile $cachefile]
#puts "STYLE: $styles"
		setStyle $styles
		set getCSS 0
		catch {unset styles inhalt dummy}
	} elseif {[chkIMG $ext] || [chkIMG $uxt]} {
	  	set chk [regSTR $remSTR $url]
	  	set dummy [lindex [split $chk /] end]
	  	if {$dummy!=""} {set chk $dummy}
	  	set bgImage [regSTR $remSTR $bgImage]
		if {[string length $bgImage]>0 && ([regexp -nocase "$chk" $bgImage] || [regexp -nocase $bgImage $chk])} {
		    #set BackgroundImage
    		set getBG 0
#puts "BGimage: $chk $bgImage $cachefile"
       		if {[file exists $cachefile]  && ![regexp -nocase $filtVars $url]} {
#puts "BGexists: $cachefile"
				if {[info exists background($activeHTM)]} {image delete $background($activeHTM)}
				if {$backImage>0} {
#image create photo background -file $cachefile
					if {[catch {image create photo background($activeHTM) -file $cachefile}]==0} {
						$mainHTML bgimage background($activeHTM)
					}
				}
			}
		} else {
			#set Images
			synPic $cachefile $url
		}
	} elseif {[chkAPP $ext]} {
#puts "APPLET: [llength $applet] $applet"
	  	if {[llength $applet]>5} {
			foreach {fn w start handle para} $applet {
				if {[regexp -nocase $fn $fake]} {
				   	 playAPP "FILE://$cachefile" $w $start $handle $para
				}
			}
		} elseif {[llength $applet]>0} {
				scan $applet "%s %s %s %s %s" fn w start handle para
		  	   	playAPP "FILE://$cachefile" $w $start $handle $para
		}
#		catch {unset dummy swf url w}
	} elseif {[chkANI $ext]} {
		foreach {fn w start handle para} $video {
			if {[regexp -nocase $fn $fake]} {
			   	 playAPP "FILE://$cachefile" $w $start $handle $para
			}
        }
#	  	catch {unset dummy w start url}
	} elseif {[chkSND $ext]} {
		foreach {fn w start handle para} $sound {
			if {[regexp -nocase $fn $fake]} {
			   	 playAPP "FILE://$cachefile" $w $start $handle $para
			}
		}
#	  	catch {unset dummy w start url}
	} elseif {[chkEXT $ext]} {
	  		set getCSS 0
			set getBG 0
#			if {$downMode>0} {
#			    set src [downHTML $cachefile $url]
#			    if {[llength $src]>0} {
#				    foreach req $src {
#			    	    getSyncURL $req
#				    }
#			    }
#			}
	}
}
