package provide FIQPRC 1.0
# Frenzy's InquisitorProc2
# Additional Procedures needed 4 Frenzy's Inquisitor
# V160304
# Written by: Jens Timmermann
# Based upon the "HV.TCL"-Demo for "TkHTML"-Widget

#NEU180704: mkCacheDir if not exists
#Check if CacheDirs exists; if not create them
#Called from various Functions, which needs the Cache
proc mkCacheDir {} {
	global cacheLocation homeDir destDir anzDest
	set dir [string trimright $homeDir /]/bookmarks/
	if {![file isdirectory $dir]} {
		file mkdir $dir
	}
	set dir [string trimright $cacheLocation /]/cache/
	if {![file isdirectory $dir]} {
		file mkdir $dir
	}
	set dir [string trimright $cacheLocation /]/cache/cookies/
	if {![file isdirectory $dir]} {
		file mkdir $dir
	}
#	set dir [string trimright $homeDir /]/cache/domDB/
#	if {![file isdirectory $dir]} {
#		file mkdir $dir
#	}
#	set dir [string trimright $homeDir /]/cache/eTagDB/
#	if {![file isdirectory $dir]} {
#		file mkdir $dir
#	}
	set dir [string trimright $cacheLocation /]/cache/html/
	if {![file isdirectory $dir]} {
		file mkdir $dir
	}
#	set dir [string trimright $homeDir /]/cache/directories/
#	if {![file isdirectory $dir]} {
#		file mkdir $dir
#	}
	set dir [string trimright $cacheLocation /]/cache/favicons/
	if {![file isdirectory $dir]} {
		file mkdir $dir
	}
	set dir [string trimright $cacheLocation /]/cache/preview/
	if {![file isdirectory $dir]} {
		file mkdir $dir
	}
	set dir $destDir
	if {![file isdirectory $dir] && ![file exists $dir]} {
		catch {file mkdir $dir}
	        set anzDest 0
	}
	unset dir
}

#add new Entry 2 history
proc addHistry {wert} {
	global debug histry idxHistry imgHistry getFavIcon remSTR killCHR cacheLocation
	if {[string length $wert]<=0} return
	if {$debug>1} {puts "addHistry get: $wert"}
    set imFavIcon imForbidden
	set wert [acode resolv $wert]
	set wert [regSTR $remSTR $wert]
	regsub -nocase -all $killCHR $wert {} wert
    catch {lsearch $histry $wert} dummy
	if {$dummy<0} {
		if {$getFavIcon>0} {
			set favicon [regSTR $remSTR $wert]
			set favicon [lindex [split $favicon /] 0]/favicon.ico
                        set chart [getCachedir $favicon]
			set favicon [acode encode $favicon]
			set cachedir [string trimright $cacheLocation /]/cache/favicons/$chart/$favicon
			if {[file exists $cachedir] && [file size $cachedir]>1024} {
				if {[catch {image create photo -file $cachedir} dummyGFX]==0} {
					catch {image create photo -width 16 -height 16} imFavIcon
					catch {image width $dummyGFX} wide
					catch {image height $dummyGFX} high
					if {$wide>16 || $high>16} {
						set imFavIcon [resizeIMG $dummyGFX 16 16]
					} else {
						catch {$imFavIcon copy $dummyGFX}
					}
					catch {image delete $dummyGFX}
					catch {unset dummyGFX}
				} else {
					set imFavIcon imForbidden
				}
			}
		}
		if {$idxHistry==0} {
			lappend histry $wert
			if {$getFavIcon>0 && [string length $imFavIcon]>2 && [info exists imFavIcon]} {lappend imgHistry $imFavIcon}
			set idxHistry [expr [llength $histry] - 1]
		} else {
			incr idxHistry
			set histry [linsert $histry $idxHistry $wert]
			if {$getFavIcon>0 && [string length $imFavIcon]>2 && [info exists imFavIcon]} {set imgHistry [linsert $imgHistry $idxHistry $imFavIcon]}
		}
	} else {
		set idxHistry $dummy
	}
	.head.dispUrl.url configure -values $histry -images $imgHistry
	if {$debug>5} {puts "AddHistry sets: $wert IDX: $idxHistry"}
}

#NEW260910
proc addDirlist {wert} {
	global debug idxDirlist dirList
	if {[string length $wert]<=0} return
	if {$debug>1} {puts "addDirList get: $wert"}
        catch {lsearch $dirList $wert} dummy
	if {$dummy<0} {
		if {$idxDirlist==0} {
			lappend dirList $wert
			set idxDirlist [expr [llength $dirList] - 1]
		} else {
			incr idxDirlist
			set dirList [linsert $dirList $idxDirlist $wert]
		}
	} else {
		set idxDirlist $dummy
	}
	if {$debug>5} {puts "AddDirList sets: $wert IDX: $idxDirlist"}
.tile.bottom.pane.f3.box.etDest configure -values $dirList
#puts "AddDirList sets: $wert IDX: $idxDirlist"
}

#opens a given File and returns its contents
proc openFile {datei} {
	set back ""
	if {[string length $datei]<=0} return
	if {![file exists $datei]} return
	if {[file isdirectory $datei]} return
	if {![catch {open $datei "r"} fileid]} {
		set back [read $fileid]
		close $fileid
	}
	return $back
}

#writes inhalt 2 given filename
proc writeFile {filename inhalt} {
        global msgText
		regsub -nocase -all {^\x0d\x0a$|^\x0a\x0d$|^\n$|^\x0a$|^\x0d$|^$} $inhalt {} inhalt
	if {![catch {open $filename "w"} write]} {
		puts $write $inhalt
		close $write
	}  else {
          dispMSG $msgText(unable.write.file)
		  setLED red
	}
}

#Saves edited Text (HTMLsource) 2 HD
proc saveText {datei win} {
	 global filter msgText appText lastDir
	 if {[string length $datei]<=1 || [regexp -nocase {/$} $datei] || ![regexp -nocase {\.[a-zA-Z0-9]+$} $datei]} {
	 	 set filetypes {
			{{HTML Files} {.htm .html}}
			{{Text Files} {.txt}}
			{{All Files} *}
	 	 }
		 set datei [tk_getSaveFile -title $appText(.mbar.file.2.1) -initialdir $lastDir -filetypes $filetypes -initialfile "index.htm"]
		 if {[string length $datei]<=1} {
		 	dispMSG $msgText(unable.write.file)
			setLED red
			return
		 }
	 }
	 set input [$win get 0.0 end]
	 regsub -nocase -all {^\x0d\x0a$|^\x0a\x0d$|^\n$|^\x0a$|^\x0d$|^$} $input {} input
	 if {[regexp -nocase {\.FIL} $datei]} {set filter $input}
	 writeFile $datei $input
	 setLED green
	 dispMSG $msgText(file.save.2)
}

# Read a file from HD (called from various Functions)
proc ReadFile {datei} {
	global debug msgText
	if {$debug>9} {puts "ReadFile bekommt: $datei"}
	if {[string length $datei]<=0} return
	if {![file exists $datei]} return
	if {[file isdirectory $datei]} return
	if {[regexp -nocase -all {$/} $datei] || [file isdirectory $datei]} {
		dispMSG $msgText(request.warning.3)
		return
	}
	if {![file exists $datei]} {
		onError "1 ReadFile: File $datei does not exist !"
		return
	}
	if {[catch {open $datei r} fp]} {
		catch {close $fp}
		onError "2 ReadFile: unable to open File $datei !"
		return
	} else {
		fconfigure $fp -translation binary
		set fsize [file size $datei]
		if {$fsize<=0} {
			close $fp
			dispMSG "$msgText(request.warning.2) [lindex [split $datei /] end] = $fsize bytes !"
			return
		}
		catch {read $fp $fsize} r
		close $fp
		set ext [lindex [split $datei .] end]
		if {$debug>9} {puts "ReadFile returns: $r"}
		return $r
	}
}

#resolves a directory path
proc reslvDIR {datei} {
# lst einen DirectoryNamen, der "../" enthlt in einen "real"-DirectoryNamen auf
	if {$datei==""} return
	global baseurl activeHTM
	regsub -nocase -all {://} $datei {} check
	regsub -nocase -all {..//} $check {} check
	regsub -nocase -all {//} $check "/../" check
	set datei $check
	regsub -all -nocase {\.\./} $check {} check
	set check [lindex [split $check ] 0]
#NEU300804: DomainNamen bercksichtigen; wenn z.B. www.irgendwas.de/../directory/gfx.jpg
	if {[regexp -nocase -all {/} $check]>1} {
		regsub -nocase -all { } $datei {} datei
		set back ""
		set dummy [acode resolv $datei]
		regsub -all -nocase {\.\.} $dummy {} dummy
		set help [split $dummy ]
		set dummy [split $dummy /]
		foreach irgendwas $help {
			set find [lsearch $dummy ""]
			set fdir [expr $find - 1]
			set dummy [lreplace $dummy $find $find]
			set dummy [lreplace $dummy $fdir $fdir]
		}
		regsub -all -nocase { } [join $dummy] {/} back
		regsub -nocase -all {} $back { } back
	} else {
		regsub -nocase -all {\.\./} $datei {} back
	}
	set back [string trim $back]
	return [acode decode $back]
}

#chkExt prft HTML-Dateiendungen, welche ins HTMLwidget "geparsed" werden sollen
proc chkEXT {ext} {
	global fTypes
	set back 0
	if {[regexp -nocase {^com$|/$|%2F$|HTTP://} $ext]} {return 1}
	if {[extensionGrep $ext $fTypes(HTML)]>0} {set back 1}
	return $back
}

#NEU270204: fileIMG (prft, ob Datei gltige GFX ist)
proc chkIMG {ext} {
	global fTypes
	set back 0
	if {[extensionGrep $ext $fTypes(Images)]>0 || [regexp -nocase {^\.vis|^\.apd} $ext]} {set back 1}
	return $back
}

#NEU280304:chkAPP(lets)
proc chkAPP {ext} {
	global fTypes
	set back 0
	if {[extensionGrep $ext $fTypes(Applets)]>0} {set back 1}
	return $back
}

#chkAnimations
proc chkANI {ext} {
	global fTypes
	set back 0
	if {[extensionGrep $ext $fTypes(Video)]>0} {set back 1}
	return $back
}

#NEU160504: chkSND (Sounds2play)
proc chkSND {ext} {
	global fTypes
	set back 0
	if {[extensionGrep $ext $fTypes(Audio)]>0} {set back 1}
	return $back
}

#NEU1040704: chkTXT (DisplayText)
proc chkTXT {ext} {
	global fTypes
	set back 0
	if {[extensionGrep $ext $fTypes(Text)]>0} {set back 1}
	return $back
}

#NEU080704: chkARC (ZIPformats)
proc chkARC {ext} {
	global fTypes
	set back 0
	if {[extensionGrep $ext $fTypes(Archives)]>0} {set back 1}
	return $back
}

#NEW201105: chkALL
proc chkALL {ext} {
	set ext [transType $ext]
	if {[chkEXT $ext]} {return 1}
	if {[chkIMG $ext]} {return 1}
	if {[chkAPP $ext]} {return 1}
	if {[chkSND $ext]} {return 1}
	if {[chkANI $ext]} {return 1}
	if {[chkARC $ext]} {return 1}
	if {[chkTXT $ext]} {return 1}
	if {[regexp -nocase {.INI$|.CFG$} $ext]} {return 1}
	return 0
}

#Button HOME
proc goHome {} {
	global homeDir MapMode FTPdest urltext home
	if {$MapMode==4} {
		set win [chkFTPactive]
		set FTPdest($win) $homeDir
		enterFTP $win
	} else {
		clearPage
		set urltext [upperHTTP $home]
		goEnter
	}
}

#NEU150304: regSTR(such string) entfernt eine Liste (!) "$such" aus "$string"
proc regSTR {args} {
	set such [lindex $args 0]
	set str [lindex $args 1]
	set allways [lindex $args 2]
	if {[string length $allways]<=0} {set allways 1}
	set back $str
	regsub -nocase -all { } [join $such] {|} begriff
		if {$allways==1} {
			regsub -nocase -all $begriff $back {} back
		} else {
			regsub -nocase $begriff $back {} back
		}
	catch {unset such str allways begriff}
	return $back
}

#counts String within chr
proc strCount {str chr} {
# liefert Anzahl CHRs in STR zurck
	set len [string length $str]
	regsub -nocase -all $chr $str {} str
	set len [expr $len - [string length $str]]
	return $len
}

#wird fr "FICS" (TM) betigt: der Dateiname aus dem tiefsten Directory wird zurckgeliefert
#(geht besser als "lSort -decreasing", welches immer den LNGSTEN Dateinamen zurckliefert)
proc strSort {listin chr} {
#gibt LISTEn-inhalt mit den meisten CHR zurck
	set merk 0
	set dmerk 0
	set idx 0
	set back ""
	set hold ""
	set anz [llength $listin]
	foreach inhalt $listin {
		set dummy [strCount $inhalt $chr]
		if {$dummy>$dmerk} {
			set merk $idx
			set back $inhalt
			set dmerk $dummy
		} elseif {$dummy==$dmerk} {
			lappend back $inhalt
		}
		incr idx
	}
	if {$anz==$idx && $dmerk==0} return ""
	set hold $back
	set len 0
	foreach inhalt $back {
		set dummy [string length $inhalt]
		if {$dummy>$len} {
			set hold $inhalt
			set len $dummy
		} elseif {$dummy==$len} {
			lappend hold $inhalt
		}
	}
	set hold [lindex [lsort -unique -decreasing $hold] 0]
	return $hold
}

proc grep {suchliste instring} {
# "grep" sucht Begriff(e) aus $suchliste in $instring, gibt als Ergebnis Stelle > 0 zurck
        global debug
	if {[llength $suchliste]<=0 || [string length $instring]<=0} {return 0}
	if {[lindex $suchliste 0]=="*"} {return 1}
	set back 0
	regsub -nocase -all { } [join $suchliste] {|} suchliste
	set back [regexp -nocase -all $suchliste $instring]
	return $back
}

#NEU160304: searchMLST ($list $suchbegriff); searchMultipleList
proc searchMLST {table such} {
# Sucht in Liste aus $table den Suchbegriff $such (also aus Liste IN Liste suchen)
	set back 0
	if {[string length $such]==0 || [llength $table]==0} {
		return $back
	}
	foreach inhalt $table {
		set dummy [lsearch -regexp $inhalt $such]
		if {$dummy} {
			set back $dummy
			break
		}
	}
	return $back
}

proc searchLST {table such} {
# Sucht in Liste aus $table den Suchbegriff $such (also aus Liste IN Liste suchen)
	set back 0
	if {[string length $such]==0 || [llength $table]==0} {
		return $back
	}
	set zlr 1
	foreach inhalt $table {
		if {[regexp -nocase $such $inhalt]} {
			set back $zlr
			break
		}
		incr zlr
	}
	return $back
}

proc chkDir {filename} {
# prft, ob Filename ein Directory ist, oder eine Datei angegeben ist
	set back 0
	set dir [lindex [split $filename /] end]
	if {[regexp -nocase {\.} $dir]} {
	#Ja, Enthlt Dateiname; weil "." enthalten
		set back 1
	} else {
		set back 0
	}
	return $back
}

#fileDIR liefert Directory zurck, OHNE Filename !
#geht besser als: "file dirname" !
proc fileDIR {datei} {
	global debug remSTR chkCHR
	set datei [acode decode $datei]
	if {$debug>8} {puts "fileDIR bekommt: $datei"}
	set datei [regSTR $remSTR $datei 0]
	regsub -nocase -all $chkCHR $datei {} datei
	set datei [lindex [split $datei ] 0]
	set back $datei
	if {[regexp -nocase {/} $datei]} {
		set dummy [split $datei /]
		set last [lindex $dummy end]
	} else {
		set dummy $datei
		set last $datei
	}
	if {[regexp -nocase {\.} $last] && [chkALL $last]} {
	# Dot in FileName enthalten, ist also Datei
		set len [expr [llength $dummy] - 2]
		set back [lrange $dummy 0 $len]
		set back [join $back]
		regsub -all { } $back {/} back
		set back [string trimright $back /]/
	} elseif {[string length $last]>0 && ![regexp -nocase {\.} $last]} {
		regsub -nocase $last$ $back {} back
	} else {
		if {[llength [split $back .]]>1} {
		#Filename enthlt mehr als 1 Dot, also WWW-File
			set back [string trimleft $back /]
		} else {
			set back /[string trimleft $back /]
		}
	}
	set back [string trim $back]
	if {$debug>8} {puts "fileDIR returns: $back"}
	return $back
}

# lst aus Filename "http://", und "www" heraus
#wird bentigt um 1. Buchstaben fr CacheDir zu ermitteln
proc trimFile {datei} {
	global debug winSYS remSTR
	if {$debug>8} {puts "TrimFile bekommt: $datei"}
	if {[string length $datei]==0} return
#	set datei [regSTR "www\. www[0-9]\. $remSTR" $datei 0]
	regsub -nocase -all { } $remSTR {|} chk
	regsub -nocase -all {www\.|www[0-9]\.|$chk} $datei {} datei
        if {$winSYS==1} {
                regsub -nocase -all {^/} $datei {} datei
                regsub -nocase -all {^[a-z]:} $datei {^[A-Z]:} datei
        }
	set dir [fileDIR $datei]
	set back $dir
	set ext [getEXT $datei]
	if {[string length $ext]<=1} {
		set datei [string trimright /]/
	} else {
		set datei [string trimright $datei /]
	}
	if {[llength [split $datei .]]>2 && [regexp -nocase {www\.|www[0-9]\.} [lindex [split $datei .] 0] ]} {
	#Filename enthlt mehr als 1 Dot, also WWW-File
		set dummy [lrange [split $datei .] 1 end]
		regsub -all { } [join $dummy] {.} back
	} else {
		set back [string trimleft $datei /]
	}
	if {$debug>8} {puts "TrimFile zurck: $back"}
	return $back
}

#Neue Links fr Listbox mit rechteMaus ausgewhlt
proc AddSelected {currentFile mark} {
	global debug anzDest accept fileOK anzGFX zlrGFX waitID keepColor active renderIMG anzSEL linktext mainHTML downMode otherWarn \
	selected linkmark quickSave urltext destDir activeHTM mouseOver showPHPlinks fgColor etryBack backColor remSTR fTypes downMode \
	liste cancel HTMLwin winSYS Images activeHTM maxImgSize minImgSize shrinkBigSize maxMarkSize autoscroll imScroll msgText
	if {$cancel==1} {return}
	#NEW110606:
	if {$downMode>0} {set fileOK $mark}
	set currentFile [acode decode $currentFile]
	regsub -nocase -all {\[} $currentFile {%5B} currentFile
	regsub -nocase -all {\]} $currentFile {%5D} currentFile
        regsub -nocase -all {\(} $currentFile {%28} currentFile
        regsub -nocase -all {\)} $currentFile {%29} currentFile
	set merkFile $currentFile
	set currentFile [lindex [split $currentFile ] 0]
	if {$debug>2} {puts "AddSelected get: $currentFile $mark"}
	if {$winSYS>0} {regsub -nocase {^/} $currentFile {} currentFile}
	regsub -nocase -all {\n} $currentFile {} currentFile
	if {$linkmark==0 && [llength $selected]<=0} return
#NEW111106: check for Dangerous Domains AND FileTypes (don't allow to select them)
	if {[string length $currentFile]>8 && [regexp -nocase $fTypes(Danger) $currentFile]} {
		if {[regexp -nocase $fTypes(DDOM) $currentFile]} {
			.mbar.lbAnim configure -image imTuxForbidden
			set memgfx [getLink $currentFile $activeHTM]
			if {[string length $memgfx]>0} {markImage $memgfx red}
			if {$otherWarn>0} {optionBox -title $msgText(request.warning.1) -icon warning -type ok -message $msgText(fiq.blocked.2)}
			return
		}
	}
	#WENN Maus ber selektierbaren Link steht
	if {$renderIMG && $active && !$mark} {
		#NEU160304: FileTypes vor Aufnehmen in Auswahl prfen, nur erlaubte auswhlen
		set ext .[getEXT $currentFile]
		if {[chkALL $ext] || [regexp -nocase {/$|/?} $currentFile]} {
			catch {lappend selected [freezeURL $merkFile]}
#puts "Bin hier: $renderIMG / $active / $mark"
			set erg [expr $anzGFX - $zlrGFX]
			if {$erg<10} {
				set anzSEL [format "%02u" $erg]
			} else {
				set anzSEL $erg
			}
			.lbAnzSelGfx configure -width [string length $anzSEL]
		}
		if {$debug>9} {puts "AddSelected: $selected"}
		unset ext
	} else {
#puts "Bin Da !"
		if {$debug>5} {puts "AddSel: $currentFile"}
		regsub -all {\#.*} $linktext {} linktext
		set memgfx [getLink $currentFile $activeHTM]
		set search [lsearch [string tolower $selected] [string tolower [freezeURL $merkFile]]]
#puts "MemGFX: $memgfx"
#NEW091206:
if {$downMode>0 && $memgfx==""} {
   set linkin [lindex [split [string trimright $currentFile /] /] end]
   set memgfx [getLink $linkin $activeHTM]
   if {$search<0} {
      set search [lsearch -regexp [string tolower $selected] [string tolower [freezeURL $linkin]]]
   }
}

		if {$debug>5} {puts "AddSel: $search"}
		if {$search>=0} {
			# Bereits ausgewhlt, also wieder raus aus Liste
			set selected [lreplace $selected $search $search]
			# GFX Auswahl wieder deaktivieren (GFX farbig)
			if {$linkmark == 1 && [string length $memgfx] > 0} {
				if {!$mark} {
				#normalzustand (GFX wieder "normal" anzeigen; also farbig)
					if {[string length $memgfx] > 0} {
						#NEW301105: Copy LinkTypeIcons back2Image (even if no LinkTypeIcons activated !!!!!)
						set icon [fileType $currentFile]
#puts "icon: $icon $currentFile"
						if {[string length $icon]>0} {
							catch {::$memgfx copy $icon}
						}
						catch {image width $memgfx} width
						catch {image height $memgfx} height
						set imgsize [expr $width * $height]
						set check [expr $maxMarkSize * $maxMarkSize]
						if {$imgsize <= $check} {
							catch {::$memgfx configure -palette 1}
						}
					} else {
						if {$winSYS == 0} {
							#TextLink wieder normal "markieren"
							set tid [getToken $currentFile]
							set chk [$HTMLwin($mouseOver) text ascii $tid.0]
							if {$tid > 0 && ![regexp -nocase {^\+|^\-} $chk]} {
								$HTMLwin($mouseOver) text delete $tid.0 $tid.1
								$HTMLwin($mouseOver) refresh text
							}
						}
					}
#puts "Hier..."
				} else {
#puts "oder da !"
				#Nach "grabben" GFX farbig markieren (grn machen; gamma=0.6)
					if {$keepColor} {
        					catch {image width $memgfx} width
						catch {image height $memgfx} height
						set imgsize [expr $width * $height]
						set check [expr $maxMarkSize * $maxMarkSize]
						if {$imgsize <= $check} {
							catch {::$memgfx configure -palette 1 -gamma 0.5}
						}
						#NEU190304: Image in Ecke mit "Kasten" versehen
						set width [image width $memgfx]
						set height [image height $memgfx]
						#NEU220804: set ImageSize, if result = 0
						if {$width==0} {set width 12}
						if {$height==0} {set height 12}
						if {$debug>6} {puts "Image size: $width x $height"}
						if {$fileOK==0 || $fileOK==100} {
							#set icon [fileType $currentFile]
							#::$memgfx copy $icon
							catch {::$memgfx copy imOKbutton}
							#catch {::$memgfx copy imOKbutton -shrink}
							markImage $memgfx green
							incr anzDest
							setLED green
						} else {
							if {$fileOK==1 || $fileOK<$accept} {
								catch {::$memgfx copy imCancel}
								markImage $memgfx red
								set fileOK 0
								setLED red
							} else {
								catch {::$memgfx copy imEscape}
								markImage $memgfx orange
								set fileOK 0
								incr anzDest
								setLED orange
							}
						}
						if {$autoscroll > 0} {
							catch {image height $memgfx} high
							set dummy 440
							if {$shrinkBigSize>0} {
								set dummy $shrinkBigSize
							}
							#set megahigh [expr $maxImgSize * 2]
							set gigahigh [expr $maxImgSize * 2]
							if {$high <= $maxImgSize} {
								if {$high > $minImgSize || $imScroll==0} {
									#update idletasks; $mainHTML yview scroll 1 units
									update; $mainHTML yview scroll 1 units
								}
								if {$imScroll==0} {
									set imScroll 1
								} elseif {$imScroll==1} {
                                    set imScroll 2
								} else {
									set imScroll 0
								}
							} elseif {$high > $maxImgSize && $high <= $maxMarkSize} {
								#update idletasks; $mainHTML yview scroll 2 units
								update; $mainHTML yview scroll 2 units
							} elseif {$high > $maxMarkSize && $high <= $dummy} {
								#update idletasks; $mainHTML yview scroll 3 units
								update; $mainHTML yview scroll 3 units
							} elseif {$high > $dummy && $high <= $gigahigh} {
								#update idletasks; $mainHTML yview scroll 4 units
								update; $mainHTML yview scroll 4 units
							} elseif {$high > $gigahigh} {
								#update idletasks; $mainHTML yview scroll 5 units
								update; $mainHTML yview scroll 5 units
							}
						}

                                                if {$anzDest <=999} {
                                                        .tile.bottom.pane.f3.box.etTotal configure -foreground $fgColor -background $backColor -activebackground $backColor -disabledforeground $etryBack
                                                } else {
               	                                       if {$anzDest > 999} {.tile.bottom.pane.f3.box.etTotal configure -foreground black -background yellow -activebackground yellow -disabledforeground black}
                                                       if {$anzDest > 9999} {.tile.bottom.pane.f3.box.etTotal configure -foreground black -background orange -activebackground orange -disabledforeground black}
                                                       if {$anzDest > 99999} {.tile.bottom.pane.f3.box.etTotal configure -foreground black -background red -activebackground red3 -disabledforeground black}
                                                }
					} else {
						#set icon [fileType $currentFile]
						#::$memgfx copy $icon
						catch {::$memgfx copy imOKbutton}
						#catch {::$memgfx copy imOKbutton -shrink}
        					catch {image width $memgfx} width
						catch {image height $memgfx} height
						set imgsize [expr $width * $height]
						set check [expr $maxMarkSize * $maxMarkSize]
						if {$imgsize <= $check} {
							catch {::$memgfx configure -palette 1}
						}
						incr anzDest
					}
				}
			}
		} else {
#puts "oder auch hier: $merkFile - $currentFile"
#puts "getThumb: [getThumb $currentFile]"
			# Noch nicht gewhlt, also an Liste anhngen
			if {$currentFile!=""} {
				if {$merkFile!=""} {
					catch {lappend selected [freezeURL $merkFile]}
				} else {
					catch {lappend selected [freezeURL $currentFile]}
				}
			}
			#GFX Auswahl aktivieren (GFX grau markieren)
			if {$linkmark == 1 && [string length $memgfx] > 0} {
				catch {image width $memgfx} width
				catch {image height $memgfx} height
				set imgsize [expr $width * $height]
				set check [expr $maxMarkSize * $maxMarkSize]
				if {$imgsize <= $check} {
					catch {::$memgfx configure -palette 9}
				}
				#NEW301105: copy MiniMarkIcon in Image (um auch SW GFX zu markieren, da sonst "unsichtbar")
#				catch {::$memgfx copy imStamp}
				catch {::$memgfx copy imBookAdd}
			} elseif {[string length $memgfx] <= 0} {
				if {$winSYS == 0} {
					#TextLink farbig markieren
					set tid [getToken $currentFile]
					set chk [$HTMLwin($mouseOver) text ascii $tid.0]
					if {$tid > 0 && ![regexp -nocase {^\+|^\-} $chk]} {
						$HTMLwin($mouseOver) text insert $tid.0 "-"
						$HTMLwin($mouseOver) refresh text
					}
				}
			}
		}
		set zahl [llength $selected]
		if {$zahl<10} {
			set anzSEL [format "%02u" $zahl]
		} else {
			set anzSEL $zahl
		}
		.lbAnzSelGfx configure -width [string length $anzSEL]
		refreshSelected
#		setLED cyan
		unset memgfx zahl
	}
	unset currentFile
}

#NEU200304: cutEXT $file schnedet Endung von $file ab
proc cutEXT {datei} {
	global fTypes
	if {[string length $datei]==0} return
#puts "cutEXT: $datei"
	set back $datei
	set ext [lindex [split $datei .] end]
	if {[chkALL $ext]} {
		regsub -nocase $ext$ $datei {} back
	}
	set back [string trim $back .]
	return $back
}

#GFXScript (Listbox, URL) laden/ausfhren
proc LoadScript {datei} {
	global activeHTM debug FTPask FTPdest fsizeWarn variTime tableOnly keepColor renderIMG lastDir baseurl urltext useVideo otherWarn \
		selected destDir linkmark config underlineHyper showTableStruct showImages zoomText quickSave changeBack backImage cookie \
		useApplet autoConfig fontsize ignoreReDir playAnim onceAnim playSounds onceSounds inifile bHelp winSYS thumbsOnly \
		newPage msgText bHelp useFrames backColor
	if {$debug>2} {puts "LoadScript: $datei"}
	if {[string length $datei]<=0} {
		set filetypes {
			{{Ini Files} {.INI}}
			{{Config Files} {.CFG}}
			{{Skin Files} {.SKN}}
			{{All Files} *}
		}
		catch {stop_anigif .mbar.lbAnim} err
		catch {show_anigif [list -data [getAnim explode22]] .mbar.lbAnim} err
		set f [tk_getOpenFile -title $msgText(config.load) -initialdir $lastDir -filetypes $filetypes]
        catch {stop_anigif .mbar.lbAnim} err
		update
		if {[string length $f]>0} {
			set lastDir [string trimright [fileDIR $f] /]/
		}
	} else {
		set f $datei
	}
	if {[string length $f]<=1 || ![file exists $f]} return
	if {[regexp -nocase {\.ini$} $f]} {
 	        set dummy [openFile $f]
	        #Diese Variablen IMMER setzen
		set showImagesDummy [lindex $dummy 2]
	        set changeBackDummy [lindex $dummy 5]
	        set autoConfig [lindex $dummy 15]
		#MenuConfig
                if {[string length $datei]<=0 || $datei == $inifile} {
                	#und diese NUR setzen, wenn KEINE Datei angegeben wurde (bei INI-File mit HTM)
			#set config [lrange $dummy 0 22]
                	set underlineHyper [lindex $dummy 0]
                       	set showTableStruct [lindex $dummy 1]
                       	#set showImagesDummy [lindex $dummy 2]
                        set zoomText [lindex $dummy 3]
                        set quickSave [lindex $dummy 4]
                        #set changeBackDummy [lindex $dummy 5]
			#set ignoreReDir [lindex $dummy 5]
                        set backImage [lindex $dummy 6]
                        set useApplet [lindex $dummy 7]
                        set fsizeWarn [lindex $dummy 8]
                        set thumbsOnly [lindex $dummy 9]
			set useFrames [lindex $dummy 10]
                        set renderIMG [lindex $dummy 11]
                        set keepColor [lindex $dummy 12]
                        set ignoreReDir [lindex $dummy 13]
                        set tableOnly [lindex $dummy 14]
                        #set autoConfig [lindex $dummy 15]
                        set fontsize [lindex $dummy 16]
                        set playAnim [lindex $dummy 17]
                        set onceAnim [lindex $dummy 18]
                        set playSounds [lindex $dummy 19]
                        set onceSounds [lindex $dummy 20]
                        set FTPask [lindex $dummy 21]
			set bHelp [lindex $dummy 22]
			set useVideo [lindex $dummy 23]
			set otherWarn [lindex $dummy 24]
                }
                #Files/URLs
                set urltext [upperHTTP [regsub {^_} [lindex $dummy 25] {}]]
                if {$debug>3} {puts "LoadScriptURL: $urltext"}
                set baseurl($activeHTM) ""
                set merk $destDir
                set merkDir $destDir
		set destDir [regsub {^_} [lindex $dummy 26] {}]
		#NEW311004: Compatible .INI-Files Linux/Windoze
		if {($winSYS==0 && [regexp -nocase {^.:} $destDir]) || ($winSYS==1 && [regexp -nocase {^/} $destDir])} {
			set destDir $merk
			unset merk
		}
#NEW260807: loadCookie
		set cookie [regsub {^_} [join [concat [lindex $dummy 27]]] {}]
                set FTPdest(local) $destDir
                set selDummy [regsub {^_} [lrange $dummy 28 end] {}]
                set selected [lindex $selDummy 0]
                if {$destDir != $merkDir} refreshTotal
                unset selDummy merkDir
                #variTime (TM)
                if {$showImagesDummy>1} {
                	set showImages 1
                	set variTime $showImagesDummy
                } else {
                	set showImages $showImagesDummy
                }
                #variHead (TM)
                if {$changeBackDummy>1} {
                	set changeBack 1
                	set variHead $changeBackDummy
                } else {
                	set changeBack $changeBackDummy
                }
		if {[winfo exists .tile.bottom.pane.f3.box.lbType]} {
			if {$thumbsOnly==1} {
				.tile.bottom.pane.f3.box.lbType configure -background red -image imOPTthumbnail
				.mbar.lbAnim configure -image imTuxUnallowed
			}
		}
                if {$autoConfig==0 && $autoConfig!=""} return
                if {$urltext!=""} {
                	LoadFile $urltext
                }
                # Bereits ausgewhlte GFX wieder grau markieren
                if {[llength $selected]>0} {
                	foreach suchurl $selected {
                		if {$linkmark == 0} return
                		regsub -all {\#.*} $suchurl {} suchurl
                		set memgfx [getLink $suchurl $activeHTM]
                		if {$suchurl > -1} {
                			# GFX Auswahl wieder deaktivieren (GFX farbig)
                			if {$linkmark == 1 && [string length $memgfx] > 0} {
                				::$memgfx configure -palette 9
                			}
                		}
                        }
                       	grabPic $destDir 0
                }
        } elseif {[regexp -nocase {\.cfg$} $f]} {
		if {[file exists $f]} {
			loadCFG $f
		} else {
			saveCFG $f
		}
	} elseif {[regexp -nocase {\.skn$} $f]} {
	#Load OWN Skin File
		loadSkin $f
		setSkin
	}
}

#GFXScript (Listbox, URL) speichern
proc SaveScript {datei} {
	global FTPask fsizeWarn variTime variHead tableOnly keepColor renderIMG lastDir urltext selected destDir config useVideo otherWarn \
		underlineHyper showTableStruct showImages zoomText quickSave changeBack backImage useApplet autoConfig fontsize \
		playAnim onceAnim playSounds onceSounds thumbsOnly useFrames msgText bHelp ignoreReDir cookie
	if {[string length $datei]==0} {
		set filetypes {
			{{Ini Files} {.INI}}
			{{Config Files} {.CFG}}
			{{Skin Files} {.SKN}}
			{{All Files} *}
		}
		catch {stop_anigif .mbar.lbAnim} err
		catch {show_anigif [list -data [getAnim wackel22]] .mbar.lbAnim} err
		set filename [lindex [split $urltext /] end]
		set filename [lindex [split $filename .] 0].INI
		set f [tk_getSaveFile -title $msgText(config.save) -initialdir $lastDir -filetypes $filetypes -initialfile $filename]
        catch {stop_anigif .mbar.lbAnim} err
		update
		if {[string length $f]>0} {
			set lastDir [string trimright [fileDIR $f] /]/
		}
	} else {
		set f $datei
	}
	if {[string length $f]>1} {
		set showImagesDummy $showImages
		#variTime (TM)
		if {$variTime>1} {
			set showImagesDummy $variTime
		}
		#variHead (TM)
		set changeBackDummy $changeBack
		if {$variHead>1} {
			set changeBackDummy $variHead
		}
                if {[regexp -nocase {\.ini$} $f]} {
                            set config [list $underlineHyper $showTableStruct $showImages $zoomText $quickSave $changeBack $backImage $useApplet $fsizeWarn $thumbsOnly $useFrames $renderIMG $keepColor $ignoreReDir $tableOnly $autoConfig $fontsize $playAnim $onceAnim $playSounds $onceSounds $FTPask $bHelp $useVideo $otherWarn]
                           	regsub -nocase -all {\{|\}} $cookie {} cookie
                      		if {![catch {open $f "w"} fileid]} {
                                    puts $fileid $config
                        		    puts $fileid _$urltext
                               		puts $fileid _$destDir
#NEW260807: saveCookie
                                    puts $fileid _[list [join [concat $cookie]]]
                                    puts $fileid _$selected
                                    close $fileid
                                }
                } elseif {[regexp -nocase {\.cfg$} $f]} {
                                saveCFG $f
                } elseif {[regexp -nocase {\.skn$} $f]} {
		#Save OWN Skin
			saveSkin $f
		}
	}
}

#NEW161004 Load/Save SetupConfig
proc saveCFG {fnam} {
#saves FIQ-SetupConfig
        global dontaccept accept cutGfx convert unknownGFX fics cCompress cClean HTMLsync DOWNsync HTMLtimeout blocksize maxDepth \
	HTProxy debug markIcons getFavIcon renderUPD ANIdelay fgColor backColor normLight etryBack useSiteFonts cacheLocation mediaCTRL \
	listColor htmlBG htmlFG cutType sendCookies writeCookie speedCache language prefType cutLinks ByteCount askServer stream blacklistDIR \
	maxBytes winPos autoscroll FTPrealprev FTPpreview prevSize thumbSize crtThumbs tempIcons silentHTM minFileSize skinFile useBlink \
	tableCorrect barColor writeTempIcons kidZprotect homeDir smallStyle noTimeout compltCache saveTimeout cleanHTML

        if {[file exists $fnam]} {
        	set fdate [clock format [file mtime $fnam] -format %d]
		set date [clock format [clock seconds] -format %d]
		if {$fdate != 01 && $date == 01} {
			set ByteCount 0
		}
		catch {file delete -force $fnam}
	}
	if {[regexp -nocase {^dummy} $skinFile]} {set skinFile ""}
	if {![catch {open $fnam "w"} fileid]} {
		puts $fileid "DontBelow     = $dontaccept"
        puts $fileid "MarkAbove     = $accept"
		puts $fileid "CutDestFile   = $cutGfx"
		puts $fileid "CutDestType   = $cutType"
		puts $fileid "CovertImg     = $convert"
		puts $fileid "UnknownGFX    = $unknownGFX"
		puts $fileid "FicsLevel     = $fics"
		puts $fileid "CacheCompr    = $cCompress"
		puts $fileid "RealtimeClean = $speedCache"
		puts $fileid "AutoClean     = $cClean"
		puts $fileid "HttpSync      = $HTMLsync / $DOWNsync"
		puts $fileid "HttpTimeout   = $HTMLtimeout"
		puts $fileid "HttpBlocksize = $blocksize"
		puts $fileid "MaxLinkDepth  = $maxDepth"
		puts $fileid "HttpProxy     = $HTProxy(serv)"
		puts $fileid "HttpPort      = $HTProxy(port)"
		puts $fileid "DebugLevel    = $debug"
		puts $fileid "LinkTypeIcons = $markIcons"
		puts $fileid "GetFavIcons   = $getFavIcon"
		puts $fileid "Update Render = $renderUPD"
		puts $fileid "AnimDelay     = $ANIdelay"
        puts $fileid "SendReferer   = $askServer"
		puts $fileid "CacheLocation = $cacheLocation"
		puts $fileid "BackColor     = $backColor"
		puts $fileid "ForeColor     = $fgColor"
		puts $fileid "BarColor      = $barColor"
		puts $fileid "LightColor    = $normLight"
		puts $fileid "EntryColor    = $etryBack"
		puts $fileid "ListColor     = $listColor"
		puts $fileid "HtmlBackColor = $htmlBG"
		puts $fileid "HtmlForeColor = $htmlFG"
		puts $fileid "SilentHTM     = $silentHTM"
		puts $fileid "WriteCookie   = $writeCookie"
		puts $fileid "FIQ Language  = $language"
		puts $fileid "Select Type   = $prefType"
		puts $fileid "Cut linkedURL = $cutLinks"
		puts $fileid "ByteCounter   = $ByteCount / $maxBytes"
		puts $fileid "WindowPosition= $winPos"
		puts $fileid "AutoScroll    = $autoscroll"
		puts $fileid "RealPreview   = $FTPrealprev"
		puts $fileid "FTPPreview    = $FTPpreview"
		puts $fileid "FTPPreviewSize= $prevSize"
		puts $fileid "FTPThumbSize  = $thumbSize"
		puts $fileid "FTPThumbs     = $crtThumbs"
		puts $fileid "ShowTempIcons = $tempIcons"
		puts $fileid "MinAcceptSize = $minFileSize"
		puts $fileid "UseSkinFile   = $skinFile"
		puts $fileid "TableCorrect  = $tableCorrect"
		puts $fileid "WriteStdFIcons= $writeTempIcons"
		puts $fileid "KidzProtect   = $kidZprotect"
		puts $fileid "UseSiteFonts  = $useSiteFonts"
		puts $fileid "SmallStyle    = $smallStyle"
		puts $fileid "NoTimeout     = $noTimeout / $saveTimeout"
		puts $fileid "CompleteCache = $compltCache"
		puts $fileid "StreamVideo   = $stream"
		puts $fileid "ShowMediaCTRL = $mediaCTRL"
		puts $fileid "BlacklistFile = $blacklistDIR"
		puts $fileid "BlinkMarquees = $useBlink"
		puts $fileid "HTMLclean     = $cleanHTML"
		close $fileid
	}
}

proc loadCFG {fnam} {
#loads FIQ-SetupConfig
        global dontaccept accept cutGfx convert unknownGFX fics cCompress cClean HTMLsync DOWNsync HTMLtimeout blocksize maxDepth useBlink \
	HTProxy debug markIcons getFavIcon renderUPD ANIdelay fgColor backColor normLight etryBack useSiteFonts cacheLocation mediaCTRL \
	listColor htmlBG htmlFG cutType sendCookies writeCookie speedCache language prefType ignoreReDir cutLinks askServer stream tagStyle \
	ByteCount maxBytes winPos autoscroll FTPrealprev FTPpreview prevSize thumbSize crtThumbs tempIcons silentHTM minFileSize blacklistDIR \
	merkColor skinFile tableCorrect barColor writeTempIcons kidZprotect homeDir smallStyle noTimeout saveTimeout compltCache cleanHTML

	if {![file exists $fnam]} {
		saveCFG $fnam
		return
	}
        set dummy [split [openFile $fnam] \n]
        set dontaccept    [string trim [lindex [split [lindex $dummy 0] =] end]]
       	set accept        [string trim [lindex [split [lindex $dummy 1] =] end]]
	set cutGfx        [string trim [lindex [split [lindex $dummy 2] =] end]]
	set cutType       [string trim [lindex [split [lindex $dummy 3] =] end]]
	set convert       [string trim [lindex [split [lindex $dummy 4] =] end]]
	set unknownGFX    [string trim [lindex [split [lindex $dummy 5] =] end]]
	set fics          [string trim [lindex [split [lindex $dummy 6] =] end]]
	set cCompress     [string trim [lindex [split [lindex $dummy 7] =] end]]
        set speedCache    [string trim [lindex [split [lindex $dummy 8] =] end]]
        set cClean        [string trim [lindex [split [lindex $dummy 9] =] end]]
	set Dsync         [string trim [lindex [split [lindex $dummy 10] =] end]]
	set HTMLsync [string trim [lindex [split $Dsync /] 0]]
	set DOWNsync [string trim [lindex [split $Dsync /] 1]]
	set HTMLtimeout   [string trim [lindex [split [lindex $dummy 11] =] end]]
	set blocksize     [string trim [lindex [split [lindex $dummy 12] =] end]]
        set maxDepth      [string trim [lindex [split [lindex $dummy 13] =] end]]
	set HTProxy(serv) [string trim [lindex [split [lindex $dummy 14] =] end]]
	set HTProxy(port) [string trim [lindex [split [lindex $dummy 15] =] end]]
	set debug         [string trim [lindex [split [lindex $dummy 16] =] end]]
	set markIcons     [string trim [lindex [split [lindex $dummy 17] =] end]]
	set getFavIcon    [string trim [lindex [split [lindex $dummy 18] =] end]]
	set renderUPD     [string trim [lindex [split [lindex $dummy 19] =] end]]
	set ANIdelay      [string trim [lindex [split [lindex $dummy 20] =] end]]
        set askServer     [string trim [lindex [split [lindex $dummy 21] =] end]]
	set cacheLocation [string trim [lindex [split [lindex $dummy 22] =] end]]
        set backColor     [string trim [lindex [split [lindex $dummy 23] =] end]]
	set fgColor       [string trim [lindex [split [lindex $dummy 24] =] end]]
	set barColor      [string trim [lindex [split [lindex $dummy 25] =] end]]
	set normLight     [string trim [lindex [split [lindex $dummy 26] =] end]]
	set etryBack      [string trim [lindex [split [lindex $dummy 27] =] end]]
	set listColor     [string trim [lindex [split [lindex $dummy 28] =] end]]
	set htmlBG        [string trim [lindex [split [lindex $dummy 29] =] end]]
	set htmlFG        [string trim [lindex [split [lindex $dummy 30] =] end]]
	set silentHTM     [string trim [lindex [split [lindex $dummy 31] =] end]]
	set writeCookie   [string trim [lindex [split [lindex $dummy 32] =] end]]
	set language      [string trim [lindex [split [lindex $dummy 33] =] end]]
	set prefType      [string trim [lindex [split [lindex $dummy 34] =] end]]
	set cutLinks      [string trim [lindex [split [lindex $dummy 35] =] end]]
	set bytes         [string trim [lindex [split [lindex $dummy 36] =] end]]
	set ByteCount   [string trim [lindex [split $bytes /] 0]]
	set maxBytes    [string trim [lindex [split $bytes /] 1]]
	set winPos        [string trim [lindex [split [lindex $dummy 37] =] end]]
	set autoscroll    [string trim [lindex [split [lindex $dummy 38] =] end]]
	set FTPrealprev   [string trim [lindex [split [lindex $dummy 39] =] end]]
	set FTPpreview    [string trim [lindex [split [lindex $dummy 40] =] end]]
	set prevSize      [string trim [lindex [split [lindex $dummy 41] =] end]]
	set thumbSize     [string trim [lindex [split [lindex $dummy 42] =] end]]
	set crtThumbs     [string trim [lindex [split [lindex $dummy 43] =] end]]
	set tempIcons     [string trim [lindex [split [lindex $dummy 44] =] end]]
	set minFileSize   [string trim [lindex [split [lindex $dummy 45] =] end]]
	set skinFile      [string trim [lindex [split [lindex $dummy 46] =] end]]
	set tableCorrect  [string trim [lindex [split [lindex $dummy 47] =] end]]
	set writeTempIcons [string trim [lindex [split [lindex $dummy 48] =] end]]
	set kidZprotect   [string trim [lindex [split [lindex $dummy 49] =] end]]
	set useSiteFonts  [string trim [lindex [split [lindex $dummy 50] =] end]]
	set smallStyle    [string trim [lindex [split [lindex $dummy 51] =] end]]
	set timeout       [string trim [lindex [split [lindex $dummy 52] =] end]]
	set noTimeout   [string trim [lindex [split $timeout /] 0]]
	set saveTimeout [string trim [lindex [split $timeout /] 1]]
	set compltCache   [string trim [lindex [split [lindex $dummy 53] =] end]]
	set stream        [string trim [lindex [split [lindex $dummy 54] =] end]]
	set mediaCTRL     [string trim [lindex [split [lindex $dummy 55] =] end]]
	set blacklistDIR  [string trim [lindex [split [lindex $dummy 56] =] end]]
	set useBlink	  [string trim [lindex [split [lindex $dummy 57] =] end]]
	set cleanHTML	  [string trim [lindex [split [lindex $dummy 58] =] end]]
	catch {unset dummy bytes resoHTM resoWIN}
	set merkColor(backColor) $backColor
	set merkColor(fgColor) $fgColor
	set merkColor(barColor) $barColor
	set merkColor(normLight) $normLight
	set merkColor(etryBack) $etryBack
	set merkColor(listColor) $listColor
	set merkColor(htmlBG) $htmlBG
	set merkColor(htmlFG) $htmlFG
	if {[regexp -nocase {^dummy} $skinFile]} {set skinFile ""}
	if {[string length $skinFile]>1} {loadSkin $skinFile}
	if {[string length $kidZprotect]<=0} {set kidZprotect 0}
	if {[string length $saveTimeout]<=0} {set saveTimeout 0}
	if {[string length $useBlink]<=0} {set useBlink 1}
	if {$maxBytes == 0} {set ByteCount 0}
	set tagStyle(bold) "-background $normLight -relief raised -borderwidth 1"
	set tagStyle(mark) "-foreground $fgColor -background $normLight -relief raised -borderwidth 1"
	if {[string length $cacheLocation]<=1 || ![file isdirectory $cacheLocation]} {set cacheLocation $homeDir}
	if {[winfo exists .tile.bottom.pane.f3.box.lbType]} {
                if {$markIcons==1} {
                        .tile.bottom.pane.f3.box.lbType configure -state normal
                } else {
                        .tile.bottom.pane.f3.box.lbType configure -state disabled
                }
        }
	if {[winfo exists .tile.bottom.pane.f3.box.cbCutLinks]} {
		switch $cutLinks {
			0 {.tile.bottom.pane.f3.box.cbCutLinks configure -image imCutNone -compound left}
			1 {.tile.bottom.pane.f3.box.cbCutLinks configure -image imCutRght -compound left}
			2 {.tile.bottom.pane.f3.box.cbCutLinks configure -image imCutLeft -compound left}
			3 {.tile.bottom.pane.f3.box.cbCutLinks configure -image imCutBoth -compound left}
		}
		if {$cutLinks > 0} {
			.tile.bottom.pane.f3.box.cbCutLinks configure -relief ridge -background black -foreground yellow
		} else {
			.tile.bottom.pane.f3.box.cbCutLinks configure -relief ridge -background black -foreground green
		}
	}
	if {[winfo exists .mbar.lbAnim]} {
		if {$kidZprotect==0} {
			if {$ignoreReDir==0} {
				.mbar.lbAnim configure -image imAnim
			} else {
				.mbar.lbAnim configure -image imTuxInfiltrate
			}
		} else {
			.mbar.lbAnim configure -image imKidTux
		}
	}
	if {[string length $blacklistDIR]>0} {
		set f [string trim $blacklistDIR]
		if {[file isdirectory $f]} {set f [string trimright $f /]/Targets.nfo}
		if {[file exists $f]} {
			       blackList $f
		}
	}
        imLED configure -foreground $backColor
        if {$maxDepth==0} {set ignoreReDir 1}
}

#ZoomButtons enabled/disabled (bei GFX, ZoomModeTextOnly)
proc Buttons {enabled} {
	global linkmark merk
	if {$enabled==0} {
		.mbar.zoomin configure -state disabled
		.mbar.zoomout configure -state disabled
		.mbar.zoom configure -state disabled
		set linkmark 0
	} else {
		.mbar.zoomin configure -state normal
		.mbar.zoomout configure -state normal
		.mbar.zoom configure -state normal
		set linkmark 1
	}
	set merk ""
}

proc MouseCurs {cursor} {
	global mainHTML HTMLwin active
	set chk [. cget -cursor]
	if {($cursor==1 && $chk=="watch") || ($cursor==0 && $chk!="watch")} return
#puts "MOUSEcurs: $cursor"
	if {$cursor==1} {
		. configure -cursor watch
		$HTMLwin(local) configure -cursor watch
		$HTMLwin(remote) configure -cursor watch
		.tile.top.ftp.tile configure -cursor watch
		.tile.bottom.foot.box.selected configure -cursor watch
		.tile.top.html.tile.bookmark configure -cursor watch
	} else {
		. configure -cursor {}
		$HTMLwin(local) configure -cursor {}
		$HTMLwin(remote) configure -cursor {}
		.tile.top.ftp.tile configure -cursor {}
		.tile.bottom.foot.box.selected configure -cursor {}
		.tile.top.html.tile.bookmark configure -cursor {}
	}
}

#Eigene ProgressBar (besser als bWidget, weil sich min UND max Wert aktualisieren lassen)
#Bei bWidget, kann immer nur min-Wert aktualisiert werden !
proc ProgressFile {akt max} {
	if {$akt==0} {
		.mbar.prgFile coords proFile 0 0 0 4
	} else {
		if {$max > 0} {
			set len [winfo width .mbar.prgFile]
			set pro [expr 100.0 / [expr $max.0 / $akt.0]]
			set bar [expr round($len.0 / 100.0 * $pro)]
			.mbar.prgFile coords proFile 0 0 $bar 4
			#update idletasks
			update
		}
	}
}

#GesamtProgress (unten)
proc ProgressBar {akt max} {
	global MapMode
	set type .tile.bottom.pane.f3.box.prgBar
	switch $MapMode {
		2 {set type .tile.bottom.pane.f2.box.prgBar}
		3 {set type .tile.bottom.pane.f3.box.prgBar}
		4 {set type .tile.bottom.pane.f4.box.prgBar}
	}
	if {$akt==0} {
		$type coords proBar 0 0 0 4
	} else {
		if {$max > 0} {
			set len [winfo width $type]
			set pro [expr 100.0 / [expr $max.0 / $akt.0]]
			set bar [expr round($len.0 / 100.0 * $pro)]
			$type coords proBar 0 0 $bar 4
			#update idletasks
			update
		}
	}
}

#ErrorHandling
proc onError {mtext} {
	global errNo errMerk active kidZprotect msgText language token
	if {[string length $mtext]<=0} return
	regsub -nocase -all {:} $mtext {} mtext
	catch {lindex $mtext 0} ertMerk
	set active 0
	MouseCurs 0
	setLED red
	dispMSG $mtext
	if {$errMerk==1 && $ertMerk==$errNo} return
	catch {stop_anigif .mbar.lbAnim} err
	.mbar.lbAnim configure -image imTuxFly
	set errNo [lindex $mtext 0]
	set answer [optionBox -title $msgText(error) -icon error -type abortretryignore -message $mtext]
	switch $answer {
		abort {Stop $token}
		retry {
			set errMerk 0
			puts "DEBUG: FIQ-Error: $mtext"
			return
		}
		ignore {
			set errMerk 1
		}
		1 {leavePRG $mtext}
	}
        if {$kidZprotect==1} {
                if {$ignoreReDir==0} {
                         .mbar.lbAnim configure -image imAnim
                } else {
                         .mbar.lbAnim configure -image imTuxInfiltrate
                }
        } else {
                .mbar.lbAnim configure -image imAnim
        }
}

#clears both HTMLwindows
proc clearBoth {} {
        global activeHTM mainHTML HTMLwin
        Clear
        SetDefColor
	if {$activeHTM=="local"} {
		set mainHTML $HTMLwin(remote)
	} else {
		set mainHTML $HTMLwin(local)
	}
	Clear
	SetDefColor
}

#prft ob INet-bertragung luft, de-/aktiviert Mens/Buttons, whrend bertragung
proc chkActive {args} {
	global active MapMode HTMLactive backColor
	if {$active==1} {
#puts "CHKactive 1"
		MouseCurs 1
		foreach inhalt [winfo children .mbar] {
                        if {![grep {stop lbAnim screw lbText lbStatus prgFile lbLED} $inhalt]} {
                                catch "$inhalt configure -state disabled"
                        }
                }
		.head.dispUrl.btEnter configure -state disabled
		.head.dispUrl.btHtml configure -state disabled
		.head.dispUrl.btClrUrl configure -state disabled
		.head.dispUrl.url.a configure -state disabled
		switch $MapMode {
			2 {
			.tile.bottom.pane.f2.box.btClr configure -state disabled
			.tile.bottom.pane.f2.box.btAdd configure -state disabled
			.tile.bottom.pane.f2.box.btImp configure -state disabled
			}
			3 {
				foreach inhalt [winfo children .tile.bottom.pane.f3.box] {
					if {![grep {screw prgBar} $inhalt]} {
						catch "$inhalt configure -state disabled"
					}
				}
			}
			4 {
				foreach inhalt [winfo children .tile.bottom.pane.f4.box] {
					if {![grep {screw prgBar lbType} $inhalt]} {
						$inhalt configure -state disabled
					}
				}

			}
		}
		catch "$HTMLactive(local) configure -state disabled"
		catch "$HTMLactive(remote) configure -state disabled"
	} else {
		MouseCurs 0
		foreach inhalt [winfo children .mbar] {
                        catch "$inhalt configure -state normal"
                }
		.head.dispUrl.btEnter configure -state normal
		.head.dispUrl.btHtml configure -state normal
		.head.dispUrl.btClrUrl configure -state normal
		.head.dispUrl.url.a configure -state normal
		switch $MapMode {
			2 {
			.tile.bottom.pane.f2.box.btClr configure -state normal
			.tile.bottom.pane.f2.box.btAdd configure -state normal
			.tile.bottom.pane.f2.box.btImp configure -state normal
			}
			3 {
				foreach inhalt [winfo children .tile.bottom.pane.f3.box] {
					if {![grep {screw prgBar} $inhalt]} {
						catch "$inhalt configure -state normal"
					}
				}
			}
			4 {
				foreach inhalt [winfo children .tile.bottom.pane.f4.box] {
					if {![grep {screw prgBar lbType} $inhalt]} {
						$inhalt configure -state normal
					}
				}
			}
		}
		catch "$HTMLactive(local) configure -state normal"
		catch "$HTMLactive(remote) configure -state normal"
        if {[.mbar.lbAnim cget -image] != "imStopTux"} {catch {stop_anigif .mbar.lbAnim}}
#		.imHTTPS configure -image imUnLock -background $backColor
	}
	update
}

#NEU150304: FTP-Status Messages
#Wird von u.a. von "FTP" verwendet (neuerdings auch im ges. Proggy !)
proc dispMSG {status} {
	global infostatus waitID sysFont msgText backColor fgColor
	if {[string length $status]<=0} return
	.mbar.lbText configure -text "Status:" -relief flat -foreground $fgColor -background $backColor -font $sysFont(0)
	catch {after cancel $waitID}
    set infostatus "$status                                                                                "
#    set infostatus "Status: $status                                                                                "
	set waitID [after 6000 {set infostatus $msgText(fiq.ready)}]
}

#NEW180606: display "waiting for reply" on proc process
proc dispWAIT {status} {
	global infostatus waitID sysFont msgText backColor fgColor
	if {[string length $status]<=0} return
	.mbar.lbText configure -text "Status:" -relief flat -foreground $fgColor -background $backColor -font $sysFont(0)
	catch {after cancel $waitID}
    set infostatus "$status                                                                                "
#    set infostatus "Status: $status                                                                                "
	set waitID [after 5000 {set infostatus $msgText(request.send.5)}]
}

#NEW220505: Display ALT-TAGS with INFO
proc dispINF {status} {
	global infostatus waitID sysFont msgText backColor fgColor
	if {[string length $status]<=0} return
	regsub -nocase {\{|\}} $status {} status
    set infostatus "                                                                                       "
	if {[regexp -nocase {^FAKE:} $status]} {
	   	regsub -nocase {^fake:_} $status {} status
	   	.mbar.lbText configure -text "FAKE: '$status'" -relief ridge -foreground black -background orange -font $sysFont(3)
	} else {
		.mbar.lbText configure -text "Info: '$status'" -relief groove -foreground $fgColor -background $backColor -font $sysFont(3)
	}

	catch {after cancel $waitID}
	set waitID [after 6000 {.mbar.lbText configure -text "Status:" -relief flat -foreground $fgColor -background $backColor -font $sysFont(0); set infostatus $msgText(fiq.ready)}]
}

proc openPane {wert} {
#Opens ActivatedHTM-Pane (1/2)
	if {[string length $wert]<=0} return
	set win .tile.top.html.tile.html.pane
	set x [winfo width .]
	if {$wert=="local"} {
		if {[lindex [$win sash coord 0] 0]==1} {
			$win sash dragto 0 $x 1
			$win sash place 0 $x 1
		} else {
			$win sash dragto 0 1 1
			$win sash place 0 1 1
		}
	} else {
		if {[lindex [$win sash coord 0] 0]==1} {
			$win sash dragto 0 1 1
			$win sash place 0 1 1
		} else {
			$win sash dragto 0 $x 1
			$win sash place 0 $x 1
		}
	}
}

#chkSelected checks Selected Files, whenever Spinbox (NormalMode) is changed
proc chkSelection {arg} {
	global debug fileTypes fTypes prefType thumbsOnly
	if {$debug>6} {puts "chkSelection: $arg"}
	if {[regexp -nocase {\*} $arg]} {set arg "Selected"}
	set back imFTunknown
	switch -regexp $arg {
		"Selected" {set fileTypes {*}; set prefType "All Selected"}
		"All_Files" {set fileTypes $fTypes(All_Files); set back imFTbat; set prefType "All_Files"}
		"Images" {set fileTypes $fTypes(Images); set back imFTgfx; set prefType "Images"}
		"Audio" {set fileTypes $fTypes(Audio); set back imFTsound; set prefType "Audio"}
		"Video" {set fileTypes $fTypes(Video); set back imFTvideo; set prefType "Video"}
		"Text" {set fileTypes $fTypes(Text); set back imFTtext; set prefType "Text"}
		"Tables" {set fileTypes $fTypes(Tables); set back imFTxls; set prefType "Tables"}
		"HTML" {set fileTypes $fTypes(HTML); set back imFThtml; set prefType "HTML"}
		"Applets" {set fileTypes $fTypes(Applets); set back imFTrmv; set prefType "Applets"}
		"Archives" {set fileTypes $fTypes(Archives); set back imFTzip; set prefType "Archives"}
		default {set fileTypes $arg; set back [fileType ".$arg"]; set prefType $arg}
	}
	if {$thumbsOnly==0} {
		.tile.bottom.pane.f3.box.lbType configure -image $back -width 16 -height 16
	} else {
		.tile.bottom.pane.f3.box.lbType configure -image imOPTthumbnail
	}
}

#reGrep sucht $suchBegriff in $Liste (gibt Anzahl Fundstellen zurck)
#wohingegen "grep" eine Liste (!) von Suchbegriffen IN einem $String sucht
proc reGrep {such suchliste} {
	set back 0
	#regsub -nocase -all {^\\} $such {} such
	foreach inhalt $suchliste {
		if {[regexp -nocase -all $inhalt $such]} {
			incr back
		}
	}
	return $back
}

#extGrep (same as reGrep, but searches also a starting point)
proc extensionGrep {such suchliste} {
	set such .[string trim $such .]
	set back 0
	foreach inhalt $suchliste {
		if {[regexp -nocase -all "\.[string trim $inhalt].*$" $such]} {
			incr back
		}
	}
	return $back
}

#search 4 such in suchliste
proc inGrep {such suchliste} {
	global killCHR
	set back 0
	regsub -nocase -all $killCHR $such {} such
	foreach inhalt $suchliste {
		if {[regexp -nocase -all $such $inhalt]} {
			incr back
		}
	}
	return $back
}

#Das Gleiche wie "reGrep", gibt aber 1. gefundenen Eintrag zurck
proc fGrep {such suchliste} {
	global killCHR
	set back ""
        set such [acode resolv $such]
	regsub -nocase -all {\+} $such {\\\+} such
	regsub -nocase -all $killCHR $such {} such
	foreach inhalt $suchliste {
		if {[regexp -nocase -all $such $inhalt]} {
			set back $inhalt
			break
		}
	}
	return $back
}

proc lGrep {suchbegriffe suchliste} {
	#Sucht $suchbegriffe in $suchliste; wenn gefunden return=1
	set back 0
	foreach such $suchliste {
		foreach inhalt $suchbegriffe {
			if {[regexp -nocase -all $inhalt $such]} {
				set back 1
				return 1
			}
		}
	}
	return $back
}

#NEW160505: extGrep (greps FileExtension(s) in List)
proc extGrep {suchbegriffe suchliste} {
	#Sucht $suchbegriffe in $suchliste; wenn gefunden return=1
	set back 0
	foreach such $suchliste {
		set such [lindex [split $such .] end]
		foreach inhalt $suchbegriffe {
			if {[regexp -nocase -all $inhalt $such]} {
				set back 1
				return 1
			}
		}
	}
	return $back
}

#FileExtension SortFunction (FTPmode)
proc compare {a b} {
	if {![regexp -nocase {^/} $a] || ![regexp -nocase {^/[a-zA-Z]:} $a]} {
		set stringA [string toupper [lindex [lindex [split $a .] end] 0]]
	} else {
		set stringA [string toupper [lindex $a 1]]
	}
	if {![regexp -nocase {^/} $b] || ![regexp -nocase {^/[a-zA-Z]:} $b]} {
		set stringB [string toupper [lindex [lindex [split $b .] end] 0]]
	} else {
		set stringB [string toupper [lindex $b 1]]
	}
	if {$stringA < $stringB} {
		return -1
	} elseif {$stringA > $stringB} {
		return 1
	}
	return [string compare [lindex $a 2] [lindex $b 2]]
}

#changes TuxImage for FICS(TM) in SetupMode
proc ficsPic {wert} {
	global merkFics fics ficsText msgText language
	if {$wert==$merkFics} return
	set imFics imFICS1
	set back DodgerBlue2
	set ficsText $msgText(fics.set.2)
	switch $wert {
		0 {set imFics imFICS0; set back DodgerBlue1; set ficsText $msgText(fics.set.0)}
		1 {set imFics imFICS1; set back DodgerBlue2; set ficsText $msgText(fics.set.1)}
		2 {set imFics imFICS2; set back DodgerBlue3; set ficsText $msgText(fics.set.2)}
		3 {set imFics imFICS3; set back RoyalBlue1; set ficsText $msgText(fics.set.3)}
		4 {set imFics imFICS4; set back RoyalBlue2; set ficsText $msgText(fics.set.4)}
		5 {set imFics imFICS5; set back RoyalBlue3; set ficsText $msgText(fics.set.5)}
		6 {set imFics imFICS6; set back RoyalBlue4; set ficsText $msgText(fics.set.6)}
	}
	.tile.top.conf.page.fpage3.frm.lbFics.lbFicsPic configure -background $back -image $imFics
	set merkFics $wert
}

#check 2 (identical) lists
proc unique {searchA searchB} {
	global debug
	if {$debug>7} {puts "Unique gets: $searchA $searchB"}
	set back 1
	if {[llength $searchA]==[llength $searchB]} {
		set img 0
		foreach inhalt $searchA {
			set such [lindex [lindex $searchB $img] 0]
			regsub -nocase -all {[^a-zA-Z0-9]} $such {} such
			regsub -nocase -all {[^a-zA-Z0-9]} $inhalt {} inhalt
			if {$debug>8} {puts "Unique: $inhalt = $such"}
			if {![regexp -nocase $such $inhalt]} {
				set back 0
				break
			}
			incr img
		}
	} else {
		set back 0
	}
	if {$debug>7} {puts "Unique returns: $back"}
	return $back
}

proc acode {code datei} {
#encode/decode Filenames to ASCII (resolve URL2cachefile)
	global winSYS encodelist chkSTR
	if {$code==""} return
	if {$datei==""} return
               set back $datei
               switch $code {
			encode {
				foreach {coding char} $encodelist {regsub -nocase -all $char $back $coding back}
				regsub -nocase -all {\-} $back {%2D} back
				regsub -nocase -all {\*} $back {%2A} back
				regsub -nocase -all {\?} $back {%3F} back
			}
			decode {
				foreach {coding char} $encodelist {regsub -nocase -all $coding $back $char back}
				regsub -nocase -all {%25} $back {%} back
				regsub -nocase -all {%26} $back {\&} back
				regsub -nocase -all {\\\$|%24} $back {$} back
				regsub -nocase -all {\\\+|%2B} $back {+} back
				regsub -nocase -all {\\\(|%28} $back {(} back
				regsub -nocase -all {\\\)|%29} $back {)} back
				regsub -nocase -all {\\\[|%5B} $back {[} back
				regsub -nocase -all {\\\]|%5D} $back {]} back
				regsub -nocase -all {%2A} $back {*} back
				regsub -nocase -all {%2D} $back {-} back
				regsub -nocase -all {%2E} $back {.} back
				regsub -nocase -all {%3F} $back {?} back
			}
			resolv {
				regsub -nocase -all {\{|\}} $back {} back
				regsub -nocase -all {/\./} $back {/} back
				foreach {coding char} $encodelist {regsub -nocase -all $coding $back $char back}
                regsub -nocase -all {\*} $back {%2A} back
				regsub -nocase -all {\-} $back {%2D} back
				regsub -nocase -all {\[} $back {%5B} back
				regsub -nocase -all {\]} $back {%5D} back
				regsub -nocase -all {\(} $back {%28} back
				regsub -nocase -all {\)} $back {%29} back
#				foreach {coding char} $encodelist {regsub -nocase -all $coding $back $char back}
				regsub -nocase -all {,|&#44;|#44;|%26%2344|%2344|\?,} $back {%2C} back
				regsub -nocase -all {/+} $back {/} back
				regsub -nocase -all {\\} $back {} back
				regsub -nocase -all {:/} $back {} dummy
				set len [string length [lindex [split $dummy ] 0]]
				if {$len > 1} {set back [regchn $back]}
				catch {unset len dummy}
			}
			recode {
				#used by FTP
                                foreach {coding char} $encodelist {regsub -nocase -all $coding $back $char back}
				regsub -nocase -all {\\+} $back {} back
				regsub -nocase -all { } $back {%20} back
				regsub -nocase -all {@} $back {%40} back
				regsub -nocase -all {%25} $back {%} back
				regsub -nocase -all {%2A} $back {*} back
				regsub -nocase -all {%2D} $back {-} back
				regsub -nocase -all {%2E} $back {.} back
				regsub -nocase -all {%2F} $back {/} back
				regsub -nocase -all {%3A} $back {:} back
				regsub -nocase -all {%3B} $back {;} back
				regsub -nocase -all {%3F} $back {?} back
				regsub -nocase -all {%26} $back {\&} back
				regsub -nocase -all {\\\$|%24} $back {$} back
				regsub -nocase -all {\\\+|%2B} $back {+} back
				regsub -nocase -all {\\\(|%28} $back {(} back
				regsub -nocase -all {\\\)|%29} $back {)} back
				regsub -nocase -all {\\\[|%5B} $back {[} back
				regsub -nocase -all {\\\]|%5D} $back {]} back
			}
			solve {
				foreach {coding char} $encodelist {regsub -nocase -all $coding $back $char back}
			}
			clear {
				regsub -nocase -all {#} $back {} back
				regsub -nocase -all {\$} $back {} back
                regsub -nocase -all {%} $back {} back
				regsub -nocase -all {&} $back {} back
                regsub -nocase -all {\)} $back {} back
                regsub -nocase -all {\(} $back {} back
                regsub -nocase -all {\+} $back {} back
				regsub -nocase -all {,} $back {} back
				regsub -nocase -all {'} $back {} back
				regsub -nocase -all {:} $back {} back
                regsub -nocase -all {/} $back {} back
				regsub -nocase -all {;} $back {} back
                regsub -nocase -all {=} $back {} back
				regsub -nocase -all {\?} $back {} back
				regsub -nocase -all {@} $back {} back
                regsub -nocase -all {\\} $back {} back
#               regsub -nocase -all {~} $back {} back
                regsub -nocase -all {\*} $back {} back
			}
		}
		return $back
}

#simulates MouseClick-event on given widget (a.e. right Mouse on Download-Button)
proc buttonPress {widget} {
	global buttons
	if {[$widget cget -state]=="disabled"} return
#puts "Button: $widget [$widget cget -relief]"
	set buttons [list $widget [$widget cget -background] [$widget cget -activebackground]]
	$widget configure -relief sunken -background LightGreen -activebackground LightGreen
	update
	#NEW290105: new MouseReleaseRIGHT event
        bind $widget <ButtonRelease-3> {
             [lindex $buttons 0] configure -relief raised -background [lindex $buttons 1] -activebackground [lindex $buttons 2]
             bind [lindex $buttons 0] <ButtonRelease-3> {}
        }
	#NEW210505: new MouseReleaseLEFT event
        bind $widget <ButtonRelease-1> {
             [lindex $buttons 0] configure -relief raised -background [lindex $buttons 1] -activebackground [lindex $buttons 2]
             bind [lindex $buttons 0] <ButtonRelease-1> {}
        }
   	#NEW010907: new MouseReleaseMIDDLE event
        bind $widget <ButtonRelease-2> {
             [lindex $buttons 0] configure -relief raised -background [lindex $buttons 1] -activebackground [lindex $buttons 2]
             bind [lindex $buttons 0] <ButtonRelease-2> {}
        }

}



#NEW221104:writeCache (currently unused)
#Adds Files/Sizes to CacheDir-File while Download File
proc writeCache {args} {
return
        global debug homeDir speedCache remSTR cacheLocation
        if {$speedCache==0} return
        if {$debug > 3} {puts "writeCache gets: $args"}
        set datei [lindex $args 0]
        set size [lindex $args 1]
        if {[string length $datei]<=0 || [string length $size]<=0} return
        if {$size<=0} {catch {file size $datei} size}
       	set dummy [regSTR $remSTR $datei]
        set dummy [lindex [split [string trimright $dummy /] /] end]
#      	regsub -nocase -all {www[0-9]*\.} $dummy {} chart
#	regsub -nocase -all {www\.} $chart {} chart
#        set dirname [lindex [split $chart {}] 0]
	set dirname [getCachedir $dummy]
        set cachefile [string trimright $cacheLocation /]/cache/directories/$dirname.FQD
        if {![catch {open $cachefile "a+"} fileid]} {
                puts $fileid [list [list $size $dummy]]
        }
	close $fileid
}

#pruft 2 Listen, ob beide Listen-Eintrage identisch sind; wenn nicht return = 1
proc chkList {srcList destList} {
     global speedCache
     if {$speedCache==1} {return 0}
     set i 0
     set back 0
     if {[llength $srcList]==[llength $destList]} {
                foreach inhalt $srcList {
                        set such [string trim [lindex $destList $i]]
                        if {[string trim $inhalt] == $such} {
                                incr i
                                continue
                        } else {
                                set back 1
                                break
                        }
                }
     } else {
            set back 1
     }
     return $back
}

#NEU250704: convertImage in FTPmode; evtl auch fr HTTP !
proc convertGFX {infile type} {
#Convert Type of Image
	if {![chkIMG [getEXT $infile]]} {return $infile}
        if {$type!="None" && ![regexp -nocase -all $type $infile]} {
		set ext [getEXT $infile]
		regsub -nocase -all "\.$ext$" $infile "\.$type$" back
		catch {image create photo convImage -file $infile}
       		if {[regexp -nocase -all {.GIF} $ext]} {
       				::convImage configure -palette 4
       				#::convImage redither
       		}
       		if {[regexp -nocase -all {.JPG} $ext]} {set type "jpeg"}
       		catch {::convImage write $back -format $type}
       		catch {image delete convImage}
        } else {
		set back $infile
	}
	return $back
}

#needed to sort FTP-directory
proc dirSort {dirlist} {
	if {[string length $dirlist]<=0} return ""
	set dirs ""
	set files ""
	foreach inhalt $dirlist {
		set inhalt [string trim $inhalt]
		if {[regexp -nocase {^/} $inhalt]} {
			lappend dirs $inhalt
		} else {
			lappend files $inhalt
		}
	}
	set back [concat $dirs $files]
	return $back
}

#returns ever a 3 char fileExtension from given inFile
proc transType {infile} {
	regsub -nocase {\.[ps]*html*$|/$} $infile {.htm} infile
	regsub -nocase {\.php([0-9]*)$} $infile {.php} infile
	regsub -nocase {\.asp(x*)$} $infile {.asp} infile
	regsub -nocase {\.jp(e*)(g*)$|\.vis$} $infile {.jpg} infile
	regsub -nocase {\.tif(f*)$} $infile {.tif} infile
	regsub -nocase {\.mp(e*)(g*)$} $infile {.mpg} infile
	regsub -nocase {\.divx$|\.div$} $infile {.dvx} infile
	regsub -nocase {\.plain$} $infile {.txt} infile
	regsub -nocase {\.x-icon$} $infile {.ico} infile
	return $infile
}

#primary the same as transType but even faster and only used 4 getLink, getThumb, and link2thumb
proc uniqType {infile} {
	 global typeCHNG codeCHNG
	 regsub -nocase -all $typeCHNG $infile {.FIQ} back
	 regsub -nocase -all $codeCHNG $back {} back
#	 regsub -nocase -all {\?|&|%26|%3F} $back {} back
	 return $back
}

#NEW060805: getToken. returns HTMLtokenID for resolvedLink
proc getToken {token} {
	global tokenlist tokenmerk mouseOver remSTR sMode killCHR
	if {![info exists tokenmerk($mouseOver)]} {return 0}
	if {$token == $tokenmerk($mouseOver) || $sMode == 0} {return 0}
	set back 0
	regsub -nocase -all {http://|http:/} $token {} token
	#acode clear = lscht alle Sonderzeichen (z.B. "&","?", etc.) aus URL, damit der lsearch korrekt funktioniert
	regsub -nocase -all $killCHR $token {} token
	set token [acode clear $token]
	set idx [lsearch -regexp $tokenlist($mouseOver) $token]
	if {$idx >= 0} {
		set idx [expr $idx - 1]
		set back [lindex $tokenlist($mouseOver) $idx]
	}
	return $back
}

#NEW071104: sets StatusLED to given color
#possibleColors, which provide dark & normal Color: red, green, blue, orange, cyan, violet, magenta
proc setLED {color} {
	global waitLED ANIdelay colorLED backColor
	set colorLED $color
	catch {after cancel $waitLED}
	set waitLED [after $ANIdelay {.mbar.lbLED configure -image imLED${colorLED}1}]
	set waitLED [after [expr 2 * $ANIdelay] {.mbar.lbLED configure -image imLED${colorLED}2}]
	set waitLED [after [expr 3 * $ANIdelay] {.mbar.lbLED configure -image imLED${colorLED}1}]
}

#NEW091104:KidZprotect (checks if given URL may danger for kids)
proc chkKidz {input} {
     global kidZprotect urltext msgText language kidlist
     if {$kidZprotect<=0} {return 0}
     if {[string length $input]<=0} {return 0}
     set back 0
     if {[regexp -nocase $kidlist $input]} {
              set back 1
              set urltext ""
              dispMSG $msgText(kidmode.denied)
     }
     return $back
}

#NEW210505:changeLinkStyte (changes State of the "CutLinks"-Button)
proc chngLinkState {dir} {
	global cutLinks cutFiles appText
	if {[string length $dir]<=0} {return}
	switch $dir {
		right {
			if {$cutFiles==0} {
				set cutFiles 1
				bind .tile.bottom.pane.f3.box.cbCutLinks <ButtonRelease-3> {
					.tile.bottom.pane.f3.box.cbCutLinks configure -relief groove
					bind .tile.bottom.pane.f3.box.cbCutLinks <ButtonRelease-3> {}
				}
			} else {
				set cutFiles 0
				bind .tile.bottom.pane.f3.box.cbCutLinks <ButtonRelease-3> {
					.tile.bottom.pane.f3.box.cbCutLinks configure -relief groove
					bind .tile.bottom.pane.f3.box.cbCutLinks <ButtonRelease-3> {}
				}
			}
		}
		default {
			switch $cutLinks {
				0 {
				    set cutLinks 1
					.tile.bottom.pane.f3.box.cbCutLinks configure -text $appText(.tile.bottom.pane.f3.box.cbCutLinks.$cutLinks) -image imCutRght -compound left -relief sunken
		  		}
				1 {
				    set cutLinks 2
					.tile.bottom.pane.f3.box.cbCutLinks configure -text $appText(.tile.bottom.pane.f3.box.cbCutLinks.$cutLinks) -image imCutLeft -compound left -relief sunken
				}
				2 {
				   	set cutLinks 3
					.tile.bottom.pane.f3.box.cbCutLinks configure -text $appText(.tile.bottom.pane.f3.box.cbCutLinks.$cutLinks) -image imCutBoth -compound left -relief sunken
				}
				3 {
				   	set cutLinks 0
					.tile.bottom.pane.f3.box.cbCutLinks configure -text $appText(.tile.bottom.pane.f3.box.cbCutLinks.$cutLinks) -image imCutNone -compound left -relief sunken
	   			}
			}
			bind .tile.bottom.pane.f3.box.cbCutLinks <ButtonRelease-1> {
				.tile.bottom.pane.f3.box.cbCutLinks configure -relief raised
				bind .tile.bottom.pane.f3.box.cbCutLinks <ButtonRelease-1> {}
			}
		}
	}
#	.tile.bottom.pane.f3.box.cbCutLinks configure -text $appText(.tile.bottom.pane.f3.box.cbCutLinks.$cutLinks) -relief sunken
	if {$cutLinks > 0} {
		if {$cutFiles==0} {
			.tile.bottom.pane.f3.box.cbCutLinks configure -background black -foreground yellow
		} else {
			.tile.bottom.pane.f3.box.cbCutLinks configure -background red -foreground yellow
		}
	} else {
		if {$cutFiles==0} {
			.tile.bottom.pane.f3.box.cbCutLinks configure -background black -foreground green
		} else {
			.tile.bottom.pane.f3.box.cbCutLinks configure -background red -foreground green
		}
	}
}

#Adds URL 2 Selection
proc AddURL {url} {
	global remSTR msgText
	if {[string length $url]<=0} {
		setLED orange
		dispMSG $msgText(url.empty)
	} else {
		AddSelected [regSTR $remSTR $url] 1
		setLED blue
		dispMSG $msgText(url.add)
	}
}

#Loads FIQ Window positions
proc loadPOS {filename} {
	set dummy [openFile $filename]
	set size [lrange $dummy 0 1]
	set swin [lindex $size 0]
	set sx [lindex [lindex $size 1] 0]
	set sy [lindex [lindex $size 1] 1]
	set posx [lindex [lindex $size 1] 2]
	set posy [lindex [lindex $size 1] 3]
	wm geometry . "${sx}x${sy}+${posx}+${posy}"
	foreach {win inhalt} [lrange $dummy 2 end] {
		set sx [lindex $inhalt 0]
		set sy [lindex $inhalt 1]
		if {$sx>0 && $sy>0} {
                 catch {$win sash dragto 0 $sx $sy}
                 catch {$win sash place 0 $sx $sy}
        	}
	}
	catch {unset dummy size swin sx sy posx posy}
}

#Saves FIQ Window positions
proc savePOS {filename} {
	global wins
	if {![catch {open $filename "w"} fileid]} {
		foreach win $wins {
			set width [winfo width $win]
			if {$width<=1} {set width 2}
			set height [winfo height $win]
			if {$height<=1} {set height 2}
			puts $fileid "[winfo parent $win] {$width $height [winfo x $win] [winfo y $win]}"
		}
		close $fileid
	}
}

#Dateinamenlnge auf 50 Zeichen begrenzen
proc cutFile {datei} {
    global remSTR
	set dummy [regSTR $remSTR $datei]
#	regsub -nocase $dummy $datei {} scheme
	set datei $dummy
	if {[string length $datei]>100} {
        regsub -nocase -all {://} $datei {} dummy
		set dummy [split $dummy /]
		set first [lindex $dummy 0]
		set last [lindex $dummy end]
		regsub -nocase "^$first" $datei {} data
		if {[string length $last]>0} {
		   	    regsub -nocase -all {\?} $last {\\?} dummy
		   	    regsub -nocase -all {\&} $dummy {\\&} dummy
    		   	    regsub -nocase -all {\-} $dummy {\\-} dummy
    		   	    regsub -nocase -all {\+} $dummy {\\+} dummy
		   	    catch {regsub -nocase "$dummy$" $data {} data}
  	        }
		set sum [crc::cksum $data]
		set datei [string trim $first /]/[string trim $sum]/[string trim $last /]
		if {[string length $datei]>100} {
			set dummy [split $last ?]
			set last [lindex $dummy 0]
			set end [lindex $dummy end]
			set end [crc::cksum $end]
			set datei [string trim $first /]/[string trim $sum]/[string trim $last /]?[string trim $end]
		}
		regsub -nocase -all {} $datei {://} datei
	}
	return [string trim $datei]
}

#NEW291105: returns 2 (or more) Character CachedirName from given URL
proc getCachedir {url} {
	if {[string length $url]<=0} {return temp}
	global remSTR killCHR
	set back ""
	set dummy [acode decode $url]
	regsub -nocase -all {\?|&} $dummy {/} dummy
	set dummy [string trim [regSTR $remSTR $dummy] /]/
	set dummy [lindex [split $dummy /] 0]
	regsub -nocase -all {www} $dummy {} dummy
	set dummy [string trim $dummy .]
	foreach inhalt [split $dummy .] {
		regsub -nocase -all {[^0-9]} $inhalt {} value
		regsub -nocase -all {[^a-zA-Z]} $inhalt {} char
		append back [string range $char 0 0][string trim $value]
	}
	set back [string tolower [string trim $back]]
	if {[string length $back]<=0} {return temp}
	return $back
}

#NEW301105: getEXT liefert immer korrekte FileEndung oder leer
proc getEXT {datei} {
	global chkCHR killCHR fTypes
	regsub -nocase -all { } $fTypes(All_Files) {|} allFiles
	set merkDatei $datei
	set datei [acode decode $datei]
	set dummy [string trim [lindex [split $datei {\.}] end] .]
	regsub -nocase -all $chkCHR $dummy {} dummy
	set dummy [lindex [split $dummy ] 0]
	if {[regexp -nocase {\?} $dummy]} {return "htm"}
	if {[regexp -nocase {\.com$|\.com/$} $dummy] && [regexp -nocase {tp:|tps:|www\.|www[0-9]\.} $datei]} {return "htm"}
	set filext [lindex [split $datei ?] 0]
	set filext [lindex [split $filext /] end]
if {![regexp -nocase $allFiles $dummy]} {set dummy [lindex [split $filext "\."] end]}
	if {[regexp -nocase {\.} $filext]} {
		set filext [lindex [split $filext .] end]
	} else {
		if {[regexp -nocase {/|\?|&|#} $dummy]} {set dummy "htm"}
		set filext $dummy
	}
	if {![chkALL $filext] && [regexp -nocase $chkCHR $datei]} {
		regsub -nocase -all $chkCHR $datei {} filext
		set filext [lindex [split $filext ] 0]
		regsub -nocase -all {/+|%47} $filext {} filext
		set filext [lindex [split $filext ] end]
	} else {
		regsub -nocase -all $chkCHR $filext {} filext
		set filext [transType [lindex [split $filext ] 0]]
	}
	if {[regexp -nocase {\.} $filext]} {
		set filext [lindex [split $filext .] end]
		set filext [transType $filext]
	} else {
#		set filext "htm"
	}
	if {[string length $filext]<=0 || [string length $filext]>4 && ![regexp -nocase $allFiles $filext]} {set filext "htm"}
	if {[string length $dummy]<=0 || [string length $dummy]>4 && ![regexp -nocase $allFiles $dummy]} {set dummy "htm"}
	regsub -nocase -all {\.+} $filext {} filext
	#NEW080706:
	regsub -nocase -all $killCHR $filext {} dummyext
	regsub -nocase -all $killCHR $dummy {} dummydum
	#NEW180606: chkType if getEXT is not sure
	if {![regexp -nocase -all $dummyext $dummydum] || ![regexp -nocase -all $dummydum $dummyext] && ![regexp -nocase {com|com/} $dummydum]} {
		if {[file exists $merkDatei]} {
			set filext [string trim [chkType file $merkDatei] .]
			if {[string length $filext]>0} {
				return $filext
			} else {
				return $dummy
			}
		} else {
			return $dummy
		}
	} else {
		return $filext
	}
}

#NEW011205: ZeilenGrep (zGrep) sucht $such $inliste, und gibt gefundene Zeilen zurck
proc zGrep {such inliste} {
	set back ""
	foreach inhalt $inliste {
		if {[regexp -nocase $such $inhalt]} {lappend back $inhalt}
	}
	return $back
}

#adds File to HTTP-request Buffer (only used when HTMLsync>0)
proc AddBuffer {datei} {
#puts "AddBuffer: $datei"
	global buffer
#	set datei [acode encode $datei]
#	set search [lsearch -exact $buffer $datei]
#	set search -1
#	catch {lsearch -exact $buffer $datei} search
#	if {!$search} {
#		# Bereits ausgewhlt, also wieder raus aus Liste
#		set buffer [lreplace $buffer $search $search]
#	} else {
		catch {lappend buffer $datei}
#	}
}

#delete only protocol from given URL (needed on Windows while drives beginning with x:/)
proc regchn {input} {
     #Ersetze nur "XXXY://" wg. Volumes z.B. "E:/" unter Windoof
     global chkSTR
     set dumSTR [split $chkSTR |]
     foreach dummy $dumSTR {
        	regsub -nocase "^${dummy}+" $input "[string toupper $dummy]/" input
     }
     return $input
}

#NEW170406: this Functions will only return "<a href"-Tags  (currently unused !)
proc subHREF {input} {
        set dummy [split $input " "]
        foreach inhalt $dummy {
                if {[regexp -nocase {<a|href} $inhalt]} {
                             continue
                } else {
                             regsub -nocase $inhalt $input {} input
                             regsub -nocase { +} $input { } input
                             break
                }
        }
        return $input
}

#NEW220406: get Disk VolumeSize (Windoof) returns free DiskSpace in KB
proc getSize {volume} {
        if {[string length $volume]<=0} {return 0}
        if {![file isdirectory $volume]} {return 0}
        global winSYS system
        set back 0
        if {$winSYS==1} {
              #WinDoof
              set merkDir [pwd]
              cd $volume
              set res [eval exec [auto_execok dir]]
              catch {expr [llength $res] -3} var
              catch {lindex $res $var} back
              set back [regsub -nocase -all {[^0-9]} $back {}]
              cd $merkDir
			  if {[regexp -nocase {Windows 9|Windows *me} $system]} {
  			  #Win9x, ME (dir=xy MB free)
	                catch {expr $back * 1024} back
              } else {
			  #WindNT, 2K, XP (dir=xy bytes free)
                    catch {expr $back / 1024} back
              }
        } else {
	#Linux
		set back [lindex [lindex [split [exec df -k $volume] \n] end] end-2]
	}
        return $back
}

#Checks if given File exists in cache
proc cacheExists {arg} {
#returns 1 if requested file exists in cache; used by colorize (based upon getFileURL, but without getting a file)
	global debug link cacheLocation compltCache fics fTypes baseurl winSYS remSTR killCHR
	set back 0
	if {$compltCache>0} {return $back}
	set basefile $arg
	set basefile [string trim $basefile]
	set url $basefile
	set basefile [acode resolv $basefile]
	set datei [cutFile $basefile]
	regsub -nocase {/\?} $datei {?} datei
	set datei [regSTR $remSTR $datei 0]
    if {$winSYS==1} {regsub -nocase -all {^/} $datei {} datei}
	set gfx [transType $datei]
	set gfx [cutFile $gfx]

	set path [URLsplit $url]
	set path [lindex $path 2]
	set all [join $fTypes(All_Files)]
	regsub -nocase -all { } $all {$|} all
	if {[string length $path]<=0 || (![regexp -nocase [string trim [getEXT $path] .] $all] || [regexp -nocase {/$} $path]) && ![regexp -nocase {^/} $path]} {set gfx [string trimright $datei /]/index.htm}
	if {[regexp -nocase {^/|^[a-zA-Z]:|^FILE:/} $url]} {
		if {![file exists $datei]} {
			# WENN file NICHT lokal vorhanden
			set chart [getCachedir $datei]
			set cachedir [string trimright $cacheLocation /]/cache/html/$chart
			set gfx [acode encode $gfx]
			regsub -nocase -all { } [join $fTypes(HTML)] {$|} check
			regsub -nocase -all { } [join $fTypes(Images)] {$|} chk
			set ext .[string trim [getEXT $gfx] .]
			if {([chkEXT $ext] && ![regexp -nocase $check$ $gfx] && ![regexp -nocase $chk$ $gfx]) || (![chkEXT $ext] && ![regexp -nocase $all$ $gfx])} {
				set gfx $gfx.htm
			}
			# Wenn file auch NICHT lokal im Cache existiert
			if {[file exists $cachedir/$gfx]} {
				set back 1
			}
		} else {
		       set back 1
		}
	} else {
		# WENN file NICHT regexp entspricht
		set chart [getCachedir $datei]
		set cachedir [string trimright $cacheLocation /]/cache/html/$chart
		set gfx [acode encode $gfx]
		regsub -nocase -all { } [join $fTypes(HTML)] {$|} check
		regsub -nocase -all { } [join $fTypes(Images)] {$|} chk
		set ext .[string trim [getEXT $gfx] .]
		if {([chkEXT $ext] && ![regexp -nocase $check$ $gfx] && ![regexp -nocase $chk$ $gfx]) || (![chkEXT $ext] && ![regexp -nocase $all$ $gfx])} {
			set gfx $gfx.htm
		}
		# Wenn file auch NICHT lokal im Cache existiert
		if {[file exists $cachedir/$gfx]} {
			set back 1
		}
	}
	return $back
}

#Returns complete ALT-Tag by extracting value of name (same as getValue, but resolves combined ALT-Tags)
proc getAlt {name value} {
     global killCHR
     regsub -nocase -all $killCHR $value {} dummy
     regsub -nocase -all {\"} $dummy {'} dummy
     regsub -nocase -all "$name='|$name ='|$name = '" $dummy {} dummy
     set dummy [lindex [split $dummy ] end]
     regsub -nocase -all {'} $dummy {} dummy
     set dummy [lindex [split $dummy ] 0]
     regsub -nocase -all { } $dummy {%20} dummy
     return $dummy
}

#NEW121106: import Spybot's Blacklist (if available) to check for dangerous Domains and block them
#Normally found under: "../programs/spybot/include/Targets.nfo"
proc blackList {datei} {
     global fTypes remSTR msgText
     set dummy [split [openFile $datei] \n]
     if {[regexp -nocase {Company=|Product=|Threat=} [join [lrange $dummy 1 3]]]} {
     #SpyBot's "Targets.nfo"-File
	     set which 0
	     set danger ""
	     foreach inhalt $dummy {
	       		if {$which>0 && [regexp -nocase {CompanyURL} $inhalt]} {
	       		   	set danger [string trim [lindex [split $inhalt =] end]]
	       		   	if {[string length $danger]>5 && ![regexp -nocase { } $danger]} {
		       		   	set danger [regSTR "$remSTR ttp: tp: htp:" $danger 0]
		       		   	regsub -nocase {^ww[a-zA-Z0-9]+\.} $danger {} danger
		       		   	set danger [string trim [lindex [split $danger /] 0] /]
				   	   	lappend fTypes(DDOM) $danger
			   		}
					set which 0
	       		}
			if {[regexp -nocase {Threat} $inhalt]} {
			   	if {[regexp -nocase {trojan|spyware|security|keylogger|malware|hijacker|BHO|PUPS|dialer} $inhalt]} {set which 1}
			}
	     }
     } else {
     #Other BlackList which should contain every blacklisted Domain in each seperate line
             foreach inhalt $dummy {
	     	     if {[string length $inhalt]>5 && ![regexp -nocase { } $inhalt]} {
		     	   	set inhalt [regSTR "$remSTR ttp: tp: htp:" $inhalt 0]
		     	   	regsub -nocase {^ww[a-zA-Z0-9]+\.} $inhalt {} danger
		     	   	set danger [string trim [lindex [split $danger /] 0] /]
			   	   	lappend fTypes(DDOM) $danger
	   		     }
             }
     }
     regsub -nocase -all { +} [join $fTypes(DDOM)] {|} fTypes(DDOM)
     catch {unset dummy inhalt danger}
     dispMSG $msgText(blacklist.imported)
}

#NEW161106: stripValue returns only Values without any StringCharacters
proc stripValue {input value} {
     if {[string length $value]<=0 || $value=="" || $value<=0} {set value 0}
	 regsub -nocase -all {none|no} $input {0} back
 	 regsub -nocase -all {yes|horizontal|vertical} $back {1} back
	 regsub -nocase -all {[^0-9]} $back {} back
     if {[string length $back]<=0 || $back=="" || $back<=0} {set back $value}
     return $back
}

#checks if given URL is blacklisted
proc chkDanger {datei} {
	 global fTypes fgColor backColor normLight listColor showDecode
		#NEW111106: check 4 dangerous Domains/FileTypes
		set danger 0
		if {$datei==""} {return $danger}
		if {[string length $datei]>5} {
			if {[regexp -nocase $fTypes(Danger) $datei] && [regexp -nocase $fTypes(DDOM) $datei]} {
			   	    set danger 1
			   	    .f9.lbShowURL configure -foreground black -background red
	  		} elseif {[regexp -nocase $fTypes(DDOM) $datei]} {
			   	    set danger 1
			   	    .f9.lbShowURL configure -foreground black -background orange
	    	} elseif {[regexp -nocase $fTypes(Danger) $datei]} {
			   	    set danger 1
			   	    .f9.lbShowURL configure -foreground black -background yellow
	    	} else {
			   	    set danger 0
			   	    if {$showDecode>0} {
					    .f9.lbShowURL configure -relief groove -foreground $listColor -background $normLight
					} else {
				   	    .f9.lbShowURL configure -relief ridge -foreground $fgColor -background $backColor
					}
			}
   		} else {
		   	    if {$showDecode>0} {
				    .f9.lbShowURL configure -relief groove -foreground $listColor -background $normLight
				} else {
			   	    .f9.lbShowURL configure -relief ridge -foreground $fgColor -background $backColor
				}
   		}
		return $danger
}

#following Code comes from wiki.tcl.tk
proc hexDump {string} {
    set where 0
    set res {}
    while {$where<[string length $string]} {
        set str [string range $string $where [expr $where+15]]
        if {![binary scan $str H* t] || $t==""} break
        regsub -all (....) $t {\1 } t4
        regsub -all (..) $t {\1 } t2
        set asc ""
        foreach i $t2 {
            scan $i %2x c
            append asc [expr {$c>=32 && $c<=127? [format %c $c]: "."}]
        }
        lappend res [format "%7.7x: %-42s %s" $where $t4  $asc]
        incr where 16
    }
    join $res \n
}

#Breaks inputTEXT each width's Character by a CRLF
proc breakText {input width} {
	if {[string length $input]<$width} {return $input}
	set inc [expr $width + 1]
	regsub -nocase -all {>} $input ">\n" dummy
	regsub -nocase -all {<} $dummy "\n<" dummy
	set dummy [split $dummy \n]
	set back ""
	foreach inhalt $dummy {
			if {![regexp -nocase {<|>} $inhalt]} {
			   set len [string length $inhalt]
			   if {$len>$width} {
			   	  for {set i 0} {$i<$len} {incr i +$inc} {
				  	  append back "[string range $inhalt $i [expr $i + $width]]<br>\n"

			   	  }
			   } else {
				  append back $inhalt
			   }
			} else {
			  append back $inhalt
			}
	}
	return $back
}

#NEW221206: ONLY used by displayHTML (2 show HTMLsource; DON'T use 4 internal HTMLsplitter: splitHTM !)
proc htmSplitter {input} {
	if {[regexp -nocase {\n} $input]} {return $input}
	regsub -nocase -all { +} $input " " dummy
	regsub -nocase -all {<table} $dummy "\n<TABLE" dummy
	regsub -nocase -all {<a } $dummy "\n<A " dummy
	regsub -nocase -all {<th} $dummy "\n<TH" dummy
	regsub -nocase -all {<tr} $dummy "\n<TR" dummy
	regsub -nocase -all {<map } $dummy "\n<MAP " dummy
	regsub -nocase -all {<script} $dummy "\n<SCRIPT" dummy
	regsub -nocase -all {<base} $dummy "\n<BASE" dummy
	regsub -nocase -all {<html} $dummy "\n<HTML" dummy
	regsub -nocase -all {<head} $dummy "\n<HEAD" dummy
	regsub -nocase -all {<meta} $dummy "\n<META" dummy
	regsub -nocase -all {<body} $dummy "\n<BODY" dummy
	regsub -nocase -all {<link} $dummy "\n<LINK" dummy
	regsub -nocase -all {<title} $dummy "\n<TITLE" dummy
	regsub -nocase -all {<center} $dummy "\n<CENTER" dummy
	regsub -nocase -all {<form} $dummy "\n<FORM" dummy
	regsub -nocase -all {<applet} $dummy "\n<APPLET" dummy
	regsub -nocase -all {<embed} $dummy "\n<EMBED" dummy
	regsub -nocase -all {<iframe } $dummy "\n<IFRAME " dummy
	regsub -nocase -all {<frame } $dummy "\n<FRAME " dummy
	regsub -nocase -all {<frameset} $dummy "\n<FRAMESET" dummy
	regsub -nocase -all {<noframe} $dummy "\n<NOFRAME" dummy
	regsub -nocase -all {<style} $dummy "\n<STYLE" dummy
	regsub -nocase -all {<noscript} $dummy "\n<NOSCRIPT" dummy
	return $dummy
}

proc downloadStart {} {
	 global active globalCount silentHTM anzGFX maxDepth ignoreReDir msgText cancel backColor
	    if {!$active && [. cget -cursor]!="watch"} {
		set globalCount 0
		.tile.bottom.pane.f3.box.btRip configure -background $backColor
		if {$silentHTM==1} {
			set merkAnz $anzGFX
			downLoad
			#NEW220106:
			#Wenn Download durch Hacker "umgeleitet" werden sollte, aber FIQ das verhindert hat
			if {$maxDepth>0 && $ignoreReDir>0 && $cancel==0} {
				if {$anzGFX>0 && $anzGFX < $merkAnz && $globalCount < $maxDepth} {
					.mbar.lbAnim configure -image imTuxAttention
					dispMSG "$msgText(download.6) $globalCount"
					setLED orange
					while {$globalCount < $maxDepth && $cancel==0} {
						#Download hat nicht zu 100% funktioniert, weil Selection enthlt noch files
						incr globalCount
						if {$cancel==1} {break}
						downLoad
					}
				}
			}
			#NEW220106:end
		} else {
			downLoadOLD
		}
	}
}
