package provide FIQSCN 1.0
#FIQFTP V260904
#FTP Functions 4 Frenzy's Inquisitor
#(C) 2004 by: Frenzy Softworks
#Written by: Jens Timmermann

#MapMode=2; ScannerMode
proc MapSCN {} {
	global debug urltext URLvalue mainHTML scanType scanLen ftype merkScan msgText remSTR backColor
	if {$debug>2} {puts "MapScan: $scanType"}
	if {[string length $urltext]<=0} return
	if {![regexp -nocase {[0-9]} $urltext]} {
		set URLvalue ""
		return
	}
	set name [regSTR $remSTR $urltext]/
	set name [join [lrange [split $name /] 1 end]]
	if {[regexp -nocase {[0-9]} $name]} {
		regsub -nocase -all { } $name {/} name
		set start 0
		set URLvalue ""
		#Find any Values within given URL (remember any found Values in List: $URLvalue)
		set dummy [split $name {}]
		set merk ""
		set idx 0
		foreach inhalt $dummy {
			if {[string is integer $inhalt]} {
				#puts "Integer found: $inhalt"
				set merk $merk[string trim $inhalt]
				set idx 1
			} elseif {$idx==1} {
				lappend URLvalue $merk
				set merk ""
				set idx 0
			}

		}
#puts "Value: $URLvalue"
		if {[llength $URLvalue]<=0} {
			ChangeMode 2
			dispMSG $msgText(scan.values)
			setLED orange
			return
		}
		set dummy [lindex $URLvalue 0]
		regsub -nocase {^0} $dummy {} startValue
		set start $dummy
		if {$debug>2} {puts "ScanStart: $start"}
		regsub -nocase $start $urltext {!} dummy
		set dummy [split $dummy !]
		set startURL [string trim [lindex $dummy 0]]
		set endURL [string trim [lindex $dummy end]]
		if {[string length $endURL]<=0 || $endURL==""} {set endURL /}
		if {![regexp -nocase {\.} $endURL] && ![regexp -nocase {/$} $endURL]} {set endURL [string trim $endURL]/}
		catch {expr $startValue + 10} end
		set merkScan $endURL
		set valueURL $start
		set counter "%0[string length $start].0f"
		set len [string length $valueURL]
		pack forget .tile.top.ftp
		pack .tile.top.html -side left -fill both -expand true
		#Set CounterValues
		.tile.bottom.pane.f2.box.start set $start
		.tile.bottom.pane.f2.box.stop set $end
		.tile.bottom.pane.f2.box.scanType set [lindex $ftype 0]
		.tile.bottom.pane.f2.box.scanLen set $len
		set scanLen $len
		#Set CounterFormat (leading "0"s) -format %03.0f
		.tile.bottom.pane.f2.box.start configure -format $counter
		.tile.bottom.pane.f2.box.stop configure -format $counter
		#Display splitted URL
		pack forget .head.dispUrl
		.head.scanUrl.lbStart configure -text $startURL -width [string length $startURL]
		.head.scanUrl.lbValue configure -text $valueURL -width $scanLen
		.head.scanUrl.lbEnd configure -text $endURL
		pack .head.scanUrl -in .head -expand true -fill x
		catch {unset startURL endURL start end dummy merk idx}
	}
	.imHTTPS configure -image imScanMode -background $backColor
	#oder: RoyalBlue LightBlue2
	#ReadOnly ListBox
	.tile.bottom.foot.box.selected configure -state disabled
}

#chkScanType (prft auf welche Art und Weise der Scanner arbeiten soll)
proc chkScanType {arg} {
	global debug urltext scanLen backColor
	if {$debug>2} {puts "chkScanType get: $arg"}
	switch $arg {
		Month {set type {january february march april may june july august september october november december}}
		Monat {set type {januar februar maerz april mai juni juli august september oktober november dezember}}
		Day {set type {monday tuesday wednesday thursday friday saturday sunday}}
		Tag {set type {montag dienstag mittwoch donnerstag freitag samstag sonntag}}
		Date {set type {Date}}
		Datum {set type {Datum}}
		"Var. a-z" {set type {a b c d e f g h i j k l m n o p q r s t u v w x y z}}
		"From File" {set type {File}}
		default {set type {Numeric}}
	}
	if {[lindex $type 0]=="File"} {
		.tile.bottom.pane.f2.box.btFile configure -state normal
	} else {
		.tile.bottom.pane.f2.box.btFile configure -state disabled
	}
	if {[lindex $type 0]!="Numeric"} {
		if {[string length $urltext]<=0} return
		set dummy [URLsplit $urltext]
		set startURL [lindex $dummy 1]/
#puts "dummy: $dummy"
		set restURL [string trimleft [lindex $dummy 2] /]
#puts "rest: $restURL"
		set to [string length $restURL]
		if {$to <= 0} {set to 2}
		set valueURL [string range $restURL 0 0]
		set endURL [string range $restURL 1 [string length $restURL]]
		if {[string length $endURL]<=0 || $endURL==""} {set endURL /}
		if {![regexp -nocase {\.} $endURL] && ![regexp -nocase {/$} $endURL]} {set endURL [string trim $endURL]/}
		pack forget .head.dispUrl
		pack forget .tile.top.ftp
		pack .tile.top.html
		#Set CounterValues
		.tile.bottom.pane.f2.box.start set 1
		.tile.bottom.pane.f2.box.stop set 1
		.tile.bottom.pane.f2.box.step set 0
		if {[regexp -nocase {Variable} $arg]} {
			.tile.bottom.pane.f2.box.start configure -from 1 -to $to -format {}
			.tile.bottom.pane.f2.box.stop configure -state disabled -format {}
		} else {
			.tile.bottom.pane.f2.box.start configure -from 1 -to $to -format {}
			.tile.bottom.pane.f2.box.stop configure -state normal -from 1 -to $to -format {}
		}
		set scanLen [string length $valueURL]
		#Display splitted URL
		.head.scanUrl.lbStart configure -text $startURL -width [string length $startURL]
		.head.scanUrl.lbValue configure -text $valueURL -width [string length $valueURL]
		.head.scanUrl.lbEnd configure -text $endURL
		.tile.bottom.pane.f2.box.lbPlus configure -text "-"
		pack .head.scanUrl -in .head -expand true -fill x
		pack .tile.bottom.box -in .tile.bottom.foot -fill both -expand true
		.imHTTPS configure -image imScanMode -background $backColor
	} else {
		.tile.bottom.pane.f2.box.start configure -from 0 -to 9999 -format {}
		.tile.bottom.pane.f2.box.stop configure -state normal -from 0 -to 9999 -format {}
		.tile.bottom.pane.f2.box.step set 1
		.tile.bottom.pane.f2.box.lbPlus configure -text "+"
	}
	return $type
}

#Scanner-Liste aus File importieren
proc importList {} {
	global destDir
	set filetypes {
		{{Text Files} {.txt .TXT}}
		{{All Files} *}
	}
	set f [tk_getOpenFile -title {Import ScannerList} -initialdir $destDir -filetypes $filetypes]
	update
	set back {Numeric}
	if {$f!=""} {
		set back [openFile $f]
	}
	return $back
}

#SpinBoxen Start/Stop bei Auswahl: "NonNumeric" setzen Variable
proc setScanStart {} {
	global scanType urltext
	if {[string length $urltext]<=0} return
	set start [.tile.bottom.pane.f2.box.start get]
	set step [.tile.bottom.pane.f2.box.stop get]
	if {[lindex $scanType 0]=="Numeric"} {
		.head.scanUrl.lbValue configure -text [.tile.bottom.pane.f2.box.start get]
		set back "+"
		if {$start > $step} {set back "-"}
		.tile.bottom.pane.f2.box.lbPlus configure -text $back
		return
	}
	set start [expr $start - 1]
	set step [expr $step - 1]
	set dummy [URLsplit $urltext]
	set startURL [lindex $dummy 1]/
	set restURL [string trimleft [lindex $dummy 2] /]
	set valueURL [string range $restURL $start [expr $start + $step]]
	set endURL [string range $restURL [expr $start + $step + 1] [string length $restURL]]
	if {[string length $endURL]<=0 || $endURL==""} {set endURL /}
	if {![regexp -nocase {\.} $endURL] && ![regexp -nocase {/$} $endURL]} {set endURL [string trim $endURL]/}
	set startURL $startURL[string range $restURL 0 [expr $start -1]]
	#Display splitted URL
	.head.scanUrl.lbStart configure -text $startURL -width [string length $startURL]
	.head.scanUrl.lbValue configure -text $valueURL -width [string length $valueURL]
	.head.scanUrl.lbEnd configure -text $endURL
}

#sets Stop Mark in ScannerMode
proc setScanStop {} {
	global scanType urltext
	if {[string length $urltext]<=0} return
	set start [.tile.bottom.pane.f2.box.start get]
	set step [.tile.bottom.pane.f2.box.stop get]
	if {[lindex $scanType 0]=="Numeric"} {
		set back "+"
		if {$start > $step} {set back "-"}
		.tile.bottom.pane.f2.box.lbPlus configure -text $back
		return
	}
	set start [expr $start - 1]
	set step [expr $step - 1]
	set dummy [URLsplit $urltext]
	set startURL [lindex $dummy 1]/
	set restURL [string trimleft [lindex $dummy 2] /]
	set valueURL [string range $restURL $start [expr $start + $step]]
	set endURL [string range $restURL [expr $start + $step + 1] [string length $restURL]]
	if {[string length $endURL]<=0 || $endURL==""} {set endURL /}
	if {![regexp -nocase {\.} $endURL] && ![regexp -nocase {/$} $endURL]} {set endURL [string trim $endURL]/}
	set startURL $startURL[string range $restURL 0 [expr $start -1]]
	#Display splitted URL
	.head.scanUrl.lbStart configure -text $startURL -width [string length $startURL]
	.head.scanUrl.lbValue configure -text $valueURL -width [string length $valueURL]
	.head.scanUrl.lbEnd configure -text $endURL
}

#NEU130406: markActive ScanType RadioButton
proc activeScanType {which} {
	global fgColor normLight backColor scanFile merkScan
	set win .tile.bottom.pane.f2.box.fr
	if {[$win.$which cget -foreground]=="Green"} return
	if {[string length $merkScan]<=0} {set merkScan [.head.scanUrl.lbEnd cget -text]}
	$win.$which configure -foreground Green -background $backColor -activeforeground Green -relief sunken
	switch $which {
		1 {
			set w1 2; set w2 3
			set endURL $merkScan
		}
		2 {
			set w1 1; set w2 3
			set dummy [lindex [split $merkScan /] end]
			regsub -nocase -all $dummy $merkScan {} endURL
		}
		3 {
			set w1 1; set w2 2
			set endURL $merkScan
		}
	}
	.head.scanUrl.lbEnd configure -text $endURL
	$win.$w1 configure -foreground $fgColor -background $backColor -activeforeground white -relief raised
	$win.$w2 configure -foreground $fgColor -background $backColor -activeforeground white -relief raised
}

#HTTP DirectoryScanner
proc scanServ {arglist} {
	global activeHTM scanFile linkmark baseurl debug active cancel URLvalue HTMLtimeout HTMLheader refererBACK anzSEL \
		linktext msgText scanCreate remSTR rbytes tbytes synCount mainHTML backColor
	if {$debug>2} {puts "AlphaScan: $arglist"}
#	clearSelected
	set url [.head.scanUrl.lbStart cget -text]
	if {![regexp -nocase $baseurl($activeHTM) $url] && [string length $baseurl($activeHTM)]>0} {
		setBase $url
	}
	set anzSEL 00
	if {[lindex $arglist 0]=="Numeric"} {
		if {[llength $URLvalue]<=0} {
			dispMSG $msgText(scan.values)
			setLED orange
			return
		}
		.imHTTPS configure -image imScanMode -background LightGreen
		catch {stop_anigif .mbar.lbAnim} err
		catch {show_anigif [list -data [getAnim rotate22]] .mbar.lbAnim} err
		scanNumeric
		.imHTTPS configure -image imScanMode -background $backColor
		catch {stop_anigif .mbar.lbAnim}
	} else {
		if {[string length [.head.scanUrl.lbValue cget -text]]<=0} {
			dispMSG $msgText(scan.values.1)
			setLED orange
			return
		}
		set valueURL [.head.scanUrl.lbValue cget -text]
		if {[regexp -nocase -all {/} $valueURL]} {
			dispMSG $msgText(scan.values.2)
			setLED orange
			return
		}
		.imHTTPS configure -image imScanMode -background LightGreen
		catch {stop_anigif .mbar.lbAnim} err
		catch {show_anigif [list -data [getAnim lense22]] .mbar.lbAnim} err
		set linkmark 1
		set startURL [string trim $url]
		set startURL [regSTR $remSTR $startURL]
		set stopURL [string trim [.head.scanUrl.lbEnd cget -text]]
		set sendheader [concat $refererBACK $HTMLheader]
		set fixed [.tile.bottom.pane.f2.box.step get]
		set cut [expr $fixed - 1]
		set upperfont [.tile.bottom.pane.f2.box.lbPlus cget -text]
		set endURL $stopURL
		switch $scanFile {
			1 {
				set endURL $stopURL
			}
			2 {
				set kill [lindex [split $stopURL /] end]
				set endURL $stopURL
				if {[regexp -nocase -all {\.} $kill]} {
					regsub -nocase $kill $stopURL {} endURL
					if {![regexp -nocase {\?} $endURL]} {
						set endURL [string trimright $endURL /]/
					}
				}
			}
			3 {
				set kill [lindex [split $stopURL /] end]
				set endURL $stopURL
				if {[regexp -nocase -all {\.} $kill]} {
					regsub -nocase $kill $stopURL {} endURL
					if {![regexp -nocase {\?} $endURL]} {
						set endURL [string trimright $endURL /]/
					}
					lappend endURL $stopURL
				}
			}
		}
		set active 1
		set z 1
		set stop [llength $arglist]
		foreach lastURL $endURL {
			foreach inhalt $arglist {
				set inhalt [string trim $inhalt]
				if {$fixed>0} {
					set inhalt [string range $inhalt 0 $cut]
				}
				if {$upperfont=="+"} {
					set inhalt [string toupper $inhalt]
				}
				set reqURL [lowerHTTP [reslvURL $startURL$inhalt$lastURL 1]]
				.head.scanUrl.lbValue configure -text $inhalt -width [string length $inhalt]
				set linktext "$msgText(scan.msg) $reqURL"
				ProgressBar $z $stop
				if {[regexp -nocase {file://} $reqURL] || [regexp -nocase {^/} $reqURL]} {
					regsub -nocase -all {file://} $reqURL {} reqURL
					if {[file exists $reqURL]} {
						AddSelected $reqURL 1
					}
				} else {
					if {$scanCreate==0} {
						if {[catch {::http::geturl $reqURL -validate true -progress progress -timeout $HTMLtimeout -headers $sendheader} token]} {
							dispMSG $msgText(request.send.2)
							if {[winfo exists $mainHTML.info]} {destroy $mainHTML.info}
							label $mainHTML.info -image imInfo -background [$mainHTML cget -background]; pack $mainHTML.info -side top -anchor nw
							$mainHTML parse "&nbsp;&nbsp;&nbsp;&nbsp;$msgText(request.send.2)\n"
							setLED red
							break
						}
						if {[info exists token]} {
							upvar #0 $token state
							set tbytes($synCount) $state(totalsize)
							set rbytes($synCount) 0
							set status $state(status)
							set response $state(http)
							set HTTPerror [string trim [lindex $response 1]]
							if {$debug>2} {
								puts "Scanned URL: $reqURL"
								puts "HTTP: $response"
							}
							catch {::http::cleanup $token} err
							if {[regexp -nocase timeout $status]} {
#								if {[info exists token]} {
#									#Stop $token
#								}
								dispMSG $msgText(request.send.3)
								setLED red
								break
							}
							if {[regexp -nocase {^2} $HTTPerror]} {
								#Wenn gescannte Seite OK (Code=200), Add2List
								AddSelected $reqURL 1
							}
						}
					} else {
						AddSelected $reqURL 1
					}
				}
				if {$cancel==1} {break}
				incr z
			}
		}
	catch {unset reqURL HTTPerror response startURL endURL stop fixed cut upperfont}
	.imHTTPS configure -image imScanMode -background $backColor
	catch {stop_anigif .mbar.lbAnim}
	set active 0
	set linkmark 0
	ProgressBar 0 0
	setLED blue
	dispMSG $msgText(scan.values.3)
	}
}

#NEU170404: scanNumeric
#Server nach numerischen Verzeichnissen/Dateien scannen (ScannerMode)
proc scanNumeric {} {
	global scanLen scanFile debug HTMLtimeout HTMLheader refererBACK active cancel linktext linkmark msgText scanCreate remSTR \
	rbytes tbytes synCount mainHTML
	if {$debug>2} {puts "StartNumScan"}
	set start [.tile.bottom.pane.f2.box.start get]
	if {$scanLen==0} {
		set counter "%0[string length $start]u"
	} else {
		set counter "%0[string trim $scanLen]u"
	}
	regsub -nocase -all {^0*} $start {} startvalue
	catch {expr int($startvalue)} startvalue
	#letzten Stop Wert+1 damit bis einschl. StopWert gezhlt wird
	set stop [.tile.bottom.pane.f2.box.stop get]
	set step [.tile.bottom.pane.f2.box.step get]
	if {$step<=0} {set step 1}
	regsub -nocase -all {^0*} $stop {} stopvalue
	set plus [.tile.bottom.pane.f2.box.lbPlus cget -text]
	catch {expr int ([.tile.bottom.pane.f2.box.step get])} step
	#Set Diplayed URL
	set startURL [string trim [.head.scanUrl.lbStart cget -text]]
	set startURL [regSTR $remSTR $startURL]
	set stopURL [string trim [.head.scanUrl.lbEnd cget -text]]
	set sendheader [concat $refererBACK $HTMLheader]
	if {[string length $start]<=0 || [string length $stop]<=0 || [string length $plus]<=0 || [string length $step]<=0} return
	if {[string length $startURL]<=0 || [string length $stopURL]<=0 || $start==$stop} return
	if {$plus=="+"} {
		catch {expr int($stopvalue + 1)} stop
		catch {expr $stop - $startvalue} max
		set check {$z < $stop}
		set cmd {incr z $step}
	} else {
		catch {expr int($stopvalue - 1)} stop
		catch {expr $startvalue - $stop} max
		set check {$z > $stop}
		set cmd {catch {expr $z - $step} z}
	}
	set endURL $stopURL
	switch $scanFile {
		1 {
			set endURL $stopURL
		}
		2 {
			set kill [lindex [split $stopURL /] end]
			set endURL $stopURL
			if {[regexp -nocase -all {\.} $kill]} {
				regsub -nocase $kill $stopURL {} endURL
				if {![regexp -nocase {\?} $endURL]} {
					set endURL [string trimright $endURL /]/
				}
			}
		}
		3 {
			set kill [lindex [split $stopURL /] end]
			set endURL $stopURL
			if {[regexp -nocase -all {\.} $kill]} {
				regsub -nocase $kill $stopURL {} endURL
				if {![regexp -nocase {\?} $endURL]} {
					set endURL [string trimright $endURL /]/
				}
				lappend endURL $stopURL
			}
		}
	}
	set active 1
	set akt 0
	set linkmark 1
	foreach inhalt $endURL {
		for {set z $startvalue} $check $cmd {
			set zlr [format $counter $z]
			if {$scanLen==0} {regsub -nocase -all {^0} $zlr {} zlr}
			set reqURL [lowerHTTP [acode decode [reslvURL $startURL[string trim $zlr]$inhalt 1]]]

			.head.scanUrl.lbValue configure -text $zlr -width [string length $zlr]
			set linktext "$msgText(scan.msg) $reqURL"
			ProgressBar $akt $max
			wm title . "FIQ SCAN: $akt/$max"
			wm iconname . "FIQ SCAN: $akt/$max"
			if {[regexp -nocase {file://} $reqURL] || [regexp -nocase {^/} $reqURL]} {
				regsub -nocase -all {file://} $reqURL {} reqURL
				if {[file exists $reqURL]} {
					AddSelected $reqURL 1
				}
			} else {
				if {$scanCreate==0} {
					if {[catch {::http::geturl $reqURL -validate true -progress progress -timeout $HTMLtimeout -headers $sendheader} token]} {
						dispMSG $msgText(request.send.2)
						if {[winfo exists $mainHTML.info]} {destroy $mainHTML.info}
						label $mainHTML.info -image imInfo -background [$mainHTML cget -background]; pack $mainHTML.info -side top -anchor nw
						$mainHTML parse "&nbsp;&nbsp;&nbsp;&nbsp;$msgText(request.send.2)\n"
						setLED red
						break
					}
					if {$debug>2} {puts "requestedURL: $reqURL"}
					if {[info exists token]} {
						upvar #0 $token state
						set tbytes($synCount) $state(totalsize)
						set rbytes($synCount) 0
						set status $state(status)
						set response $state(http)
						set HTTPerror [string trim [lindex $response 1]]
						if {$debug>2} {
							puts "Scanned URL: $reqURL"
							puts "HTTP-Error: $HTTPerror"
						}
						catch {::http::cleanup $token} err
						if {[regexp -nocase timeout $status]} {
#							if {[info exists token]} {
#								#Stop $token
#							}
							dispMSG $msgText(request.send.3)
							setLED red
							break
						}
						if {[regexp -nocase {^2} $HTTPerror]} {
							#Wenn gescannte Seite OK (Code=200), Add2List
							AddSelected $reqURL 1
						}
					}
				} else {
					AddSelected $reqURL 1
				}
				if {$cancel==1} {break}
			}
			incr akt
		}
	}
	catch {unset reqURL HTTPerror response startURL endURL start counter startvalue step stop}
	set active 0
	set linkmark 0
	ProgressBar 0 0
	setLED blue
	dispMSG $msgText(scan.values.4)
}

#NEU170404: ScanHistory: adds Found Entrys from ScannerMode 2 History and vv (ScannerMode)
proc scanHistory {mode} {
	if {[string length $mode]<=0} return
	global selected histry idxHistry linkmark fileTypes FTPsort msgText followLinks urltext remSTR
	catch {stop_anigif .mbar.lbAnim} err
#	.mbar.lbAnim configure -image imWorker2
#	MouseCurs 1
	switch $mode {
		0 {
#NEW291105: extract only such Links from same Domain
			set dom ""
			if {[string length $urltext]>0} {
				set dom [acode decode [regSTR $remSTR $urltext]]
				regsub -nocase -all {www\.|www[0-9]\.} $dom {} dom
				regsub -nocase -all {\?|&|\#} $dom {/} dom
				set dom [lindex [split $dom /] 0]
			}
						set max [llength $selected]
						if {$max<=0} return
						.mbar.lbAnim configure -image imWorker2
	                                        MouseCurs 1
						set z 0
						set dummy [lsort -dictionary $selected]
			        		if {$FTPsort==1} {
			        			set dummy [lsort -command compare $dummy]
			        		}
						foreach inhalt $dummy {
							ProgressBar $z $max
							set erg [expr $max - $z]
							wm title . "FIQ: $z/$max ($erg)"
							wm iconname . "FIQ: $z/$max ($erg)"
#							if {[string length $dom]>0} {
#								#Wenn Domain in Link enthalten (Filter)
#								if {[regexp -nocase -all $dom $inhalt]} {addHistry [lindex $inhalt 0]}
#							} else {
								addHistry [lindex $inhalt 0]
#							}
							incr z
						}
						set idxHistry 1
						if {[string length $dom]>0} {
							dispMSG $msgText(scan.add.0)
						} else {
							dispMSG $msgText(scan.add.1)
						}
						setLED blue
		}
		1 {
			set max [llength $histry]
			if {$max<=0} return
			.mbar.lbAnim configure -image imWorker2
	                MouseCurs 1
			set linkmark 1
			set z 0
			set q 0
			foreach inhalt $histry {
				ProgressBar $z $max
				set erg [expr $max - $z]
				wm title . "FIQ: $z/$max ($erg)"
				wm iconname . "FIQ: $z/$max ($erg)"
				if {[lindex $fileTypes 0]=="*"} {
			 	       AddSelected [string trim $inhalt] 1
			 	       set q 1
			        } else {
				       set dummyfn [transType $inhalt]
				       set ext [getEXT $dummyfn]
           			       if {[grep $fileTypes $dummyfn] || [chkEXT $ext] || [regexp -nocase {/$} $dummyfn]} {
				          AddSelected [string trim $inhalt] 1
				          set q 1
				       }
			        }
				incr z
			}
			set linkmark 0
			if {$q>0} {
				dispMSG $msgText(scan.add.2)
				setLED blue
			} else {
                dispMSG $msgText(file.match)
               	setLED orange
	       	}
		}
	}
	catch {stop_anigif .mbar.lbAnim}
	ProgressBar 0 0
	MouseCurs 0
	wm title . "Inquisitor"
	wm iconname . "FIQ"
}

#NEW141006: syncHTML = the same as readHTML, but may changed seperatly
proc syncHTML {inhalt url} {
	global urltext cancel fileTypes fics ficsVars filtVars minFileSize remSTR cookie maxDepth msgText fileOK followLinks anzDest selected \
		   activeHTM liste
	set merkUrl $url
	set url [regSTR $remSTR $url]
	if {![chkEXT .[string trim [getEXT $inhalt] .]]} return
#puts "syncHTML get: $inhalt $url"
	set dummy $inhalt
	set srcfiles ""
	set back ""
	set count 0
	set htmlpage [encode [ReadFile $dummy]]
	set htmlpage [splitHTM $htmlpage]
	set htmlpage [split $htmlpage \n]
	foreach zeile $htmlpage {
		set chklen [string trim [string length $zeile]]
		if {$chklen<=0 || ($chklen<3 && [regexp -nocase {^.>|^>} [string trim $zeile]])} continue
#puts "ZEILE: $zeile"
		if {$cancel==1} {break}
		set cookie ""
		if {[regexp -nocase {img } $zeile] && [regexp -nocase {src} $zeile]} {
			#WENN FileType in SRC enthalten (meist bei HTML)
			set src [reslvURL [getValue src $zeile] 1]
			if {[regexp -nocase $filtVars $src]} continue
			if {$fics>0} {
	   	     			if {[regexp -nocase $ficsVars $src]} continue
			}
			set ext [string trim [getEXT $src] "\."]
			if {[reGrep $ext $fileTypes]>0 && [string length $src]>0} {

#NEW031206: handle redirected Links/Images
if {[info exists liste($activeHTM,$url)]} {
	set hsrc $liste($activeHTM,$url)
	set origURL [regSTR $remSTR $src]
	if {[string length $hsrc]>0} {set liste($activeHTM,$origURL) $hsrc}
}
				set dummy [getFileURL $src 0]
			          if {$followLinks<=0} {
				          lappend srcfiles $dummy $src
				  } else {
    				          #set back [AddSelected $src 0]
					  set back [copyPic $dummy $src 100]
					  #incr anzDest
				  }
				incr count
			}
		} elseif {[regexp -nocase { href} $zeile]} {
			set href [reslvURL [getValue href $zeile] 1]
			if {[string length $href]<=0} {set href [reslvURL [getValue src $zeile] 1]}
			if {[regexp -nocase $filtVars $href]} continue
			if {$fics>0} {
	   	     			if {[regexp -nocase $ficsVars $href]} continue
			}
			set ext [string trim [getEXT $href] "\."]
			if {[reGrep $ext $fileTypes]>0 && [string length $href]>0} {

#NEW031206: handle redirected Links/Images
if {[info exists liste($activeHTM,$url)]} {
	set hsrc $liste($activeHTM,$url)
	set origURL [regSTR $remSTR $href]
	if {[string length $hsrc]>0} {set liste($activeHTM,$origURL) $hsrc}
}
				#WENN FileType in HREF enthalten (bei PHP)
				set dummy [getFileURL $href 0]
			          if {$followLinks<=0} {
				          lappend srcfiles $dummy $href
				  } else {
				       	  set back [copyPic $dummy $href 100]
				  }

				incr count
			} else {
				#WENN FileType in SRC enthalten (meist bei HTML)
				set src [reslvURL [getValue src $zeile]]
				if {[regexp -nocase $filtVars $src]} continue
				if {$fics>0} {
		   	     			if {[regexp -nocase $ficsVars $src]} continue
				}
      	    			set ext [string trim [getEXT $src] "\."]
				if {[reGrep $ext $fileTypes]>0 && [string length $src]>0} {

#NEW031206: handle redirected Links/Images
if {[info exists liste($activeHTM,$url)]} {
	set hsrc $liste($activeHTM,$url)
	set origURL [regSTR $remSTR $src]
	if {[string length $hsrc]>0} {set liste($activeHTM,$origURL) $hsrc}
}
					set dummy [getFileURL $src 0]
				          if {$followLinks<=0} {
					          lappend srcfiles $dummy $src
					  } else {
       					         #set back [AddSelected $src 0]
						 set back [copyPic $dummy $src 100]
						 #incr anzDest
					  }
					incr count
				}
			}
		}
	}
	catch {unset htmlpage zeile dummy}
	if {$cancel==1} {return}
		set max [llength $srcfiles]
		if {$max==1} {
			set dummy [lindex $srcfiles 0]
			set srcfile [lindex $dummy 0]
			set src [lindex $dummy 1]
			if {[string length $srcfile]>0} {
				set back [copyPic $srcfile $src 1]
			}
		} elseif {$max>1} {
			set files ""
			set merksize 0
				foreach {datei furl} $srcfiles {
					if {$cancel==1} {break}
					if {[string length $datei]<=0 || [string length $furl]<=0} continue
					set ext [string trim [getEXT $datei] "\."]
					if {[reGrep $ext $fileTypes]<=0} continue
					if {[file exists $datei]} {
						catch {file size $datei} filesize
						if {$filesize >= $minFileSize} {
							lappend files [list $filesize $datei]
						}
					}
				}
				if {[llength $files]>0} {
					set srcfiles [lsort -integer -index 0 $files]
					ProgressFile 100 100
					set dummy [lindex $srcfiles end]
					set srcfile [lindex $dummy 1]
					#NEW120206: standardmig fileOK auf 100 setzen, weil es sein kann, da die zuletzt angefragte Datei NICHT ok sein knnte
					#aber die vorherige (mit dem JPG) in Ordnung ist, und an dieser Stelle auch existiert, und grer 0 ist
					set fileOK 100
					set back [copyPic $srcfile $url $fileOK]
				}
                }
	if {$followLinks>0} {
		set fileOK 100
		set back [AddSelected $merkUrl $fileOK]
		incr anzDest -1
		clearSelected
    }
	catch {unset srcfiles files srcfile url max merkUrl}
#	setBase $merkBase
	return $back
}

#NEW161106: scrollerRoutine for MarqueeTAGS handled by a special (tricky) FormTAG cause HTMLwidget dosn't support Scrolltext
proc scrollMarq {win direction speed tWidth} {
     global cancel marqSwap useBlink
     if {$cancel==1 || $useBlink<=0 || ![winfo exists $win]} return
     set width [$win cget -width]
     if {[string length $direction]<=0} {set direction left}
     if {[regexp -nocase {left} $direction]} {
	     $win move 1 -1 0
	     if {[lindex [$win coords 1] 0] <= -$tWidth} {$win move 1 [expr $width + $tWidth] 0}
     } elseif {[regexp -nocase {right} $direction]} {
	     $win move 1 1 0
	     if {[lindex [$win coords 1] 0] >= $width} {$win move 1 -$tWidth 0}
     } elseif {[regexp -nocase {alternate} $direction]} {
	     if {$marqSwap==0} {
	       	     #Move to left
		     $win move 1 -1 0
		     if {[lindex [$win coords 1] 0] <= 0} {set marqSwap 1}
	     } else {
		     #Move to right
		     $win move 1 1 0
		     if {[lindex [$win coords 1] 0] >= [expr $width - $tWidth]} {set marqSwap 0}
             }
      }
     after 20 [subst "scrollMarq $win $direction $speed $tWidth"]
}

#Lets a Label "blink" within HTML (invoked by <blink>TAG via Form action=blink)
proc blink {win} {
     global cancel useBlink
     if {$cancel==1 || $useBlink<=0 || ![winfo exists $win]} return
     $win configure -background [$win cget -foreground] -foreground [$win cget -background]
     after 300 [subst "blink $win"]
}

#NEW191106: this function is called from FormCMD before Marquee becomes the (cleaned) Text
proc extractText {input} {
	 set dummy [split $input >]
	 set back ""
	 foreach inhalt $dummy {
	 		 set inhalt [string trim $inhalt]
	 		 if {[regexp -nocase {^} $inhalt] || [string length $inhalt]<=0} continue
			 regsub -nocase -all {<|>} $inhalt {} dummy
			 set dummy [lindex [split $dummy ] 0]
	 		 append back $dummy
	 }
	 return [acode decode $back]
}
