package provide app-Inquisitor 1.0

#!/bin/sh
# This line makes the next one a comment in Tcl \
exec wish "$0" ${1+"$@"}
#/usr/bin/wish
# Frenzy's Inquisitor V030711
# Written 15.02.04 by: Jens Timmermann
# Frenzy Softworks       $msgText(fiq.ready)
# (Linux/Windows compatible Version)
# Based upon the "HV.TCL"-Demo-Browser for "TkHTML"-Widget

#Global Variable of OpperatingSystem (Linux\Unix/Windoze/Macintrash)
set system $tcl_platform(os)
#set homeDir [string trimright [pwd] /]/
set homeDir [string trimright [pwd] /]
if {[regexp -nocase {windows|Windows.*9|Windows.*me} $system]} {
  regsub -nocase -all {\\} $env(windir) {/} userDir
} else {
  if {[info exists env(USERPROFILE)]} {
    regsub -nocase -all {\\} $env(USERPROFILE) {/} userDir
  } else {
    regsub -nocase -all {\\} $env(HOME) {/} userDir
  }
}
set userDir [string trimright $userDir /]/
#NEW071104: for StatusLED BGcolor required
set backColor "#4682B4"

#HTMLwidget
#Linux
#package require Tkhtml 2.0
#Windoof
package require Tkhtml

# ImgLibrary (also used 4 GIF-Animations)
#package require -exact Img 1.2.4
package require Img 1.3
package require TkImageTools 1.0
#GIFblock (2chkGIFs)
package require gifblock

#TKMagick
#package require TclMagick
#package require TkMagick
#load TclMagick.dll
#load TkMagick.dll

# HttpLibrary
package require -exact http 2.5.0
#HTTPS (Package "TLS"; openSSL)
if {[catch {package require tls}]==0} {
#	package require tls
	http::register https 443 ::tls::socket
}
#FTP
package require ftp 2.4

# WidgetLibrary (ComboBox)
#if {[catch {package require Iwidgets}]!=0} break
package require BWidget

# TextEncoding (generate chkSum to shorten FileNames) used by cutFile
package require cksum
# base64 en/decoding used for Sites with authentication and for decoding coded Links (used under Windows & Linux now)
package require base64
# HTML Hex en/decoding (unused, cause encode/decode functions now in FIQHTM)
#package require ncgi

# Tile-Styles (WindowsXP Schemes)
package require tile

#AnimationPackage (provides AVI playback)
#package require XanimTcl

#Sound Untersttzung (provided by Snack-Package)
package require snack 2.2
#Optional SoundFormatPackages
#catch {package require snacksphere}
#catch {package require snackogg}

#Config SnackSoundPackage
snack::sound snd -debug 0
snack::audio playLatency 1200
#Config TuxOmeter
snack::sound s -channels 2
snack::levelMeter .dummy -width 10 -length 200

if {![info exists starkit::topdir]} {
        # Load Inquisitor variables
        if {[catch {source $homeDir/FIQVAR.tcl}]!=0} {puts "FIQVAR"; break}
        # LoadProcedures (required by Inquisitor; only when startet from Wish !)
        if {[catch {source $homeDir/FIQPRC.tcl}]!=0} {puts "FIQPRC"; break}
        # LoadApplication-Procedures (required by Inquisitor)
        if {[catch {source $homeDir/FIQAPP.tcl}]!=0} {puts "FIQAPP"; break}
        # LoadAdditionalNetProcedures (such as FTP; required by Inquisitor)
        if {[catch {source $homeDir/FIQNET.tcl}]!=0} {puts "FIQNET"; break}
        # LoadHTTP-Procedures (required by Inquisitor)
        if {[catch {source $homeDir/FIQHTP.tcl}]!=0} {puts "FIQHTP"; break}
        # LoadHTML-Procedures (required by Inquisitor)
        if {[catch {source $homeDir/FIQHTM.tcl}]!=0} {puts "FIQHTM"; break}
		# LoadFTP-Procedures (required by Inquisitor)
        if {[catch {source $homeDir/FIQFTP.tcl}]!=0} {puts "FIQFTP"; break}
        # LoadSCAN-Procedures (required by Inquisitor)
        if {[catch {source $homeDir/FIQSCN.tcl}]!=0} {puts "FIQSCN"; break}
        # LoadBookmark-Procedures (required by Inquisitor)
        if {[catch {source $homeDir/FIQBOK.tcl}]!=0} {puts "FIQBOK"; break}
        # LoadMAIL-Procedures (required by Inquisitor)
#        if {[catch {source $homeDir/FIQMIL.tcl}]!=0} {puts "FIQMIL"; break}
        # LoadIRC-Procedures (required by Inquisitor)
#        if {[catch {source $homeDir/FIQIRC.tcl}]!=0} {puts "FIQIRC"; break}
        #AnimationFunctions (from IMG-Package)
        if {[catch {source $homeDir/FIQIMG.tcl}]!=0} {puts "FIQIMG"; break}
        # Load embedded GFX-Objects (required by Inquisitor)
        if {[catch {source $homeDir/FIQGFX.tcl}]!=0} {puts "FIQGFX"; break}
        # Load Help-Text (required by Inquisitor)
        if {[catch {source $homeDir/FIQHLP.tcl}]!=0} {puts "FIQHLP"; break}
        #catch {console hide}
        set FIQexe 0
        #FIQstart ImageWindow (Intro)
        set root .start
        if {![winfo exists $root]} {toplevel $root}
        wm overrideredirect $root 1
        set swidth  [winfo screenwidth $root]
        set sheight [winfo screenheight $root]
        set width [image width imStartFIQ]
        set height [image height imStartFIQ]
        wm geometry $root ${width}x${height}+[expr {($swidth-$width)/2}]+[expr {($sheight-$height)/2}]
        label .start.c -background black -image imStartFIQ -relief sunken
	label .start.t -background black -text "$version\nWritten and (C) 2011 by: Jens Timmermann"
	pack .start.t -side bottom -expand true -fill x
        pack .start.c -fill both -expand 1
        after 3400 {destroy $root; imStartFIQ configure -data {} }
        #IntroEnd
} else {
        #Only within StartKit (Inquisitor.EXE 4 Windoze)
		catch {package require FIQVAR}
        catch {package require FIQPRC}
        catch {package require FIQNET}
        catch {package require FIQHTP}
        catch {package require FIQHTM}
        catch {package require FIQFTP}
        catch {package require FIQSCN}
 	catch {package require FIQBOK}
	catch {package require FIQAPP}
#        catch {package require FIQMIL}
#        catch {package require FIQIRC}
        catch {package require FIQIMG}
        catch {package require FIQGFX}
        catch {package require FIQHLP}
		set FIQexe 1
}

#FIQconfig laden (wenn vorhanden)
if {[file exists $cfgfile]} {
       	 loadCFG $cfgfile
} else {
       	 saveCFG $cfgfile
}

if {$smallStyle==1} {
	if {$winSYS==1} {
	#windoof
		set buttonSize 12
		set FTPbuttonSize 5
		set HTMbuttonSize 8
		set sysFont(0) "Arial 8"
		set sysFont(1) "Times 8"
		set sysFont(2) "Arial 7"
		set sysFont(3) "Arial 7 bold"
		set sysFont(4) {"gothic i" 8}
		set sysFont(5) "Times 7 bold"
		set sysFont(6) "clean 7 bold"
		set sysFont(7) "arial 9 bold"
		set FTPfont(0) 12
		set FTPfont(1) 11
		set FTPfont(2) 10
		set FTPfont(3) 9
		set FTPfont(4) 8
		set FTPfont(5) 7
		set FTPfont(6) 6
	} else {
	#linux
		set sysFont(0) "Times 8 bold"
		set sysFont(1) "Times 9"
		set sysFont(2) "Times 8 bold"
		set sysFont(3) "Times 8 bold"
		set sysFont(4) {"Times i" 9}
		set sysFont(5) "Times 7 bold"
		set sysFont(6) "Times 8 bold"
		set sysFont(7) "Times 10 bold"
		set FTPfont(0) 12
		set FTPfont(1) 11
		set FTPfont(2) 10
		set FTPfont(3) 9
		set FTPfont(4) 8
		set FTPfont(5) 7
		set FTPfont(6) 6
	}
}

#NEW300105: multiple Language Support 4 Inquisitor
readAppText

#GUI erstellen
# Create TopLevelWindow (Form)
wm title . "Inquisitor"
wm iconname . "FIQ"
wm protocol . WM_DELETE_WINDOW {leavePRG 0}
wm minsize . 800 612
wm maxsize . [winfo screenwidth .] [winfo screenheight .]
tk_setPalette background $backColor foreground $fgColor disabledForeground $normLight disabledBackground $backColor

#Set StyleThemeColors (Set ttk::label for Windoze cause Problems with normal Labels, but they can be sizted !)
if {$winSYS==1} {
  #WinDoof (label MUSS aus tile importiert werden, da sonst die labels "verschwinden")
  #namespace import -force ttk::scrollbar ttk::combobox ttk::text ttk::checkbutton ttk::label ttk::button ttk::frame ttk::notebook
  namespace import -force ttk::scrollbar ttk::combobox ttk::text ttk::checkbutton ttk::label ttk::notebook ttk::radio
	package require mkZiplib 1.0
} else {
  namespace import -force ttk::scrollbar ttk::combobox ttk::text ttk::checkbutton ttk::frame ttk::notebook
}
tile::setTheme step
#ggf. unter Windoof auch ttk::button aufnehmen !
style map "." -foreground [list disabled $normLight] -background [list {active !disabled} $normLight]







style default "." -foreground $fgColor -background $backColor -troughcolor $listColor -selectbackground $normLight -activebg $etryBack
style map TScrollbar -background [list disabled $backColor active $normLight] -foreground [list disabled $etryBack]
style map TText -background [list disabled $backColor active $normLight] -foreground [list disabled $normLight]
style default TCheckbutton -indicatorrelief groove -indicatorcolor $normLight -borderwidth 2
style map TCheckbutton -indicatorrelief {pressed ridge} -indicatorcolor [list disabled $backColor active $etryBack] -background [list disabled $backColor active $etryBack] -foreground [list disabled $normLight]
style map TLabel -background [list disabled $backColor active $normLight] -foreground [list disabled $normLight]
style default TNotebook.Tab -background $backColor
style map TNotebook.Tab -background [list selected $backColor active $normLight]

if {$winSYS==0} {
	if {$FIQexe>0} {
		catch {file join $starkit::topdir world4.xpm} icon
#catch {file join $starkit::topdir Inquisitor.png} icon
		#catch {file join $starkit::topdir fsXlogo3.xpm} icon
		#catch {file join $starkit::topdir fsXlogo3b.xpm} mask
	} else {
		set icon [string trim $homeDir]/Icons/world4.xpm
#set icon [string trim $homeDir]/Icons/Inquisitor.png
		#set icon [string trim $homeDir]/fsXlogo3.xpm
		#set mask [string trim $homeDir]/fsXlogo3b.xpm
	}
	wm iconbitmap . @$icon
#image create photo imTest -file $icon
#wm iconphoto . imTest
	#wm iconmask . @$mask
}

#Set MainWindowSize
wm geometry . "800x612"

# Menus, Buttons, EditBoxen, etc.
#frame .mbar -borderwidth 2 -relief raised -background $backColor
label .mbar -borderwidth 2 -relief raised -background $backColor
pack .mbar -side top -fill x

set ScrewRelief sunken
label .mbar.imScrew -image imScrews -relief $ScrewRelief -background $backColor -borderwidth 1 -cursor sb_up_arrow
pack .mbar.imScrew -in .mbar -side left -padx 3
#NEW051205: shrink MenuBar
bind .mbar.imScrew <1> {shrinkMBar}

label .mbar.imScrew2 -image imScrews -relief $ScrewRelief -background $backColor -borderwidth 1 -cursor sb_up_arrow
pack .mbar.imScrew2 -in .mbar -side right -padx 4

bind .mbar.imScrew2 <1> {shrinkMBar}

# Menu: File (Open/Refresh/Exit)
menubutton .mbar.file -text $appText(.mbar.file) -underline 0 -menu .mbar.file.m -relief $mainGroove -foreground $fgColor -background $backColor -activebackground $normLight -activeforeground white -font $sysFont(0)
pack .mbar.file -side left -padx 2
set m [menu .mbar.file.m -tearoff 0 -activeforeground $htmlFG -foreground $fgColor]
$m add command -label $appText(.mbar.file.0) -underline 0 -command {catch {exec ${homeDir}Inquisitor &} err} -image imWorld2 -compound left -font $sysFont(0) -foreground $fgColor
$m add separator

$m add cascade -label $appText(.mbar.file.1) -underline 0 -menu $m.load -image imLoad -compound left -font $sysFont(0) -foreground $fgColor
menu $m.load -tearoff 0  -activeforeground $htmlFG -foreground $fgColor
	$m.load add command -label $appText(.mbar.file.1.1) -underline 0 -command {LoadPage ""} -image imFTopen -compound left -font $sysFont(0) -foreground $fgColor
	$m.load add command -label $appText(.mbar.file.1.2) -underline 0 -command LoadHistory -image imLoadHist -compound left -font $sysFont(0) -foreground $fgColor
	$m.load add command -label $appText(.mbar.file.1.3) -underline 0 -command {LoadScript ""} -image imImport -compound left -font $sysFont(0) -foreground $fgColor

$m add cascade -label $appText(.mbar.file.2) -underline 0 -menu $m.save -image imSave -compound left -font $sysFont(0) -foreground $fgColor
menu $m.save -tearoff 0  -activeforeground $htmlFG -foreground $fgColor
$m.save add command -label $appText(.mbar.file.2.1) -underline 0 -command SavePage -image imFTfolder -compound left -font $sysFont(0)
$m.save add command -label $appText(.mbar.file.2.2) -underline 0 -command SaveHistory -image imSaveHist -compound left -font $sysFont(0) -foreground $fgColor
$m.save add command -label $appText(.mbar.file.2.3) -underline 0 -command {SaveScript ""} -image imExport -compound left -font $sysFont(0) -foreground $fgColor
$m.save add command -label $appText(.mbar.file.9.3) -underline 0 -command {sendDesktop $urltext ""} -image imLink -compound left -font $sysFont(0) -foreground $fgColor
$m add separator

#NEW080907: SendTo Desktop/Application
$m add cascade -label $appText(.mbar.file.9) -underline 0 -menu $m.sendto -image imExec -compound left -font $sysFont(0) -foreground $fgColor
menu $m.sendto -tearoff 0 -activeforeground $htmlFG -foreground $fgColor
$m.sendto add command -label $appText(.mbar.file.9.2) -underline 0 -command {sendDesktop $urltext "[string trimright $userDir /]/Desktop/"} -image imDesktop -compound left -font $sysFont(0) -foreground $fgColor
#$m.sendto add command -label $appText(.mbar.file.9.3) -underline 0 -command {sendDesktop $urltext ""} -image imFTfolder -compound left -font $sysFont(0) -foreground $fgColor
$m.sendto add command -label $appText(.mbar.file.9.1) -underline 0 -image imRemote -compound left -font $sysFont(0) -foreground $fgColor -command {
      if {$winSYS==1} {
      #Windoof
	    catch {eval exec [auto_execok start] [list $urltext] &}
      } else {
      #Linux
            foreach browser {firefox konqueror mozilla netscape} {
	            set binary [lindex [auto_execok $browser] 0]
	            if {[string length $binary]} {
	                catch {exec $binary $url &}
	                break
	            }
	    }
      }
}

#NEW080907: Import/Export Bookmarks
$m add cascade -label $appText(.mbar.file.8) -underline 0 -menu $m.impexp -image imBookmark -compound left -font $sysFont(0) -foreground $fgColor
menu $m.impexp -tearoff 0 -activeforeground $htmlFG -foreground $fgColor
$m.impexp add command -label $appText(.mbar.file.8.1) -underline 0 -command importBook -image imForw -compound left -font $sysFont(0) -foreground $fgColor
$m.impexp add command -label $appText(.mbar.file.8.2) -underline 0 -command exportBook -image imBack -compound left -font $sysFont(0) -foreground $fgColor

#NEW090907: Print Text
#$m add separator
#$m add command -label $appText(.mbar.file.3) -underline 1 -command {ezPrint} -image imPrint -compound left -font $sysFont(0) -foreground $fgColor

$m add separator
$m add command -label $appText(.mbar.file.7) -underline 1 -command {leavePRG 0} -activebackground yellow -image imExit -compound left -font $sysFont(0) -foreground $fgColor

#NEW090907: EditMenu
#event generate . <Control-x>
menubutton .mbar.edit -text $appText(.mbar.edit) -underline 0 -menu .mbar.edit.m -relief $mainGroove -foreground $fgColor -background $backColor -activebackground $normLight -activeforeground white -font $sysFont(0)
pack .mbar.edit -side left -padx 2
set m [menu .mbar.edit.m -tearoff 0 -activeforeground $htmlFG -foreground $fgColor]
$m add command -label $appText(.mbar.edit.1) -underline 0 -command {event generate . <Control-x>} -image imCut -compound left -font $sysFont(0) -foreground $fgColor
$m add command -label $appText(.mbar.edit.2) -underline 0 -command {event generate . <Control-c>} -image imCopy -compound left -font $sysFont(0) -foreground $fgColor
$m add command -label $appText(.mbar.edit.3) -underline 0 -command {event generate . <Control-v>} -image imPaste -compound left -font $sysFont(0) -foreground $fgColor
$m add separator
$m add command -label $appText(.mbar.edit.4) -underline 0 -command {event generate . <Control-a>} -image imPencil -compound left -font $sysFont(0) -foreground $fgColor
$m add separator
$m add command -label $appText(.mbar.edit.5) -underline 0 -command searchMode -image imFind -compound left -font $sysFont(0) -foreground $fgColor
$m add separator
$m add command -label $appText(.mbar.edit.8) -underline 1 -image imFilter -compound left -font $sysFont(0) -foreground $fgColor -command {
   set urltext [string trimright  $homeDir /]/FIQ.FIL
   displayHTML $urltext
}

$m add cascade -label $appText(.mbar.edit.6) -underline 0 -menu $m.crtMirror -activebackground LightBlue -image imMirror -compound left -font $sysFont(0) -foreground $fgColor
	menu $m.crtMirror -tearoff 0 -activeforeground $htmlFG -foreground $fgColor
	$m.crtMirror add command -label $appText(.mbar.edit.6.1) -command {MirrorPage 0} -activebackground green -font $sysFont(0) -foreground $fgColor
	$m.crtMirror add command -label $appText(.mbar.edit.6.2) -command {MirrorPage 1} -activebackground yellow -font $sysFont(0) -foreground $fgColor
	$m.crtMirror add command -label $appText(.mbar.edit.6.3) -command {MirrorSite 1} -activebackground red -font $sysFont(0) -foreground $fgColor

$m add cascade -label $appText(.mbar.edit.7) -underline 0 -menu $m.crtHistory -image imHistory -compound left -font $sysFont(0) -foreground $fgColor
	menu $m.crtHistory -tearoff 0  -foreground white -activeforeground $htmlFG -foreground $fgColor
	$m.crtHistory add command -label $appText(.mbar.edit.7.1) -underline 0 -command {scanHistory 0} -image imUp -compound left -font $sysFont(0) -foreground $fgColor
	$m.crtHistory add command -label $appText(.mbar.edit.7.2) -underline 0 -command {scanHistory 1} -image imDown -compound left -font $sysFont(0) -foreground $fgColor
	$m.crtHistory add separator
#NEW161006: url2sel (same as right on ComboArrowBTN), url2clip, url2application
	$m.crtHistory add command -label $appText(.mbar.edit.7.7) -underline 0 -image imMailGet -compound left -font $sysFont(0) -foreground $fgColor -command {
	     set merk $linkmark
	     set linkmark 1
	     AddSelected $urltext 0
	     set linkmark $merk
	}
	$m.crtHistory add command -label $appText(.mbar.edit.7.8) -underline 0 -image imMailList -command {clipboard clear; clipboard append $urltext} -compound left -font $sysFont(0) -foreground $fgColor
	$m.crtHistory add separator
	$m.crtHistory add command -label $appText(.mbar.edit.7.3) -underline 0 -command {selectALL 0; scanHistory 0; clearSelected} -image imExtract -compound left -font $sysFont(0) -foreground $fgColor
	$m.crtHistory add separator
#Without Function (for the moment) !!!!!!!!!!
	$m.crtHistory add command -label $appText(.mbar.edit.7.4) -underline 0 -command {book2select} -image imBook2Hist -compound left -font $sysFont(0) -foreground $fgColor
	$m.crtHistory add command -label $appText(.mbar.edit.7.5) -underline 0 -command {select2book} -image imHist2Book -compound left -font $sysFont(0) -foreground $fgColor
	$m.crtHistory add separator
	$m.crtHistory add command -label $appText(.mbar.edit.7.6) -underline 0 -command clrHistory -image imCLRlist -compound left -font $sysFont(0) -foreground $fgColor

$m add separator
$m add cascade -label $appText(.mbar.edit.9) -underline 1 -menu $m.clrCache -activebackground red -image imCache -compound left -font $sysFont(0) -foreground $fgColor
	menu $m.clrCache -tearoff 0 -activeforeground $htmlFG -foreground $fgColor
	$m.clrCache add command -label $appText(.mbar.edit.9.1) -command {clearCache 2} -font $sysFont(0) -foreground $fgColor
	$m.clrCache add command -label $appText(.mbar.edit.9.2) -command {clearCache 3} -activebackground green -font $sysFont(0) -foreground $fgColor
	$m.clrCache add command -label $appText(.mbar.edit.9.3) -activebackground yellow -command {clearCache 1} -font $sysFont(0) -foreground $fgColor
	$m.clrCache add separator
	$m.clrCache add command -label $appText(.mbar.edit.9.5) -activebackground orange -command {clearCache 4} -font $sysFont(0) -foreground $fgColor
	$m.clrCache add separator
	$m.clrCache add command -label $appText(.mbar.edit.9.4) -activebackground red -command {clearCache 0} -font $sysFont(0) -foreground $fgColor

#Menu Tools
menubutton .mbar.tools -text $appText(.mbar.tools) -underline 0 -menu .mbar.tools.m -relief $mainGroove -foreground $fgColor -background $backColor -activebackground $normLight -activeforeground white -font $sysFont(0)
pack .mbar.tools -side left -padx 2
set m [menu .mbar.tools.m -tearoff 0 -activeforeground $htmlFG -foreground $fgColor]
#CHNG090907: InquisitorMode
$m add cascade -label $appText(.mbar.tools.3) -underline 0 -menu $m.fiqMode -image imTools -compound left -font $sysFont(0) -foreground $fgColor
	menu $m.fiqMode -tearoff 0  -activeforeground $htmlFG -foreground $fgColor
	$m.fiqMode add radiobutton -label $appText(.mbar.tools.3.1) -underline 0 -variable MMode -value 2 -command {ChangeMode 2} -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.fiqMode add radiobutton -label $appText(.mbar.tools.3.2) -underline 0 -variable MMode -value 3 -command {ChangeMode 3} -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.fiqMode add radiobutton -label $appText(.mbar.tools.3.3) -underline 0 -variable MMode -value 4 -command {ChangeMode 4} -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor

#NEW030711: hide MenuBar
$m add command -label $appText(.mbar.tools.1) -underline 0 -command {set hideMenu 1; pack forget .mbar} -image imFTPsort -compound left -font $sysFont(0) -foreground $fgColor

$m add separator
$m add command -label $appText(.mbar.tools.2) -underline 0 -command dispBook -image imBookOpen -compound left -font $sysFont(0) -foreground $fgColor
$m add command -label $appText(.mbar.tools.7) -underline 1 -command {displayHTML $urltext} -image imFThtml -compound left -font $sysFont(0) -foreground $fgColor
$m add separator
$m add command -label $appText(.mbar.tools.6) -underline 1 -image imCamera -compound left -command {snapshot $HTMLwin($activeHTM)} -font $sysFont(0) -foreground $fgColor
#NEW280505
$m add command -label $appText(.mbar.tools.10) -underline 1 -command {swapPage} -image imSwap -compound left -font $sysFont(0) -foreground $fgColor
$m add separator
#NEW270805: freezeURL
$m add command -label $appText(.mbar.tools.11) -underline 1 -command {setFreeze} -image imFreeze -compound left -font $sysFont(0) -foreground $fgColor
$m add command -label $appText(.mbar.tools.8) -underline 1 -command SetDefColor -image imPalette -compound left -font $sysFont(0) -foreground $fgColor

#Menu Options
menubutton .mbar.options -text $appText(.mbar.options) -underline 0 -menu .mbar.options.m -relief $mainGroove -foreground $fgColor -background $backColor -activebackground $normLight -activeforeground white -font $sysFont(0)
pack .mbar.options -side left -padx 2
set m [menu .mbar.options.m -tearoff 0 -foreground white -activeforeground $htmlFG -foreground $fgColor]
#Image-Options
$m add cascade -label $appText(.mbar.options.1) -underline 0 -menu $m.background -image imFTbackground -compound left -font $sysFont(0) -foreground $fgColor
	menu $m.background -tearoff 0 -activeforeground $htmlFG -foreground $fgColor
	$m.background add checkbutton -label $appText(.mbar.options.1.1) -variable showImages -command Refresh -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
#OUT041206:
#	$m.background add checkbutton -label $appText(.mbar.options.1.2) -variable renderIMG -command renderActivate -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.background add checkbutton -label $appText(.mbar.options.1.3) -variable tableOnly -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.background add checkbutton -label $appText(.mbar.options.1.4) -variable keepColor -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.background add checkbutton -label $appText(.mbar.options.1.5) -variable FTPpreview -command {enterFTP [chkFTPactive]} -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.background add checkbutton -label $appText(.mbar.options.1.6) -variable crtThumbs -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.background add checkbutton -label $appText(.mbar.options.1.7) -variable backImage -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.background add checkbutton -label $appText(.mbar.options.1.8) -variable tempIcons -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	# -state disabled
#GIF-Animations
$m add cascade -label $appText(.mbar.options.2) -underline 0 -menu $m.anim -image imFTvideo -compound left -font $sysFont(0) -foreground $fgColor
	menu $m.anim -tearoff 0 -activeforeground $htmlFG -foreground $fgColor
	$m.anim add checkbutton -label $appText(.mbar.options.2.1) -variable playAnim -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.anim add checkbutton -label $appText(.mbar.options.2.2) -variable onceAnim -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.anim add checkbutton -label $appText(.mbar.options.2.3) -variable useVideo -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.anim add checkbutton -label $appText(.mbar.options.2.4) -variable useApplet -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.anim add checkbutton -label $appText(.mbar.options.2.5) -variable useBlink -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
#Play Sounds
$m add cascade -label $appText(.mbar.options.3) -underline 0 -menu $m.sound -image imMusic -compound left -font $sysFont(0) -foreground $fgColor
	menu $m.sound -tearoff 0 -activeforeground $htmlFG -foreground $fgColor
	$m.sound add checkbutton -label $appText(.mbar.options.3.1) -variable playSounds -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.sound add checkbutton -label $appText(.mbar.options.3.2) -variable onceSounds -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
#General HTML-Options
$m add cascade -label $appText(.mbar.options.4) -underline 0 -menu $m.html -image imHTMsource -compound left -font $sysFont(0) -foreground $fgColor
	menu $m.html -tearoff 0 -activeforeground $htmlFG -foreground $fgColor
#CHANGE110605:
	#$m.html add checkbutton -label $appText(.mbar.options.4.0) -variable zoomText -command Refresh -font $sysFont(0) -selectcolor $etryBack
	$m.html add checkbutton -label $appText(.mbar.options.4.0) -variable zoomText -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.html add checkbutton -label $appText(.mbar.options.4.11) -variable useSiteFonts -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.html add checkbutton -label $appText(.mbar.options.4.1) -variable underlineHyper -command ChangeUnderline -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.html add checkbutton -label $appText(.mbar.options.4.2) -variable showTableStruct -command ShowTableStruct -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.html add checkbutton -label $appText(.mbar.options.4.9) -variable tableCorrect -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.html add checkbutton -label $appText(.mbar.options.4.3) -variable changeBack -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
#NEW240905: AutoScroll
	$m.html add checkbutton -label $appText(.mbar.options.4.10) -variable autoscroll -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
#	$m.html add checkbutton -label $appText(.mbar.options.4.4) -variable useApplet -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.html add checkbutton -label $appText(.mbar.options.4.5) -variable useFrames -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
#	$m.html add checkbutton -label $appText(.mbar.options.4.6) -variable askServer -font $sysFont(0) -selectcolor $etryBack -state disabled -foreground $fgColor
	$m.html add checkbutton -label $appText(.mbar.options.4.7) -variable thumbsOnly -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor -command {
		if {$thumbsOnly==0} {
			.tile.bottom.pane.f3.box.lbType configure -background $backColor -image imFTunknown
			chkSelection [.tile.bottom.pane.f3.box.spStype get]
			setLED blue
			#goEnter
		} else {
			.tile.bottom.pane.f3.box.lbType configure -background red -image imOPTthumbnail
			.mbar.lbAnim configure -image imTuxUnallowed
			setLED magenta
			dispMSG $msgText(onlyThumbs)
			set shiftPress 0
			goEnter
		}
	}
#DEACTIVE: 260306
#	$m.html add checkbutton -label $appText(.mbar.options.4.8) -variable silentHTM -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	#$m.html add checkbutton -label $appText(.mbar.options.4.9) -variable tableCorrect -font $sysFont(0) -selectcolor $etryBack
#Quick Inquisitor Options
$m add cascade -label $appText(.mbar.options.5) -underline 0 -menu $m.fiq -image imWorld -compound left -font $sysFont(0) -foreground $fgColor
	menu $m.fiq -tearoff 0 -activeforeground $htmlFG -foreground $fgColor
	$m.fiq add checkbutton -label $appText(.mbar.options.5.1) -variable quickSave -command QSaskActivate -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.fiq add checkbutton -label $appText(.mbar.options.5.2) -variable fsizeWarn -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.fiq add checkbutton -label $appText(.mbar.options.5.10) -variable otherWarn -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.fiq add checkbutton -label $appText(.mbar.options.5.3) -variable FTPask -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
        $m.fiq add checkbutton -label $appText(.mbar.options.5.4) -variable bHelp -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
        $m.fiq add checkbutton -label $appText(.mbar.options.5.9) -variable askServer -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.fiq add checkbutton -label $appText(.mbar.options.5.5) -variable ignoreReDir -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor -command {
	if {$ignoreReDir==1} {
                      .mbar.lbAnim configure -image imTuxInfiltrate
                     dispMSG $msgText(mode.change.6)
              } else {
                     .mbar.lbAnim configure -image imAnim
                     dispMSG $msgText(mode.change.3)
              }
        }
    $m.fiq add checkbutton -label $appText(.mbar.options.5.0) -variable textIMG -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.fiq add checkbutton -label $appText(.mbar.options.5.6) -variable kidZprotect -command KidZmodeActivate -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.fiq add checkbutton -label $appText(.mbar.options.5.7) -variable winPos -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor
	$m.fiq add checkbutton -label $appText(.mbar.options.5.8) -variable autoConfig -font $sysFont(0) -selectcolor $etryBack -foreground $fgColor

$m add separator
#Inquisitor Setup
$m add command -label $appText(.mbar.options.6) -underline 0 -command {confFIQ} -image imConfigure -compound left -font $sysFont(0) -foreground $fgColor

#Menu Help
menubutton .mbar.help -text $appText(.mbar.help) -underline 0 -menu .mbar.help.m -relief $mainGroove -foreground $fgColor -background $backColor -activebackground $normLight -activeforeground white -font $sysFont(0)
pack .mbar.help -side left -padx 2
set m [menu .mbar.help.m -tearoff 0 -foreground white -activeforeground $htmlFG -foreground $fgColor]
$m add command -label $appText(.mbar.help.1) -underline 0 -command {ChangeMode 3; HELPinhalt} -image imHelp -compound left -font $sysFont(0) -foreground $fgColor
$m add command -label $appText(.mbar.help.2) -underline 0 -command {ChangeMode 3; HELPgeneral} -image imInfohelp -compound left -font $sysFont(0) -foreground $fgColor
$m add command -label $appText(.mbar.help.3) -underline 0 -command {ChangeMode 3; HELPnews} -image imIdea -compound left -font $sysFont(0) -foreground $fgColor
$m add separator
$m add command -label $appText(.mbar.help.5) -underline 0 -command statistics -image imStatistic -compound left -font $sysFont(0) -foreground $fgColor
$m add separator
$m add command -label $appText(.mbar.help.4) -underline 0 -command HELPabout -image imInfo -compound left -font $sysFont(0) -foreground $fgColor

button .mbar.clrScreen -underline 0 -command {set cookie ""; clearPage} -image imClrScreen -background $backColor -activebackground $normLight -width $mainButtons -height $mainButtons -borderwidth $mainButtonSize
pack .mbar.clrScreen -side left -padx 5
bind .mbar.clrScreen <3> {buttonPress .mbar.clrScreen; clearCache 3}
button .mbar.home -underline 0 -command {goHome} -image imHome -background $backColor -activebackground $normLight -width $mainButtons -height $mainButtons -borderwidth $mainButtonSize
pack .mbar.home -side left -padx 2
bind .mbar.home <3> {buttonPress .mbar.home; clearCache 2}
button .mbar.reload -underline 0 -command {goEnter} -image imReloadPNG -background $backColor -activebackground $normLight -width $mainButtons -height $mainButtons -borderwidth $mainButtonSize

pack .mbar.reload -side left -padx 2
bind .mbar.reload <3> {buttonPress .mbar.reload; ReLoad}

button .mbar.back -underline 0 -command BackPage -image imBackPNG -background $backColor -activebackground $normLight -width $mainButtons -height $mainButtons -borderwidth $mainButtonSize
pack .mbar.back -side left -padx 2
bind .mbar.back <3> {buttonPress .mbar.back; jumPage first}
button .mbar.forw -underline 0 -command ForwPage -image imForwPNG -background $backColor -activebackground $normLight -width $mainButtons -height $mainButtons -borderwidth $mainButtonSize
pack .mbar.forw -side left -padx 2
bind .mbar.forw <3> {buttonPress .mbar.forw; jumPage last}
button .mbar.stop -underline 0 -command {Stop $token; .mbar.stop configure -background $backColor} -image imStopPNG -background $backColor -activebackground $normLight -width $mainButtons -height $mainButtons -borderwidth $mainButtonSize
pack .mbar.stop -side left -padx 5
bind .mbar.stop <3> {buttonPress .mbar.stop; addFilter}

# Zoom Fonsize
#button .mbar.zoomin -underline 0 -command ZoomIn -image imZoomInPNG -background $backColor -activebackground $normLight -width $mainButtons -height $mainButtons -borderwidth $mainButtonSize
button .mbar.zoomin -underline 0 -command ZoomIn -image imZoomInPNG -background $backColor -activebackground $normLight -width $miniButtons -height $miniButtons -borderwidth $mainButtonSize
pack .mbar.zoomin -side left -padx 2 -in .mbar
bind .mbar.zoomin <3> {buttonPress .mbar.zoomin; setGamma "light"}
button .mbar.zoomout -underline 0 -command ZoomOut -image imZoomOutPNG -background $backColor -activebackground $normLight -width $miniButtons -height $miniButtons -borderwidth $mainButtonSize
pack .mbar.zoomout -side left -padx 2 -in .mbar
bind .mbar.zoomout <3> {buttonPress .mbar.zoomout; setGamma "dark"}
button .mbar.zoom -underline 0 -command Zoom -image imZoomPNG -background $backColor -activebackground $normLight -width $miniButtons -height $miniButtons -borderwidth $mainButtonSize
pack .mbar.zoom -side left -padx 2 -in .mbar
bind .mbar.zoom <3> {buttonPress .mbar.zoom; setGamma 1}

#Tux Penguin (stillImage & AnimLR)
label .mbar.lbAnim -image imAnim -relief sunken -background #B2C0DC -cursor question_arrow
pack .mbar.lbAnim -in .mbar -side right -padx 3

#FileProgressBar, oben (kleine StatusBar whrend FileTransfer)
canvas .mbar.prgFile -height 2 -relief sunken -borderwidth 1 -background $normLight -selectforeground $backColor -highlightbackground $backColor
pack .mbar.prgFile -in .mbar -side bottom -padx 3 -pady 2 -fill x -expand true
.mbar.prgFile create rectangle 0 0 0 0 -fill $barColor -tags proFile

# Statusanzeige
label .mbar.lbText -text "Status:" -foreground $fgColor -background $backColor -font $sysFont(0)
label .mbar.lbStatus -textvariable infostatus -font $sysFont(1) -foreground $fgColor -background $backColor
# -relief sunken -borderwidth 1

#NEW071104: StatusLED
label .mbar.lbLED -relief flat -borderwidth 0 -foreground $backColor -background $backColor -image imLEDblue1
pack .mbar.lbLED -in .mbar -side left -padx 3 -pady 1

pack .mbar.lbText .mbar.lbStatus -in .mbar -side left -fill x -padx 1 -pady 1
#pack .mbar.lbStatus .mbar.lbText -in .mbar -side left -fill x -padx 1 -pady 1

#pack .mbar.lbText -in .mbar -side left -padx 1 -pady 1
#pack .mbar.lbStatus -in .mbar -side left -fill x -padx 1 -pady 1

# URL-EditBox (NormalMode)
frame .head -background $backColor
pack .head -anchor w -side top -fill x -padx 1 -pady 1

#Frame1
#ComboBox URLentry (BWidget Library)
#URLZeile (NormalMode)
frame .head.dispUrl -background $backColor

ComboBox .head.dispUrl.url \
	-textvariable urltext \
	-takefocus true \
	-modifycmd {preSolve} \
	-background $backColor \
	-foreground $fgColor \
	-entrybg $etryBack \
	-highlightcolor $normLight \
	-highlightbackground white \
	-selectbackground $normLight \
	-selectforeground $htmlFG \
	-values $histry \
	-hottrack true \
	-autocomplete true \
	-expand tab \
	-exportselection true \
	-images $imgHistry

#NEW: freezeURL on RightClick in URL
bind .head.dispUrl.url.e <3> {
	if {!$active} {setFreeze}
}
#NEW161006: right Mouse on Arrow of ComboBox adds URL 2 Selection
bind .head.dispUrl.url.a.c <3> {
#     buttonPress .head.dispUrl.url.a
     if {!$active} {
	     set merk $linkmark
	     set linkmark 1
	     AddSelected $urltext 0
	     set linkmark $merk
     }
}

#puts [.head.dispUrl.url getlistbox]
#.head.dispUrl.url.shell.listb
#bind .head.dispUrl.url.c.c <3> {
#     puts "ListBox clicked !"
#}

label .head.dispUrl.lbUrl -text "URL:" -foreground $fgColor -background $backColor -relief ridge -font $sysFont(0) -width 4 -height 1
#Klick auf URL links (Bookmarks)/rechts (URL2Selection)
bind .head.dispUrl.lbUrl <1> {
	if {!$active} {
		.head.dispUrl.lbUrl configure -relief sunken; dispBook
	}
}
bind .head.dispUrl.lbUrl <3> {
	if {!$active} {AddURL $urltext}
}
button .head.dispUrl.btClrUrl -underline 0 -command {set urltext ""; set cookie ""; set cancel 0; focus .head.dispUrl.url.e} -image imClrURL -background $backColor -activebackground $normLight -disabledforeground $backColor
bind .head.dispUrl.btClrUrl <3> {buttonPress .head.dispUrl.btClrUrl; clrHistory}
button .head.dispUrl.btHtml -command {LoadPage ""} -image imSelDir -background $backColor -activebackground $normLight
bind .head.dispUrl.btHtml <3> {
	if {!$active} {buttonPress .head.dispUrl.btHtml; fileSave 1}
}
button .head.dispUrl.btEnter -image imEnter -background $backColor -activebackground $normLight -command {preSolve}
#RightMouse on "Enter"-Button cuts away reDirected Links
bind .head.dispUrl.btEnter <3> {
	if {!$active} {
		buttonPress .head.dispUrl.btEnter
		set cookie ""
		set urltext [upperHTTP [cutLink $urltext]]
	}
}
pack .head.dispUrl.lbUrl -in .head.dispUrl -padx 3 -side left
pack .head.dispUrl.btClrUrl -in .head.dispUrl -side left
pack .head.dispUrl.btHtml .head.dispUrl.btEnter -in .head.dispUrl -side right
pack .head.dispUrl.url -in .head.dispUrl -padx 1 -fill x -expand true

#NEU170404: URL-Zeile (ScannerMode)
frame .head.scanUrl -background $backColor
label .head.scanUrl.lbUrl -text "Scan URL:" -foreground white -background $backColor -font $sysFont(0)
button .head.scanUrl.btHtml -command {LoadPage ""} -image imSelDir -background $backColor -activebackground $normLight
label .head.scanUrl.lbStart -foreground $fgColor -background $backColor -relief groove -anchor w
label .head.scanUrl.lbValue -foreground Green -background $backColor -relief sunken -cursor hand2
label .head.scanUrl.lbEnd -foreground $fgColor -background $backColor -relief groove -anchor w
pack .head.scanUrl.lbUrl -in .head.scanUrl -side left
pack .head.scanUrl.btHtml -in .head.scanUrl -side right
pack .head.scanUrl.lbStart -side left -padx 2
pack .head.scanUrl.lbValue -side left
pack .head.scanUrl.lbEnd -side left -fill x -expand true -padx 2

#TEST101010: Click on ScanEnd
#bind .head.scanUrl.lbEnd <1> {
#     if {$selStop < [string length $urltext]} {
#         set selStop [expr $selStop + 1]
#         set scanLen [expr $selStop - $selStart]
#         if {$scanLen <= 0} {set scanLen 1}
#         set URLvalue [string range $urltext $selStart $selStop]
#         .tile.bottom.pane.f2.box.scanLen set $scanLen
#         .head.scanUrl.lbStart configure -text [string range $urltext 0 $selStart] -width $selStart
#         .head.scanUrl.lbValue configure -text $URLvalue -width $scanLen
#         .head.scanUrl.lbEnd configure -text [string range $urltext [expr $selStop + 1] [string length $urltext]]
#     }
#}
#bind .head.scanUrl.lbEnd <3> {
#      if {$selStop > 0} {
#         set selStop [expr $selStop - 1]
#         set scanLen [expr $selStop - $selStart]
#         if {$scanLen <= 0} {set scanLen 1}
#         set URLvalue [string range $urltext $selStart $selStop]
#         .tile.bottom.pane.f2.box.scanLen set $scanLen
#         .head.scanUrl.lbStart configure -text [string range $urltext 0 $selStart] -width $selStart
#         .head.scanUrl.lbValue configure -text $URLvalue -width $scanLen
#         .head.scanUrl.lbEnd configure -text [string range $urltext [expr $selStop + 1] [string length $urltext]]
#      }
#}
# Set ScanStart
#bind .head.scanUrl.lbStart <1> {
#      if {$selStart < $selStop} {
#         set selStart [expr $selStart + 1]
#         set scanLen [expr $selStop - $selStart]
#         if {$scanLen <= 0} {set scanLen 1}
#         set URLvalue [string range $urltext $selStart $selStop]
#         .tile.bottom.pane.f2.box.scanLen set $scanLen
#         .head.scanUrl.lbStart configure -text [string range $urltext 0 $selStart] -width $selStart
#         .head.scanUrl.lbValue configure -text $URLvalue -width $scanLen
#         .head.scanUrl.lbEnd configure -text [string range $urltext [expr $selStop + 1] [string length $urltext]]
#      }
#}
#bind .head.scanUrl.lbStart <3> {
#      if {$selStart > 0} {
#         set selStart [expr $selStart - 1]
#         set scanLen [expr $selStop - $selStart]
#         if {$scanLen <= 0} {set scanLen 1}
#         set URLvalue [string range $urltext $selStart $selStop]
#         .tile.bottom.pane.f2.box.scanLen set $scanLen
#         .head.scanUrl.lbStart configure -text [string range $urltext 0 $selStart] -width $selStart
#         .head.scanUrl.lbValue configure -text $URLvalue -width $scanLen
#         .head.scanUrl.lbEnd configure -text [string range $urltext [expr $selStop + 1] [string length $urltext]]
#      }
#}

#NEU170404: URL-Zeile (SearchMode)
#searchDoc (HTML nach Text durchsuchen)
frame .head.searchDoc -background $backColor
label .head.searchDoc.lbSearch -text $appText(.head.searchDoc.lbSearch) -foreground $fgColor -background $backColor -font $sysFont(0)
button .head.searchDoc.btClrSrc -underline 0 -command {set search ""} -image imClrURL -background $backColor -activebackground $normLight
#entry .head.searchDoc.etSearch -textvariable search -background $etryBack -foreground $fgColor -relief ridge
entry .head.searchDoc.etSearch -textvariable search -background LightYellow1 -foreground black -relief ridge
#ReturnTaste=Suche (an SuchEntry binden; SearchMode)
bind .head.searchDoc.etSearch <Return> {set sMerk [searchDoc $search $sMerk]}
bind .head.searchDoc.etSearch <Escape> {searchMode}
button .head.searchDoc.btEnter -image imEnter -background $backColor -activebackground $normLight -command {set sMerk [searchDoc $search $sMerk]}
button .head.searchDoc.btSearch -command searchMode -image imExitSearch -background $backColor -activebackground $normLight
pack .head.searchDoc.lbSearch .head.searchDoc.btClrSrc -side left
pack .head.searchDoc.btSearch .head.searchDoc.btEnter -side right
pack .head.searchDoc.etSearch -side left -fill x -expand true

#NEU300404: URL-Zeile (MkDirFTP)
frame .head.mkdirFTP -background $backColor
label .head.mkdirFTP.lbInput -text "MkDir:" -foreground $fgColor -background $backColor -font $sysFont(0)
button .head.mkdirFTP.btClrSrc -underline 0 -command {set FTPinput ""} -image imClrURL -background $backColor -activebackground $normLight
entry .head.mkdirFTP.etInput -textvariable FTPinput -background $backColor -foreground $fgColor -relief ridge
#ReturnTaste=Suche (an InputEntry binden; FTPmkDir)
bind .head.mkdirFTP.etInput <Return> {mkdirFTP [chkFTPactive]; inputMode}
bind .head.mkdirFTP.etInput <Escape> {inputMode}
button .head.mkdirFTP.btEnter -image imEnter -background $backColor -activebackground $normLight -command {mkdirFTP [chkFTPactive]}
button .head.mkdirFTP.btExit -command inputMode -image imExitSearch -background $backColor -activebackground $normLight
pack .head.mkdirFTP.lbInput .head.mkdirFTP.btClrSrc -side left
pack .head.mkdirFTP.btExit .head.mkdirFTP.btEnter -side right
pack .head.mkdirFTP.etInput -side left -fill x -expand true -pady 2

#NEU300404: URL-Zeile (renameFTP)
frame .head.renameFTP -background $backColor
label .head.renameFTP.lbInput -text "ReName:" -foreground $fgColor -background $backColor -font $sysFont(0)
button .head.renameFTP.btClrSrc -underline 0 -command {set FTPinput ""} -image imClrURL -background $backColor -activebackground $normLight
entry .head.renameFTP.etInput -textvariable FTPinput -background $backColor -foreground $fgColor -relief ridge
#ReturnTaste=Suche (an InputEntry binden; FTPmkDir)
bind .head.renameFTP.etInput <Return> {renameFTP [chkFTPactive]; renameMode}
bind .head.renameFTP.etInput <Escape> {renameMode}
button .head.renameFTP.btEnter -image imEnter -background $backColor -activebackground $normLight -command {renameFTP [chkFTPactive]}
button .head.renameFTP.btExit -command renameMode -image imExitSearch -background $backColor -activebackground $normLight
pack .head.renameFTP.lbInput .head.renameFTP.btClrSrc -side left
pack .head.renameFTP.btExit .head.renameFTP.btEnter -side right
pack .head.renameFTP.etInput -side left -fill x -expand true -pady 1

#Standardmig Frame1 (URL-Zeile) anzeigen
pack .head.dispUrl -in .head -side left -fill x -expand true

#NEU210404: WindowTiling (Top/Bottom)
panedwindow .tile -orient vertical -background $backColor -showhandle false -borderwidth 0 \
	-relief flat -sashrelief raised -sashwidth 3 -opaqueresize false
pack .tile -in . -side top -expand yes -fill both -padx 2

#TopFrame (Oben)
#frame .tile.top -width $resoX -height $resoY -background $backColor
frame .tile.top -background $backColor
pack .tile.top -in .tile -side left -fill both -expand true

#NEU060604: WindowTiling Bookmarks/HTML
frame .tile.top.html -background $backColor
panedwindow .tile.top.html.tile -orient horizontal -background $backColor -showhandle false \
	-borderwidth 0 -relief flat -sashrelief raised -sashwidth 3 -opaqueresize false
pack .tile.top.html.tile -in .tile.top.html -side left -fill both -expand true -padx 1

#BookmarkBrowserWindow (left)
frame .tile.top.html.tile.bookmark -background $backColor
frame .tile.top.html.tile.bookmark.editbox -background $backColor
button .tile.top.html.tile.bookmark.editbox.btClr -image imClrURL -background $backColor -activebackground $normLight -command {set bookName ""}
entry .tile.top.html.tile.bookmark.editbox.etName -textvariable bookName -background $backColor -foreground $fgColor -relief ridge
bind .tile.top.html.tile.bookmark.editbox.etName <Return> {renBook $merkBook $bookName}
pack .tile.top.html.tile.bookmark.editbox.btClr -in .tile.top.html.tile.bookmark.editbox -side left
pack .tile.top.html.tile.bookmark.editbox.etName -in .tile.top.html.tile.bookmark.editbox -side left -expand true -fill x
pack .tile.top.html.tile.bookmark.editbox -in .tile.top.html.tile.bookmark -side top -fill x
frame .tile.top.html.tile.bookmark.buttons -background $backColor
pack .tile.top.html.tile.bookmark.buttons -in .tile.top.html.tile.bookmark -side bottom -fill x

button .tile.top.html.tile.bookmark.buttons.addBook -text "Add Bookmark" -image imBookAdd -background $backColor -activebackground $normLight -borderwidth 1 -height 18 -command {addBook $urltext}
button .tile.top.html.tile.bookmark.buttons.editBook -text "Save Bookmark" -image imSaveHist -background $backColor -activebackground $normLight -borderwidth 1 -height 18 -command {saveBook}
button .tile.top.html.tile.bookmark.buttons.newFold -text "New Folder" -image imBookDir -background $backColor -activebackground $normLight -borderwidth 1 -height 18 -command {addFolder}
button .tile.top.html.tile.bookmark.buttons.delBook -text "Del Bookmark" -image imTrash -background $backColor -activebackground $normLight -borderwidth 1 -height 18 -command {clearBook}
button .tile.top.html.tile.bookmark.buttons.selBook -text "Bookmark2Selection" -image imBook2Hist -command {book2select} -background $backColor -activebackground $normLight -borderwidth 1 -height 18
button .tile.top.html.tile.bookmark.buttons.bookSel -text "Selection2Bookmark" -image imHist2Book -command {select2book} -background $backColor -activebackground $normLight -borderwidth 1 -height 18
#NEW090907: actualize FavIcons
button .tile.top.html.tile.bookmark.buttons.bookFav -text "Actualize FavIcons" -image imIcons -command {loadFavIcons} -background $backColor -activebackground $normLight -borderwidth 1 -height 18
button .tile.top.html.tile.bookmark.buttons.btExit -text "Exit Bookmarks" -image imClose -background $backColor -activebackground $normLight -borderwidth 1 -height 18 -command dispBook

pack .tile.top.html.tile.bookmark.buttons.addBook .tile.top.html.tile.bookmark.buttons.editBook -in .tile.top.html.tile.bookmark.buttons -side left -pady 1
pack .tile.top.html.tile.bookmark.buttons.newFold .tile.top.html.tile.bookmark.buttons.delBook -in .tile.top.html.tile.bookmark.buttons -side left -pady 1
pack .tile.top.html.tile.bookmark.buttons.selBook .tile.top.html.tile.bookmark.buttons.bookSel -in .tile.top.html.tile.bookmark.buttons -side left -pady 1
pack .tile.top.html.tile.bookmark.buttons.bookFav .tile.top.html.tile.bookmark.buttons.btExit -in .tile.top.html.tile.bookmark.buttons -side left -pady 1
frame .tile.top.html.tile.bookmark.frm
scrollbar .tile.top.html.tile.bookmark.frm.xscroll -orient horizontal -command {.tile.top.html.tile.bookmark.dir xview} -background $backColor
label .tile.top.html.tile.bookmark.frm.lbl -textvariable anzBook -relief sunken -foreground $etryBack -background $backColor -font $sysFont(0)
pack .tile.top.html.tile.bookmark.frm.lbl -in .tile.top.html.tile.bookmark.frm -side right -padx 1 -pady 1
pack .tile.top.html.tile.bookmark.frm.xscroll -in .tile.top.html.tile.bookmark.frm -side left -fill x -expand true
scrollbar .tile.top.html.tile.bookmark.yscroll -orient vertical -command {.tile.top.html.tile.bookmark.dir yview} -background $backColor
pack .tile.top.html.tile.bookmark.frm -in .tile.top.html.tile.bookmark -side bottom -fill x
pack .tile.top.html.tile.bookmark.yscroll -in .tile.top.html.tile.bookmark -side right -fill y
#SelectBackground muss IMMER gleich Background sein, damit MouseSelection nicht sichtbar ist
text .tile.top.html.tile.bookmark.dir -cursor {} -wrap none -relief sunken \
	-xscrollcommand [subst ".tile.top.html.tile.bookmark.frm.xscroll set"] \
	-yscrollcommand [subst ".tile.top.html.tile.bookmark.yscroll set"] \
	-height 29 -width 118 -font $sysFont(3) -cursor {} -selectborderwidth 0 \
	-foreground $fgColor -background $listColor -exportselection false -state disabled -selectbackground $listColor
        # -selectforeground $fgColor
pack .tile.top.html.tile.bookmark.dir -in .tile.top.html.tile.bookmark -side left -fill both -expand true

#mainHTMLframe (Pane2:HTMLleft1)
frame .tile.top.html.tile.html
panedwindow .tile.top.html.tile.html.pane -orient horizontal -background $backColor -showhandle false \
	-borderwidth 0 -relief flat -sashrelief raised -sashwidth 3 -opaqueresize false
pack .tile.top.html.tile.html.pane -in .tile.top.html.tile.html -side left -fill both -expand true -padx 1

#NEW160906: internal HTML-Widget for downloading InlineImages (NOT visible !)
frame .tile.top.html.tile.html.intern
createHTML tile.top.html.tile.html.intern internal 1 2

#NEU220904: holder fr HTML-Frames wg. neuer ClearRoutine
frame .tile.top.html.tile.html.pane.left
frame .tile.top.html.tile.html.pane.left.hold
createHTML tile.top.html.tile.html.pane.left.hold local 1 2
#NEU150604 2nd HTMLframe
frame .tile.top.html.tile.html.pane.rght
frame .tile.top.html.tile.html.pane.rght.hold
createHTML tile.top.html.tile.html.pane.rght.hold remote 1 2

pack .tile.top.html.tile.html.pane.left.hold -in .tile.top.html.tile.html.pane.left -side left -fill both -expand true
pack .tile.top.html.tile.html.pane.rght.hold -in .tile.top.html.tile.html.pane.rght -side right -fill both -expand true
pack .tile.top.html.tile.html.pane.left .tile.top.html.tile.html.pane.rght -in .tile.top.html.tile.html.pane -side left -fill both
#-expand true

#bind .tile.top.html.tile.html.pane.left.hold.local <MouseWheel> {.tile.top.html.tile.html.pane.left.hold.local yview scroll [expr {int(pow(%D/-120,3))}] units}

#DisplayBookmarks/HTML
.tile.top.html.tile add .tile.top.html.tile.bookmark .tile.top.html.tile.html
.tile.top.html.tile.html.pane add .tile.top.html.tile.html.pane.left .tile.top.html.tile.html.pane.rght
.tile.top.html.tile paneconfigure .tile.top.html.tile.bookmark -width 1
.tile.top.html.tile.html.pane paneconfigure .tile.top.html.tile.html.pane.rght -width 1
#.tile.top.html.tile.html.pane paneconfigure .tile.top.html.tile.html.pane.rght -width $resoX
readBookmarks

$HTMLactive(remote) invoke

#Bookmarks
pack .tile.top.html -in .tile.top -fill both -expand true
.tile.top.html.tile sash dragto 0 1 1
.tile.top.html.tile sash place 0 1 1

# --------------------------OPTION Pages--------------------------
#Configure/OptionsPage (Menu: Options>General)
frame .tile.top.conf -background $backColor
#PagesManager .tile.top.conf.page
NoteBook .tile.top.conf.page -background $backColor
.tile.top.conf.page insert end page2 -text $appText(.tile.top.conf.page2) -image imSearchWorld
.tile.top.conf.page insert end page3 -text $appText(.tile.top.conf.page3) -image imWorld2
.tile.top.conf.page insert end page4 -text $appText(.tile.top.conf.page4) -image imRemote
.tile.top.conf.page insert end page6 -text $appText(.tile.top.conf.page6) -image imExitSearch
.tile.top.conf.page raise page3

#page2 Scanner
.tile.top.conf.page itemconfigure page2 -foreground $fgColor -background $backColor -activeforeground $htmlFG \
	-raisecmd {.tile.top.conf.page itemconfigure page2 -image imAgent} \
	-leavecmd {.tile.top.conf.page itemconfigure page2 -image imSearchWorld}
#page3 FIQ
.tile.top.conf.page itemconfigure page3 -foreground $fgColor -background $backColor -activeforeground $htmlFG \
	-raisecmd {.tile.top.conf.page itemconfigure page3 -image imWorld2} \
	-leavecmd {.tile.top.conf.page itemconfigure page3 -image imWorld}
#page4 FTP
.tile.top.conf.page itemconfigure page4 -foreground $fgColor -background $backColor -activeforeground $htmlFG \
	-raisecmd {.tile.top.conf.page itemconfigure page4 -image imLocal} \
	-leavecmd {.tile.top.conf.page itemconfigure page4 -image imRemote}
#page6 eXit
.tile.top.conf.page itemconfigure page6 -foreground $fgColor -background $backColor -activeforeground $htmlFG -raisecmd confFIQ

#OptionsPage2 (HTTP-Scanner)
#NEW210406: Scanner-Options not available yet
label .tile.top.conf.page.fpage2.lbScan -text $appText(.tile.top.conf.page.fpage2.lbScan) -foreground $fgColor -background $backColor
pack .tile.top.conf.page.fpage2.lbScan -in .tile.top.conf.page.fpage2 -side top

#OptionsPage3 (Normal/General-Setup)
frame .tile.top.conf.page.fpage3.fr -background $backColor
label .tile.top.conf.page.fpage3.fr.imScrew1 -image imScrew -relief $ScrewRelief -background $backColor -borderwidth 1
label .tile.top.conf.page.fpage3.fr.imScrew2 -image imScrew -relief $ScrewRelief -background $backColor -borderwidth 1
label .tile.top.conf.page.fpage3.fr.lbVersion -text " $version " -relief groove -foreground white -background $backColor

#frame .tile.top.conf.page.fpage3.bt -relief ridge -background $backColor -foreground white
frame .tile.top.conf.page.fpage3.bt -relief groove -background $backColor -borderwidth 2
label .tile.top.conf.page.fpage3.bt.lbScrew1 -image imScrews2 -relief $ScrewRelief -background $backColor -borderwidth 1
label .tile.top.conf.page.fpage3.bt.lbScrew2 -image imScrews2 -relief $ScrewRelief -background $backColor -borderwidth 1
label .tile.top.conf.page.fpage3.bt.lbFIQ -image imFSworld -background $backColor
label .tile.top.conf.page.fpage3.bt.lbLogo -image imFSlogo -background $backColor
label .tile.top.conf.page.fpage3.bt.lbCopyright -text "(C) 2011 by: Frenzy Softworks \n Written by: Jens Timmermann" -foreground white -background $backColor

#HTML-Options
frame .tile.top.conf.page.fpage3.frHtm -background $backColor
labelframe .tile.top.conf.page.fpage3.frHtm.lfHtml -text $appText(.tile.top.conf.page.fpage3.frHtm.lfHtml) -labelanchor n -relief ridge -background $backColor
label .tile.top.conf.page.fpage3.frHtm.lfHtml.lbTimeout -text $appText(.tile.top.conf.page.fpage3.frHtm.lfHtml.lbTimeout) -image imOPTworldclock -compound left -background $backColor
spinbox .tile.top.conf.page.fpage3.frHtm.lfHtml.etTimeout -from 0 -to 180000 -increment 1000 -width 8 -foreground Green -background black -readonlybackground black \
		-repeatdelay 500 -state readonly -command {set HTMLtimeout %s}
.tile.top.conf.page.fpage3.frHtm.lfHtml.etTimeout set $HTMLtimeout

label .tile.top.conf.page.fpage3.frHtm.lfHtml.etSync -text $appText(.tile.top.conf.page.fpage3.frHtm.lfHtml.etSync)
frame .tile.top.conf.page.fpage3.frHtm.lfHtml.frSync

spinbox .tile.top.conf.page.fpage3.frHtm.lfHtml.frSync.sbSync -values $sync -relief groove -foreground Green -background black -readonlybackground black \
	-repeatdelay 500 -width 2 -state readonly -command {set HTMLsync %s}
.tile.top.conf.page.fpage3.frHtm.lfHtml.frSync.sbSync set $HTMLsync

#NEW160906: seperated SyncValues for HTML/Image Download
spinbox .tile.top.conf.page.fpage3.frHtm.lfHtml.frSync.sbSyncDown -values $sync -relief groove -foreground Green -background black -readonlybackground black \
	-repeatdelay 500 -width 2 -state readonly -command {set DOWNsync %s}
.tile.top.conf.page.fpage3.frHtm.lfHtml.frSync.sbSyncDown set $DOWNsync

#NEW030705 use Spinbox instead Scale (=1 Zeile weniger)
#scale .tile.top.conf.page.fpage3.frHtm.lfHtml.maxLink -label $appText(.tile.top.conf.page.fpage3.frHtm.lfHtml.maxLink) -variable maxDepth -from 0 -to 20 -orient horizontal -background $backColor -highlightbackground $backColor
label .tile.top.conf.page.fpage3.frHtm.lfHtml.maxLink -text $appText(.tile.top.conf.page.fpage3.frHtm.lfHtml.maxLink) -image imWalk -compound left -background $backColor
spinbox .tile.top.conf.page.fpage3.frHtm.lfHtml.sbMaxLink -from 0 -to 20 -width 2 -foreground Green -background black -readonlybackground black \
	-state readonly -repeatdelay 500 -cursor {} -command {set maxDepth %s}
.tile.top.conf.page.fpage3.frHtm.lfHtml.sbMaxLink set $maxDepth
label .tile.top.conf.page.fpage3.frHtm.lfHtml.lbblocksize -text $appText(.tile.top.conf.page.fpage3.frHtm.lfHtml.lbblocksize) -image imOPTsocket -compound left -background $backColor
spinbox .tile.top.conf.page.fpage3.frHtm.lfHtml.blockSize -values $chunk -width 6 -foreground Green -background black -readonlybackground black \
	-state readonly -repeatdelay 500 -cursor {} -command {set blocksize %s}
.tile.top.conf.page.fpage3.frHtm.lfHtml.blockSize set $blocksize
#NEW190806: don't wait for TimeOut (if no Server Ending-Answer comes)
checkbutton .tile.top.conf.page.fpage3.frHtm.lfHtml.cbNoTimeout -variable noTimeout -text $appText(.tile.top.conf.page.fpage3.frHtm.lfHtml.noTimeout) -relief groove -image imClock -compound right -background $backColor -selectcolor $btnPress -command {
      if {$noTimeout<=0} {
            .tile.top.conf.page.fpage3.frHtm.lfHtml.cbSaveTimeout configure -state disabled
      } else {
            .tile.top.conf.page.fpage3.frHtm.lfHtml.cbSaveTimeout configure -state normal
      }
}
checkbutton .tile.top.conf.page.fpage3.frHtm.lfHtml.cbSaveTimeout -variable saveTimeout -text $appText(.tile.top.conf.page.fpage3.frHtm.lfHtml.saveTimeout) -relief groove -image imFTbackground -compound right -background $backColor -selectcolor $btnPress

#FrameLeft (Images/Language)
frame .tile.top.conf.page.fpage3.frmleft -background $backColor
#Image Options
labelframe .tile.top.conf.page.fpage3.frmleft.lfImages -text $appText(.tile.top.conf.page.fpage3.frmleft.lfImages) -labelanchor n -relief ridge -background $backColor
scale .tile.top.conf.page.fpage3.frmleft.lfImages.scDont -label $appText(.tile.top.conf.page.fpage3.frmleft.lfImages.scDont) -variable dontaccept -from 0 -to 100 -orient horizontal -background $backColor -highlightbackground $backColor
scale .tile.top.conf.page.fpage3.frmleft.lfImages.scColor -label $appText(.tile.top.conf.page.fpage3.frmleft.lfImages.scColor) -variable accept -from 1 -to 100 -orient horizontal -background $backColor -highlightbackground $backColor
checkbutton .tile.top.conf.page.fpage3.frmleft.lfImages.etCutGFX -variable cutGfx -text $appText(.tile.top.conf.page.fpage3.frmleft.lfImages.etCutGFX) -relief groove -image imCut -compound right -background $backColor -selectcolor $btnPress -command {
	if {$cutGfx==1} {
		.tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX.sbCutGFX configure -state normal
	} else {
		.tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX.sbCutGFX configure -state disabled
	}
}

frame .tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX
#NEU241004: nur bei best. FileTypes Filename krzen
label .tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX.lbCutGFX -text $appText(.tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX.lbCutGFX) -image imOPTthumbnail -compound left -background $backColor
spinbox .tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX.sbCutGFX -values $Stype -width 10 -foreground Green -background black -readonlybackground black \
	-state readonly -repeatdelay 500 -cursor {} -disabledbackground $backColor -borderwidth 2 -command {set cutType %s}
.tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX.sbCutGFX set $cutType
if {$cutGfx==1} {
	.tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX.sbCutGFX configure -state normal
} else {
	.tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX.sbCutGFX configure -state disabled
}
#Set prefered Selection with RightMouse
bind .tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX.sbCutGFX <3> {
	if {!$active} {
		set win .tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX.sbCutGFX
		if {[$win get]=="JPG"} {
			.tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX.sbCutGFX set "All Selected"
			set cutType "All Selected"
		} else {
			.tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX.sbCutGFX set "JPG"
			set cutType "JPG"
		}
	}
}

frame .tile.top.conf.page.fpage3.frmleft.lfImages.frConvert
#NEU241004ende
label .tile.top.conf.page.fpage3.frmleft.lfImages.frConvert.lbConvert -text $appText(.tile.top.conf.page.fpage3.frmleft.lfImages.frConvert.lbConvert) -image imOPTgallery -compound left -background $backColor
spinbox .tile.top.conf.page.fpage3.frmleft.lfImages.frConvert.sbConvert -values "None $fTypes(Images)" -width 7 -foreground Green -background black \
        -readonlybackground black -state readonly -repeatdelay 500 -cursor {} -textvariable convert
checkbutton .tile.top.conf.page.fpage3.frmleft.lfImages.etUnknownGFX -variable unknownGFX -text $appText(.tile.top.conf.page.fpage3.frmleft.lfImages.etUnknownGFX) -relief groove -selectcolor $btnPress -background $backColor -state disabled
#NEW:041205: Dont't Download Images with less than xy bytes
label .tile.top.conf.page.fpage3.frmleft.lfImages.lbMinSize -text $appText(.tile.top.conf.page.fpage3.frmleft.lfImages.lbMinSize) -image imOPTFilesize -compound left -background $backColor
spinbox .tile.top.conf.page.fpage3.frmleft.lfImages.sbMinSize -from 0 -to 9999999 -increment 50 -width 7 -foreground Green -background black \
        -readonlybackground black -state readonly -repeatdelay 500 -cursor {} -command {set minFileSize %s}
.tile.top.conf.page.fpage3.frmleft.lfImages.sbMinSize set $minFileSize

#NEW290105: LanguageOptions (ehemals image: imFlag noch vorhanden !)
labelframe .tile.top.conf.page.fpage3.frmleft.lfLang -text $appText(.tile.top.conf.page.fpage3.frmleft.lfLang) -labelanchor n -relief ridge -background $backColor
label .tile.top.conf.page.fpage3.frmleft.lfLang.lbLang -text $appText(.tile.top.conf.page.fpage3.frmleft.lfLang.lbLang) -image imLocale -compound left -background $backColor
radiobutton .tile.top.conf.page.fpage3.frmleft.lfLang.1 -text $appText(.tile.top.conf.page.fpage3.frmleft.lfLang.1) -underline -1 -variable language -value 1 -selectcolor $etryBack -activebackground $normLight -relief groove -background $backColor
radiobutton .tile.top.conf.page.fpage3.frmleft.lfLang.2 -text $appText(.tile.top.conf.page.fpage3.frmleft.lfLang.2) -underline -1 -variable language -value 2 -selectcolor $etryBack -activebackground $normLight -relief groove -background $backColor

#Frame right
frame .tile.top.conf.page.fpage3.frmIcons -background $backColor

#CookieOptions
labelframe .tile.top.conf.page.fpage3.frmIcons.lfCookies -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfCookies) -labelanchor n -relief ridge -background $backColor
checkbutton .tile.top.conf.page.fpage3.frmIcons.lfCookies.writeCookie -variable writeCookie -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfCookies.writeCookie) -relief groove -image imFThdd -compound right -selectcolor $btnPress -background $backColor
button .tile.top.conf.page.fpage3.frmIcons.lfCookies.btCookies -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfCookies.btCookies) -image imCookie -compound left -borderwidth 3 -command clearCookies -background $backColor

#IconOptions
labelframe .tile.top.conf.page.fpage3.frmIcons.lfIcons -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfIcons) -labelanchor n -relief ridge -background $backColor
#NEW030705: use Spinbox instead Scale for FavIcons (=1 Zeile weniger)
label .tile.top.conf.page.fpage3.frmIcons.lfIcons.scIcons -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfIcons.scIcons) -image imIcons -compound left -background $backColor
spinbox .tile.top.conf.page.fpage3.frmIcons.lfIcons.sbFavIcons -from -1 -to 2 -width 2 -foreground Green -background black -readonlybackground black \
	-state readonly -repeatdelay 500 -cursor {} -command {set getFavIcon %s}
.tile.top.conf.page.fpage3.frmIcons.lfIcons.sbFavIcons set $getFavIcon
label .tile.top.conf.page.fpage3.frmIcons.lfIcons.lbIcons -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfIcons.lbIcons) -background $backColor
checkbutton .tile.top.conf.page.fpage3.frmIcons.lfIcons.ckIcons -variable markIcons -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfIcons.ckIcons) -relief groove -image imFTgfx -compound right -background $backColor -selectcolor $btnPress -command {
        if {$markIcons==1} {
               .tile.bottom.pane.f3.box.lbType configure -state normal
        } else {
               .tile.bottom.pane.f3.box.lbType configure -state disabled
        }
}
checkbutton .tile.top.conf.page.fpage3.frmIcons.lfIcons.ckTmpIcons -variable writeTempIcons -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfIcons.ckTmpIcons) -relief groove -image imBookClosed -compound right -background $backColor -selectcolor $btnPress

#DisplayOptions
labelframe .tile.top.conf.page.fpage3.frmIcons.lfOther -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfOther) -labelanchor n -relief ridge -background $backColor

frame .tile.top.conf.page.fpage3.frmIcons.lfOther.frAnimDly
label .tile.top.conf.page.fpage3.frmIcons.lfOther.frAnimDly.lbAnimDly -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfOther.lbAnimDly) -image imOPTclock -compound left -background $backColor
spinbox .tile.top.conf.page.fpage3.frmIcons.lfOther.frAnimDly.etAnimDly -from 10 -to 1024 -width 4 -foreground Green -background black -readonlybackground black -repeatdelay 500 -command {set ANIdelay %s}
.tile.top.conf.page.fpage3.frmIcons.lfOther.frAnimDly.etAnimDly set $ANIdelay
checkbutton .tile.top.conf.page.fpage3.frmIcons.lfOther.etRender -variable renderUPD -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfOther.etRender) -relief groove -image imFTexe -compound right -selectcolor $btnPress -background $backColor
checkbutton .tile.top.conf.page.fpage3.frmIcons.lfOther.etStyle -variable smallStyle -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfOther.etStyle) -relief groove -image imFontStyle -compound right -selectcolor $btnPress -background $backColor
#NEW051106:
checkbutton .tile.top.conf.page.fpage3.frmIcons.lfOther.etStream -variable stream -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfOther.etStream) -relief groove -image imFTvideo -compound right -selectcolor $btnPress -background $backColor
#NEW181106: show Media/PlugIN-Controller
checkbutton .tile.top.conf.page.fpage3.frmIcons.lfOther.etMedia -variable mediaCTRL -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfOther.etMedia) -relief groove -image imTools -compound right -selectcolor $btnPress -background $backColor

#ChangeAppsColor
frame .tile.top.conf.page.fpage3.frmIcons.lfOther.frColor -background $backColor
button .tile.top.conf.page.fpage3.frmIcons.lfOther.frColor.btColor -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfOther.frColor.btColor) -image imColor -compound left -borderwidth 3 -command {setAppColor} -background $backColor
button .tile.top.conf.page.fpage3.frmIcons.lfOther.frColor.btSkin -text $appText(.tile.top.conf.page.fpage3.frmIcons.lfOther.frColor.btSkin) -image imColorFill -compound left  -borderwidth 3 -background $backColor -command {loadSkin ""; setSkin}
#Proxy
labelframe .tile.top.conf.page.fpage3.frHtm.lfProxy -text "HTTP Proxy-Server" -labelanchor n -relief ridge -background $backColor
label .tile.top.conf.page.fpage3.frHtm.lfProxy.lbProxyServ -text "Proxy:" -image imOPTnetwork -compound left -background $backColor
entry .tile.top.conf.page.fpage3.frHtm.lfProxy.etProxyServ -textvariable HTProxy(serv) -width 24
label .tile.top.conf.page.fpage3.frHtm.lfProxy.lbProxyPort -text "Port:" -image imOPTnoconnect -compound left -background $backColor
entry .tile.top.conf.page.fpage3.frHtm.lfProxy.etProxyPort -textvariable HTProxy(port) -width 24

#NEW030705: LabelFrame ByteCounter (TrafficMonitor)
labelframe .tile.top.conf.page.fpage3.frHtm.lfByteCount -text $appText(.tile.top.conf.page.fpage3.frHtm.lfByteCount) -labelanchor n -relief ridge -background $backColor
label .tile.top.conf.page.fpage3.frHtm.lfByteCount.lbTraffic -text $appText(.tile.top.conf.page.fpage3.frHtm.lfByteCount.lbTraffic) -image imTraffic -compound left -background $backColor
spinbox .tile.top.conf.page.fpage3.frHtm.lfByteCount.sbTraffic -from 0 -to 9999 -increment 256 -width 4 -foreground Green -background black -readonlybackground black -repeatdelay 500 -command {set maxBytes [expr %s * 1024]} -cursor {}
.tile.top.conf.page.fpage3.frHtm.lfByteCount.sbTraffic set [expr $maxBytes / 1024]
button .tile.top.conf.page.fpage3.frHtm.lfByteCount.btTraffic -text $appText(.tile.top.conf.page.fpage3.frHtm.lfByteCount.btTraffic) -image imWarning -compound left -borderwidth 3  -background $backColor -command {
	if {$FTPask==1} {
		set answer [optionBox -title $msgText(reset.counter.1) -icon warning -type yesno -message $msgText(reset.counter.2)]
	} else {
		set answer yes
	}
	switch $answer {
		yes {
			set ByteCount 0
			.tile.bottom.pane.f3.box.btRip configure -activebackground $normLight -background $backColor
		}
	}
}
pack .tile.top.conf.page.fpage3.frHtm.lfByteCount -in .tile.top.conf.page.fpage3.frHtm -side bottom -padx 1 -pady 2
pack .tile.top.conf.page.fpage3.frHtm.lfByteCount.lbTraffic .tile.top.conf.page.fpage3.frHtm.lfByteCount.sbTraffic  .tile.top.conf.page.fpage3.frHtm.lfByteCount.btTraffic -in  .tile.top.conf.page.fpage3.frHtm.lfByteCount -side top -padx 1 -pady 2

#FICS (TM) Level
frame .tile.top.conf.page.fpage3.frm -background $backColor
labelframe .tile.top.conf.page.fpage3.frm.lbFics -text $appText(.tile.top.conf.page.fpage3.frm.lbFics) -labelanchor n -relief ridge -background $backColor
label .tile.top.conf.page.fpage3.frm.lbFics.lbFicsPic -background DodgerBlue2 -image imFICS${fics} -relief ridge
#EasterEgg
bind .tile.top.conf.page.fpage3.frm.lbFics.lbFicsPic <1> {dispMSG "Try the 'GOD' Mode !"}
bind .tile.top.conf.page.fpage3.frm.lbFics.lbFicsPic <3> {dispMSG "You should try the 'GOD' Mode !"}
bind .tile.top.conf.page.fpage3.bt.lbFIQ <3> {goofBox}
scale .tile.top.conf.page.fpage3.frm.lbFics.ficsLevel -variable fics -from 0 -to 6 -orient horizontal -command ficsPic -showvalue false -background $backColor -highlightbackground $backColor
label .tile.top.conf.page.fpage3.frm.lbFics.lbFicsText -textvariable ficsText -relief flat -justify center -background $backColor
#CacheOptions
labelframe .tile.top.conf.page.fpage3.frm.lfCache -text $appText(.tile.top.conf.page.fpage3.frm.lfCache) -labelanchor n -relief ridge -background $backColor
checkbutton .tile.top.conf.page.fpage3.frm.lfCache.cbCompress -variable cCompress -text $appText(.tile.top.conf.page.fpage3.frm.lfCache.cbCompress) -state disabled -relief groove -selectcolor $btnPress -background $backColor
#NEW190806: clear COMPLETE Cache after Leaving
checkbutton .tile.top.conf.page.fpage3.frm.lfCache.cbComplete -variable compltCache -text $appText(.tile.top.conf.page.fpage3.frm.lfCache.cbComplete) -relief groove -image imTrash -compound right -selectcolor $btnPress -background $backColor -foreground red

checkbutton .tile.top.conf.page.fpage3.frm.lfCache.cbCacheSpeed -variable speedCache -text $appText(.tile.top.conf.page.fpage3.frm.lfCache.cbCacheSpeed) -state disabled -relief groove -image imErase -compound right -selectcolor $btnPress -background $backColor
scale .tile.top.conf.page.fpage3.frm.lfCache.scClean -label $appText(.tile.top.conf.page.fpage3.frm.lfCache.scClean) -variable cClean -from 0 -to 1000 -resolution 10 -orient horizontal -background $backColor -highlightbackground $backColor
button .tile.top.conf.page.fpage3.frm.lfCache.btCache -text $appText(.tile.top.conf.page.fpage3.frm.lfCache.btCache) -image imCache -compound left -borderwidth 3  -background $backColor -command {
       set linktext $msgText(exit.4)
       #update idletasks
       update
       cleanCache $cClean
       set infostatus $msgText(fiq.ready)
       set linktext ""
       set dayClean 1
}

#NEW220406: Clear whole Cache/Change Cache Location Button
button .tile.top.conf.page.fpage3.frm.lfCache.btClrCache -text $appText(.tile.top.conf.page.fpage3.frm.lfCache.btClrCache) -image imCancel -compound left -borderwidth 3 -background $backColor -foreground red -command {clearCache 0}
button .tile.top.conf.page.fpage3.frm.lfCache.btChngCache -text $appText(.tile.top.conf.page.fpage3.frm.lfCache.btChngCache) -image imSelDir -compound left -borderwidth 3 -background $backColor -command {changeDIR}

#SystemDebugOptions
labelframe .tile.top.conf.page.fpage3.frm.lfSystem -text $appText(.tile.top.conf.page.fpage3.frm.lfSystem) -labelanchor n -relief ridge -background $backColor
label .tile.top.conf.page.fpage3.frm.lfSystem.lbDebug -text $appText(.tile.top.conf.page.fpage3.frm.lfSystem.lbDebug) -background $backColor
spinbox .tile.top.conf.page.fpage3.frm.lfSystem.etDebug -from 0 -to 9 -width 2 -foreground Green -background black -readonlybackground black -command {set debug %s}
.tile.top.conf.page.fpage3.frm.lfSystem.etDebug set $debug

#Display on Page3
pack .tile.top.conf.page.fpage3.fr.imScrew1 .tile.top.conf.page.fpage3.fr.lbVersion .tile.top.conf.page.fpage3.fr.imScrew2 -in .tile.top.conf.page.fpage3.fr -side left -padx 1 -pady 2
pack .tile.top.conf.page.fpage3.fr -side top -anchor center
pack .tile.top.conf.page.fpage3.bt.lbScrew1 .tile.top.conf.page.fpage3.bt.lbFIQ .tile.top.conf.page.fpage3.bt.lbCopyright .tile.top.conf.page.fpage3.bt.lbLogo .tile.top.conf.page.fpage3.bt.lbScrew2 -in .tile.top.conf.page.fpage3.bt -side left -padx 2 -pady 1
pack .tile.top.conf.page.fpage3.bt -side bottom -anchor center
pack .tile.top.conf.page.fpage3.frmleft.lfImages -in .tile.top.conf.page.fpage3.frmleft -side top
pack .tile.top.conf.page.fpage3.frmleft.lfImages.scDont .tile.top.conf.page.fpage3.frmleft.lfImages.scColor -in .tile.top.conf.page.fpage3.frmleft.lfImages -side top -padx 1 -pady 1
pack .tile.top.conf.page.fpage3.frmleft.lfImages.etCutGFX -in .tile.top.conf.page.fpage3.frmleft.lfImages -side top -padx 1 -pady 1

pack .tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX.lbCutGFX .tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX.sbCutGFX -in .tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX -side left -padx 1 -pady 1
pack .tile.top.conf.page.fpage3.frmleft.lfImages.frConvert.lbConvert .tile.top.conf.page.fpage3.frmleft.lfImages.frConvert.sbConvert -in .tile.top.conf.page.fpage3.frmleft.lfImages.frConvert -side left -padx 1 -pady 1
pack .tile.top.conf.page.fpage3.frmleft.lfImages.frCutGFX .tile.top.conf.page.fpage3.frmleft.lfImages.frConvert -in .tile.top.conf.page.fpage3.frmleft.lfImages -side top -padx 1 -pady 1

pack .tile.top.conf.page.fpage3.frmleft.lfLang.lbLang -in .tile.top.conf.page.fpage3.frmleft.lfLang -side top
pack .tile.top.conf.page.fpage3.frmleft.lfLang.1 .tile.top.conf.page.fpage3.frmleft.lfLang.2 -in .tile.top.conf.page.fpage3.frmleft.lfLang -side left -padx 2 -pady 2 -fill x
pack .tile.top.conf.page.fpage3.frmleft.lfLang -in .tile.top.conf.page.fpage3.frmleft -side bottom -padx 1 -pady 1
pack .tile.top.conf.page.fpage3.frmleft.lfImages.etUnknownGFX -in .tile.top.conf.page.fpage3.frmleft.lfImages -padx 2 -pady 1
pack .tile.top.conf.page.fpage3.frmleft.lfImages.lbMinSize .tile.top.conf.page.fpage3.frmleft.lfImages.sbMinSize -in .tile.top.conf.page.fpage3.frmleft.lfImages -padx 2 -pady 1 -side top
pack .tile.top.conf.page.fpage3.frmleft -in .tile.top.conf.page.fpage3 -side left
pack .tile.top.conf.page.fpage3.frHtm.lfHtml.frSync.sbSync .tile.top.conf.page.fpage3.frHtm.lfHtml.frSync.sbSyncDown -in .tile.top.conf.page.fpage3.frHtm.lfHtml.frSync -padx 1 -side left
pack .tile.top.conf.page.fpage3.frHtm.lfHtml.etSync .tile.top.conf.page.fpage3.frHtm.lfHtml.frSync -in .tile.top.conf.page.fpage3.frHtm.lfHtml -padx 2 -pady 1
pack .tile.top.conf.page.fpage3.frHtm.lfHtml.lbTimeout .tile.top.conf.page.fpage3.frHtm.lfHtml.etTimeout -in .tile.top.conf.page.fpage3.frHtm.lfHtml
pack .tile.top.conf.page.fpage3.frHtm.lfHtml.lbblocksize .tile.top.conf.page.fpage3.frHtm.lfHtml.blockSize .tile.top.conf.page.fpage3.frHtm.lfHtml.cbNoTimeout .tile.top.conf.page.fpage3.frHtm.lfHtml.cbSaveTimeout -in .tile.top.conf.page.fpage3.frHtm.lfHtml
pack .tile.top.conf.page.fpage3.frmIcons.lfCookies.btCookies -in .tile.top.conf.page.fpage3.frmIcons.lfCookies -side bottom -padx 2 -pady 2
pack .tile.top.conf.page.fpage3.frmIcons.lfCookies.writeCookie -in .tile.top.conf.page.fpage3.frmIcons.lfCookies -side bottom -padx 2 -pady 2
pack .tile.top.conf.page.fpage3.frmIcons.lfCookies -in .tile.top.conf.page.fpage3.frmIcons
pack .tile.top.conf.page.fpage3.frmIcons.lfIcons.ckIcons .tile.top.conf.page.fpage3.frmIcons.lfIcons.ckTmpIcons .tile.top.conf.page.fpage3.frmIcons.lfIcons.scIcons .tile.top.conf.page.fpage3.frmIcons.lfIcons.sbFavIcons -in .tile.top.conf.page.fpage3.frmIcons.lfIcons -side top -padx 1
pack .tile.top.conf.page.fpage3.frmIcons.lfIcons -in .tile.top.conf.page.fpage3.frmIcons -side right -padx 1 -pady 1
pack .tile.top.conf.page.fpage3.frmIcons.lfIcons.lbIcons -in .tile.top.conf.page.fpage3.frmIcons.lfIcons -side bottom -padx 1
pack .tile.top.conf.page.fpage3.frmIcons.lfOther.frColor.btColor -in .tile.top.conf.page.fpage3.frmIcons.lfOther.frColor -side left -padx 1 -pady 2
pack .tile.top.conf.page.fpage3.frmIcons.lfOther.frColor.btSkin -in .tile.top.conf.page.fpage3.frmIcons.lfOther.frColor -side right -padx 1 -pady 2
pack .tile.top.conf.page.fpage3.frmIcons.lfOther.frColor -in .tile.top.conf.page.fpage3.frmIcons.lfOther -side bottom -padx 1 -pady 1
pack .tile.top.conf.page.fpage3.frmIcons.lfOther.etRender -in .tile.top.conf.page.fpage3.frmIcons.lfOther -side top
pack .tile.top.conf.page.fpage3.frmIcons.lfOther.etStyle -in .tile.top.conf.page.fpage3.frmIcons.lfOther -side top
pack .tile.top.conf.page.fpage3.frmIcons.lfOther.etStream -in .tile.top.conf.page.fpage3.frmIcons.lfOther -side top
pack .tile.top.conf.page.fpage3.frmIcons.lfOther.etMedia -in .tile.top.conf.page.fpage3.frmIcons.lfOther -side top
pack .tile.top.conf.page.fpage3.frmIcons.lfOther.frAnimDly.lbAnimDly .tile.top.conf.page.fpage3.frmIcons.lfOther.frAnimDly.etAnimDly -in .tile.top.conf.page.fpage3.frmIcons.lfOther.frAnimDly -side left -padx 1 -pady 1
pack .tile.top.conf.page.fpage3.frmIcons.lfOther.frAnimDly -in .tile.top.conf.page.fpage3.frmIcons.lfOther -side top -padx 1 -pady 1
pack .tile.top.conf.page.fpage3.frmIcons.lfIcons .tile.top.conf.page.fpage3.frmIcons.lfOther -in .tile.top.conf.page.fpage3.frmIcons -side top -padx 1 -pady 1
pack .tile.top.conf.page.fpage3.frm.lfSystem.lbDebug .tile.top.conf.page.fpage3.frm.lfSystem.etDebug -in .tile.top.conf.page.fpage3.frm.lfSystem -side left -padx 1 -pady 1
pack .tile.top.conf.page.fpage3.frHtm.lfHtml.maxLink .tile.top.conf.page.fpage3.frHtm.lfHtml.sbMaxLink -in .tile.top.conf.page.fpage3.frHtm.lfHtml -padx 1 -pady 2
pack .tile.top.conf.page.fpage3.frHtm.lfProxy.lbProxyServ .tile.top.conf.page.fpage3.frHtm.lfProxy.etProxyServ -in .tile.top.conf.page.fpage3.frHtm.lfProxy -side top -padx 1 -pady 1
pack .tile.top.conf.page.fpage3.frHtm.lfProxy.lbProxyPort .tile.top.conf.page.fpage3.frHtm.lfProxy.etProxyPort -in .tile.top.conf.page.fpage3.frHtm.lfProxy -side top -padx 1 -pady 1
pack .tile.top.conf.page.fpage3.frm.lbFics.lbFicsPic -in .tile.top.conf.page.fpage3.frm.lbFics -side top
pack .tile.top.conf.page.fpage3.frm.lbFics.ficsLevel .tile.top.conf.page.fpage3.frm.lbFics.lbFicsText -in .tile.top.conf.page.fpage3.frm.lbFics -side top
pack .tile.top.conf.page.fpage3.frm.lfCache.cbCompress .tile.top.conf.page.fpage3.frm.lfCache.cbCacheSpeed .tile.top.conf.page.fpage3.frm.lfCache.cbComplete .tile.top.conf.page.fpage3.frm.lfCache.scClean -in .tile.top.conf.page.fpage3.frm.lfCache -side top -padx 2 -pady 1
pack .tile.top.conf.page.fpage3.frm.lfCache.btChngCache .tile.top.conf.page.fpage3.frm.lfCache.btClrCache .tile.top.conf.page.fpage3.frm.lfCache.btCache -in .tile.top.conf.page.fpage3.frm.lfCache -side bottom -padx 2 -pady 2
pack .tile.top.conf.page.fpage3.frm.lbFics .tile.top.conf.page.fpage3.frm.lfCache -in .tile.top.conf.page.fpage3.frm -side top -padx 2 -pady 2
pack .tile.top.conf.page.fpage3.frm.lfSystem -in .tile.top.conf.page.fpage3.frm -side top -padx 2 -pady 2
pack .tile.top.conf.page.fpage3.frm -side left -padx 2
pack .tile.top.conf.page.fpage3.frHtm.lfHtml .tile.top.conf.page.fpage3.frHtm.lfProxy -in .tile.top.conf.page.fpage3.frHtm -side top -padx 1 -pady 1
pack .tile.top.conf.page.fpage3.frHtm .tile.top.conf.page.fpage3.frmIcons -in .tile.top.conf.page.fpage3 -side left -padx 1 -pady 1

#OptionsPage4 (FTP)
labelframe .tile.top.conf.page.fpage4.lfFTP -text $appText(.tile.top.conf.page.fpage4.lfFTP) -labelanchor n -relief ridge -background $backColor
checkbutton .tile.top.conf.page.fpage4.lfFTP.etDebug -variable FTPdebug -text $appText(.tile.top.conf.page.fpage4.lfFTP.etDebug) -relief groove -selectcolor $btnPress -background $backColor
label .tile.top.conf.page.fpage4.lfFTP.lbftpUserL -text "$appText(.tile.top.conf.page.fpage4.lfFTP.lbftpUserL)" -image imIdentity -compound left -background $backColor
entry .tile.top.conf.page.fpage4.lfFTP.etftpUserL -textvariable FTPuser(local) -width 24
label .tile.top.conf.page.fpage4.lfFTP.lbftpPassL -text $appText(.tile.top.conf.page.fpage4.lfFTP.lbftpPassL) -image imPassword -compound left -background $backColor
entry .tile.top.conf.page.fpage4.lfFTP.etftpPassL -textvariable FTPpass(local) -width 24
label .tile.top.conf.page.fpage4.lfFTP.lbftpUserR -text $appText(.tile.top.conf.page.fpage4.lfFTP.lbftpUserR) -image imIdentity -compound left -background $backColor
entry .tile.top.conf.page.fpage4.lfFTP.etftpUserR -textvariable FTPuser(remote) -width 24
label .tile.top.conf.page.fpage4.lfFTP.lbftpPassR -text $appText(.tile.top.conf.page.fpage4.lfFTP.lbftpPassR) -image imPassword -compound left -background $backColor
entry .tile.top.conf.page.fpage4.lfFTP.etftpPassR -textvariable FTPpass(remote) -width 24
#PreviewOptions
labelframe .tile.top.conf.page.fpage4.lfFile -text $appText(.tile.top.conf.page.fpage4.lfFile) -labelanchor n -relief ridge -background $backColor
scale .tile.top.conf.page.fpage4.lfFile.imgSize -label $appText(.tile.top.conf.page.fpage4.lfFile.imgSize) -variable prevSize -from 2 -to 48 -orient horizontal -background $backColor -highlightbackground $backColor
scale .tile.top.conf.page.fpage4.lfFile.thmSize -label $appText(.tile.top.conf.page.fpage4.lfFile.thmSize) -variable thumbSize -from 1 -to 8 -orient horizontal -background $backColor -highlightbackground $backColor
checkbutton .tile.top.conf.page.fpage4.lfFile.etSort -variable FTPsort -text $appText(.tile.top.conf.page.fpage4.lfFile.etSort) -relief groove -selectcolor $btnPress -background $backColor -image imFTPsort -compound right
checkbutton .tile.top.conf.page.fpage4.lfFile.etPreview -variable FTPrealprev -text $appText(.tile.top.conf.page.fpage4.lfFile.etPrev) -relief groove -selectcolor $btnPress -background $backColor -image imFTgfx2 -compound right
checkbutton .tile.top.conf.page.fpage4.lfFile.etDivZoom -variable divZoom -text $appText(.tile.top.conf.page.fpage4.lfFile.etDivZoom) -relief groove -selectcolor $btnPress -background $backColor
checkbutton .tile.top.conf.page.fpage4.lfFile.etRender -variable FTPrender -text $appText(.tile.top.conf.page.fpage4.lfFile.etRender) -relief groove -selectcolor $btnPress -background $backColor
#Proxy
labelframe .tile.top.conf.page.fpage4.lfProxy -text "FTP Proxy-Server" -labelanchor n -relief ridge -background $backColor
label .tile.top.conf.page.fpage4.lfProxy.lbProxyServ -text "Proxy:" -image imOPTnetwork -compound left -background $backColor
entry .tile.top.conf.page.fpage4.lfProxy.etProxyServ -textvariable HTProxy(serv) -width 24
label .tile.top.conf.page.fpage4.lfProxy.lbProxyPort -text "Port:" -image imOPTnoconnect -compound left -background $backColor
entry .tile.top.conf.page.fpage4.lfProxy.etProxyPort -textvariable HTProxy(port) -width 24
#Display on Page4
pack .tile.top.conf.page.fpage4.lfFTP.etDebug -in .tile.top.conf.page.fpage4.lfFTP -side top -padx 1 -pady 1
pack .tile.top.conf.page.fpage4.lfFTP.lbftpUserL .tile.top.conf.page.fpage4.lfFTP.etftpUserL -in .tile.top.conf.page.fpage4.lfFTP -side top -padx 2 -pady 1
pack .tile.top.conf.page.fpage4.lfFTP.lbftpPassL .tile.top.conf.page.fpage4.lfFTP.etftpPassL -in .tile.top.conf.page.fpage4.lfFTP -side top -padx 2 -pady 1
pack .tile.top.conf.page.fpage4.lfFTP.lbftpUserR .tile.top.conf.page.fpage4.lfFTP.etftpUserR -in .tile.top.conf.page.fpage4.lfFTP -side top -padx 2 -pady 1
pack .tile.top.conf.page.fpage4.lfFTP.lbftpPassR .tile.top.conf.page.fpage4.lfFTP.etftpPassR -in .tile.top.conf.page.fpage4.lfFTP -side top -padx 2 -pady 1
pack .tile.top.conf.page.fpage4.lfFile.imgSize .tile.top.conf.page.fpage4.lfFile.thmSize -in .tile.top.conf.page.fpage4.lfFile -side top -padx 2 -pady 1
pack .tile.top.conf.page.fpage4.lfFile.etSort .tile.top.conf.page.fpage4.lfFile.etPreview .tile.top.conf.page.fpage4.lfFile.etDivZoom .tile.top.conf.page.fpage4.lfFile.etRender -in .tile.top.conf.page.fpage4.lfFile -side top -padx 2 -pady 2
pack .tile.top.conf.page.fpage4.lfProxy.lbProxyServ .tile.top.conf.page.fpage4.lfProxy.etProxyServ -in .tile.top.conf.page.fpage4.lfProxy -side top -padx 1 -pady 1
pack .tile.top.conf.page.fpage4.lfProxy.lbProxyPort .tile.top.conf.page.fpage4.lfProxy.etProxyPort -in .tile.top.conf.page.fpage4.lfProxy -side top -padx 1 -pady 1
pack  .tile.top.conf.page.fpage4.lfFTP .tile.top.conf.page.fpage4.lfFile .tile.top.conf.page.fpage4.lfProxy -in .tile.top.conf.page.fpage4 -side left -padx 2 -pady 1

#Display whole OptionsPageFrames
pack .tile.top.conf.page -in .tile.top.conf -side left -fill both -expand true

#WindowTiling (Left/Right) FTP-Mode
frame .tile.top.ftp -background $backColor
panedwindow .tile.top.ftp.tile -orient horizontal -background $backColor -showhandle false -borderwidth 0 \
	-relief flat -sashrelief raised -sashwidth 3 -opaqueresize false
pack .tile.top.ftp.tile -in .tile.top.ftp -side left -expand true -fill both

#FTPlocal Window
frame .tile.top.ftp.tile.local -background $backColor
frame .tile.top.ftp.tile.local.title -background $backColor
label .tile.top.ftp.tile.local.title.lbMode -text "Local:" -relief groove -cursor hand2 -image imLocal -compound left -font $sysFont(4) -background $backColor
bind .tile.top.ftp.tile.local.title.lbMode <1> {changeFTPmode local}
button .tile.top.ftp.tile.local.title.btClrLocal -underline 0 -command {setActive local; set FTPdest(local) ""} -image imClrURL -background $backColor -activebackground $normLight
entry .tile.top.ftp.tile.local.title.etInput -textvariable FTPdest(local) -relief groove -background $normLight
bind .tile.top.ftp.tile.local.title.etInput <1> {setActive local}
bind .tile.top.ftp.tile.local.title.etInput <Return> {enterFTP local}
label .tile.top.ftp.tile.local.title.lbAnzFiles -foreground $fgColor -background $backColor -textvariable FTPanz(local) -relief sunken -font "Arial 9"
pack .tile.top.ftp.tile.local.title.lbMode -in .tile.top.ftp.tile.local.title -side left
pack .tile.top.ftp.tile.local.title.btClrLocal -in .tile.top.ftp.tile.local.title -side left -padx 1
pack .tile.top.ftp.tile.local.title.lbAnzFiles -in .tile.top.ftp.tile.local.title -side right -padx 1
pack .tile.top.ftp.tile.local.title.etInput -in .tile.top.ftp.tile.local.title -side left -fill x -expand true
pack .tile.top.ftp.tile.local.title -in .tile.top.ftp.tile.local -side top -fill x -pady 1

#FTPremote Window
frame .tile.top.ftp.tile.remote -background $backColor
frame .tile.top.ftp.tile.remote.title -background $backColor
label .tile.top.ftp.tile.remote.title.lbMode -text "Remote:" -relief groove -cursor hand2 -image imRemote -compound left -font $sysFont(4) -background $backColor
bind .tile.top.ftp.tile.remote.title.lbMode <1> {changeFTPmode remote}
button .tile.top.ftp.tile.remote.title.btClrRemote -underline 0 -command {setActive remote; set FTPdest(remote) ""} -image imClrURL -background $backColor -activebackground $normLight -relief groove
entry .tile.top.ftp.tile.remote.title.etInput -textvariable FTPdest(remote) -relief groove -background $backColor
bind .tile.top.ftp.tile.remote.title.etInput <1> {setActive remote}
bind .tile.top.ftp.tile.remote.title.etInput <Return> {enterFTP remote}
label .tile.top.ftp.tile.remote.title.lbAnzFiles -foreground $etryBack -background $backColor -textvariable FTPanz(remote) -relief sunken -font "Arial 9"
pack .tile.top.ftp.tile.remote.title.lbMode -in .tile.top.ftp.tile.remote.title -side left
pack .tile.top.ftp.tile.remote.title.btClrRemote -in .tile.top.ftp.tile.remote.title -side left -padx 1
pack .tile.top.ftp.tile.remote.title.lbAnzFiles -in .tile.top.ftp.tile.remote.title -side right -padx 1
pack .tile.top.ftp.tile.remote.title.etInput -in .tile.top.ftp.tile.remote.title -side left -fill x -expand true
pack .tile.top.ftp.tile.remote.title -in .tile.top.ftp.tile.remote -side top -fill x -pady 1

if {$FTPrender==0} {
	#FTPlocal
	frame .tile.top.ftp.tile.local.frm -background $backColor
	label .tile.top.ftp.tile.local.frm.rbButton -image im2back -background $backColor -cursor hand2 -relief ridge -width $buttonSize -height $buttonSize
	scrollbar .tile.top.ftp.tile.local.frm.xscroll -orient horizontal -command {.tile.top.ftp.tile.local.local xview} -background $backColor
	bind .tile.top.ftp.tile.local.frm.xscroll <1> {setActive local}
	bind .tile.top.ftp.tile.local.frm.rbButton <1> {wideFTP 1; setActive remote}
	bind .tile.top.ftp.tile.local.frm.rbButton <3> {setActive local}
	scrollbar .tile.top.ftp.tile.local.yscroll -orient vertical -command {.tile.top.ftp.tile.local.local yview} -background $backColor
	bind .tile.top.ftp.tile.local.yscroll <1> {setActive local}
	pack .tile.top.ftp.tile.local.frm.rbButton -in .tile.top.ftp.tile.local.frm -side right
        # -padx 1
	pack .tile.top.ftp.tile.local.frm.xscroll -in .tile.top.ftp.tile.local.frm -side left -fill x -expand true
	pack .tile.top.ftp.tile.local.frm -in .tile.top.ftp.tile.local -side bottom -fill x
	pack .tile.top.ftp.tile.local.yscroll -in .tile.top.ftp.tile.local -side right -fill y
	#FTPremote
	frame .tile.top.ftp.tile.remote.frm -background $backColor
	label .tile.top.ftp.tile.remote.frm.rbButton -image im2forw -background $backColor -cursor hand2 -relief ridge -width $buttonSize -height $buttonSize
	scrollbar .tile.top.ftp.tile.remote.frm.xscroll -orient horizontal -command {.tile.top.ftp.tile.remote.remote xview} -background $backColor
	bind .tile.top.ftp.tile.remote.frm.xscroll <1> {setActive remote}
	bind .tile.top.ftp.tile.remote.frm.rbButton <1> {wideFTP 2; setActive local}
	bind .tile.top.ftp.tile.remote.frm.rbButton <3> {setActive remote}
	scrollbar .tile.top.ftp.tile.remote.yscroll -orient vertical -command {.tile.top.ftp.tile.remote.remote yview} -background $backColor
	bind .tile.top.ftp.tile.remote.yscroll <1> {setActive remote}
	pack .tile.top.ftp.tile.remote.frm.rbButton -in .tile.top.ftp.tile.remote.frm -side right
        # -padx 1
	pack .tile.top.ftp.tile.remote.frm.xscroll -in .tile.top.ftp.tile.remote.frm -side left -fill x -expand true
	pack .tile.top.ftp.tile.remote.frm -in .tile.top.ftp.tile.remote -side bottom -fill x
	pack .tile.top.ftp.tile.remote.yscroll -in .tile.top.ftp.tile.remote -side right -fill y
}

.tile.top.ftp.tile add .tile.top.ftp.tile.local .tile.top.ftp.tile.remote

#NEU210404.TiledWindowBottomFrame
frame .tile.bottom -background $backColor
pack .tile.bottom -side top -fill both -expand true

set panel raised
#set panel ridge

#UntererContainer fr versch. Modes (Scan, Normal, FTP, IRC, etc.) = Panels
#NEW031104: PagesManager displays Panels now
if {$smallStyle==1} {
   PagesManager .tile.bottom.pane -background $backColor -height 36
} else {
   PagesManager .tile.bottom.pane -background $backColor -height 44
}
.tile.bottom.pane add 1
.tile.bottom.pane add 2
.tile.bottom.pane add 3
.tile.bottom.pane add 4
.tile.bottom.pane add 5
.tile.bottom.pane raise 3
pack .tile.bottom.pane -pady 1 -fill x -side top

#Frame2 (Scanner Mode)
label .tile.bottom.pane.f2.box -relief $panel -borderwidth 2 -background $backColor
#Klickbare Screws
frame .tile.bottom.pane.f2.clickScrewR -relief $panel -borderwidth 2 -background $backColor
label .tile.bottom.pane.f2.clickScrewR.cScrewR -image imScrews -relief $ScrewRelief -background $backColor -borderwidth 1 -cursor sb_right_arrow
pack .tile.bottom.pane.f2.clickScrewR -in .tile.bottom.pane.f2 -side right -padx 1
pack .tile.bottom.pane.f2.clickScrewR.cScrewR -in .tile.bottom.pane.f2.clickScrewR -padx 2 -pady 3
#Normale Screws R/L
label .tile.bottom.pane.f2.box.imScrewL -image imScrews -relief $ScrewRelief -background $backColor -borderwidth 1
pack .tile.bottom.pane.f2.box.imScrewL -in .tile.bottom.pane.f2.box -side left -padx 2 -pady 1
label .tile.bottom.pane.f2.box.imScrewR -image imScrews -relief $ScrewRelief -background $backColor -borderwidth 1
pack .tile.bottom.pane.f2.box.imScrewR -in .tile.bottom.pane.f2.box -side right -padx 2 -pady 1
#GUI
button .tile.bottom.pane.f2.box.btScan -text "ScanServ" -command {scanServ $scanType} -image imScan -activebackground $normLight -background $backColor
bind .tile.bottom.pane.f2.box.btScan <3> {buttonPress .tile.bottom.pane.f2.box.btScan; clearSelected; scanServ $scanType}
pack .tile.bottom.pane.f2.box.btScan -in .tile.bottom.pane.f2.box -side right -padx 2
label .tile.bottom.pane.f2.box.lbStart -text "Start:" -foreground $fgColor -font $sysFont(2) -background $backColor
spinbox .tile.bottom.pane.f2.box.start -from 0 -to 99999 -width 5 -foreground Green -background black -repeatdelay 400 \
	-repeatinterval 50 -command setScanStart -disabledbackground $backColor
label .tile.bottom.pane.f2.box.lbStop -text "Stop:" -foreground $fgColor -font $sysFont(2) -background $backColor
spinbox .tile.bottom.pane.f2.box.stop -from 0 -to 99999 -width 5 -foreground Green -background black -repeatdelay 400 \
	-repeatinterval 50 -command setScanStop -disabledbackground $backColor
label .tile.bottom.pane.f2.box.lbStep -text $appText(.tile.bottom.pane.f2.box.lbStep) -foreground $fgColor -font $sysFont(2) -background $backColor
label .tile.bottom.pane.f2.box.lbPlus -text "+" -relief raised -width 2 -foreground Green -background $backColor -cursor hand2 -background $backColor
spinbox .tile.bottom.pane.f2.box.step -from 0 -to 999 -width 2 -foreground Green -background black -repeatdelay 300 \
	-repeatinterval 50 -disabledbackground $backColor
.tile.bottom.pane.f2.box.step set 1
label .tile.bottom.pane.f2.box.lbLen -text $appText(.tile.bottom.pane.f2.box.lbLen) -foreground $fgColor -font $sysFont(2) -background $backColor
spinbox .tile.bottom.pane.f2.box.scanLen -from 1 -to 9 -width 1 -foreground Green -background black -repeatdelay 300 \
	-repeatinterval 50 -disabledbackground $backColor -command {set scanLen [expr [.tile.bottom.pane.f2.box.scanLen get] - 1]}
.tile.bottom.pane.f2.box.scanLen set $scanLen
#NEW050605: scanServer, or Create Selection without Scan
checkbutton .tile.bottom.pane.f2.box.lbType -variable scanCreate -text $appText(.tile.bottom.pane.f2.box.lbType) -foreground $fgColor -background $backColor -font $sysFont(2) -indicatoron false -command {
	if {$scanCreate==0} {
		.tile.bottom.pane.f2.box.lbType configure -text $appText(.tile.bottom.pane.f2.box.lbType) -background $backColor
	} else {
		.tile.bottom.pane.f2.box.lbType configure -text $appText(.tile.bottom.pane.f2.box.lbType.1) -background red
	}
}
spinbox .tile.bottom.pane.f2.box.scanType -values $ftype -width 8 -foreground Green -background black -readonlybackground black \
	-state readonly -repeatdelay 400 -cursor {} -command {set scanType [chkScanType %s]}
button .tile.bottom.pane.f2.box.btFile -text "ChooseFile" -command {set scanType [importList]} -image imSelDir -activebackground $normLight -borderwidth 2 -state disabled -height 18 -background $backColor
labelframe .tile.bottom.pane.f2.box.fr -text "URL:" -foreground $fgColor -labelanchor w -font $sysFont(2) -relief ridge -height 10 -background $backColor
radiobutton .tile.bottom.pane.f2.box.fr.1 -text $appText(.tile.bottom.pane.f2.box.fr.1) -underline -1 -variable scanFile -value 1 -font $sysFont(5) -activebackground $normLight \
        -selectcolor $etryBack -activeforeground white -relief raised -foreground $fgColor -background $backColor -command {activeScanType 1}
radiobutton .tile.bottom.pane.f2.box.fr.2 -text $appText(.tile.bottom.pane.f2.box.fr.2) -underline -1 -variable scanFile -value 2 -font $sysFont(5) -activebackground $normLight \
		-selectcolor $etryBack -activeforeground white -relief raised -foreground $fgColor -background $backColor -command {activeScanType 2}
radiobutton .tile.bottom.pane.f2.box.fr.3 -text $appText(.tile.bottom.pane.f2.box.fr.3) -underline -1 -variable scanFile -value 3 -font $sysFont(5) -activebackground $normLight \
		-selectcolor $etryBack -activeforeground white -relief raised -foreground $fgColor -background $backColor -command {activeScanType 3}
button .tile.bottom.pane.f2.box.btClr -text "Clear History" -command {clrHistory} -activebackground $normLight -borderwidth 2 -image imCLRlist -height 18 -background $backColor
button .tile.bottom.pane.f2.box.btAdd -text "Add2History" -command {scanHistory 0} -activebackground $normLight -borderwidth 2 -image imUp -height 18 -background $backColor
button .tile.bottom.pane.f2.box.btImp -text "ImportHistory" -command {scanHistory 1} -activebackground $normLight -borderwidth 2 -image imDown -height 18 -background $backColor
# Fortschrittsanzeiger Gesamt, unten
canvas .tile.bottom.pane.f2.box.prgBar -height 2 -relief sunken -borderwidth 1 -background $normLight -highlightbackground $backColor
.tile.bottom.pane.f2.box.prgBar create rectangle 0 0 0 4 -fill $barColor -tags proBar
pack .tile.bottom.pane.f2.box.prgBar -in .tile.bottom.pane.f2.box -side bottom -fill x -padx 1 -pady 2 -expand true
pack .tile.bottom.pane.f2.box.lbStart .tile.bottom.pane.f2.box.start .tile.bottom.pane.f2.box.lbStop .tile.bottom.pane.f2.box.stop -in .tile.bottom.pane.f2.box -side left
pack .tile.bottom.pane.f2.box.lbStep .tile.bottom.pane.f2.box.lbPlus .tile.bottom.pane.f2.box.step -in .tile.bottom.pane.f2.box -side left
pack .tile.bottom.pane.f2.box.lbLen .tile.bottom.pane.f2.box.scanLen -in .tile.bottom.pane.f2.box -side left
pack .tile.bottom.pane.f2.box.lbType -in .tile.bottom.pane.f2.box -side left
pack .tile.bottom.pane.f2.box.scanType -in .tile.bottom.pane.f2.box -side left -fill x -expand true
pack .tile.bottom.pane.f2.box.btFile -in .tile.bottom.pane.f2.box -side left
pack .tile.bottom.pane.f2.box.fr.1 .tile.bottom.pane.f2.box.fr.2 .tile.bottom.pane.f2.box.fr.3 -in .tile.bottom.pane.f2.box.fr -side left
pack .tile.bottom.pane.f2.box.fr -in .tile.bottom.pane.f2.box -side left -padx 1 -pady 2
pack .tile.bottom.pane.f2.box.btClr .tile.bottom.pane.f2.box.btAdd .tile.bottom.pane.f2.box.btImp -in .tile.bottom.pane.f2.box -side left
pack .tile.bottom.pane.f2.box -in .tile.bottom.pane.f2 -padx 1 -fill x -expand true

#Frame3 for Normal Mode
#frame .tile.bottom.pane.f3.box -relief $panel -borderwidth 2 -background $backColor
label .tile.bottom.pane.f3.box -relief $panel -borderwidth 2 -background $backColor
#Klickbare Screws R/L (einzige Ausnahme: hier sind Screws INNERHALB der Box; also KEINE ext. Screws !!!)
label .tile.bottom.pane.f3.box.clickScrewL -image imScrews -relief $ScrewRelief -background $backColor -borderwidth 1 -cursor sb_left_arrow
pack .tile.bottom.pane.f3.box.clickScrewL -in .tile.bottom.pane.f3.box -side left -padx 2
# -pady 4
label .tile.bottom.pane.f3.box.clickScrewR -image imScrews -relief $ScrewRelief -background $backColor -borderwidth 1 -cursor sb_right_arrow
pack .tile.bottom.pane.f3.box.clickScrewR -in .tile.bottom.pane.f3.box -side right -padx 3
# -pady 4
#GUI
button .tile.bottom.pane.f3.box.btRip -text "DOWNLOAD" -image imgRip -activebackground $normLight -background $backColor -command downloadStart

pack .tile.bottom.pane.f3.box.btRip -in .tile.bottom.pane.f3.box -side right -padx 2
# -pady 2
#NEW091104: RM on DownLoad = SelectsAll Links/Images
bind .tile.bottom.pane.f3.box.btRip <3> {buttonPress .tile.bottom.pane.f3.box.btRip; selectALL $followLinks}
#NEW010907: MiddleMouseKey selects All and download at once
bind .tile.bottom.pane.f3.box.btRip <2> {buttonPress .tile.bottom.pane.f3.box.btRip; selectALL $followLinks; downloadStart}

label .tile.bottom.pane.f3.box.lbDest -text $appText(.tile.bottom.pane.f3.box.lbDest) -foreground $fgColor -font $sysFont(0) -background $backColor
button .tile.bottom.pane.f3.box.btBrowse -text "Select" -command {selectDIR} -image imSelDir -activebackground $normLight -background $backColor
bind .tile.bottom.pane.f3.box.btBrowse <3> {
	if {!$active} {buttonPress .tile.bottom.pane.f3.box.btBrowse; fileSave 2}
}

#CHNG260910:
#entry .tile.bottom.pane.f3.box.etDest -textvariable destDir -foreground $fgColor -background $etryBack -relief ridge -disabledbackground $backColor
#ComboBox .tile.bottom.pane.f3.box.etDest \
#	-textvariable destDir \
#	-takefocus true \
#       -background $backColor \
#	-foreground $fgColor \
#	-entrybg $etryBack \
#	-highlightcolor $normLight \
#	-highlightbackground white \
#	-selectbackground $normLight \
#	-selectforeground $htmlFG \
#	-values $dirList \
#	-hottrack true \
#	-autocomplete true \
#	-expand tab \
#	-exportselection true \
#-bwlistbox 1 \
#-modifycmd {refreshTotal}
#	-height 6
#	-images {}

ttk::combobox .tile.bottom.pane.f3.box.etDest -textvariable destDir -values $dirList
bind .tile.bottom.pane.f3.box.etDest <<ComboboxSelected>> {refreshTotal}

#NEU: Anzeige TotalFiles
label .tile.bottom.pane.f3.box.lbTotal -text $appText(.tile.bottom.pane.f3.box.lbTotal) -relief groove -foreground $fgColor -font $sysFont(0) -background $backColor -width [string length $appText(.tile.bottom.pane.f3.box.lbTotal)] -height 1
label .tile.bottom.pane.f3.box.etTotal -textvariable anzDest -foreground $fgColor -background $backColor -relief sunken -justify center -cursor {} -borderwidth 2 -font $sysFont(2) -disabledforeground $etryBack
#NEU241004: cutLinks Chekbox
label .tile.bottom.pane.f3.box.lbStype -text $appText(.tile.bottom.pane.f3.box.lbStype) -relief groove -foreground $fgColor -font $sysFont(0) -background $backColor -width [string length $appText(.tile.bottom.pane.f3.box.lbStype)] -height 1

#NEW290505: Forw/BackBage
bind .tile.bottom.pane.f3.box.lbTotal <1> {
	.tile.bottom.pane.f3.box.lbTotal configure -text $appText(.tile.bottom.pane.f3.box.lbTotal) -relief sunken
	BackPage
}
bind .tile.bottom.pane.f3.box.lbTotal <ButtonRelease-1> {
	.tile.bottom.pane.f3.box.lbTotal configure -text $appText(.tile.bottom.pane.f3.box.lbTotal) -relief groove -image "" -width [string length $appText(.tile.bottom.pane.f3.box.lbTotal)] -height 1
}

bind .tile.bottom.pane.f3.box.lbStype <1> {
	.tile.bottom.pane.f3.box.lbStype configure -text $appText(.tile.bottom.pane.f3.box.lbStype) -relief sunken
	ForwPage
}
bind .tile.bottom.pane.f3.box.lbStype <ButtonRelease-1> {
	.tile.bottom.pane.f3.box.lbStype configure -text $appText(.tile.bottom.pane.f3.box.lbStype) -relief groove -image "" -width [string length $appText(.tile.bottom.pane.f3.box.lbStype)] -height 1
}

label .tile.bottom.pane.f3.box.lbType -foreground $fgColor -font $sysFont(0) -image imFTunknown -background $backColor -relief sunken -width 16 -height 16
spinbox .tile.bottom.pane.f3.box.spStype -values $Stype -width 10 -foreground Green -background black -readonlybackground black \
	-state readonly -repeatdelay 500 -cursor {} -command {chkSelection %s} -disabledbackground black -borderwidth 2
#RightMouse auf GroupIcon schaltet thumbsOnly an/aus
bind .tile.bottom.pane.f3.box.lbType <3> {
	if {$thumbsOnly==0} {
		set thumbsOnly 1
		.tile.bottom.pane.f3.box.lbType configure -background red -image imOPTthumbnail
		setLED magenta
		dispMSG $msgText(onlyThumbs)
		set shiftPress 0
		goEnter
	} else {
		set thumbsOnly 0
		.tile.bottom.pane.f3.box.lbType configure -background $backColor -image imFTunknown
		chkSelection [.tile.bottom.pane.f3.box.spStype get]
		setLED blue
		#goEnter
	}
}

#Set 1st FileType Selection with RightMouse
bind .tile.bottom.pane.f3.box.spStype <3> {
        if {!$active} {
		if {$sTypeZlr<9} {
			set sTypeZlr [expr $sTypeZlr + 1]
		} else {
			set sTypeZlr 0
		}
		set dummy [lindex $Stype $sTypeZlr]
		.tile.bottom.pane.f3.box.spStype set $dummy
		chkSelection $dummy
		unset dummy
	}
}

#NEW301004
#setShowLinkTypeIcons on LeftMouse by IconTypeIcon
bind .tile.bottom.pane.f3.box.lbType <1> {
        if {!$active} {
		if {$markIcons==1} {
			.tile.bottom.pane.f3.box.lbType configure -state disabled
			set markIcons 0
		} else {
			.tile.bottom.pane.f3.box.lbType configure -state normal
			set markIcons 1
		}
	#        buttonPress .tile.bottom.pane.f3.box.lbType
	}
}

#NEW101004: Total bei Klick aktualisieren
bind .tile.bottom.pane.f3.box.etTotal <1> {
	if {!$active} {
		.tile.bottom.pane.f3.box.etTotal configure -relief sunken
		#     buttonPress .tile.bottom.pane.f3.box.etTotal
		refreshTotal
	}
}

#NEW270205: Archive DestDIR (rename Old, and create NewDir)
bind .tile.bottom.pane.f3.box.etTotal <3> {
	if {!$active} {
		set dir [string trimright $destDir /]
		regsub -nocase -all {\-} [clock clicks] {} code
		if {[catch {file rename -force $dir ${dir}_${code}}]!=0} {
        		dispMSG $msgText(dir.rename.failed)
        		setLED red
        		return
                }
		if {![file isdirectory $dir]} {
			catch {file mkdir $dir}
		}
		set cfile [acode encode [string trim $dir /]]
		set prevdir [string trimright $cacheLocation /]/cache/preview/[lindex [split $cfile {}] 0]
		set dir ${prevdir}/${cfile}
		if {[file exists ${dir}.FQV]} {
			catch {file rename -force ${dir}.FQV ${dir}_${code}.FQV}
			#catch {file rename -force ${dir}.FQI ${dir}_${code}.FQI}
		}
		dispMSG $msgText(dir.renamed)
		refreshTotal
		setLED blue
	}
}
#CutLinks
label .tile.bottom.pane.f3.box.cbCutLinks -text $appText(.tile.bottom.pane.f3.box.cbCutLinks.$cutLinks) -image imCutLeft -compound left -borderwidth 3 -background $backColor -foreground $fgColor -font $sysFont(4) -relief ridge -disabledforeground $etryBack
bind .tile.bottom.pane.f3.box.cbCutLinks <1> {
	if {!$active} {chngLinkState left}
}
bind .tile.bottom.pane.f3.box.cbCutLinks <3> {
	if {!$active} {chngLinkState right}
}

checkbutton .tile.bottom.pane.f3.box.cbFollow -text $appText(.tile.bottom.pane.f3.box.cbFollow) -borderwidth 2 -variable followLinks -background $backColor -selectcolor green -font $sysFont(5) -indicatoron false \
	-command {
		if {$followLinks==1} {
			.tile.bottom.pane.f3.box.cbFollow configure -background green -activebackground lightgreen -text $appText(.tile.bottom.pane.f3.box.cbFollow)
			if {[llength $selected]<=0 || ![lGrep $fTypes(HTML) $selected]} {
				#AddSelected $urltext 1
				selectALL 1
			}
		} else {
			.tile.bottom.pane.f3.box.cbFollow configure -background $backColor -activebackground $normLight -text $appText(.tile.bottom.pane.f3.box.cbFollow)
		}
	}

# Fortschrittsanzeiger Gesamt, unten
canvas .tile.bottom.pane.f3.box.prgBar -height 2 -relief sunken -borderwidth 1 -background $normLight -highlightbackground $backColor
.tile.bottom.pane.f3.box.prgBar create rectangle 0 0 0 4 -fill $barColor -tags proBar
pack .tile.bottom.pane.f3.box.prgBar -in .tile.bottom.pane.f3.box -side bottom -fill x -padx 1 -pady 2 -expand true
pack .tile.bottom.pane.f3.box.cbFollow -in .tile.bottom.pane.f3.box -side right -padx 3 -pady 2
pack .tile.bottom.pane.f3.box.cbCutLinks -in .tile.bottom.pane.f3.box -side right -padx 2 -pady $padv
pack .tile.bottom.pane.f3.box.spStype -padx 1 -pady $padv -side right
pack .tile.bottom.pane.f3.box.lbType -in .tile.bottom.pane.f3.box -side right -padx 1 -pady 1
pack .tile.bottom.pane.f3.box.lbStype -in .tile.bottom.pane.f3.box -side right -padx 1 -pady 0
#pack .tile.bottom.pane.f3.box.cbCutLinks -in .tile.bottom.pane.f3.box -side right -padx 2 -pady 2
pack .tile.bottom.pane.f3.box.etTotal -in .tile.bottom.pane.f3.box -side right -padx 1 -pady 3
pack .tile.bottom.pane.f3.box.lbTotal -in .tile.bottom.pane.f3.box -side right -padx 1 -pady 0
pack .tile.bottom.pane.f3.box.lbDest .tile.bottom.pane.f3.box.btBrowse -in .tile.bottom.pane.f3.box -side left -padx 1 -pady 1
pack .tile.bottom.pane.f3.box.etDest -in .tile.bottom.pane.f3.box -side left -fill x -padx 1 -pady $padv -expand true
pack .tile.bottom.pane.f3.box -in .tile.bottom.pane.f3 -padx 1 -fill x -expand true

#NEW220505: Set CutLink Button on/off
if {[winfo exists .tile.bottom.pane.f3.box.cbCutLinks]} {
	switch $cutLinks {
		0 {.tile.bottom.pane.f3.box.cbCutLinks configure -image imCutNone -compound left}
		1 {.tile.bottom.pane.f3.box.cbCutLinks configure -image imCutRght -compound left}
		2 {.tile.bottom.pane.f3.box.cbCutLinks configure -image imCutLeft -compound left}
		3 {.tile.bottom.pane.f3.box.cbCutLinks configure -image imCutBoth -compound left}
	}
	if {$cutLinks > 0} {
		if {$cutFiles==0} {
			.tile.bottom.pane.f3.box.cbCutLinks configure -background black -foreground yellow
		} else {
			.tile.bottom.pane.f3.box.cbCutLinks configure -background red -foreground black
		}
	} else {
		if {$cutFiles==0} {
			.tile.bottom.pane.f3.box.cbCutLinks configure -background black -foreground green
		} else {
			.tile.bottom.pane.f3.box.cbCutLinks configure -background red -foreground black
		}
	}
}

#Frame4 for FTP-Mode
label .tile.bottom.pane.f4.box -relief $panel -borderwidth 2 -background $backColor
#Klickbare Screws
frame .tile.bottom.pane.f4.clickScrewL -relief $panel -borderwidth 2 -background $backColor
label .tile.bottom.pane.f4.clickScrewL.cScrewL -image imScrews -relief $ScrewRelief -background $backColor -borderwidth 1 -cursor sb_left_arrow
pack .tile.bottom.pane.f4.clickScrewL -in .tile.bottom.pane.f4 -side left -padx 1
pack .tile.bottom.pane.f4.clickScrewL.cScrewL -in .tile.bottom.pane.f4.clickScrewL -padx 2 -pady 3

#Normale (interne Screws); nicht klickbar !
label .tile.bottom.pane.f4.box.imScrewL -image imScrews -relief $ScrewRelief -background $backColor -borderwidth 1
pack .tile.bottom.pane.f4.box.imScrewL -in .tile.bottom.pane.f4.box -side left -padx 2 -pady 1
label .tile.bottom.pane.f4.box.imScrewR -image imScrews -relief $ScrewRelief -background $backColor -borderwidth 1
pack .tile.bottom.pane.f4.box.imScrewR -in .tile.bottom.pane.f4.box -side right -padx 2 -pady 2
#Labels/Buttons
button .tile.bottom.pane.f4.box.btRip -text "Sniff" -command searchMode -image imFTPfind -activebackground $normLight -background $backColor
pack .tile.bottom.pane.f4.box.btRip -in .tile.bottom.pane.f4.box -side right -padx 2 -pady 2
#FTP-User/Passwd
label .tile.bottom.pane.f4.box.lbUser -text $appText(.tile.bottom.pane.f4.box.lbUser) -foreground $fgColor -borderwidth 1 -font $sysFont(2) -background $backColor -anchor w
entry .tile.bottom.pane.f4.box.etUser -textvariable FTPuser(local) -foreground $fgColor -background $etryBack -width 7 -relief ridge -borderwidth 1 -foreground Green -background black \
 -selectbackground LightGreen -selectforeground black -disabledbackground black
bind .tile.bottom.pane.f4.box.etUser <Return> {closeFTP; goEnter}
label .tile.bottom.pane.f4.box.lbPass -text $appText(.tile.bottom.pane.f4.box.lbPass) -foreground $fgColor -borderwidth 1 -font $sysFont(2) -background $backColor -anchor w
entry .tile.bottom.pane.f4.box.etPass -textvariable FTPpass(local) -show "*" -foreground $fgColor -background $etryBack -width 7 -relief ridge -borderwidth 1 -foreground Green -background black \
 -selectbackground LightGreen -selectforeground black -disabledbackground black
bind .tile.bottom.pane.f4.box.etPass <Return> {closeFTP; goEnter}
button .tile.bottom.pane.f4.box.btCopy -text $appText(.tile.bottom.pane.f4.box.btCopy) -command {copyFTP [chkFTPactive]} -activebackground $normLight -borderwidth 1 -width $FTPbuttonSize -font $sysFont(6) -background $backColor
button .tile.bottom.pane.f4.box.btMove -text $appText(.tile.bottom.pane.f4.box.btMove) -command {moveFTP [chkFTPactive]} -activebackground yellow -borderwidth 1 -width $FTPbuttonSize -font $sysFont(6) -background $backColor
button .tile.bottom.pane.f4.box.btRen -text $appText(.tile.bottom.pane.f4.box.btRen) -command {renameMode} -activebackground $normLight -borderwidth 1 -width $FTPbuttonSize -font $sysFont(6) -background $backColor
button .tile.bottom.pane.f4.box.btDel -text $appText(.tile.bottom.pane.f4.box.btDel) -command {deleteFTP [chkFTPactive]} -activebackground red -borderwidth 1 -width $FTPbuttonSize -font $sysFont(6) -background $backColor
button .tile.bottom.pane.f4.box.btGet -text $appText(.tile.bottom.pane.f4.box.btGet) -command {inputMode} -activebackground $normLight -borderwidth 1 -width $FTPbuttonSize -font $sysFont(6) -background $backColor
#NEW280505: Button "EDIT"
button .tile.bottom.pane.f4.box.btEdit -text $appText(.tile.bottom.pane.f4.box.btEdit) -command {EditText} -activebackground Green -borderwidth 1 -width $FTPbuttonSize -font $sysFont(6) -background $backColor
button .tile.bottom.pane.f4.box.btClose -text $appText(.tile.bottom.pane.f4.box.btClose) -command {closeFTP} -activebackground LightBlue -borderwidth 1 -width $FTPbuttonSize -font $sysFont(6) -background $backColor
label .tile.bottom.pane.f4.box.lbConvert -text $appText(.tile.bottom.pane.f4.box.lbConvert) -font $sysFont(2) -background $backColor
spinbox .tile.bottom.pane.f4.box.sbConvert -values "None $fTypes(Images)" -width 7 -foreground Green -background black -readonlybackground black \
	-state readonly -repeatdelay 500 -cursor {} -textvariable convert -disabledbackground black
label .tile.bottom.pane.f4.box.lbDirection -text "<<" -image imBack -relief groove -background Green -cursor hand2 -anchor nw
#LeftClick turns Direction, RightClick turns PipeOn/Off
bind  .tile.bottom.pane.f4.box.lbDirection <1> {chkClick 0}
bind  .tile.bottom.pane.f4.box.lbDirection <3> {chkClick 1}
bind  .tile.bottom.pane.f4.box.lbDirection <Any-Enter> {.tile.bottom.pane.f4.box.lbDirection configure -background LightGreen}
bind  .tile.bottom.pane.f4.box.lbDirection <Any-Leave> {.tile.bottom.pane.f4.box.lbDirection configure -background Green}
canvas .tile.bottom.pane.f4.box.prgBar -height 2 -relief sunken -borderwidth 1 -background $normLight -highlightbackground $backColor
.tile.bottom.pane.f4.box.prgBar create rectangle 0 0 0 4 -fill $barColor -tags proBar
pack .tile.bottom.pane.f4.box.prgBar -in .tile.bottom.pane.f4.box -side bottom -fill x -padx 1 -pady 2 -expand true
pack .tile.bottom.pane.f4.box.lbUser -in .tile.bottom.pane.f4.box -side left -padx 1 -pady 1
pack .tile.bottom.pane.f4.box.etUser -in .tile.bottom.pane.f4.box -side left -padx 1 -pady 1 -fill x -expand true
pack .tile.bottom.pane.f4.box.lbPass -in .tile.bottom.pane.f4.box -side left -padx 1 -pady 1
pack .tile.bottom.pane.f4.box.etPass -in .tile.bottom.pane.f4.box -side left -padx 1 -pady 1 -fill x -expand true
pack .tile.bottom.pane.f4.box.lbDirection -in .tile.bottom.pane.f4.box -side left -padx 1 -pady 1
pack .tile.bottom.pane.f4.box.btCopy .tile.bottom.pane.f4.box.btMove .tile.bottom.pane.f4.box.btRen \
     .tile.bottom.pane.f4.box.btDel .tile.bottom.pane.f4.box.btGet .tile.bottom.pane.f4.box.btEdit \
     .tile.bottom.pane.f4.box.btClose -in .tile.bottom.pane.f4.box -side left -pady 2
pack .tile.bottom.pane.f4.box.lbConvert .tile.bottom.pane.f4.box.sbConvert -in .tile.bottom.pane.f4.box -side left -padx 1 -pady 3
pack .tile.bottom.pane.f4.box -in .tile.bottom.pane.f4 -padx 1 -fill x -expand true

#UntereList (SelectionGFX/TextEntryIRC) Box
#other Cursors: draft_small, center_ptr, X_cursor, draft_large
frame .tile.bottom.foot -cursor hand2 -background $backColor
pack .tile.bottom.foot -anchor n -fill both -expand y
#ListBox (Selected)
frame .tile.bottom.foot.box -background $backColor
scrollbar .tile.bottom.foot.box.sbList -orient vertical -command {.tile.bottom.foot.box.selected yview}
#-selectbackground red -selectforeground cyan
#-fieldbackground LightGreen

#ListBox aus TextWidget
text .tile.bottom.foot.box.selected -yscrollcommand {.tile.bottom.foot.box.sbList set} \
        -font $sysFont(6) -exportselection false -state disabled -cursor hand2 \
	-foreground white -background $listColor -selectbackground $normLight -selectforeground $fgColor
pack .tile.bottom.foot.box.sbList -in .tile.bottom.foot.box -side right -fill y -pady 1
pack .tile.bottom.foot.box.selected -in .tile.bottom.foot.box -fill both -expand true
pack .tile.bottom.foot.box -in .tile.bottom.foot -fill both -expand true

#NEU210404: AddTiledWindows (Top/Bottom)
.tile add .tile.top .tile.bottom
if {$smallStyle==1} {
   .tile paneconfigure .tile.bottom -minsize 38 -height 38
} else {
   .tile paneconfigure .tile.bottom -minsize 44 -height 44
}
.tile paneconfigure .tile.top -pady 2

#UntereInfo (Link) Zeile
#InfoZhler (rechtsUnten) AnzSelectedGFX
label .lbAnzSelGfx -textvariable anzSEL -relief sunken -foreground $fgColor -background $backColor -font "Arial 9" -anchor w
label .imScrew6 -image imScrew -relief $ScrewRelief -background $backColor -borderwidth 1
pack .lbAnzSelGfx -in . -side right -padx 3 -anchor w
pack .imScrew6 -in . -side right -padx 4
#NEU150304: bei HTTPS-Image anzeigen
label .imHTTPS -image imUnLock -relief sunken -height 16 -background $backColor
#Screw untenLinks/Rechts
label .imScrew5 -image imScrew -relief $ScrewRelief -background $backColor -borderwidth 1
pack .imHTTPS .imScrew5 -in . -side left -padx 3 -pady 1 -expand false
#dazwischen Frame9 mit InfoZeile (Links)
frame .f9 -background $backColor
#label .f9 -background $backColor
pack .f9 -in . -side right -fill x -expand true
#Display LinkURL
label .f9.lbShowURL -textvariable linktext -font $sysFont(1) -relief ridge -foreground $fgColor -background $backColor -anchor w
#-width 120
pack .f9.lbShowURL -in .f9 -side left -pady 2 -fill x -expand true -anchor w

#NEW030711: hide/show Menu on leftclick ScrewRight (experimental)
bind .imScrew6 <1> {
	if {$hideMenu == 0} {
		set hideMenu 1		
		pack forget .mbar
	} else {
		set hideMenu 0		
		pack .mbar -in . -side top -fill x
	}
}
#Emergency STOP (if menu is hidden)
bind .imScrew5 <1> {Stop $token}

#NEW220105: Frenzy's CommandInpterpreter (FCI) TM
set cmd ""
set openCMD 0
label .f9.lbCMD -text "FCI:" -relief flat -foreground green -background black
#-foreground $fgColor -background $backColor
entry .f9.etCMD -textvariable cmd -font $sysFont(2) -relief sunken -foreground black -background white -takefocus true
# -cursor {X_cursor lila green red}

#Open FCI console
bind .imScrew5 <3> {
        if {$openCMD == 0 && $kidZprotect==0} {
                set openCMD 1
                dispMSG "FCI open; Welcome Frenzy !"
                pack forget .f9.lbShowURL
                pack .f9.lbCMD -in .f9 -side left -padx 2 -pady 1
				pack .f9.etCMD -in .f9 -side left -padx 2 -pady 1 -fill x -expand true
                .tile.bottom.foot.box.selected configure -state normal
                focus .f9.etCMD
                #set selected ""
                clearSelected
                bind .f9.etCMD <Return> {
                        regsub -nocase -all {\$} $cmd {} cmd
                        set dummy [concat [split $cmd " "]]
                        set command [string toupper [lindex $dummy 0]]
                        regsub -nocase {^[a-z][a-z][a-z]} $cmd $command cmd
                        if {[string length $command]<=0} return
                        switch $command {
                               ADD {lappend selected "$cmd = [incr $[lindex $dummy 1]]\n"}
                               ANI {lappend selected "$cmd = [set ANIdelay [lindex $dummy 1]]\n"}
                               ARY {lappend selected "$cmd = [array get [lindex $dummy 1]]\n"}
                               CDR {lappend selected "$cmd = [cd [lindex $dummy 1]]\n"}
                               CAL {lappend selected "$cmd = [if {[llength $dummy]>1} {[lindex $dummy 1] [lrange $dummy 2 end]} else {[lindex $dummy 1]}]\n"}
                               CLR {lappend selected "$cmd = [catch {clearBoth}]\n"}
                               CLS {lappend selected "$cmd = [catch {clearSelected}]\n"}
                               COM {lappend selected "$cmd = [info commands [lindex $dummy 1]]\n"}
                               CUT {lappend selected "$cmd = [set urltext [cutLink $urltext]]\n"}
                               DIR {lappend selected "$cmd = [set out ""; foreach inhalt [glob -nocomplain *] {append out "$inhalt\n"}; append selected $out]\n"}
                               DOM {lappend selected "$cmd = [catch {clearCache 1}]\n"}
                               DSP {lappend selected "$cmd = [subst $[lindex $dummy 1]]\n"}
                               DCD {lappend selected "$cmd = [set urltext [acode decode [::base64::decode $urltext]]]\n"}
                               END {lappend selected "$cmd = Leave Inquisitor\n"; set cClean 0; refreshSelected; leavePRG -1}
                               ERR {lappend selected "$cmd = [concat $errorCode $errorInfo]\n"}
                               EXT {set openCMD 0; clearSelected ; pack forget .f9.lbCMD .f9.etCMD; pack .f9.lbShowURL -in .f9 -side left -padx 2 -pady 2 -fill x -expand true; .tile.bottom.foot.box.selected configure -state disabled}
                               GOD {dispMSG "Are you kidding ?!"}
                               HLP {lappend selected "$cmd = [helpCMD [lindex $dummy 1]]\n"}
                               HOM {lappend selected "$cmd = [pwd]\n"}
                               HST {lappend selected "$cmd = [info hostname]\n"}
                               IFO {lappend selected "$cmd = [info exists [lindex $dummy 1]]\n"}
                               KIL {lappend selected "$cmd = KILL Inquisitor\n"; destroy .}
                               LIB {lappend selected "$cmd = [array get tcl_library]\n"}
                               LST {lappend selected "$cmd = [lappend [lindex $dummy 1] [lrange $dummy 2 end]]\n"}
                               MOD {lappend selected "$cmd = 0\n"; ChangeMode [lindex $dummy 1]}
                               MSG {lappend selected "$cmd = [dispMSG [lindex $dummy 1]]\n"}
                               OPN {lappend selected "$cmd = [catch {LoadPage [subst $[lindex $dummy 1]]}]\n"}
                               OUT {lappend selected "$cmd = [catch {renderHTML [regsub -nocase -all "\n" [join $selected] "<br>\n"]}]\n"; catch {clearSelected}}
                               QIT {lappend selected "$cmd = Quit Inquisitor\n"; refreshSelected; leavePRG 0}
                               RMT {lappend selected "$cmd = [catch {trace vdelete [subst $[lindex $dummy 1]] rw {dispMSG [subst $[lindex $dummy 1]]}}]\n"}
                               PRG {lappend selected "$cmd = [info procs [lindex $dummy 1]]\n"}
                               PRO {lappend selected "$cmd = [info args [lindex $dummy 1]]\n"}
                               PTH {lappend selected "$cmd = [concat tcl_pkgPath]\n"}
                               SET {lappend selected "$cmd = [catch {set [subst [lindex $dummy 1]] [lindex $dummy 2]}]\n"}
                               SRC {lappend selected "$cmd = [info body [lindex $dummy 1]]\n"}
                               STP {lappend selected "$cmd = Stop\n"; set cancel 1}
                               SUB {lappend selected "$cmd = [expr $[lindex $dummy 1] - 1]"\n}
                               TRC {lappend selected "$cmd = [catch {trace variable [subst $[lindex $dummy 1]] rw {dispMSG [subst $[lindex $dummy 1]]}}]\n"}
                               VAR {lappend selected "$cmd = [info vars [lindex $dummy 1]]\n"}
                               VER {lappend selected "$cmd = [array get tcl_platform]\n"}
                               default {lappend selected "$cmd = Unknown Command !\n"}
                        }
                        refreshSelected
                        set cmd ""
						focus .f9.etCMD
                        #focus .f9.lbCMD
                }
        } else {
                set openCMD 0
                clearSelected
                pack forget .f9.lbCMD .f9.etCMD
                pack .f9.lbShowURL -in .f9 -side left -padx 2 -pady 2 -fill x -expand true; .tile.bottom.foot.box.selected configure -state disabled
        }
}

#ButtonKlick2Left/Right Screws (SelectModes)

bind .tile.bottom.pane.f2.clickScrewR.cScrewR <1> {ChangeMode 3}
bind .tile.bottom.pane.f4.clickScrewL.cScrewL <1> {ChangeMode 3}

#Frame3 (Mitte) ScrewLinks/Rechts (also Mode wechseln)
bind .tile.bottom.pane.f3.box.clickScrewL <1> {ChangeMode 2}
bind .tile.bottom.pane.f3.box.clickScrewR <1> {ChangeMode 4}

#Klick auf ScanValue (ScannerMode) oben in URL
# HTTP://media-us01.girlspublicnudity.com/shg/75/art/1/9/0.jpg !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
bind .head.scanUrl.lbValue <1> {
	if {[lindex $scanType 0]!="Numeric"} return
	incr URLvalueIDX
	set start [lindex $URLvalue $URLvalueIDX]
#puts "Start: $start $URLvalueIDX"
	if {[string length $start]<=0} {
		set URLvalueIDX 0
		set start [string trim [lindex $URLvalue 0]]
	}
#CHNG161010:
#	set startvalue [expr int($start)]
        set startvalue [scan $start %d]
	if {$startvalue>9999} {set start 1; set startvalue 1}
	regsub -nocase $start $urltext {~} dummy
#puts "dummy: $dummy"
	#NEW050605: wenn 2 identische URLvalues in URL enthalten sind
	if {$URLvalueIDX==1} {
		regsub -nocase -all $start $dummy {} dummy
		if {[regexp -nocase -all {} $dummy]} {
			regsub -nocase -all {~} $dummy $start dummy
			regsub -nocase -all {} $dummy {~} dummy
		}
	}
#puts "dummy2: $dummy"
	set dummy [split $dummy ~]
	set startURL [string trim [lindex $dummy 0]]
	set endURL [string trim [lindex $dummy end]]
#puts "end: $endURL"
	if {[string length $endURL]<=0} {
		set endURL /
	}
	set merkScan $endURL
	set endvalue [expr int($startvalue + 10)]
	if {$endvalue>9999} {set end 9999; set endvalue 9999}
	set end $endvalue
	#Set CounterValues
	.tile.bottom.pane.f2.box.start set $startvalue
	.tile.bottom.pane.f2.box.stop set $endvalue
	.tile.bottom.pane.f2.box.scanLen set [string length $start]
	.tile.bottom.pane.f2.box.lbPlus configure -text "+" -relief raised -background $backColor
	#Set CounterFormat (leading "0"s)
        set scanLen [string length $start]
        if {$scanLen>1} {
              	set counter "%%0$scanLen.0f"
        } else {
              	set counter "%%$scanLen.0f"
        }
	.tile.bottom.pane.f2.box.start configure -format $counter
	.tile.bottom.pane.f2.box.stop configure -format $counter
	#Set URL Display
	.head.scanUrl.lbStart configure -text $startURL -width [string length $startURL]
	.head.scanUrl.lbValue configure -text $start -width [string length $start]
	.head.scanUrl.lbEnd configure -text $endURL
	unset dummy
}

#Klick auf +/- (ScannerMode)
bind .tile.bottom.pane.f2.box.lbPlus <1> {
	set dummy [.tile.bottom.pane.f2.box.lbPlus cget -text]
	set type $scanType
	set start [.head.scanUrl.lbValue cget -text]
	set end [.tile.bottom.pane.f2.box.stop cget -text]
	if {$start<=0 || $start==""} {set start 00}
	if {$end<=0 || $end==""} {set end 00}
	if {$type=="Numeric"} {catch {expr int($start)} startValue}
	if {$dummy=="+"} {
		.tile.bottom.pane.f2.box.lbPlus configure -text "-" -relief sunken -background $backColor
		if {$type=="Numeric"} {
			if {$startValue > 10} {
				catch {expr $startValue - 10} end
			} else {
				set end 0
			}
		}
	}
	if {$dummy=="-"} {
		.tile.bottom.pane.f2.box.lbPlus configure -text "+" -relief raised -background $backColor
		if {$type=="Numeric"} {
			catch {expr $startValue + 10} end
			if {$end>9999} {
				set end 9999
			}
		}
	}
	if {$type=="Numeric"} {

	        set scanLen [string length $start]
                if {$scanLen>1} {
                    	set counter "%%0$scanLen.0f"
                } else {
                   	set counter "%%$scanLen.0f"
                }
		#Set CounterValues
		.tile.bottom.pane.f2.box.start set $start
		.tile.bottom.pane.f2.box.stop set $end
		#Set CounterFormat (leading "0"s) -format %03.0f
		.tile.bottom.pane.f2.box.start configure -format $counter
		.tile.bottom.pane.f2.box.stop configure -format $counter
		.tile.bottom.pane.f2.box.scanLen set $scanLen
	}
	unset dummy
}

#Mouse on ImgCounter (Button CLRSelected)
bind . <Motion> {
	if {!$active && $rubber==0} {
		set parent %W
#if {$parent==".tile.bottom.foot.box.selected"} {puts [%W tag names @%x,%y]}
                #TrashSelectCounter
                if {$parent==".lbAnzSelGfx"} {
			.lbAnzSelGfx configure -image imTrash -relief raised -background $backColor -width $trashSize -height $trashSize
		} else {
			.lbAnzSelGfx configure -image "" -relief sunken -foreground $fgColor -background $backColor -width [string length $anzSEL] -height 1

		}
#New160406: set "activeBackGround" on Buttons at MouseOver
#if {[winfo class $parent]=="Button"} {$parent configure -background $normLight} else {$parent configure -background $backColor}
                if {$parent==".mbar.back"} {.mbar.back configure -background $normLight} else {.mbar.back configure -background $backColor}
                if {$parent==".mbar.forw"} {.mbar.forw configure -background $normLight} else {.mbar.forw configure -background $backColor}
                if {$parent==".mbar.stop"} {.mbar.stop configure -background $normLight} else {.mbar.stop configure -background $backColor}
                if {$parent==".mbar.clrScreen"} {.mbar.clrScreen configure -background $normLight} else {.mbar.clrScreen configure -background $backColor}
                if {$parent==".mbar.home"} {.mbar.home configure -background $normLight} else {.mbar.home configure -background $backColor}
                if {$parent==".mbar.reload"} {.mbar.reload configure -background $normLight} else {.mbar.reload configure -background $backColor}
                if {$parent==".mbar.zoom"} {.mbar.zoom configure -background $normLight} else {.mbar.zoom configure -background $backColor}
                if {$parent==".mbar.zoomin"} {.mbar.zoomin configure -background $normLight} else {.mbar.zoomin configure -background $backColor}
                if {$parent==".mbar.zoomout"} {.mbar.zoomout configure -background $normLight} else {.mbar.zoomout configure -background $backColor}
#                .head.dispUrl.btClrUrl .head.dispUrl.btHtml .head.dispUrl.btEnter .head.scanUrl.btHtml .head.searchDoc.btClrSrc .head.searchDoc.btEnter .head.searchDoc.btSearch
#                .head.mkdirFTP.btClrSrc .head.mkdirFTP.btEnter

#               #NEW220406: Display cache Location on MouseOver URL
                if {$parent==".head.dispUrl.url"} {
                         if {[string length $urltext]>0} {
                                set dummy [regSTR $remSTR $urltext]
                                set fake [getCachedir $dummy]
                                set dummy [acode encode $dummy]
		                set linktext "Cache: [string trimright $cacheLocation /]/cache/html/[string trim $fake]/$dummy"
                         }
                }

#		#NEW121004: BookmarksOnURL
		if {$parent==".head.dispUrl.lbUrl"} {
			#::imBookOpen configure -height 16 -width 30
			.head.dispUrl.lbUrl configure -relief raised -image imBook48 -height 16 -width 30
		} else {
			.head.dispUrl.lbUrl configure -relief ridge -image "" -width 4 -height 1
		}
		#NEW010706: show FavIcon if exists
		if {$getFavIcon>=0} {
			if {$parent==".head.dispUrl.btClrUrl"} {
				.head.dispUrl.btClrUrl configure -relief raised -image imClrURL -background $backColor
			} else {
				if {[string length $imFavIcon]>2 && [info exists imFavIcon] && ![regexp -nocase {imClrURL} $imFavIcon]} {
					catch {.head.dispUrl.btClrUrl configure -relief groove -image $imFavIcon -height 16 -width 16 -background white}
				} else {
					.head.dispUrl.btClrUrl configure -relief raised -image imClrURL -background $backColor
				}
			}
		}
#NEW290505: TotalLabel = Forw/Back Page
#WinProblems Panel
		if {$parent==".tile.bottom.pane.f3.box.lbTotal"} {
				.tile.bottom.pane.f3.box.lbTotal configure -image imBack48 -relief raised -width 48 -height 16
		} else {
				.tile.bottom.pane.f3.box.lbTotal configure -text $appText(.tile.bottom.pane.f3.box.lbTotal) -relief groove -image "" -width [string length $appText(.tile.bottom.pane.f3.box.lbTotal)] -height 1
		}
		if {$parent==".tile.bottom.pane.f3.box.lbStype"} {
				.tile.bottom.pane.f3.box.lbStype configure -image imForw48 -relief raised -width 48 -height 16
		} else {
				.tile.bottom.pane.f3.box.lbStype configure -text $appText(.tile.bottom.pane.f3.box.lbStype) -relief groove -image "" -width [string length $appText(.tile.bottom.pane.f3.box.lbStype)] -height 1
		}

#WinProblems menu
		if {$parent==".f9.lbShowURL"} {
			if {$maxBytes > 0 && $ByteCount > $maxBytes} {
				setLED red
				dispINF "$msgText(download.5)"
				set linktext "Total Traffic: $ByteCount KBytes ([expr $ByteCount / 1024] MB) / $maxBytes KBytes ([expr $maxBytes / 1024] MB)"
				.tile.bottom.pane.f3.box.btRip configure -activebackground red -background red
				if {$fsizeWarn == 1} {
					optionBox -title $msgText(warning.traffic.1) -icon warning -type ok -message $msgText(warning.traffic.2)
				}
			} else {
   			        set linktext "Total Traffic: $ByteCount KBytes ([expr $ByteCount / 1024] MB)"
			}
		}

		#NEW030705: MouseOnStatus
		if {$parent==".mbar.lbText" || $parent==".mbar.lbStatus"} {
			dispINF "Traffic: $ByteCount KBytes ([expr $ByteCount / 1024] MB)"
			if {$maxBytes > 0 && $ByteCount > $maxBytes} {
				setLED red
				dispINF "$msgText(download.5)"
				set linktext "Total Traffic: $ByteCount KBytes ([expr $ByteCount / 1024] MB) / $maxBytes KBytes ([expr $maxBytes / 1024] MB)"
				.tile.bottom.pane.f3.box.btRip configure -activebackground red -background red
				if {$fsizeWarn == 1} {
					optionBox -title $msgText(warning.traffic.1) -icon warning -type ok -message $msgText(warning.traffic.2)
				}
			}
		}

                #NEW220406: Destination/Cache Size
                if {$parent==".tile.bottom.pane.f3.box.lbDest" || $parent==".tile.bottom.pane.f3.box.btBrowse" || $parent==".tile.bottom.pane.f3.box.etDest"} {
     		                set linktext "$msgText(space.destination) $destSpace KB"
                }
                if {$parent==".mbar.lbAnim" || $parent==".imHTTPS"} {set linktext "$msgText(space.cache) $cacheSpace KB ([string trimright $cacheLocation /]/cache/)"}

#		#TotalFileCounter
		if {$parent==".tile.bottom.pane.f3.box.etTotal"} {
			.tile.bottom.pane.f3.box.etTotal configure -relief raised
		} else {
			.tile.bottom.pane.f3.box.etTotal configure -relief sunken
		}
		#FileGroupIcon
		if {$parent==".tile.bottom.pane.f3.box.lbType"} {
			.tile.bottom.pane.f3.box.lbType configure -relief raised
		} else {
			.tile.bottom.pane.f3.box.lbType configure -relief sunken
		}
#		#imLock (show decoded Links)
		if {$parent==".imHTTPS"} {
			    .imHTTPS configure -image imMagnify -relief raised
		} else {
		    	if {$showDecode>0} {
				    .imHTTPS configure -image imMagnify -relief raised
				} else {
			   	    switch $MapMode {
						   2 {.imHTTPS configure -image imScanMode -relief sunken}
   						   5 {.imHTTPS configure -image imIRC -relief sunken}
   						   default {.imHTTPS configure -image imUnLock -relief sunken}
	   				}
				}
		}

#		#CutLinksButton
		if {$parent==".tile.bottom.pane.f3.box.cbCutLinks"} {
			if {$cutFiles==0} {
				.tile.bottom.pane.f3.box.cbCutLinks configure -relief raised
			} else {
				.tile.bottom.pane.f3.box.cbCutLinks configure -relief ridge
			}
		} else {
			if {$cutLinks > 0} {
				if {$cutFiles==0} {
					.tile.bottom.pane.f3.box.cbCutLinks configure -background black -foreground yellow -relief ridge
				} else {

					.tile.bottom.pane.f3.box.cbCutLinks configure -background red -foreground yellow -relief sunken
				}
			} else {
				if {$cutFiles==0} {
					.tile.bottom.pane.f3.box.cbCutLinks configure -background black -foreground green -relief ridge
				} else {
					.tile.bottom.pane.f3.box.cbCutLinks configure -background red -foreground green -relief sunken
				}
			}
		}

	} elseif {$rubber==1} {
			#set parent %W
			set child [winfo containing [winfo pointerx .] [winfo pointery .]]
			set xp [winfo pointerx $child]
			set yp [winfo pointery $child]
			set x [expr $xp - [winfo rootx $child]]
			set y [expr $yp - [winfo rooty $child]]
			set x0 [winfo x $child]
			set y0 [winfo y $child]
			set xe [expr $x0 + [winfo width $child]]
			set ye [expr $y0 + [winfo height $child]]
			set linktext "$msgText(select.area): X1=$rubberX1 , Y1=$rubberY1 / X2=$x , Y2=$y"
	$mainHTML yview scroll 1 units
	$mainHTML yview moveto 0.0
			if {$autoscroll > 0} {
				if {$xp<$x0} {update; $mainHTML xview scroll -1 units; after 300}
				if {$xp>$xe} {update; $mainHTML xview scroll 1 units; after 300}

				if {$yp<$y0} {update; $mainHTML yview scroll -1 units; after 300}
				if {$yp>$ye} {update; $mainHTML yview scroll 1 units; after 300}
			}
	}
}

#NEW221006: ESC/Pause-Key
bind . <Escape> {Stop $token; .mbar.stop configure -background $backColor}
#BOSS-Key:
bind . <Pause> {wm iconify .}

#MouseClick on ImgCounter (Button CLRselected)
bind .lbAnzSelGfx <1> {
	if {!$active} {
		.lbAnzSelGfx configure -image imTrash -relief sunken -background $backColor -width $trashSize -height $trashSize
		bind .lbAnzSelGfx <ButtonRelease-1> {
			clearSelected
			.lbAnzSelGfx configure -image "" -relief sunken -foreground $fgColor -background $backColor -width [string length $anzSEL] -height 1
		}
	}
}

trace variable active w chkActive

bind .imHTTPS <1> {
	if {$showDecode<=0} {
	    .imHTTPS configure -image imMagnify -relief sunken
	    .f9.lbShowURL configure -relief groove -foreground $listColor -background $normLight
	    set showDecode 1
	} else {
   	    .imHTTPS configure -image imUnLock -relief sunken
   	    .f9.lbShowURL configure -relief ridge -foreground $fgColor -background $backColor
   	    set showDecode 0
	}
}

# "Enter"-Taste, wenn URL manuell eingegeben wird (NormalMode)
.head.dispUrl.url bind <Return> {set idxHistry [llength $histry]; set cookie ""; preSolve}

# linke Maus > empty ListBox Area (=extract Links from HTMLtree)
bind .tile.bottom.foot.box.selected <1> {
     if {$tagIDX<=0} {
          selectALL 0; scanHistory 0; clearSelected
     }
}
# rechte Maus > empty ListBox Area (=de-/select Links)
bind .tile.bottom.foot.box.selected <3> {
     if {$tagIDX<=0} {
 	      selectALL 1
     }
}

#NEW010907: MiddleMouseKey selcts all and download at once
bind .tile.bottom.foot.box.selected <2> {
     if {$tagIDX<=0} {
#     	set active 1
	 	selectALL $followLinks
		downloadStart
	 }
}

#Fun: User Clicked on "Tux"
bind .mbar.lbAnim <1> {HELPabout}
bind .mbar.lbAnim <3> {
	.mbar.lbAnim configure -image imTuxFly
	set infostatus "What's up, Bill ?!"
#	setLED yellow
	after 580 {set infostatus $msgText(fiq.ready)}
	if {$kidZprotect==1} {
               after 480 {.mbar.lbAnim configure -image imKidTux}
        } else {
               if {$ignoreReDir==1} {
                     after 480 {.mbar.lbAnim configure -image imTuxInfiltrate}
              } else {
                     after 480 {.mbar.lbAnim configure -image imAnim}
              }
        }
}

#Initialisation finished
#Setup ErrorHandler (funzt nich so richtig)
#bgerror [onError "$errorCode $errorInfo"]

#Load FIQconfiguration
if {[file exists $inifile]} {
	LoadScript $inifile
} else {
	SaveScript $inifile
}

#NEW210406: change DestDir into HomeDir if not exists
if {![file isdirectory $destDir] && ![file exists $destDir]} {
   set destDir [string trimright $homeDir /]/pictures/
}

#NEW260910
addDirlist $destDir

#Create CacheDirs, if not exists
mkCacheDir

#NEW:110606 preFill recivedBytes Array up to max $HTMLsync (max=100)
for {set i -2} {$i <= 100} {incr i} {
	set rbytes($i) 0
	set tbytes($i) 1
}

#NEW071205: show Debug (and other) Information(s) only when started from console
if {$FIQexe==1} {
	pack forget .tile.top.conf.page.fpage3.frm.lfSystem .tile.top.conf.page.fpage4.lfFTP.etDebug .tile.top.conf.page.fpage3.frmleft.lfImages.etUnknownGFX \
        .tile.top.conf.page.fpage3.frm.lfCache.cbCompress .tile.top.conf.page.fpage4.lfFile.etDivZoom .tile.top.conf.page.fpage4.lfFile.etRender \
        .tile.top.conf.page.fpage3.frm.lfCache.cbCacheSpeed .tile.top.conf.page.fpage3.frHtm.lfHtml.cbSaveTimeout
	set debug 0
}

if {[string length $skinFile]>0} {
	if {[file exists $skinFile]} {setSkin}
}

#Set Total Counter
refreshTotal
#NEW050205: Load/Save SelectedFileType in CFG
chkSelection $prefType
.tile.bottom.pane.f3.box.spStype set $prefType

#readCommandLine
if {$command!=""} {
	#set ext [lindex [split $command /] end]
	set ext [lindex [split $command .] end]
	if {[regexp -nocase ini $ext]} {
		LoadScript $command
	} else {
		if {[regexp -nocase -all {\.|^http:/|^ftp:/} $command] || ([chkEXT $ext] || [chkIMG $ext] || [chkTXT $ext] || [chkANI $ext])} {
			set urltext [upperHTTP $command]
			if {[string length $urltext]>0} {
				set home $urltext
				goEnter
			}
		} else {
		#Command beinhaltet bereits HTML-Seite (weil z.B. von KQ bergeben)
			set cache [string trimright $cacheLocation /]/cache/html/virtualPage
			mkCacheDir
			if {[file exists $cache]} {
				file delete -force $cache
			}
			if {![catch {open $cache "w"} fileid]} {
				puts $fileid $command
				close $fileid
				LoadPage $cache
			}
		}
	}
} else {
	# Wenn kein File bei Start angegeben, dann setzte URL-Eingabe auf aktiv
	Buttons 0
#	label $mainHTML.info -image imInfo -background [$mainHTML cget -background] -width [$mainHTML cget -width]; pack $mainHTML.info -side top -anchor nw
	$mainHTML parse "<BODY bgcolor=$htmlBG color=$htmlFG><b>$version</b><br><b>(C) 2011 by: Frenzy Softworks<br>Written by: Jens Timmermann</b><br></BODY>"
	catch {show_anigif [list -data [getAnim tumbler22]] .mbar.lbAnim}
	after 1900 {catch {stop_anigif .mbar.lbAnim}}
}

#Restore WinPositions
set f [lindex [split $cfgfile .] 0].POS
if {[file exists $f]} {loadPOS $f}

#NEW300706: Load Filter if exists
set f [lindex [split $cfgfile .] 0].FIL
if {[file exists $f]} {
   set dummy [openFile $f]
   if {[string length $dummy]>0} {set filter $dummy}
}

#BubbleHelp on/off
if {$bHelp==1} {bubbleHelp}
#Enable/Disable ShowLinkTypeIcons
if {$markIcons==1} {
        .tile.bottom.pane.f3.box.lbType configure -state normal
} else {
        .tile.bottom.pane.f3.box.lbType configure -state disabled
}

if {$kidZprotect==0} {
	if {$ignoreReDir==0} {
		.mbar.lbAnim configure -image imAnim
	} else {
		.mbar.lbAnim configure -image imTuxInfiltrate
	}
} else {
	.mbar.lbAnim configure -image imKidTux
}

#NEW221006:
if {$noTimeout<=0} {
    .tile.top.conf.page.fpage3.frHtm.lfHtml.cbSaveTimeout configure -state disabled
} else {
    .tile.top.conf.page.fpage3.frHtm.lfHtml.cbSaveTimeout configure -state normal
}

#NEW290505: ScanMode with/withoutFile
if {$scanFile>0} {activeScanType $scanFile}

# Maus over Link ?
set merk ""
bind HtmlClip <Motion> {
	if {$rubber==0} {colorize %W %x %y}
}
set selected ""

#New151005: RubberBand Selection
bind . <KeyPress-Alt_L> {
	if {!$active && $rubber==0} {
	#	set parent %W
		#set child [winfo containing [winfo pointerx .] [winfo pointery .]]
		catch {winfo containing [winfo pointerx .] [winfo pointery .]} child
		set win .tile.top.html.tile.html.pane
		regsub -nocase -all {.x$} $child {} htm
		if {$child=="$win.left.hold.local.x" || $child=="$win.rght.hold.remote.x"} {
			set rubber 1
			$htm configure -cursor cross
			set rubberX1 [expr [winfo pointerx $child] - [winfo rootx $child]]
			set rubberY1 [expr [winfo pointery $child] - [winfo rooty $child]]
			if {![winfo exists .rubber]} {
				catch {label .rubber -image imRubber -background [$child cget -background]}
				catch {place .rubber -in $child -x $rubberX1 -y $rubberY1}

			}
		}
	}
}

bind . <KeyRelease-Alt_L> {
	if {!$active && $rubber==1} {
		set rubber 0
		set rubberX2 [expr [winfo pointerx $child] - [winfo rootx $child]]
		set rubberY2 [expr [winfo pointery $child] - [winfo rooty $child]]
		rubberSelect $rubberX1 $rubberY1 $rubberX2 $rubberY2
		$htm configure -cursor {}
		catch {place forget .rubber; destroy .rubber}
	}
}

#NEW210106: (left) Shift-Key pressed; used to selectALL 0 FileTypes even if ".JPG" is selected
bind . <KeyPress-Shift_L> {
	if {!$active && $shiftPress==0} {set shiftPress 1}
}

bind . <KeyRelease-Shift_L> {
	if {!$active && $shiftPress==1} {set shiftPress 0}
}

#CHNG010907: MouseMover like AcroBat
mouseMover

#NEW210207: MouswheelBinding as described under: http://www.tcl.tk/cgi-bin/tct/tip/171.html
proc ::tk::MouseWheel {wFired X Y D {shifted 0}} {
    # Set event to check based on call
    set evt "<[expr {$shifted?{Shift-}:{}}]MouseWheel>"
    # do not double-fire in case the class already has a binding
    if {[bind [winfo class $wFired] $evt] ne ""} { return }
    # obtain the window the mouse is over
    set w [winfo containing $X $Y]
    # if we are outside the app, try and scroll the focus widget
    if {![winfo exists $w]} { catch {set w [focus]} }
    if {[winfo exists $w]} {
	if {[bind $w $evt] ne ""} {
	    # Awkward ... this widget has a MouseWheel binding, but to
	    # trigger successfully in it, we must give it focus.
	    catch {focus} old
	    if {$w ne $old} { focus $w }
	    event generate $w $evt -rootx $X -rooty $Y -delta $D
	    if {$w ne $old} { focus $old }
	    return
	}
	# aqua and x11/win32 have different delta handling (norm=30)
	if {[tk windowingsystem] ne "aqua"} {
	    set delta [expr {- ($D / 60)}]
#Softer Scrolling
#           set delta [expr {int(pow($D/-120,3))}]
	} else {
	    set delta [expr {- ($D)}]
	}
	# scrollbars have different call conventions
	if {[string match "*Scrollbar" [winfo class $w]]} {
	    catch {tk::ScrollByUnits $w \
		       [string index [$w cget -orient] 0] $delta}
	} else {
	    set cmd [list $w [expr {$shifted ? "xview" : "yview"}] \
			 scroll $delta units]
	    # Walking up to find the proper widget handles cases like
	    # embedded widgets in a canvas
	    while {[catch $cmd] && [winfo toplevel $w] ne $w} {
		set w [winfo parent $w]
	    }
	}
    }
}
bind all <MouseWheel> [list ::tk::MouseWheel %W %X %Y %D 0]
bind all <Shift-MouseWheel> [list ::tk::MouseWheel %W %X %Y %D 1]
if {[tk windowingsystem] eq "x11"} {
    # Support for mousewheels on Linux/Unix commonly comes through
    # mapping the wheel to the extended buttons.
    bind all <4> [list ::tk::MouseWheel %W %X %Y 120]
    bind all <5> [list ::tk::MouseWheel %W %X %Y -120]
}

#NEW090907: Bind SelectAll to CTRL+A
event add <<SelectAll>> <Control-a>
bind . <<SelectAll>> {selectALL $followLinks}

#NEW200805: TrafficWarning
if {$maxBytes > 0 && $ByteCount > $maxBytes} {
	setLED red
	dispINF "$msgText(download.5)"
	set linktext "Total Traffic: $ByteCount KBytes ([expr $ByteCount / 1024] MB) / $maxBytes KBytes ([expr $maxBytes / 1024] MB)"
	.tile.bottom.pane.f3.box.btRip configure -activebackground red -background red
	if {$fsizeWarn == 1} {
		optionBox -title $msgText(warning.traffic.1) -icon warning -type ok -message $msgText(warning.traffic.2)
	}
}

#New220406: Set VolumeSizes on WinDoof Systems
set cacheSpace [getSize $cacheLocation]
if {$cacheSpace < 102400} {
       .mbar.prgFile configure -background red
}
set destSpace [getSize $destDir]
if {$destSpace < 102400} {
       .tile.bottom.pane.f3.box.prgBar configure -background red
}

set lockfile [string trimright $cacheLocation /]/cache/FIQ.LOCK
if {[file exists $lockfile]} {
   catch {file delete -force $lockfile}
}

#Prg Start
set linktext "(C) 2011 by: Frenzy Softworks - Written by: Jens Timmermann"
after 2800 {set linktext ""}
#NEW121106: import SpyBots Blacklist if exists
if {[string length $blacklistDIR]<=0} {
	set f "[string trimright $homeDir /]/SYSTEM/Targets.nfo"
	if {[file exists $f]} {
	       blackList $f
	} else {
	       set infostatus "System $msgText(fiq.ready)"
	}
}
set anzGFX [llength [$mainHTML token find img]]
focus .head.dispUrl.url.e
#set activeHTM "local"
#update idletasks
update
